ALTER TABLE `unified_supplier`
  add `supplier_code` varchar(64) DEFAULT NULL COMMENT '供应商编码',
  add `source_id` varchar(32) DEFAULT '' COMMENT '数据胡-供应商ID',
  add `source_name` varchar(64) DEFAULT '' COMMENT '数据胡-供应商名称',
  add `bank_name` varchar(64) DEFAULT NULL COMMENT '开户银行',
  add `bank_account` varchar(64) DEFAULT NULL COMMENT '收款账号',
  add `tax_common` varchar(512) DEFAULT NULL COMMENT '一般纳税,逗号分割',
  add `tax_simple` varchar(512) DEFAULT NULL COMMENT '简易计税,逗号分割',
  add `tax_small` varchar(512) DEFAULT NULL COMMENT '小规模纳税,逗号分割';

CREATE TABLE `biz_contract` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `source_type` varchar(32) DEFAULT '' COMMENT '数据来源,企业福利1,企业商城2',
  `supplier_id` bigint(20) COMMENT '供应商ID',
  `supplier_name` varchar(64) DEFAULT NULL COMMENT '供应商名称',
  `contract_code` varchar(64) DEFAULT '' COMMENT '合同编号',
  `contract_name` varchar(64) DEFAULT '' COMMENT '合同标题',
  `start_date` datetime DEFAULT NULL COMMENT '合同开始时间',
  `end_date` datetime DEFAULT NULL COMMENT '合同结束时间',
  `status` char(1) DEFAULT '0' COMMENT '合同状态',
  `is_default` char(1) DEFAULT 'N' COMMENT '是否默认（Y是 N否）',
  `del_flag` char(1) DEFAULT '0' COMMENT '删除标志（0代表存在 2代表删除）',
  `create_by` varchar(64) DEFAULT '' COMMENT '创建者',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `update_by` varchar(64) DEFAULT '' COMMENT '更新者',
  `update_time` datetime DEFAULT NULL COMMENT '更新时间',
  `remark` varchar(256) DEFAULT NULL COMMENT '备注',
  PRIMARY KEY (`id`),
  KEY `idx_provider_id` (`source_type`,`supplier_id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8mb4 COMMENT='合同信息表';


-- 采购单位对账单明细 增加费用Id
ALTER TABLE `qchjc_accounting_score_customer`
  add `cost_belong_id` varchar(512) DEFAULT '' COMMENT '费用归属ID',
  add `cost_belong_name` varchar(512) DEFAULT '' COMMENT '费用归属名称';

-- 采购单位对账单明细-发票 增加费用Id
ALTER TABLE `qchjc_invoice_apply`
  add `cost_belong_id` varchar(512) DEFAULT '' COMMENT '费用归属ID',
  add `cost_belong_name` varchar(512) DEFAULT '' COMMENT '费用归属名称';


-- 供应商对账单明细 增加费用Id
ALTER TABLE `qchjc_accounting_unified_supplier`
  add `cost_belong_id` varchar(512) DEFAULT '' COMMENT '费用归属ID',
  add `cost_belong_name` varchar(512) DEFAULT '' COMMENT '费用归属名称';

-- 供应商对账单明细-发票 增加费用Id
ALTER TABLE `qchjc_invoice_apply_supplier`
  add `cost_belong_id` varchar(512) DEFAULT '' COMMENT '费用归属ID',
  add `cost_belong_name` varchar(512) DEFAULT '' COMMENT '费用归属名称';

-- 京东对账单-增加费用Id
ALTER TABLE `qchjc_order_goods`
  add `cost_belong_id` varchar(512) DEFAULT '' COMMENT '费用归属ID',
  add `cost_belong_name` varchar(512) DEFAULT '' COMMENT '费用归属名称';

-- 订单/商品-增加费用Id
ALTER TABLE `unified_order_goods`
  add `cost_belong_id` varchar(512) DEFAULT '' COMMENT '费用归属ID',
  add `cost_belong_name` varchar(512) DEFAULT '' COMMENT '费用归属名称';
  
----------------------------------------------------------------------zy-----------------------------------------------------------------------------
-- 业务人员
-- uniorder_test_20211018.sys_business_user definition

CREATE TABLE `sys_business_user` (
 `id` bigint(20) NOT NULL AUTO_INCREMENT,
 `user_name` varchar(100) NOT NULL COMMENT '业务人名称',
 `work_number` varchar(100) NOT NULL COMMENT '业务人工号',
 `job_code` varchar(100) NOT NULL COMMENT '岗位编码',
 `job_name` varchar(100) NOT NULL COMMENT '岗位名称',
 `department_code` varchar(100) NOT NULL COMMENT '部门编码',
 `department_name` varchar(100) NOT NULL COMMENT '部门名称',
 `duty_department_code` varchar(100) NOT NULL COMMENT '责任部门编码',
 `duty_department_name` varchar(100) NOT NULL COMMENT '责任部门名称',
 `bind_operation_userid` bigint(20) DEFAULT NULL COMMENT '绑定操作用户id',
 `bind_operation_user` varchar(100) DEFAULT NULL COMMENT '绑定操作用户',
 `desc` varchar(200) DEFAULT NULL COMMENT '备注',
 `create_user_name` varchar(100) DEFAULT NULL COMMENT '创建人名称',
 `create_user_id` bigint(20) DEFAULT NULL COMMENT '创建人ID',
 `update_user_name` varchar(100) DEFAULT NULL COMMENT '更新人名称',
 `update_user_id` bigint(20) DEFAULT NULL COMMENT '更新人ID',
 `create_time` datetime DEFAULT NULL COMMENT '创建时间',
 `update_time` datetime DEFAULT NULL COMMENT '更新时间',
 `del_flag` int(1) DEFAULT NULL COMMENT '是否删除 0删除 1未删除',
 PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=405 DEFAULT CHARSET=utf8;

-- 企业管理-增加字段
ALTER TABLE sys_enterprise
    ADD customer_uuid varchar(100) NULL COMMENT '数据湖-客户uuid',
    ADD customer_name varchar(100) NULL COMMENT '数据湖-客户名称',
    ADD customer_id varchar(100) NULL COMMENT '源系统客户id',
    ADD client_code varchar(100) NULL COMMENT '数据湖-客户编码',
    ADD property_code varchar(20) NULL COMMENT '数据湖-单位性质，1:境内组织、2:境内个⼈、3:其他或境外组织、4:境外个⼈',
    ADD update_user_name varchar(50) NULL COMMENT '更新人',
    ADD update_user_id bigint(20) NULL COMMENT '更新人ID',
    ADD update_time TIMESTAMP NULL COMMENT '更新时间';
-- 企业管理增加编辑权限
INSERT INTO sys_menu
(id, pid, menu_name, menu_url, perms, menu_type, menu_icon, order_num, enabled, deleted, remark, create_time, create_user_id, update_time, update_user_id)
VALUES(394, 39, '编辑', '', 'edit', 3, '', 0, 1, 0, '', now(), 1, now(), 1);

-- 共享参数配置项菜单
CREATE TABLE `sys_account_config` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `interface_name` varchar(100) DEFAULT NULL COMMENT '共享中心接口名称',
  `user_id` varchar(100) DEFAULT NULL COMMENT '更新人id',
  `user_name` varchar(100) DEFAULT NULL COMMENT '更新人',
  `update_time` datetime DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='共享参数配置';

-- 初始化菜单项
INSERT INTO sys_account_config (id, interface_name, user_id, user_name) VALUES(1, '应收数据同步接口（应收报账单）', '', '');
INSERT INTO sys_account_config (id, interface_name, user_id, user_name) VALUES(2, '成本数据同步接口（应付报账单）', '', '');
INSERT INTO sys_account_config (id, interface_name, user_id, user_name) VALUES(3, '实收数据同步接口（实收报账单）', '', '');
INSERT INTO sys_account_config (id, interface_name, user_id, user_name) VALUES(4, '付款数据同步接口（实付报账单）', '', ''); 

-- 增加菜单项-共享参数配置、业务人员
INSERT INTO sys_menu
(id, pid, menu_name, menu_url, perms, menu_type, menu_icon, order_num, enabled, deleted, remark, create_time, create_user_id, update_time, update_user_id)
VALUES(40, 3, '业务人员', 'businessPersonManger', '', 2, '', 8, 1, 0, '', now(), 1, now(), 1);
-- 调整菜单顺序
update sys_menu set order_num =9 where id = 39 and menu_name  ='企业管理';
update sys_menu set order_num =10 where id = 37 and menu_name ='供应商管理';

-- 业务人员权限配置
INSERT INTO sys_menu
(id, pid, menu_name, menu_url, perms, menu_type, menu_icon, order_num, enabled, deleted, remark, create_time, create_user_id, update_time, update_user_id)
VALUES
    (401, 40, '查询', '', 'search', 3, '', 0, 1, 0, '', now(), 1,  now(), 1),
    (402, 40, '重置', '', 'reset', 3, '', 0, 1, 0, '', now(), 1, now(), 1),
    (403, 40, '编辑', '', 'edit', 3, '', 0, 1, 0, '', now(), 1,  now(), 1),
    (404, 40, '删除', '', 'delete', 3, '', 0, 1, 0, '', now(), 1, now(), 1),
    (405, 40, '新增', '', 'add', 3, '', 0, 1, 0, '', now(), 1, now(), 1);

INSERT INTO sys_menu
(id, pid, menu_name, menu_url, perms, menu_type, menu_icon, order_num, enabled, deleted, remark, create_time, create_user_id, update_time, update_user_id)
VALUES(47, 4, '共享参数配置', 'commParams', '', 2, '', 2, 1, 0, '', now(), 1, now(), 1);
INSERT INTO sys_menu
(id, pid, menu_name, menu_url, perms, menu_type, menu_icon, order_num, enabled, deleted, remark, create_time, create_user_id, update_time, update_user_id)
VALUES
    (440, 47, '编辑', '', 'edit', 3, '', 0, 1, 0, '', now(), 1,  now(), 1),
    (441, 47, '删除', '', 'delete', 3, '', 0, 1, 0, '', now(), 1, now(), 1);


-- 应付款报账单
CREATE TABLE `sys_account_payable` (
   `id` bigint(20) NOT NULL AUTO_INCREMENT,
   `business_category` varchar(100) DEFAULT NULL COMMENT '业态类别',
   `operation_type_code` varchar(100) DEFAULT NULL COMMENT '业务类型编码',
   `le_code` varchar(100) DEFAULT NULL COMMENT '业务单位编码',
   `le_name` varchar(100) DEFAULT NULL COMMENT '业务单位名称',
   `operation_sub_type_code` varchar(100) DEFAULT NULL COMMENT '业务小类',
   `cc_code` varchar(100) DEFAULT NULL COMMENT '成本中心编码',
   `cc_name` varchar(100) DEFAULT NULL COMMENT '成本中心名称',
   `project_num` varchar(100) DEFAULT NULL COMMENT '项目编码',
   `project_name` varchar(100) DEFAULT NULL COMMENT '项目名称',
   `business_type` varchar(100) DEFAULT NULL COMMENT '业态类别编码',
   `dimension_cblb` varchar(100) DEFAULT NULL COMMENT '成本类别编码',
   `dimension_fwjsp` varchar(100) DEFAULT NULL COMMENT '企业商城-服务及商品编码',
   `shop_dimension_fwjsp` varchar(100) DEFAULT NULL COMMENT '福利商城-服务及商品编码',
   `data_is_complete` tinyint(4) DEFAULT '0' COMMENT '标识变更为该接口信息完整，0,不完整 1,完整',
   PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 COMMENT='应付款报账单';

-- 初始化数据-应付款报账单
INSERT INTO sys_account_payable
(id, business_category, operation_type_code, le_code, le_name, operation_sub_type_code, cc_code, cc_name, project_num, project_name, business_type, dimension_cblb, dimension_fwjsp, shop_dimension_fwjsp)
VALUES(1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

-- 实付款报账单
CREATE TABLE `sys_account_reality_payable` (
   `id` bigint(20) NOT NULL AUTO_INCREMENT,
   `business_category` varchar(100) DEFAULT NULL COMMENT '业态类别',
   `operation_type_code` varchar(100) DEFAULT NULL COMMENT '业务类型编码',
   `company_num` varchar(100) DEFAULT NULL COMMENT '业务单位编码',
   `company_name` varchar(100) DEFAULT NULL COMMENT '业务单位名称',
   `operation_sub_type_code` varchar(100) DEFAULT NULL COMMENT '业务小类',
   `costcenter_id` varchar(100) DEFAULT NULL COMMENT '成本中心编码',
   `costcenter_name` varchar(100) DEFAULT NULL COMMENT '成本中心名称',
   `project_num` varchar(100) DEFAULT NULL COMMENT '项目编码',
   `project_name` varchar(100) DEFAULT NULL COMMENT '项目名称',
   `data_is_complete` tinyint(4) DEFAULT '0' COMMENT '标识变更为该接口信息完整，0,不完整 1,完整',
   PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8 COMMENT='实付款报账单';

-- 初始化数据-实付款报账单
INSERT INTO sys_account_reality_payable
(id, business_category, operation_type_code, company_num, company_name, operation_sub_type_code, costcenter_id, costcenter_name, project_num, project_name)
VALUES(1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

-- 实收报账单
-- uniorder_test_20211018.sys_account_reality_receivable definition

CREATE TABLE `sys_account_reality_receivable` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `business_category` varchar(100) DEFAULT NULL COMMENT '业态类别',
  `operation_type_code` varchar(100) DEFAULT NULL COMMENT '业务类型编码',
  `company_num` varchar(100) DEFAULT NULL COMMENT '业务单位编码',
  `company_name` varchar(100) DEFAULT NULL COMMENT '业务单位名称',
  `operation_sub_type_code` varchar(100) DEFAULT NULL COMMENT '业务小类-核销明细小类',
  `income_detail_type_code` varchar(100) DEFAULT NULL COMMENT '业务小类-收入明细小类',
  `costcenter_id` varchar(100) DEFAULT NULL COMMENT '成本中心编码',
  `costcenter_name` varchar(100) DEFAULT NULL COMMENT '成本中心名称',
  `receipt_bank_acc_num` varchar(100) DEFAULT NULL COMMENT '收款账号',
  `wechat_trade_no` varchar(100) DEFAULT NULL COMMENT '微信流水号',
  `format_type` varchar(100) DEFAULT NULL COMMENT '业态类别编码',
  `service_type` varchar(100) DEFAULT NULL COMMENT '企业商城-服务及商品编码',
  `welfare_shop_service_type` varchar(255) DEFAULT NULL COMMENT '福利商城-服务及商品编码',
  `data_is_complete` tinyint(4) DEFAULT '0' COMMENT '标识变更为该接口信息完整，0,不完整 1,完整',
  `project_num` varchar(100) DEFAULT NULL COMMENT '项目编码',
  `project_name` varchar(100) DEFAULT NULL COMMENT '项目名称',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 COMMENT='实收报账单';

-- 初始化数据-实收报账单
INSERT INTO sys_account_reality_receivable
(id, business_category, operation_type_code, company_num, company_name, operation_sub_type_code, income_detail_type_code, costcenter_id, costcenter_name, receipt_bank_acc_num, wechat_trade_no, format_type, service_type, welfare_shop_service_type)
VALUES(1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

-- 应收报账单
CREATE TABLE `sys_account_receivable` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `business_category` varchar(100) DEFAULT NULL COMMENT '业态类别',
  `operation_type_code` varchar(100) DEFAULT NULL COMMENT '业务类型编码',
  `company_num` varchar(100) DEFAULT NULL COMMENT '业务单位编码',
  `company_name` varchar(100) DEFAULT NULL COMMENT '业务单位名称',
  `operation_sub_type_code` varchar(100) DEFAULT NULL COMMENT '业务小类',
  `costcenter_id` varchar(100) DEFAULT NULL COMMENT '成本中心编码',
  `costcenter_name` varchar(100) DEFAULT NULL COMMENT '成本中心名称',
  `project_num` varchar(100) DEFAULT NULL COMMENT '项目编码',
  `project_name` varchar(100) DEFAULT NULL COMMENT '项目名称',
  `format_type` varchar(100) DEFAULT NULL COMMENT '业态类别编码',
  `service_type` varchar(100) DEFAULT NULL COMMENT '企业商城-服务及商品编码',
  `welfare_shop_service_type` varchar(100) DEFAULT NULL COMMENT '福利商城-服务及商品编码',
  `data_is_complete` tinyint(4) DEFAULT '0' COMMENT '标识变更为该接口信息完整，0,不完整 1,完整',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 COMMENT='应收报账单';

-- 初始化数据-应收报账单
INSERT INTO sys_account_receivable
(id, business_category, operation_type_code, company_num, company_name, operation_sub_type_code, costcenter_id, costcenter_name, project_num, project_name, format_type, service_type, welfare_shop_service_type)
VALUES(1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

-------------------------------------------------------------------------------zy--------------------------------------------------------------------------------

-- v2 ------------
-- 订单/商品-应付冲销状态
ALTER TABLE `unified_order_goods`
  add `cost_belong_id` varchar(512) DEFAULT '' COMMENT '费用归属ID',
  add `cost_belong_name` varchar(512) DEFAULT '' COMMENT '费用归属名称',
  add `payable_verify_status` tinyint(4) DEFAULT '0' COMMENT '应付冲销状态:0未冲销、1部分冲销、2全部冲销';

-- 订单流水表-应付冲销状态
ALTER TABLE `unified_order_credit`
  add `settle_cost` decimal(14,4) DEFAULT 0 COMMENT '结算成本';


-- 客户对账-增加字段
ALTER TABLE `accounting_score_customer`
  add `receivable_data_status` tinyint(4) DEFAULT '0' COMMENT '应收数据状态 0未生成/1生成中/2生成失败/3已生成',
  add `payable_data_status` tinyint(4) DEFAULT '0' COMMENT '应付数据状态 0未生成/1生成中/2生成失败/3已生成',
  add `receivable_account_status` tinyint(4) DEFAULT '0' COMMENT '应收报账状态(非微信) 0未报账/1部分报账/2全部报账/3无需报账',
  add `wx_receivable_account_status` tinyint(4) DEFAULT '0' COMMENT '应收报账状态(微信) 0未报账/1部分报账/2全部报账/3无需报账',
  add `payable_account_status` tinyint(4) DEFAULT '0' COMMENT '应付报账状态 0未报账/1部分报账/2全部报账',
  add `received_account_status` tinyint(4) DEFAULT '0' COMMENT '实收报账状态(非微信) 0未回款/1部分回款/2全部回款/3无需回款',
  add `wx_received_account_status` tinyint(4) DEFAULT '0' COMMENT '实收报账状态(微信) 0未回款/1部分回款/2全部回款/3无需回款',
  add `received_account_amount` decimal(15,2) DEFAULT '0' COMMENT '实收账款(非微信)',
  add `wx_received_account_amount` decimal(15,2)DEFAULT '0' COMMENT '实收账款(微信)';



-- 应收流水明细表
DROP TABLE IF EXISTS `flow_receivable_detail`;
CREATE TABLE `flow_receivable_detail` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `accounting_order_sn` varchar(64) DEFAULT NULL COMMENT '对账单编号',
  `cus_settlement_id` bigint(20) DEFAULT NULL COMMENT '客户结算中心id',
  `cus_biz_code` varchar(64) DEFAULT NULL COMMENT '客户业务方编号',
  `cus_biz_name` varchar(64) DEFAULT NULL COMMENT '客户名称',
  `order_sn` varchar(50) NOT NULL COMMENT '订单编号',
  `credit_no` varchar(50) DEFAULT NULL COMMENT '结算中心编号',
  `refund_order_sn` varchar(50) DEFAULT NULL COMMENT '退款订单编号',
  `service_no` varchar(32) DEFAULT NULL COMMENT '订单类型id',
  `service_no_name` varchar(50) DEFAULT NULL COMMENT '订单类型',
  `order_state` tinyint(2) DEFAULT NULL COMMENT '订单状态id',
  `order_state_name` varchar(50) DEFAULT NULL COMMENT '订单状态',
  `bill_created_at` datetime DEFAULT NULL COMMENT '下单时间',
  `finish_time` datetime DEFAULT NULL COMMENT '完成时间',
  `cost_belong_id` varchar(512) DEFAULT '' COMMENT '费用归属ID',
  `cost_belong_name` varchar(512) DEFAULT '' COMMENT '费用归属名称',
  `goods_id` bigint(20) NOT NULL COMMENT '商品id',
  `goods_name` varchar(255) DEFAULT NULL COMMENT '商品名称',
  `goods_unit` varchar(50) DEFAULT NULL COMMENT '单位',
  `goods_quantity` bigint(20) DEFAULT NULL COMMENT '商品数量',
  `goods_price` decimal(10,2) DEFAULT '0.00' COMMENT '销售单价',
  `goods_total_amount` decimal(10,2) DEFAULT '0.00' COMMENT '销售总价',
  `credit_type` tinyint(2) DEFAULT NULL COMMENT '积分类型 0-微信 1-福利积分',
  `credit_name` varchar(50) DEFAULT NULL COMMENT '积分类型',
  `balance` decimal(10,2) DEFAULT '0.00' COMMENT '结算金额',
  `operation_tax_rate` decimal(10,2) DEFAULT '0.00' COMMENT '税率',
  `operation_tax_code` varchar(50) DEFAULT NULL COMMENT '平台税务分类编码',
  `income_no_tax` decimal(10,2) DEFAULT '0.00' COMMENT '收入(不含税)',
  `tax_amount` decimal(10,2) DEFAULT '0.00' COMMENT '税额',
  `receivable_amount` decimal(10,2) DEFAULT '0.00' COMMENT '应收账款',
  `accounting_state` tinyint(3) DEFAULT '0' COMMENT '对账状态 0-未确认;1-已确认;-1-已取消;',
  `in_account_state` tinyint(3) DEFAULT '0' COMMENT '入账状态 0未入账/1已入账/2撤销入账/3已撤销',
  `in_account_id` varchar(64) DEFAULT NULL COMMENT '入账id',
  `in_account_date` datetime DEFAULT NULL COMMENT '入账日期',
  `charge_receivable_day_id` varchar(32) DEFAULT NULL COMMENT '冲销/撤销入账id',
  `collection_order_sn` varchar(50) DEFAULT NULL COMMENT '回款冲销对账单编号',
  `charge_status` tinyint(4) DEFAULT '1' COMMENT '冲销状态 1-未冲销 2-已冲销 3-已撤销''',
  `charge_user_id` bigint(20) DEFAULT NULL COMMENT '冲销人Id',
  `charge_created_at` datetime DEFAULT NULL COMMENT '冲销时间',
  `charge_user_name` varchar(20) DEFAULT NULL COMMENT '冲销人',
  `remark` varchar(512) DEFAULT NULL COMMENT '备注',
  `del_flag` char(1) DEFAULT '0' COMMENT '删除标志（0代表存在 2代表删除）',
  `create_by` varchar(64) DEFAULT '' COMMENT '创建者',
  `create_id` bigint(20) DEFAULT NULL COMMENT '创建者id',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `update_by` varchar(64) DEFAULT '' COMMENT '更新者',
  `update_id` bigint(20) DEFAULT NULL COMMENT '更新者id',
  `update_time` datetime DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='应收流水明细表';

-- 应收流水汇总表
DROP TABLE IF EXISTS `flow_receivable_summary`;
CREATE TABLE `flow_receivable_summary` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `type` tinyint(3) DEFAULT '0' COMMENT '类型 0应收/1实收',
  `share_bill_no` varchar(64) DEFAULT '' COMMENT '共享单据流水号',
  `share_bill_code` varchar(64) DEFAULT '' COMMENT '共享单据编号',
  `rm_account_state` tinyint(3) DEFAULT '0' COMMENT '报账状态 0未报账/1报账中/2已报账/3已撤销',
  `rm_account_user_id` bigint(20) DEFAULT NULL COMMENT '报账人Id',
  `rm_account_user_name` varchar(20) DEFAULT NULL COMMENT '报账人',
  `share_approve_date` datetime DEFAULT NULL COMMENT '共享审批时间',
  `in_account_id` varchar(64) DEFAULT '' COMMENT '入账Id',
  `in_account_date` datetime DEFAULT NULL COMMENT '入账日期',
  `in_account_type` tinyint(3) DEFAULT '0' COMMENT '入账类型 1-正常入账 2-撤销入账 3-冲销账款',
  `in_account_way` tinyint(2) DEFAULT NULL COMMENT '入账方式 0系统入账 1手工记账',
  `accounting_order_sn` varchar(64) DEFAULT NULL COMMENT '所属对账单编号',
  `cus_settlement_id` bigint(20) DEFAULT NULL COMMENT '客户结算中心id',
  `cus_biz_code` varchar(64) DEFAULT NULL COMMENT '客户业务方编号',
  `cus_biz_name` varchar(64) DEFAULT NULL COMMENT '客户名称',
  `biz_platform_id` varchar(64) DEFAULT NULL COMMENT '业务平台id',
  `biz_platform_name` varchar(64) DEFAULT NULL COMMENT '业务平台',
  `credit_type` tinyint(2) DEFAULT 0 COMMENT '积分类型 0-微信 1-福利积分',
  `credit_name` varchar(50) DEFAULT NULL COMMENT '积分类型',
  `operation_tax_rate` decimal(10,2) DEFAULT '0.00' COMMENT '税率',
  `income_no_tax` decimal(10,2) DEFAULT '0.00' COMMENT '收入(不含税)',
  `tax_amount` decimal(10,2) DEFAULT '0.00' COMMENT '税额',
  `receivable_amount` decimal(10,2) DEFAULT '0.00' COMMENT '应收账款',
  `remark` varchar(512) DEFAULT NULL COMMENT '备注',
  `del_flag` char(1) DEFAULT '0' COMMENT '删除标志（0代表存在 2代表删除）',
  `create_by` varchar(64) DEFAULT '' COMMENT '创建者',
  `create_id` bigint(20) DEFAULT NULL COMMENT '创建者id',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `update_by` varchar(64) DEFAULT '' COMMENT '更新者',
  `update_id` bigint(20) DEFAULT NULL COMMENT '更新者id',
  `update_time` datetime DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='应收流水汇总表';


-- 应付流水明细表
DROP TABLE IF EXISTS `flow_payable_detail`;
CREATE TABLE `flow_payable_detail` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `accounting_order_sn` varchar(64) DEFAULT NULL COMMENT '对账单编号',
  `cus_settlement_id` bigint(20) DEFAULT NULL COMMENT '供应商结算中心id',
  `cus_biz_code` varchar(64) DEFAULT NULL COMMENT '供应商业务方编号',
  `cus_biz_name` varchar(64) DEFAULT NULL COMMENT '供应商名称',
  `order_sn` varchar(50) NOT NULL COMMENT '订单编号',
  `credit_no` varchar(50) DEFAULT NULL COMMENT '结算中心编号',
  `refund_order_sn` varchar(50) DEFAULT NULL COMMENT '退款订单编号',
  `service_no` varchar(32) DEFAULT NULL COMMENT '订单类型id',
  `service_no_name` varchar(50) DEFAULT NULL COMMENT '订单类型',
  `order_state` tinyint(2) DEFAULT NULL COMMENT '订单状态id',
  `order_state_name` varchar(50) DEFAULT NULL COMMENT '订单状态',
  `bill_created_at` datetime DEFAULT NULL COMMENT '下单时间',
  `finish_time` datetime DEFAULT NULL COMMENT '完成时间',
  `cost_belong_id` varchar(512) DEFAULT '' COMMENT '费用归属ID',
  `cost_belong_name` varchar(512) DEFAULT '' COMMENT '费用归属名称',
  `data_type` tinyint(2) DEFAULT NULL COMMENT '数据类型 0订单流水/1订单商品',
  `goods_id` bigint(20) NOT NULL COMMENT '商品id',
  `goods_name` varchar(255) DEFAULT NULL COMMENT '商品名称',
  `goods_unit` varchar(50) DEFAULT NULL COMMENT '单位',
  `goods_quantity` bigint(20) DEFAULT NULL COMMENT '商品数量',
  `goods_price` decimal(10,2) DEFAULT '0.00' COMMENT '成本单价',
  `goods_total_amount` decimal(10,2) DEFAULT '0.00' COMMENT '成本总价',
  `settle_cost` decimal(14,4) DEFAULT '0.0000' COMMENT '结算成本',
  `operation_tax_rate` decimal(10,2) DEFAULT '0.00' COMMENT '税率',
  `operation_tax_code` varchar(50) DEFAULT NULL COMMENT '平台税务分类编码',
  `cost_no_tax` decimal(10,2) DEFAULT '0.00' COMMENT '成本(不含税)',
  `tax_amount` decimal(10,2) DEFAULT '0.00' COMMENT '税额',
  `payable_amount` decimal(10,2) DEFAULT '0.00' COMMENT '应付账款',
  `accounting_state` tinyint(3) DEFAULT '0' COMMENT '对账状态 0-未确认;1-已确认;-1-已取消;',
  `in_account_state` tinyint(3) DEFAULT '0' COMMENT '入账状态 0未入账/1已入账/2撤销入账/3已撤销',
  `in_account_id` varchar(64) DEFAULT NULL COMMENT '入账id',
  `in_account_date` datetime DEFAULT NULL COMMENT '入账日期',
  `charge_order_goods_id` bigint(20) COMMENT '冲销商品订单id',
  `charge_receivable_day_id` varchar(32) DEFAULT NULL COMMENT '冲销/撤销入账id',
  `collection_order_sn` varchar(50) DEFAULT NULL COMMENT '回款冲销对账单编号',
  `charge_status` tinyint(4) DEFAULT '1' COMMENT '冲销状态 1-未冲销 2-已冲销 3-已撤销''',
  `charge_user_id` bigint(20) DEFAULT NULL COMMENT '冲销人Id',
  `charge_created_at` datetime DEFAULT NULL COMMENT '冲销时间',
  `charge_user_name` varchar(20) DEFAULT NULL COMMENT '冲销人',
  `remark` varchar(512) DEFAULT NULL COMMENT '备注',
  `del_flag` char(1) DEFAULT '0' COMMENT '删除标志（0代表存在 2代表删除）',
  `create_by` varchar(64) DEFAULT '' COMMENT '创建者',
  `create_id` bigint(20) DEFAULT NULL COMMENT '创建者id',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `update_by` varchar(64) DEFAULT '' COMMENT '更新者',
  `update_id` bigint(20) DEFAULT NULL COMMENT '更新者id',
  `update_time` datetime DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='应付流水明细表';

-- 应付流水汇总表
DROP TABLE IF EXISTS `flow_payable_summary`;
CREATE TABLE `flow_payable_summary` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `type` tinyint(3) DEFAULT '0' COMMENT '类型 0应付/1实付',
  `share_bill_no` varchar(64) DEFAULT '' COMMENT '共享单据流水号',
  `share_bill_code` varchar(64) DEFAULT '' COMMENT '共享单据编号',
  `rm_account_state` tinyint(3) DEFAULT '0' COMMENT '报账状态 0未报账/1报账中/2已报账/3已撤销',
  `rm_account_user_id` bigint(20) DEFAULT NULL COMMENT '报账人Id',
  `rm_account_user_name` varchar(20) DEFAULT NULL COMMENT '报账人',
  `share_approve_date` datetime DEFAULT NULL COMMENT '共享审批时间',
  `in_account_id` varchar(64) DEFAULT '' COMMENT '入账Id',
  `in_account_date` datetime DEFAULT NULL COMMENT '入账日期',
  `in_account_type` tinyint(3) DEFAULT '0' COMMENT '入账类型 1-正常入账 2-撤销入账 3-冲销账款',
  `in_account_way` tinyint(2) DEFAULT NULL COMMENT '入账方式 0系统入账 1手工记账',
  `accounting_order_sn` varchar(64) DEFAULT NULL COMMENT '所属对账单编号',
  `cus_settlement_id` bigint(20) DEFAULT NULL COMMENT '供应商结算中心id',
  `cus_biz_code` varchar(64) DEFAULT NULL COMMENT '供应商业务方编号',
  `cus_biz_name` varchar(64) DEFAULT NULL COMMENT '供应商名称',
  `biz_platform_id` varchar(64) DEFAULT NULL COMMENT '业务平台id',
  `biz_platform_name` varchar(64) DEFAULT NULL COMMENT '业务平台',
  `operation_tax_rate` decimal(10,2) DEFAULT '0.00' COMMENT '税率',
  `cost_no_tax` decimal(10,2) DEFAULT '0.00' COMMENT '成本(不含税)',
  `tax_amount` decimal(10,2) DEFAULT '0.00' COMMENT '税额',
  `payable_amount` decimal(10,2) DEFAULT '0.00' COMMENT '应付账款',
  `remark` varchar(512) DEFAULT NULL COMMENT '备注',
  `del_flag` char(1) DEFAULT '0' COMMENT '删除标志（0代表存在 2代表删除）',
  `create_by` varchar(64) DEFAULT '' COMMENT '创建者',
  `create_id` bigint(20) DEFAULT NULL COMMENT '创建者id',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `update_by` varchar(64) DEFAULT '' COMMENT '更新者',
  `update_id` bigint(20) DEFAULT NULL COMMENT '更新者id',
  `update_time` datetime DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='应付流水汇总表';

-- 货款管理 - 对账单增加报账完成总金额、付款报账状态字段
ALTER TABLE accounting_unified_supplier
    ADD payment_report_completed_amount decimal(10,2) DEFAULT '0' COMMENT '报账完成总金额',
    ADD payment_report_status tinyint(4) NULL COMMENT '付款报账状态-:0-待付款;1-部分付款;2全部付款';

-- 应收/应付报账单表
DROP TABLE IF EXISTS `accounting_receivable_payable`;
CREATE TABLE `accounting_receivable_payable` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `accounting_order_sn` varchar(64) DEFAULT NULL COMMENT '对账单编号',
  `account_type` tinyint(3) DEFAULT '0' COMMENT '账款类型 0应收款项/1应付款项/2实收款项/3实付款项',
  `bill_no` varchar(64) DEFAULT '' COMMENT '单据流水号',
  `bill_code` varchar(64) DEFAULT '' COMMENT '单据编号',
  `bill_type` tinyint(2) DEFAULT '0' COMMENT '单据类型,0应收报账单（非微信）/1应收报账单（微信）/2应付报账单/3实收报账单（非微信）/4实收报账单（微信）/5付款报账单',
  `data_type` tinyint(2) DEFAULT '0' COMMENT '数据类型,0非微信/1微信',
  `bill_amount` decimal(15,2) DEFAULT '0.00' COMMENT '单据金额',
  `accounting_state` tinyint(3) DEFAULT '0' COMMENT '报账状态 0生成中/1待提交/2审批中/3报账完成/4处理失败/5报账作废',
  `share_bill_no` varchar(64) DEFAULT '' COMMENT '共享单据流水号',
  `share_bill_code` varchar(64) DEFAULT '' COMMENT '共享单据编号',
  `share_data_state` varchar(32) DEFAULT '' COMMENT '共享数据状态,共享中心返回',
  `share_approve_state` varchar(32) DEFAULT '' COMMENT '共享审批状态,共享中心返回',
  `share_pay_state` varchar(32) DEFAULT '' COMMENT '共享支付状态,共享中心返回',
  `approve_date` datetime DEFAULT NULL COMMENT '审批时间',
  `from_settlement_id` bigint(20) DEFAULT NULL COMMENT '所属结算中心id',
  `settlement_id` bigint(20) DEFAULT NULL COMMENT '报账主体结算中心id',
  `settlement_code` varchar(64) DEFAULT NULL COMMENT '报账主体业务方编号',
  `settlement_name` varchar(64) DEFAULT NULL COMMENT '报账主体业务方名称',
  `biz_platform_id` varchar(64) DEFAULT NULL COMMENT '业务平台id',
  `biz_platform_name` varchar(64) DEFAULT NULL COMMENT '业务平台',
  `biz_user_id` bigint(20) DEFAULT NULL COMMENT '业务员Id',
  `biz_user_name` varchar(20) DEFAULT NULL COMMENT '业务员',
  `pus_content` text DEFAULT NULL COMMENT '推送共享消息',
  `remark` varchar(512) DEFAULT NULL COMMENT '后台备注',
  `file_title` varchar(255) DEFAULT NULL COMMENT '文件标题',
  `file_detail_link` varchar(512) DEFAULT '' COMMENT '文件地址',
  `del_flag` char(1) DEFAULT '0' COMMENT '删除标志（0代表存在 2代表删除）',
  `commit_by` varchar(64) DEFAULT '' COMMENT '提交者',
  `commit_id` bigint(20) DEFAULT NULL COMMENT '提交者id',
  `commit_time` datetime DEFAULT NULL COMMENT '提交时间',
  `create_by` varchar(64) DEFAULT '' COMMENT '创建者',
  `create_id` bigint(20) DEFAULT NULL COMMENT '创建者id',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `update_by` varchar(64) DEFAULT '' COMMENT '更新者',
  `update_id` bigint(20) DEFAULT NULL COMMENT '更新者id',
  `update_time` datetime DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE INDEX accounting_receivable_payable_idx_01(`bill_no`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='应收/应付报账单表';


-- 报账单推送共享中心表
DROP TABLE IF EXISTS `accounting_push_share_data`;
CREATE TABLE `accounting_push_share_data` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `accounting_order_sn` varchar(64) DEFAULT NULL COMMENT '对账单编号',
  `accounting_rp_id` bigint(20) DEFAULT NULL COMMENT '应收/应付/实收/实付报账单ID',
  `account_type` tinyint(3) DEFAULT '0' COMMENT '账款类型 0应收款项/1应付款项/2实收款项/3实付款项',
  `bill_type` tinyint(2) DEFAULT '0' COMMENT '单据类型,0应收报账单（非微信）/1应收报账单（微信）/2应付报账单/3实收报账单（非微信）/4实收报账单（微信）/5付款报账单',
  `data_type` tinyint(2) DEFAULT '0' COMMENT '数据类型,0非微信/1微信',
  `head_data` text COMMENT '数据头部',
  `row_data` text COMMENT '数据行集合',
  `file_data` varchar(1024) DEFAULT '' COMMENT '附件地址',
  `push_state` tinyint(3) DEFAULT '0' COMMENT '推送状态,0待推送/1已推送/2推送失败',
  `del_flag` char(1) DEFAULT '0' COMMENT '删除标志（0代表存在 2代表删除）',
  `create_by` varchar(64) DEFAULT '' COMMENT '创建者',
  `create_id` bigint(20) DEFAULT NULL COMMENT '创建者id',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `update_by` varchar(64) DEFAULT '' COMMENT '更新者',
  `update_id` bigint(20) DEFAULT NULL COMMENT '更新者id',
  `update_time` datetime DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='报账单推送共享中心表';

-- 菜单修改名称
update sys_menu set menu_name='客户结算' where menu_name ='积分结算' and id = 100;

-- 货款管理增加角色权限
INSERT INTO sys_menu
(id, pid, menu_name, menu_url, perms, menu_type, menu_icon, order_num, enabled, deleted, remark, create_time, create_user_id, update_time, update_user_id)
VALUES
    (750, 74, '账单付款状态修复', '', 'billPaymentStatusRepair', 3, '', 0, 1, 0, '', now(), 1, now(), 1),
    (758, 74, '付款报账', '', 'paymentReimbursement', 3, '', 0, 1, 0, '', now(), 1, now(), 1);

-- 发票管理增加角色权限
INSERT INTO sys_menu
(id, pid, menu_name, menu_url, perms, menu_type, menu_icon, order_num, enabled, deleted, remark, create_time, create_user_id, update_time, update_user_id)
VALUES
    (10060, 1005, '账单回款状态修复', '', 'billCollectionStatusRepair', 3, '', 0, 1, 0, '', now(), 1, now(), 1),
    (10068, 1005, '实收报账', '', 'paidInReimbursement', 3, '', 0, 1, 0, '', now(), 1, now(), 1);

-- 零星客户初始化脚本
INSERT INTO uniorder_test_20211018.sys_enterprise
(source_from, organization_id, enterprise_id, enterprise_no, enterprise_name, sync_time, other_field1, other_field2, other_field3, enabled, deleted, is_has_order, is_has_ext_invoice, service_no, customer_uuid, customer_name, customer_id, update_user_name, update_user_id, update_time, client_code, property_code)
VALUES('superdesk-mall-flsc-qch', 100000, 1000000, '', '零星客户', now(), NULL, NULL, '', 1, 0, 2, 2, 'FLSC_QCH', '', '', '', '', NULL, now(), NULL, NULL);


INSERT INTO sys_menu
(id,pid, menu_name, menu_url, perms, menu_type, menu_icon, order_num, enabled, deleted, remark, create_time, create_user_id, update_time, update_user_id)
VALUES
    (780,1002, '生成应收&应付数据', '', 'creatFlow', 3, '', 0, 1, 0, '', now(), 1,  now(), 1),
    (781,1002, '报账单', '', 'accountingBill', 3, '', 0, 1, 0, '', now(), 1, now(), 1);

INSERT INTO sys_menu
(id,pid, menu_name, menu_url, perms, menu_type, menu_icon, order_num, enabled, deleted, remark, create_time, create_user_id, update_time, update_user_id)
VALUES
    (782,37, '编辑', '', 'updateSupplier', 3, '', 2, 1, 0, '', now(), 1,  now(), 1),
    (783,37, '合同管理', '', 'contractList', 3, '', 3, 1, 0, '', now(), 1, now(), 1);

