package cn.superdesk.uniorder.common.enums.accounting.customer;


import java.util.EnumSet;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description: 对账数据状态
 */
public enum AccountingDataStatusEnum {
	未生成(0, "未生成"),
	生成中(1, "生成中"),
	生成失败(2, "生成失败"),
	已生成(3, "已生成")
	;

	private Integer key;
	private String  desc;

	AccountingDataStatusEnum(Integer key, String desc) {
		this.key = key;
		this.desc = desc;
	}

	public Integer getKey() {
		return key;
	}

	public String getDesc() {
		return desc;
	}


	public static String getDesc(Integer key) {
		for (AccountingDataStatusEnum c : AccountingDataStatusEnum.values()) {
			if (c.key.equals(key)) {
				return c.getDesc();
			}
		}
		return null;
	}

	private static final Map<Integer, AccountingDataStatusEnum> LOOKUP = new HashMap<>();

	static {
		for (AccountingDataStatusEnum s : EnumSet.allOf(AccountingDataStatusEnum.class)) {
			LOOKUP.put(s.getKey(), s);
		}
	}

	public static AccountingDataStatusEnum get(Integer key) {
		return LOOKUP.get(key);
	}
}
