package cn.superdesk.uniorder.common.enums.accounting.customer;


import java.util.EnumSet;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description: 对账订单类型
 */
public enum AccountingOrderTypeEnum {

	订单流水(0, "订单流水"),
	订单商品(1, "订单商品"),
	;

	private Integer key;
	private String  desc;

	AccountingOrderTypeEnum(Integer key, String desc) {
		this.key = key;
		this.desc = desc;
	}

	public Integer getKey() {
		return key;
	}

	public String getDesc() {
		return desc;
	}


	public static String getDesc(Integer key) {
		for (AccountingOrderTypeEnum c : AccountingOrderTypeEnum.values()) {
			if (c.key.equals(key)) {
				return c.getDesc();
			}
		}
		return null;
	}

	private static final Map<Integer, AccountingOrderTypeEnum> LOOKUP = new HashMap<>();

	static {
		for (AccountingOrderTypeEnum s : EnumSet.allOf(AccountingOrderTypeEnum.class)) {
			LOOKUP.put(s.getKey(), s);
		}
	}

	public static AccountingOrderTypeEnum get(Integer key) {
		return LOOKUP.get(key);
	}
}
