package cn.superdesk.uniorder.common.enums.accounting.customer;


import java.util.EnumSet;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description: 对账报账状态
 */
public enum AccountingRmStatusEnum {

	未报账(0, "未报账"),
	部分报账(1, "部分报账"),
	全部报账(2, "全部报账"),
	无需报账(3, "无需报账")
	;

	private Integer key;
	private String  desc;

	AccountingRmStatusEnum(Integer key, String desc) {
		this.key = key;
		this.desc = desc;
	}

	public Integer getKey() {
		return key;
	}

	public String getDesc() {
		return desc;
	}


	public static String getDesc(Integer key) {
		for (AccountingRmStatusEnum c : AccountingRmStatusEnum.values()) {
			if (c.key.equals(key)) {
				return c.getDesc();
			}
		}
		return null;
	}

	private static final Map<Integer, AccountingRmStatusEnum> LOOKUP = new HashMap<>();

	static {
		for (AccountingRmStatusEnum s : EnumSet.allOf(AccountingRmStatusEnum.class)) {
			LOOKUP.put(s.getKey(), s);
		}
	}

	public static AccountingRmStatusEnum get(Integer key) {
		return LOOKUP.get(key);
	}
}
