package cn.superdesk.uniorder.common.enums.accounting.customer;


import java.util.EnumSet;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description: 对账状态
 */
public enum AccountingStateEnum {

	未确认(0, "未确认"),
	已确认(1, "已确认"),
	已取消(-1, "已取消"),
	;

	private Integer key;
	private String  desc;

	AccountingStateEnum(Integer key, String desc) {
		this.key = key;
		this.desc = desc;
	}

	public Integer getKey() {
		return key;
	}

	public String getDesc() {
		return desc;
	}


	public static String getDesc(Integer key) {
		for (AccountingStateEnum c : AccountingStateEnum.values()) {
			if (c.key.equals(key)) {
				return c.getDesc();
			}
		}
		return null;
	}

	private static final Map<Integer, AccountingStateEnum> LOOKUP = new HashMap<>();

	static {
		for (AccountingStateEnum s : EnumSet.allOf(AccountingStateEnum.class)) {
			LOOKUP.put(s.getKey(), s);
		}
	}

	public static AccountingStateEnum get(Integer key) {
		return LOOKUP.get(key);
	}
}
