package cn.superdesk.uniorder.common.enums.accounting.customer;


import java.util.EnumSet;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description: 入账状态
 */
public enum ChargeStatusEnum {

	未冲销(1, "未冲销"),
	已冲销(2, "已冲销"),
	已撤销(3, "已撤销"),
	;

	private Integer key;
	private String  desc;

	ChargeStatusEnum(Integer key, String desc) {
		this.key = key;
		this.desc = desc;
	}

	public Integer getKey() {
		return key;
	}

	public String getDesc() {
		return desc;
	}


	public static String getDesc(Integer key) {
		for (ChargeStatusEnum c : ChargeStatusEnum.values()) {
			if (c.key.equals(key)) {
				return c.getDesc();
			}
		}
		return null;
	}

	private static final Map<Integer, ChargeStatusEnum> LOOKUP = new HashMap<>();

	static {
		for (ChargeStatusEnum s : EnumSet.allOf(ChargeStatusEnum.class)) {
			LOOKUP.put(s.getKey(), s);
		}
	}

	public static ChargeStatusEnum get(Integer key) {
		return LOOKUP.get(key);
	}
}
