package cn.superdesk.uniorder.common.enums.accounting.customer;


import java.util.EnumSet;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description: 数据类型 0订单流水/1订单商品
 */
public enum InAccountDataTypeEnum {

	订单流水(0, "订单流水"),
	订单商品(1, "订单商品"),
	;

	private Integer key;
	private String  desc;

	InAccountDataTypeEnum(Integer key, String desc) {
		this.key = key;
		this.desc = desc;
	}

	public Integer getKey() {
		return key;
	}

	public String getDesc() {
		return desc;
	}


	public static String getDesc(Integer key) {
		for (InAccountDataTypeEnum c : InAccountDataTypeEnum.values()) {
			if (c.key.equals(key)) {
				return c.getDesc();
			}
		}
		return null;
	}

	private static final Map<Integer, InAccountDataTypeEnum> LOOKUP = new HashMap<>();

	static {
		for (InAccountDataTypeEnum s : EnumSet.allOf(InAccountDataTypeEnum.class)) {
			LOOKUP.put(s.getKey(), s);
		}
	}

	public static InAccountDataTypeEnum get(Integer key) {
		return LOOKUP.get(key);
	}
}
