package cn.superdesk.uniorder.common.enums.accounting.customer;


import java.util.EnumSet;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description: 入账状态
 */
public enum InAccountStateEnum {

	未入账(0, "未入账"),
	已入账(1, "已入账"),
	撤销入账(2, "撤销入账"),
	已撤销(3, "已撤销"),
	;

	private Integer key;
	private String  desc;

	InAccountStateEnum(Integer key, String desc) {
		this.key = key;
		this.desc = desc;
	}

	public Integer getKey() {
		return key;
	}

	public String getDesc() {
		return desc;
	}


	public static String getDesc(Integer key) {
		for (InAccountStateEnum c : InAccountStateEnum.values()) {
			if (c.key.equals(key)) {
				return c.getDesc();
			}
		}
		return null;
	}

	private static final Map<Integer, InAccountStateEnum> LOOKUP = new HashMap<>();

	static {
		for (InAccountStateEnum s : EnumSet.allOf(InAccountStateEnum.class)) {
			LOOKUP.put(s.getKey(), s);
		}
	}

	public static InAccountStateEnum get(Integer key) {
		return LOOKUP.get(key);
	}
}
