package cn.superdesk.uniorder.common.enums.accounting.customer;


import java.util.EnumSet;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description: 入账类型 1-正常入账 2-撤销入账 3-冲销入账
 */
public enum InAccountTypeEnum {
	正常入账(1, "正常入账"),
	撤销入账(2, "撤销入账"),
	冲销账款(3, "冲销入账")
	;

	private Integer key;
	private String  desc;

	InAccountTypeEnum(Integer key, String desc) {
		this.key = key;
		this.desc = desc;
	}

	public Integer getKey() {
		return key;
	}

	public String getDesc() {
		return desc;
	}


	public static String getDesc(Integer key) {
		for (InAccountTypeEnum c : InAccountTypeEnum.values()) {
			if (c.key.equals(key)) {
				return c.getDesc();
			}
		}
		return null;
	}

	private static final Map<Integer, InAccountTypeEnum> LOOKUP = new HashMap<>();

	static {
		for (InAccountTypeEnum s : EnumSet.allOf(InAccountTypeEnum.class)) {
			LOOKUP.put(s.getKey(), s);
		}
	}

	public static InAccountTypeEnum get(Integer key) {
		return LOOKUP.get(key);
	}
}
