package cn.superdesk.uniorder.common.enums.accounting.customer;


import java.util.EnumSet;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description: 入账方式 0系统入账 1手工记账
 */
public enum InAccountWayEnum {
	系统入账(0, "系统入账"),
	手工记账(1, "手工记账")
	;

	private Integer key;
	private String  desc;

	InAccountWayEnum(Integer key, String desc) {
		this.key = key;
		this.desc = desc;
	}

	public Integer getKey() {
		return key;
	}

	public String getDesc() {
		return desc;
	}


	public static String getDesc(Integer key) {
		for (InAccountWayEnum c : InAccountWayEnum.values()) {
			if (c.key.equals(key)) {
				return c.getDesc();
			}
		}
		return null;
	}

	private static final Map<Integer, InAccountWayEnum> LOOKUP = new HashMap<>();

	static {
		for (InAccountWayEnum s : EnumSet.allOf(InAccountWayEnum.class)) {
			LOOKUP.put(s.getKey(), s);
		}
	}

	public static InAccountWayEnum get(Integer key) {
		return LOOKUP.get(key);
	}
}
