package cn.superdesk.uniorder.common.enums.accounting.customer;


import java.util.EnumSet;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description: 报账状态 0未报账/1报账中/2已报账/3已撤销
 */
public enum RmAccountStateEnum {

	未报账(0, "未报账"),
	报账中(1, "报账中"),
	已报账(2, "已报账"),
	已撤销(3, "已撤销"),
	;

	private Integer key;
	private String  desc;

	RmAccountStateEnum(Integer key, String desc) {
		this.key = key;
		this.desc = desc;
	}

	public Integer getKey() {
		return key;
	}

	public String getDesc() {
		return desc;
	}


	public static String getDesc(Integer key) {
		for (RmAccountStateEnum c : RmAccountStateEnum.values()) {
			if (c.key.equals(key)) {
				return c.getDesc();
			}
		}
		return null;
	}

	private static final Map<Integer, RmAccountStateEnum> LOOKUP = new HashMap<>();

	static {
		for (RmAccountStateEnum s : EnumSet.allOf(RmAccountStateEnum.class)) {
			LOOKUP.put(s.getKey(), s);
		}
	}

	public static RmAccountStateEnum get(Integer key) {
		return LOOKUP.get(key);
	}
}
