package cn.superdesk.uniorder.common.enums.common;

import java.util.EnumSet;
import java.util.HashMap;
import java.util.Map;

/**
 * 报账单积分类型枚举
 */
public enum CommonReportAccountingCreditTypeEnum {

    ZERO(0, "微信支付"),

    ONE(1, "积分支付")
    ;

    private final Integer key;
    private final String  desc;

    CommonReportAccountingCreditTypeEnum(Integer key, String desc) {
        this.key = key;
        this.desc = desc;
    }

    public Integer getKey() {
        return key;
    }

    public String getDesc() {
        return desc;
    }

    public static String getDesc(Integer key) {
        for (CommonReportAccountingCreditTypeEnum c : CommonReportAccountingCreditTypeEnum.values()) {
            if (c.key.equals(key)) {
                return c.getDesc();
            }
        }
        return null;
    }

    private static final Map<Integer, CommonReportAccountingCreditTypeEnum> LOOKUP = new HashMap<>();

    static {
        for (CommonReportAccountingCreditTypeEnum s : EnumSet.allOf(CommonReportAccountingCreditTypeEnum.class)) {
            LOOKUP.put(s.key, s);
        }
    }

    public static CommonReportAccountingCreditTypeEnum get(Integer key) {
        return LOOKUP.get(key);
    }

}
