package cn.superdesk.uniorder.common.enums.common;

import java.util.EnumSet;
import java.util.HashMap;
import java.util.Map;

/**
 * 报账单数据类型枚举
 */
public enum CommonReportAccountingDataTypeEnum {

    ZERO(0, "非微信"),

    ONE(1, "微信")
    ;

    private final Integer key;
    private final String  desc;

    CommonReportAccountingDataTypeEnum(Integer key, String desc) {
        this.key = key;
        this.desc = desc;
    }

    public Integer getKey() {
        return key;
    }

    public String getDesc() {
        return desc;
    }

    public static String getDesc(Integer key) {
        for (CommonReportAccountingDataTypeEnum c : CommonReportAccountingDataTypeEnum.values()) {
            if (c.key.equals(key)) {
                return c.getDesc();
            }
        }
        return null;
    }

    private static final Map<Integer, CommonReportAccountingDataTypeEnum> LOOKUP = new HashMap<>();

    static {
        for (CommonReportAccountingDataTypeEnum s : EnumSet.allOf(CommonReportAccountingDataTypeEnum.class)) {
            LOOKUP.put(s.key, s);
        }
    }

    public static CommonReportAccountingDataTypeEnum get(Integer key) {
        return LOOKUP.get(key);
    }

}
