package cn.superdesk.uniorder.common.enums.common;

import java.util.EnumSet;
import java.util.HashMap;
import java.util.Map;

/**
 * 报账单审批状态枚举
 */
public enum CommonReportAccountingStateEnum {

    /** 生成中 */
    ZERO(0, "生成中"),

    /** 待提交 */
    ONE(1, "待提交"),
    /** 审批中 */
    TWO(2, "审批中"),

    /** 报账完成 */
    THREE(3, "报账完成"),
    /** 处理失败 */
    FOUR(4, "处理失败"),
    /** 报账作废 */
    FIVE(5, "报账作废"),
    ;

    private final Integer key;
    private final String  desc;

    CommonReportAccountingStateEnum(Integer key, String desc) {
        this.key = key;
        this.desc = desc;
    }

    public Integer getKey() {
        return key;
    }

    public String getDesc() {
        return desc;
    }

    public static String getDesc(Integer key) {
        for (CommonReportAccountingStateEnum c : CommonReportAccountingStateEnum.values()) {
            if (c.key.equals(key)) {
                return c.getDesc();
            }
        }
        return null;
    }

    private static final Map<Integer, CommonReportAccountingStateEnum> LOOKUP = new HashMap<>();

    static {
        for (CommonReportAccountingStateEnum s : EnumSet.allOf(CommonReportAccountingStateEnum.class)) {
            LOOKUP.put(s.key, s);
        }
    }

    public static CommonReportAccountingStateEnum get(Integer key) {
        return LOOKUP.get(key);
    }

}
