package cn.superdesk.uniorder.common.security;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESKeySpec;
import java.lang.reflect.Method;
import java.security.Key;

public class DESPlus {
    private static Logger logger = LoggerFactory.getLogger(DESPlus.class);
    private static String strDefaultKey = "9ad29ccb-14a0-11ed-9680-01029i2d22ad";

    public static String encode(String dataStr) {
        try {
            byte[] s = encrypt(dataStr.getBytes(), strDefaultKey.getBytes());
            //加密后的字符串
            return encodeBase64(s);
        } catch (Exception var5) {
            logger.error("DESPlus encode error",var5);
            return null;
        }
    }

    public static String decode(String dataStr) {
        try {
            //将加密字符串转为字节数组
            byte[] bytes = decodeBase64(dataStr);
            //将加密字节数组使用密钥进行解密
            byte[] decrypt = decrypt(bytes, strDefaultKey.getBytes());
            //解密后的字节数组转为字符串得到正确的附件url
            return new String(decrypt,"UTF-8");
        } catch (Exception var4) {
            logger.error("DESPlus encode decode",var4);
            return null;
        }
    }

    public static byte[] encrypt(byte[] data, byte[] key) throws Exception {
        Key k = toKey(key);
        Cipher cipher = Cipher.getInstance("DES/ECB/PKCS5Padding");
        cipher.init(1, k);
        return cipher.doFinal(data);
    }

    public static String encodeBase64(byte[] input) {
        try {
            Class clazz = Class.forName("com.sun.org.apache.xerces.internal.impl.dv.util.Base64");
            Method mainMethod = clazz.getMethod("encode", byte[].class);
            mainMethod.setAccessible(true);
            Object retObj = mainMethod.invoke((Object)null, input);
            String string = (String)retObj;
            string = string.replace("+", "-").replace("/", "*");
            return string;
        } catch (Exception var5) {
            logger.error("DESPlus encodeBase64 decode",var5);
            return null;
        }
    }

    public static byte[] decodeBase64(String input) {
        try {
            input = input.replace("-", "+").replace("*", "/");
            Class clazz = Class.forName("com.sun.org.apache.xerces.internal.impl.dv.util.Base64");
            Method mainMethod = clazz.getMethod("decode", String.class);
            mainMethod.setAccessible(true);
            Object retObj = mainMethod.invoke((Object)null, input);
            return (byte[])((byte[])retObj);
        } catch (Exception var4) {
            logger.error("DESPlus decodeBase64 decode",var4);
            return null;
        }
    }

    private static Key toKey(byte[] key) throws Exception {
        DESKeySpec des = new DESKeySpec(key);
        SecretKeyFactory keyFactory = SecretKeyFactory.getInstance("DES");
        SecretKey secretKey = keyFactory.generateSecret(des);
        return secretKey;
    }

    public static byte[] decrypt(byte[] data, byte[] key) throws Exception {
        Key k = toKey(key);
        Cipher cipher = Cipher.getInstance("DES/ECB/PKCS5Padding");
        cipher.init(2, k);
        return cipher.doFinal(data);
    }
    public static void main(String[] args) {
        System.out.println(DESPlus.encode("https://ordertest.octlife.cn/_storage/excel/accounting/score/customer/OCTLIFE0120221211171950322_DZ20210910458812416_应收报账单202212113.xlsx"));
        System.out.println(DESPlus.decode("*Gi7k8As6btiqRs3VzMtnwlUV-dVZDQhLCsP-OFMsPyWccspFJQ2r0EyEyK5gXoZ50sYYpHQ*5GAfqevAX233Vd5lmvj-jips4k-u-Mcczrh4kQ0-K6FMRF-Cc5L7qcHvNcqbBNRnGvR-0YW9z8AGm9LYQsJtpcvtI19DGnL3SV0*LiBnnL0iQ=="));
    }
}
