package cn.superdesk.uniorder.common.utils;

import cn.superdesk.uniorder.common.enums.common.CommonServiceNoEnum;
import cn.superdesk.uniorder.common.mq.redis.service.RedisUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Calendar;
import java.util.Date;

/**
 *使用redis生成自增业务流水号工具类
 */
@Component
public class IncUtils {
    @Autowired
    public RedisUtil redisUtil;

    /**
     * 获取共享流水号
     * @return
     */
    public String getShareId(String preStr) {
        /*String today = DateUtils.dateTime();
        String key= "biz_sequence_no:"+ today;

        Long incr = redisUtil.getIncr(key, getCurrent2TodayEndMillisTime());
        if(incr == 0) {
            incr = redisUtil.getIncr(key, getCurrent2TodayEndMillisTime());//从0001开始
        }
        DecimalFormat df = new DecimalFormat("000000");//序列号
        return preStr+today + df.format(incr);*/
        return preStr+DateUtils.dateTimeNow("yyyyMMddHHmmssSSS");
    }

    public String getBillNo(String serviceNo) {
        if (CommonServiceNoEnum.企业福利_侨城汇.getServiceNo().equals(serviceNo)) {
            return getShareId("OCTLIFE01");
        }
        if (CommonServiceNoEnum.企业商城_侨城汇.getServiceNo().equals(serviceNo)) {
            return getShareId("OCTLIFE02");
        }
        throw new IllegalArgumentException("服务平台编号错误");
    }

    //现在到今天结束的毫秒数
    private Long getCurrent2TodayEndMillisTime() {
        Calendar todayEnd = Calendar.getInstance();
        // Calendar.HOUR 12小时制
        // HOUR_OF_DAY 24小时制
        todayEnd.set(Calendar.HOUR_OF_DAY, 23);
        todayEnd.set(Calendar.MINUTE, 59);
        todayEnd.set(Calendar.SECOND, 59);
        todayEnd.set(Calendar.MILLISECOND, 999);
        return todayEnd.getTimeInMillis()-new Date().getTime();
    }
}