package cn.superdesk.uniorder.dao.entity.biz;

import cn.superdesk.uniorder.common.web.domain.BaseEntity;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 报账单推送共享中心对象 accounting_push_share_data
 * 
 * @author wufujing
 * @date 2022-11-26
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class AccountingPushShareData extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** ID */
    private Long id;

    /** 对账单编号 */
    @ApiModelProperty(value = "对账单编号")
    private String accountingOrderSn;

    /** 应收/应付报账单ID */
    @ApiModelProperty(value = "应收/应付报账单ID")
    private Long accountingRpId;

    /** 账款类型 0应收款项/1应付款项 */
    @ApiModelProperty(value = "账款类型 0应收款项/1应付款项")
    private Integer accountType;

    /** 单据类型,0非微信/1微信 */
    @ApiModelProperty(value = "单据类型,0非微信/1微信")
    private Integer billType;

    /** 数据类型,0非微信/1微信 */
    @ApiModelProperty(value = "数据类型,0非微信/1微信")
    private Integer dataType;

    /** 数据头部 */
    @ApiModelProperty(value = "数据头部")
    private String headData;

    /** 数据行集合 */
    @ApiModelProperty(value = "数据行集合")
    private String rowData;

    /** 附件地址 */
    @ApiModelProperty(value = "附件地址")
    private String fileData;

    /** 推送状态,0待推送/1已推送/2推送失败 */
    @ApiModelProperty(value = "推送状态,0待推送/1已推送/2推送失败")
    private Integer pushState;

    /** 删除标志（0代表存在 2代表删除） */
    private String delFlag;

    /** 创建者id */
    @ApiModelProperty(value = "创建者id")
    private Long createId;

    /** 更新者id */
    @ApiModelProperty(value = "更新者id")
    private Long updateId;
}
