package cn.superdesk.uniorder.dao.entity.biz;

import cn.superdesk.uniorder.common.web.domain.BaseEntity;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * 应收/应付报账单对象 accounting_receivable_payable
 * 
 * @author wufujing
 * @date 2022-11-20
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class AccountingReceivablePayable extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** ID */
    private Long id;

    /** 对账单编号 */
    @ApiModelProperty(value = "对账单编号")
    private String accountingOrderSn;

    /** 账款类型 0应收款项/1应付款项/2实收款项/3实付款项 */
    @ApiModelProperty(value = "账款类型 0应收款项/1应付款项/2实收款项/3实付款项")
    private Integer  accountType;

    /** 单据流水号 */
    @ApiModelProperty(value = "单据流水号")
    private String billNo;

    /** 单据编号 */
    @ApiModelProperty(value = "单据编号")
    private String billCode;

    /** 单据类型 0应收报账单（非微信）/1应收报账单（微信）/2应付报账单/3实收报账单（非微信）/4实收报账单（微信）/5付款报账单 */
    @ApiModelProperty(value = "单据类型 0应收报账单（非微信）/1应收报账单（微信）/2应付报账单/3实收报账单（非微信）/4实收报账单（微信）/5付款报账单")
    private Integer billType;


    /** 数据类型,0非微信/1微信 */
    @ApiModelProperty(value = "数据类型,0非微信/1微信")
    private Integer dataType;
    /** 单据金额 */
    @ApiModelProperty(value = "单据金额")
    private BigDecimal billAmount;

    /** 报账状态 0生成中/1待提交/2审批中/3报账完成/4处理失败/5报账作废 */
    @ApiModelProperty(value = "报账状态 0生成中/1待提交/2审批中/3报账完成/4处理失败/5报账作废")
    private Integer accountingState;

    /** 共享单据流水号 */
    @ApiModelProperty(value = "共享单据流水号")
    private String shareBillNo;

    /** 共享单据编号 */
    @ApiModelProperty(value = "共享单据编号")
    private String shareBillCode;

    /** 共享数据状态,共享中心返回 */
    @ApiModelProperty(value = "共享数据状态,共享中心返回")
    private String shareDataState;

    /** 共享审批状态,共享中心返回 */
    @ApiModelProperty(value = "共享审批状态,共享中心返回")
    private String shareApproveState;

    /** 共享支付状态,共享中心返回 */
    @ApiModelProperty(value = "共享支付状态,共享中心返回")
    private String sharePayState;

    /** 审批时间 */
    @ApiModelProperty(value = "审批时间")
    private Date approveDate;

    /** 所属结算中心id */
    @ApiModelProperty(value = "所属结算中心id")
    private Long fromSettlementId;

    /** 报账主体结算中心id */
    @ApiModelProperty(value = "报账主体结算中心id")
    private Long settlementId;

    /** 报账主体业务方编号 */
    @ApiModelProperty(value = "报账主体业务方编号")
    private String settlementCode;

    /** 报账主体业务方名称 */
    @ApiModelProperty(value = "报账主体业务方名称")
    private String settlementName;

    /** 业务平台id */
    @ApiModelProperty(value = "业务平台id")
    private String bizPlatformId;

    /** 业务平台 */
    @ApiModelProperty(value = "业务平台")
    private String bizPlatformName;

    /** 业务员Id */
    @ApiModelProperty(value = "业务员Id")
    private Long bizUserId;

    /** 业务员 */
    @ApiModelProperty(value = "业务员")
    private String bizUserName;

    /** 推送共享消息 */
    @ApiModelProperty(value = "推送共享消息")
    private String pusContent;

    @ApiModelProperty(value = "文件标题")
    private String fileTitle;

    @ApiModelProperty(value = "文件地址")
    private String fileDetailLink;

    /** 删除标志（0代表存在 2代表删除） */
    private String delFlag;

    /** 提交者 */
    @ApiModelProperty(value = "提交者")
    private String commitBy;

    /** 提交者id */
    @ApiModelProperty(value = "提交者id")
    private Long commitId;

    /** 提交时间 */
    @ApiModelProperty(value = "提交时间")
    private Date commitTime;

    @ApiModelProperty(value = "后台备注")
    private String remark;

    @ApiModelProperty(value = "单据类型集合")
    private List<Integer> billTypeList;
    @ApiModelProperty(value = "单据类型集合")
    private List<Integer> accountingStateList;
}
