package cn.superdesk.uniorder.dao.entity.biz;

import cn.superdesk.uniorder.common.web.domain.BaseEntity;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.util.Date;

/**
 * 合同信息表(BizContract)实体类
 *
 * @author makejava
 * @since 2022-10-23 15:34:29
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class BizContract extends BaseEntity implements Serializable {
    private static final long serialVersionUID = -80253839482803307L;
    /**
     * ID
     */
    @ApiModelProperty(value = "ID")
    private Long id;
    /**
     * 数据来源,
     * 企业福利(3, "FLSC", "企业福利"),
     * 企业福利_侨城汇(31, "FLSC_QCH", "福利商城"),
     */
    @ApiModelProperty(value = "数据来源,企业福利：FLSC；福利商城：FLSC_QCH")
    private String sourceType;
    /**
     * 供应商ID
     */
    @ApiModelProperty(value = "供应商ID")
    private Long supplierId;
    /**
     * 供应商名称
     */
    @ApiModelProperty(value = "供应商名称")
    private String supplierName;
    /**
     * 合同编号
     */
    @ApiModelProperty(value = "合同编号")
    private String contractCode;
    /**
     * 合同标题
     */
    @ApiModelProperty(value = "合同标题")
    private String contractName;
    /**
     * 合同开始时间
     */
    @ApiModelProperty(value = "合同开始时间")
    private Date startDate;
    /**
     * 合同结束时间
     */
    @ApiModelProperty(value = "合同结束时间")
    private Date endDate;
    /**
     * 合同状态
     */
    @ApiModelProperty(value = "合同状态")
    private String status;
    /**
     * 是否默认（Y是 N否）
     */
    @ApiModelProperty(value = "是否默认（Y是 N否）")
    private String isDefault;
    /**
     * 删除标志（0代表存在 2代表删除）
     */
    @ApiModelProperty(value = "删除标志（0代表存在 2代表删除）")
    private String delFlag;
    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String remark;

    /**
     * 供应商编码
     */
    @ApiModelProperty(value = "供应商编码（外部供应商ID）")
    private String supplierCode;
}

