package cn.superdesk.uniorder.dao.entity.biz;

import cn.superdesk.uniorder.common.web.domain.BaseEntity;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * 应付流水汇总对象 flow_payable_summary
 * 
 * @author wufujing
 * @date 2022-11-13
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class FlowPayableSummary extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** ID */
    private Long id;

    /** 类型 0应收/1实收 */
    @ApiModelProperty(value = "类型 0应收/1实收")
    private Integer type;

    /** 共享单据流水号 */
    @ApiModelProperty(value = "共享单据流水号")
    private String shareBillNo;

    /** 共享单据编号 */
    @ApiModelProperty(value = "共享单据编号")
    private String shareBillCode;

    /** 报账状态 0未报账/1报账中/2已报账/3已撤销 */
    @ApiModelProperty(value = "报账状态 0未报账/1报账中/2已报账/3已撤销")
    private Integer rmAccountState;

    /** 报账人Id */
    @ApiModelProperty(value = "报账人Id")
    private Long rmAccountUserId;

    /** 报账人 */
    @ApiModelProperty(value = "报账人")
    private String rmAccountUserName;

    /** 共享审批时间 */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "共享审批时间")
    private Date shareApproveDate;

    /** 入账id */
    @ApiModelProperty(value = "入账id")
    private String inAccountId;

    /** 入账日期 */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "入账日期")
    private Date inAccountDate;

    /** 入账类型 1-正常入账 2-撤销入账 3-冲销账款 */
    @ApiModelProperty(value = "入账类型 1-正常入账 2-撤销入账 3-冲销账款")
    private Integer inAccountType;

    /** 入账方式 0系统入账 1手工记账 */
    @ApiModelProperty(value = "入账方式 0系统入账 1手工记账")
    private Integer inAccountWay;

    /** 所属对账单编号 */
    @ApiModelProperty(value = "所属对账单编号")
    private String accountingOrderSn;

    /** 供应商结算中心id */
    @ApiModelProperty(value = "供应商结算中心id")
    private Long cusSettlementId;

    /** 供应商业务方编号 */
    @ApiModelProperty(value = "供应商业务方编号")
    private String cusBizCode;

    /** 供应商名称 */
    @ApiModelProperty(value = "供应商名称")
    private String cusBizName;

    /** 业务平台id */
    @ApiModelProperty(value = "业务平台id")
    private String bizPlatformId;

    /** 业务平台 */
    @ApiModelProperty(value = "业务平台")
    private String bizPlatformName;

    /** 税率 */
    @ApiModelProperty(value = "税率")
    private BigDecimal operationTaxRate;

    /** 成本(不含税) */
    @ApiModelProperty(value = "成本(不含税)")
    private BigDecimal costNoTax;

    /** 税额 */
    @ApiModelProperty(value = "税额")
    private BigDecimal taxAmount;

    /** 应付账款 */
    @ApiModelProperty(value = "应付账款")
    private BigDecimal payableAmount;

    /** 删除标志（0代表存在 2代表删除） */
    private String delFlag;

    /** 备注 */
    private String remark;

    /** ID集合*/
    private List<Long> ids;
    /** 客户Id集合*/
    private List<String> settlementIdList;
    /** 入账类型 1-正常入账 2-撤销入账 3-冲销账款 */
    private List<Integer> inAccountTypeList;

    /** 原共享单据流水号 */
    private String oldShareBillNo;

    @ApiModelProperty(value = "报账状态 0未报账/1报账中/2已报账/3已撤销")
    private String rmAccountStateName;
    @ApiModelProperty(value = "入账类型 1-正常入账 2-撤销入账 3-冲销账款")
    private String inAccountTypeName;
    @ApiModelProperty(value = "入账方式 0系统入账 1手工记账")
    private String inAccountWayName;

    private  String startTime;
    private  String endTime;
}
