package cn.superdesk.uniorder.dao.entity.biz;

import cn.superdesk.uniorder.common.web.domain.BaseEntity;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * 应收流水明细对象 flow_receivable_detail
 * 
 * @author wufujing
 * @date 2022-11-13
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class FlowReceivableDetail extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** ID */
    private Long id;

    @ApiModelProperty(value = "订单流水ID")
    private Long creditId;

    /** 对账单编号 */
    @ApiModelProperty(value = "对账单编号")
    private String accountingOrderSn;

    /** 客户结算中心id */
    @ApiModelProperty(value = "客户结算中心id")
    private Long cusSettlementId;

    /** 客户业务方编号 */
    @ApiModelProperty(value = "客户业务方编号")
    private String cusBizCode;

    /** 客户名称 */
    @ApiModelProperty(value = "客户名称")
    private String cusBizName;

    /** 订单编号 */
    @ApiModelProperty(value = "订单编号")
    private String orderSn;

    /** 订单流水ID */
    @ApiModelProperty(value = "订单流水ID")
    private String creditNo;

    /** 退款订单编号 */
    @ApiModelProperty(value = "退款订单编号")
    private String refundOrderSn;

    /** 订单类型id */
    @ApiModelProperty(value = "订单类型id")
    private String serviceNo;

    /** 订单类型 */
    @ApiModelProperty(value = "订单类型")
    private String serviceNoName;

    /** 订单状态id */
    @ApiModelProperty(value = "订单状态id")
    private Integer orderState;

    /** 订单状态 */
    @ApiModelProperty(value = "订单状态")
    private String orderStateName;

    /** 下单时间 */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "下单时间")
    private Date billCreatedAt;

    /** 完成时间 */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "完成时间")
    private Date finishTime;

    /** 费用归属ID */
    @ApiModelProperty(value = "费用归属ID")
    private String costBelongId;

    /** 费用归属名称 */
    @ApiModelProperty(value = "费用归属名称")
    private String costBelongName;

    /** 商品id */
    @ApiModelProperty(value = "商品id")
    private Long goodsId;

    /** 商品名称 */
    @ApiModelProperty(value = "商品名称")
    private String goodsName;

    /** 单位 */
    @ApiModelProperty(value = "单位")
    private String goodsUnit;

    /** 商品数量 */
    @ApiModelProperty(value = "商品数量")
    private Long goodsQuantity;

    /** 销售单价 */
    @ApiModelProperty(value = "销售单价")
    private BigDecimal goodsPrice;

    /** 销售总价 */
    @ApiModelProperty(value = "销售总价")
    private BigDecimal goodsTotalAmount;

    /** 积分类型 0-微信 1-福利积分 */
    @ApiModelProperty(value = "积分类型 0-微信 1-福利积分")
    private Integer creditType;

    /** 积分类型 */
    @ApiModelProperty(value = "积分类型")
    private String creditName;

    /** 结算金额 */
    @ApiModelProperty(value = "结算金额")
    private BigDecimal balance;

    /** 税率 */
    @ApiModelProperty(value = "税率")
    private BigDecimal operationTaxRate;

    /** 平台税务分类编码 */
    @ApiModelProperty(value = "平台税务分类编码")
    private String operationTaxCode;

    /** 收入(不含税) */
    @ApiModelProperty(value = "收入(不含税)")
    private BigDecimal incomeNoTax;

    /** 税额 */
    @ApiModelProperty(value = "税额")
    private BigDecimal taxAmount;

    /** 应收账款 */
    @ApiModelProperty(value = "应收账款")
    private BigDecimal receivableAmount;

    /** 对账状态 0-未确认;1-已确认;-1-已取消; */
    @ApiModelProperty(value = "对账状态 0-未确认;1-已确认;-1-已取消;")
    private Integer accountingState;

    /** 入账状态 0未入账/1已入账/2撤销入账/3已撤销 */
    @ApiModelProperty(value = "入账状态 0未入账/1已入账/2撤销入账/3已撤销")
    private Integer inAccountState;

    /** 入账id */
    @ApiModelProperty(value = "入账id")
    private String inAccountId;

    /** 入账日期 */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "入账日期")
    private Date inAccountDate;

    /** 冲销/撤销入账id */
    @ApiModelProperty(value = "冲销/撤销入账id")
    private String chargeReceivableDayId;

    /** 回款冲销对账单编号 */
    @ApiModelProperty(value = "回款冲销对账单编号")
    private String collectionOrderSn;

    /** 冲销状态 1-未冲销 2-已冲销 3-已撤销' */
    @ApiModelProperty(value = "冲销状态 1-未冲销 2-已冲销 3-已撤销'")
    private Integer chargeStatus;

    /** 冲销人Id */
    @ApiModelProperty(value = "冲销人Id")
    private Long chargeUserId;

    /** 冲销时间 */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "冲销时间")
    private Date chargeCreatedAt;

    /** 冲销人 */
    @ApiModelProperty(value = "冲销人")
    private String chargeUserName;

    /** 删除标志（0代表存在 2代表删除） */
    private String delFlag;

    /** 备注 */
    private String remark;

    /** 客户Id集合*/
    private List<String> settlementIdList;
    @ApiModelProperty(value = "入账状态 0未入账/1已入账/2撤销入账/3已撤销")
    private List<Integer> inAccountStateList;
    //对账单编号集合
    private List<String> accountingOrderSnList;
    private  String startTime;
    private  String endTime;

    /** 回款状态*/
    @ApiModelProperty(value = "回款状态 是否回款 0-未回款;1-已回款;")
    private Integer backStatus;

    /** 对账状态 0已取消 1 已确认 */
    @ApiModelProperty(value = "对账状态 0已取消 1 已确认")
    private String accountingStateName;

    /** 入账状态 0未入账/1已入账/2撤销入账/3已撤销 */
    @ApiModelProperty(value = "入账状态 0未入账/1已入账/2撤销入账/3已撤销")
    private String inAccountStateName;

    /** 冲销状态 1-未冲销 2-已冲销 3-已撤销' */
    @ApiModelProperty(value = "冲销状态 1-未冲销 2-已冲销 3-已撤销'")
    private String chargeStatusName;
}
