package cn.superdesk.uniorder.dao.entity.organisation;

import io.swagger.annotations.ApiModelProperty;
import lombok.*;

import java.io.Serializable;
import java.util.Date;

/**
 * @Description:  
 * @Author: linjinyu 
 * @CreateDate: 2022-05-13 14:03:15 
 * @UpdateUser: linjinyu 
 * @UpdateDate: 2022-05-13 14:03:15 
 * @UpdateRemark: 修改内容 
 * @Version: 1.0 
 */ 
@NoArgsConstructor
@AllArgsConstructor
@Builder(toBuilder = true)
@Data
@ToString
public class SysEnterprise implements Serializable {
    @ApiModelProperty(value = "")
    private Long id;

    /**
     * 来源-定义:始于操作(不限于界面 内部接口 第三方接口等等);1-superdesk-uniorder;2-superdesk-app;3-superdesk-mall;4-qchqyscjc-mall;
     */
    @ApiModelProperty(value = "来源-定义:始于操作(不限于界面 内部接口 第三方接口等等);1-superdesk-uniorder;2-superdesk-app;3-superdesk-mall;4-qchqyscjc-mall;")
    private String sourceFrom;

    /**
     * 项目Id
     */
    @ApiModelProperty(value = "项目Id")
    private Long organizationId;

    /**
     * 同步企业ID
     */
    @ApiModelProperty(value = "同步企业ID")
    private Long enterpriseId;

    /**
     * 企业编码
     */
    @ApiModelProperty(value = "企业编码")
    private String enterpriseNo;

    /**
     * 企业名称
     */
    @ApiModelProperty(value = "企业名称")
    private String enterpriseName;

    /**
     * 同步时间
     */
    @ApiModelProperty(value = "同步时间")
    private Date syncTime;

    /**
     * 其他字段1 占坑用
     */
    @ApiModelProperty(value = "其他字段1 占坑用")
    private String otherField1;

    /**
     * 其他字段2 占坑用
     */
    @ApiModelProperty(value = "其他字段2 占坑用")
    private String otherField2;

    /**
     * 其他字段3 占坑用
     */
    @ApiModelProperty(value = "其他字段3 占坑用")
    private String otherField3;

    @ApiModelProperty(value = "")
    private Integer enabled;

    /**
     * 软删除:0-未删除;1-已删除
     */
    @ApiModelProperty(value = "软删除:0-未删除;1-已删除")
    private Integer deleted;

    /**
     * 是否有订单:0-默认;1-有的;2-没有;
     */
    @ApiModelProperty(value = "是否有订单:0-默认;1-有的;2-没有;")
    private Integer isHasOrder;

    /**
     * 是否有开票设置
     */
    @ApiModelProperty(value = "是否有开票设置")
    private Integer isHasExtInvoice;

    /**
     * 服务编码-定义:始于订单流上标志的服务编码及从订单流衍生出来的及相关数据的来源标识-引用enum CommonServiceEnum
     */
    @ApiModelProperty(value = "服务编码-定义:始于订单流上标志的服务编码及从订单流衍生出来的及相关数据的来源标识-引用enum CommonServiceEnum")
    private String serviceNo;

    @ApiModelProperty("数据湖客户uuid")
    private String customerUuid;
    @ApiModelProperty("数据湖客户名称")
    private String customerName;
    @ApiModelProperty("源系统客户id")
    private String customerId;
    @ApiModelProperty("客户编码(单位性质为境内组织：统⼀社会信⽤代码；" +
            "单位性质为其他或境外组织⽆需传输；" +
            "单位性质为境内个⼈：身份证号； " +
            "单位性质为境外个⼈：身份证号或护照号码)")
    private String clientCode;
    @ApiModelProperty("数据湖-单位性质，1:境内组织、2:境内个⼈、3:其他或境外组织、4:境外个⼈")
    private String propertyCode;
    @ApiModelProperty("更新人ID")
    private Long updateUserId;
    @ApiModelProperty("更新人姓名")
    private String updateUserName;
    @ApiModelProperty("更新时间")
    private Date updateTime;

    private static final long serialVersionUID = 1L;
}