package cn.superdesk.uniorder.dao.mapper.biz;

import cn.superdesk.uniorder.dao.entity.biz.AccountingPushShareData;

import java.util.List;

/**
 * 报账单推送共享中心Mapper接口
 * 
 * @author wufujing
 * @date 2022-11-26
 */
public interface AccountingPushShareDataMapper 
{
    /**
     * 查询报账单推送共享中心
     * 
     * @param id 报账单推送共享中心主键
     * @return 报账单推送共享中心
     */
    public AccountingPushShareData selectAccountingPushShareDataById(Long id);

    /**
     * 查询报账单推送共享中心列表
     * 
     * @param accountingPushShareData 报账单推送共享中心
     * @return 报账单推送共享中心集合
     */
    public List<AccountingPushShareData> selectAccountingPushShareDataList(AccountingPushShareData accountingPushShareData);

    /**
     * 新增报账单推送共享中心
     * 
     * @param accountingPushShareData 报账单推送共享中心
     * @return 结果
     */
    public int insertAccountingPushShareData(AccountingPushShareData accountingPushShareData);

    /**
     * 修改报账单推送共享中心
     * 
     * @param accountingPushShareData 报账单推送共享中心
     * @return 结果
     */
    public int updateAccountingPushShareData(AccountingPushShareData accountingPushShareData);

    /**
     * 删除报账单推送共享中心
     * 
     * @param id 报账单推送共享中心主键
     * @return 结果
     */
    public int deleteAccountingPushShareDataById(Long id);

    /**
     * 批量删除报账单推送共享中心
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteAccountingPushShareDataByIds(Long[] ids);
}
