package cn.superdesk.uniorder.dao.mapper.biz;

import cn.superdesk.uniorder.dao.entity.biz.AccountingReceivablePayable;
import org.apache.ibatis.annotations.Param;

import java.math.BigDecimal;
import java.util.List;

/**
 * 应收/应付报账单Mapper接口
 *
 * @author wufujing
 * @date 2022-11-20
 */
public interface AccountingReceivablePayableMapper {
    /**
     * 查询应收/应付报账单
     *
     * @param id 应收/应付报账单主键
     * @return 应收/应付报账单
     */
    public AccountingReceivablePayable selectAccountingReceivablePayableById(Long id);

    /**
     * 查询应收/应付报账单列表
     *
     * @param accountingReceivablePayable 应收/应付报账单
     * @return 应收/应付报账单集合
     */
    public List<AccountingReceivablePayable> selectAccountingReceivablePayableList(AccountingReceivablePayable accountingReceivablePayable);

    /**
     * 新增应收/应付报账单
     *
     * @param accountingReceivablePayable 应收/应付报账单
     * @return 结果
     */
    public int insertAccountingReceivablePayable(AccountingReceivablePayable accountingReceivablePayable);

    /**
     * 修改应收/应付报账单
     *
     * @param accountingReceivablePayable 应收/应付报账单
     * @return 结果
     */
    public int updateAccountingReceivablePayable(AccountingReceivablePayable accountingReceivablePayable);

    /**
     * 删除应收/应付报账单
     *
     * @param id 应收/应付报账单主键
     * @return 结果
     */
    public int deleteAccountingReceivablePayableById(Long id);

    /**
     * 批量删除应收/应付报账单
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteAccountingReceivablePayableByIds(Long[] ids);

    /**
     * 查询报账单
     *
     * @param billNo 单据流水号
     * @return 报账单
     */
    AccountingReceivablePayable selectAccountingReceivablePayableByBillNo(String billNo);

    int changeStatus(@Param("id") Long id, @Param("newStatus") Integer newStatus, @Param("oldStatus") Integer oldStatus);

    AccountingReceivablePayable selectApprovePaymentLimit1(@Param("accountingOrderSn") String accountingOrderSn);

    BigDecimal sumApprovePaymentAmount(@Param("accountingOrderSn") String accountingOrderSn, @Param("billType") Integer billType);
}
