package cn.superdesk.uniorder.dao.mapper.biz;

import cn.superdesk.uniorder.dao.entity.biz.BizContract;

import java.util.List;


/**
 * 合同信息Mapper接口
 *
 * @date 2022-10-23
 */
public interface BizContractMapper {
    /**
     * 查询合同信息
     *
     * @param id 合同信息主键
     * @return 合同信息
     */
    public BizContract selectBizContractById(Long id);

    /**
     * 查询合同信息列表
     *
     * @param bizContract 合同信息
     * @return 合同信息集合
     */
    public List<BizContract> selectBizContractList(BizContract bizContract);

    /**
     * 新增合同信息
     *
     * @param bizContract 合同信息
     * @return 结果
     */
    public int insertBizContract(BizContract bizContract);

    /**
     * 修改合同信息
     *
     * @param bizContract 合同信息
     * @return 结果
     */
    public int updateBizContract(BizContract bizContract);

    /**
     * 修改合同信息默认为N
     *
     * @return 结果
     */
    public int updateAllDefaultNo();

    /**
     * 删除合同信息
     *
     * @param id 合同信息主键
     * @return 结果
     */
    public int deleteBizContractById(Long id);

    /**
     * 批量删除合同信息
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteBizContractByIds(Long[] ids);
}
