package cn.superdesk.uniorder.dao.mapper.biz;

import cn.superdesk.uniorder.dao.entity.biz.FlowPayableDetail;

import java.util.List;

/**
 * 应付流水明细Mapper接口
 * 
 * @author wufuing
 * @date 2022-11-13
 */
public interface FlowPayableDetailMapper 
{
    /**
     * 查询应付流水明细
     * 
     * @param id 应付流水明细主键
     * @return 应付流水明细
     */
    public FlowPayableDetail selectFlowPayableDetailById(Long id);

    /**
     * 查询应付流水明细列表
     * 
     * @param flowPayableDetail 应付流水明细
     * @return 应付流水明细集合
     */
    public List<FlowPayableDetail> selectFlowPayableDetailList(FlowPayableDetail flowPayableDetail);

    /**
     * 查询对账单，可生成的应收流水记录
     *
     * @param flowPayableDetail
     * @return 应付流水明细集合
     */
    public List<FlowPayableDetail> getPayableDetailList(FlowPayableDetail flowPayableDetail);

    /**
     * 查询对账单，应付运费明细查询
     *
     * @param flowPayableDetail
     * @return 应付流水明细集合
     */
    public List<FlowPayableDetail> getPayableFreightDetail(FlowPayableDetail flowPayableDetail);

    /**
     * 查询对账单，已经生成的应付运费明细查询
     *
     * @param flowPayableDetail
     * @return 应付流水明细集合
     */
    public List<FlowPayableDetail> getHasFreightDetail(FlowPayableDetail flowPayableDetail);

    /**
     * 新增应付流水明细
     * 
     * @param flowPayableDetail 应付流水明细
     * @return 结果
     */
    public int insertFlowPayableDetail(FlowPayableDetail flowPayableDetail);

    /**
     * 新增应付流水明细
     *
     * @param flowPayableDetails 应付流水明细
     * @return 结果
     */
    public int insertBatch(List<FlowPayableDetail> flowPayableDetails);

    /**
     * 修改应付流水明细
     * 
     * @param flowPayableDetail 应付流水明细
     * @return 结果
     */
    public int updateFlowPayableDetail(FlowPayableDetail flowPayableDetail);

    /**
     * 删除应付流水明细
     * 
     * @param id 应付流水明细主键
     * @return 结果
     */
    public int deleteFlowPayableDetailById(Long id);

    /**
     * 批量删除应付流水明细
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteFlowPayableDetailByIds(Long[] ids);
}
