package cn.superdesk.uniorder.dao.mapper.biz;

import cn.superdesk.uniorder.dao.entity.biz.FlowPayableSummary;

import java.util.List;

/**
 * 应付流水汇总Mapper接口
 * 
 * @author wufuing
 * @date 2022-11-13
 */
public interface FlowPayableSummaryMapper 
{
    /**
     * 查询应付流水汇总
     * 
     * @param id 应付流水汇总主键
     * @return 应付流水汇总
     */
    public FlowPayableSummary selectFlowPayableSummaryById(Long id);

    /**
     * 查询应付流水汇总列表
     * 
     * @param flowPayableSummary 应付流水汇总
     * @return 应付流水汇总集合
     */
    public List<FlowPayableSummary> selectFlowPayableSummaryList(FlowPayableSummary flowPayableSummary);

    /**
     * 新增应付流水汇总
     * 
     * @param flowPayableSummary 应付流水汇总
     * @return 结果
     */
    public int insertFlowPayableSummary(FlowPayableSummary flowPayableSummary);

    /**
     * 修改应付流水汇总
     * 
     * @param flowPayableSummary 应付流水汇总
     * @return 结果
     */
    public int updateFlowPayableSummary(FlowPayableSummary flowPayableSummary);

    /**
     * 修改应付流水汇总
     *
     * @param flowPayableSummary 应付流水汇总
     * @return 结果
     */
    public int updateFlowPayableSummaryOrderSn(FlowPayableSummary flowPayableSummary);

    /**
     * 删除应付流水汇总
     * 
     * @param id 应付流水汇总主键
     * @return 结果
     */
    public int deleteFlowPayableSummaryById(Long id);

    /**
     * 批量删除应付流水汇总
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteFlowPayableSummaryByIds(Long[] ids);
}
