package cn.superdesk.uniorder.dao.mapper.biz;

import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.biz.FlowReceivableDetail;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.List;

/**
 * 应收流水明细Mapper接口
 * 
 * @author wufuing
 * @date 2022-11-13
 */
public interface FlowReceivableDetailMapper 
{
    /**
     * 查询应收流水明细
     * 
     * @param id 应收流水明细主键
     * @return 应收流水明细
     */
    public FlowReceivableDetail selectFlowReceivableDetailById(Long id);

    /**
     * 查询应收流水明细列表
     * 
     * @param flowReceivableDetail 应收流水明细
     * @return 应收流水明细集合
     */
    public List<FlowReceivableDetail> selectFlowReceivableDetailList(FlowReceivableDetail flowReceivableDetail);

    /**
     * 查询订单流水-对应的应收流水明细数据
     *
     * @param flowReceivableDetail
     * @return 应收流水明细集合
     */
    public List<FlowReceivableDetail> getReceivableDetailList(FlowReceivableDetail flowReceivableDetail);

    /**
     * 新增应收流水明细
     * 
     * @param flowReceivableDetail 应收流水明细
     * @return 结果
     */
    public int insertFlowReceivableDetail(FlowReceivableDetail flowReceivableDetail);

    /**
     * 新增应收流水明细
     *
     * @param flowReceivableDetails 应收流水明细
     * @return 结果
     */
    public int insertBatch(List<FlowReceivableDetail> flowReceivableDetails);

    /**
     * 修改应收流水明细
     * 
     * @param flowReceivableDetail 应收流水明细
     * @return 结果
     */
    public int updateFlowReceivableDetail(FlowReceivableDetail flowReceivableDetail);

    /**
     * 删除应收流水明细
     * 
     * @param id 应收流水明细主键
     * @return 结果
     */
    public int deleteFlowReceivableDetailById(Long id);

    /**
     * 批量删除应收流水明细
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteFlowReceivableDetailByIds(Long[] ids);

    int chargeReceivableDetail(@Param("accountingOrderSn") String accountingOrderSn, @Param("loginSysUser") LoginSysUser loginSysUser, @Param("date") Date date);
}
