package cn.superdesk.uniorder.dao.mapper.biz;

import cn.superdesk.uniorder.dao.entity.biz.FlowReceivableSummary;

import java.util.List;

/**
 * 应收流水汇总Mapper接口
 * 
 * @author wufuing
 * @date 2022-11-13
 */
public interface FlowReceivableSummaryMapper 
{
    /**
     * 查询应收流水汇总
     * 
     * @param id 应收流水汇总主键
     * @return 应收流水汇总
     */
    public FlowReceivableSummary selectFlowReceivableSummaryById(Long id);

    /**
     * 查询应收流水汇总列表
     * 
     * @param flowReceivableSummary 应收流水汇总
     * @return 应收流水汇总集合
     */
    public List<FlowReceivableSummary> selectFlowReceivableSummaryList(FlowReceivableSummary flowReceivableSummary);

    /**
     * 新增应收流水汇总
     * 
     * @param flowReceivableSummary 应收流水汇总
     * @return 结果
     */
    public int insertFlowReceivableSummary(FlowReceivableSummary flowReceivableSummary);

    /**
     * 修改应收流水汇总
     * 
     * @param flowReceivableSummary 应收流水汇总
     * @return 结果
     */
    public int updateFlowReceivableSummary(FlowReceivableSummary flowReceivableSummary);

    /**
     * 修改应收流水汇总
     *
     * @param flowReceivableSummary 应收流水汇总
     * @return 结果
     */
    public int updateFlowReceivableSummaryOrderSn(FlowReceivableSummary flowReceivableSummary);

    /**
     * 删除应收流水汇总
     * 
     * @param id 应收流水汇总主键
     * @return 结果
     */
    public int deleteFlowReceivableSummaryById(Long id);

    /**
     * 批量删除应收流水汇总
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteFlowReceivableSummaryByIds(Long[] ids);
}
