package cn.superdesk.uniorder.dto.param.invoice.customer.reportaccounting;

import cn.superdesk.uniorder.dto.param.sharecenter.ActualAccountingAttachment;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.List;

/**
 * 新增实收报账单
 */
@NoArgsConstructor
@AllArgsConstructor
@SuperBuilder(toBuilder = true)
@Data
public class ActualPayableReportAccountingCreateParam implements Serializable {

    @ApiModelProperty("单据类型,0应收报账单（非微信）/1应收报账单（微信）/2应付报账单/3实收报账单（非微信）/4实收报账单（微信）/5付款报账单")
    private Integer billType;

    /****************************************** 所属对账单 start ******************************************/
    @ApiModelProperty("所属对账单Id-供应商结算2.0")
    private Long accountingOrderId;

    @ApiModelProperty("所属对账单编号-供应商结算2.0")
    private String accountingOrderSn;

    @ApiModelProperty("单据流水号")
    private String billNo;

    /** 备注 */
    @ApiModelProperty("备注")
    @NotBlank
    private String remark;

    /**
     * 收款账号
     */
    @ApiModelProperty("收款账号")
    private String bankAccountNum;
    /**
     * 开户行信息
     */
    @ApiModelProperty("开户行信息")
    private String bankUnitedCode;

    /**
     * 收款账户名
     */
    @ApiModelProperty("收款账户名")
    private String bankAccountName;

    /**
     * 付款用途
     */
    @ApiModelProperty("付款用途")
    private String paymentMemo;

    /**
     * 支付金额
     */
    @ApiModelProperty("支付金额")
    private BigDecimal paymentAmount;
    /**
     * 供应商编码
     */
    @ApiModelProperty("供应商编码")
    @NotBlank
    private String customerNum;
    /**
     * 供应商名称
     */
    @ApiModelProperty("供应商名称")
    @NotBlank
    private String customerName;
    /**
     * 合同编号
     */
    @ApiModelProperty("合同编号")
    @NotBlank
    private String contractNum;
    /**
     * 合同名称
     */
    @ApiModelProperty("合同名称")
    @NotBlank
    private String contractName;

    /** 附件信息 */
    @ApiModelProperty("附件信息")
    private List<ActualAccountingAttachment> attachments;

}
