package cn.superdesk.uniorder.dto.param.invoice.customer.reportaccounting;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.math.BigDecimal;

/**
 * 新增实收报账单
 */
@NoArgsConstructor
@AllArgsConstructor
@SuperBuilder(toBuilder = true)
@Data
public class ActualReportAccountingCreateParam implements Serializable {

    @ApiModelProperty("单据类型,0应收报账单（非微信）/1应收报账单（微信）/2应付报账单/3实收报账单（非微信）/4实收报账单（微信）/5付款报账单")
    private Integer billType;

    /****************************************** 所属对账单 start ******************************************/
    @ApiModelProperty("所属对账单Id-供应商结算2.0")
    private Long accountingOrderId;

    @ApiModelProperty("所属对账单编号-供应商结算2.0")
    private String accountingOrderSn;

    @ApiModelProperty("单据流水号")
    private String billNo;

    /** 备注 */
    @ApiModelProperty("备注")
    @NotBlank
    private String remark;

    /**
     * 收款金额
     */
    @ApiModelProperty("收款金额")
    private BigDecimal amount = BigDecimal.ZERO;
    /**
     * 交易日期
     */
    @ApiModelProperty("交易日期")
    @NotNull
    private String signDate;
    /**
     * 流水号
     */
    @ApiModelProperty("流水号")
    private String recordId = "";
    /**
     * 流水备注
     */
    @ApiModelProperty("流水备注")
    private String boeAbstract = "";

}
