package cn.superdesk.uniorder.dto.param.organisation;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.ToString;
import lombok.experimental.SuperBuilder;

import java.io.Serializable;
import java.util.Date;

/**
 * UnifiedSupplierCriteria AnCriteria
 *
 * @author linjinyu
 * @email linjinyu@avic-s.com
 * @date 2021-05-14 12:51:18
 */
@NoArgsConstructor
@AllArgsConstructor
@SuperBuilder(toBuilder = true)
@Data
@ToString
public class UnifiedSupplierParam implements Serializable {

    @ApiModelProperty(value = "")
    private Long id;

    @ApiModelProperty(value = "")
    private Long   saleId;
    @ApiModelProperty(value = "")
    private String saleName;

    /**************************************** mark by linjinyu at 20220516 v2.3 start ****************************************/

    @ApiModelProperty("订单类型-订单来源-引用enum CommonServiceNoEnum")
    private String serviceNo;
    @ApiModelProperty("操作来源-引用enum CommonSourceFromEnum")
    private String sourceFrom;

    /**************************************** mark by linjinyu at 20220516 v2.3   end ****************************************/

    @ApiModelProperty(value = "")
    private String contactsName;
    @ApiModelProperty(value = "")
    private String contactsPhone;
    @ApiModelProperty(value = "")
    private String contactsAdd;

    @ApiModelProperty(value = "")
    private Date createTime;
    @ApiModelProperty(value = "")
    private Long createUserId;

    @ApiModelProperty(value = "")
    private Date updateTime;
    @ApiModelProperty(value = "")
    private Long updateUserId;

    /**
     * 是否启用:1-启用;0-禁用;
     */
    @ApiModelProperty(value = "是否启用:1-启用;0-禁用;")
    private Integer enabled;

    /**
     * 软删除:0-未删除;1-已删除
     */
    @ApiModelProperty(value = "软删除:0-未删除;1-已删除")
    private Integer deleted;

    /**
     * 供应商编码
     */
    @ApiModelProperty(value = "供应商编码")
    private String supplierCode;
    /**
     * 数据胡-供应商ID
     */
    @ApiModelProperty(value = "数据胡-供应商ID")
    private String sourceId;
    /**
     * 数据胡-供应商名称
     */
    @ApiModelProperty(value = "数据胡-供应商名称")
    private String sourceName;

    /**
     * 开户银行
     */
    @ApiModelProperty(value = "开户银行")
    private String bankName;
    /**
     * 收款账号
     */
    @ApiModelProperty(value = "收款账号")
    private String bankAccount;
    /**
     * 一般纳税,逗号分割
     */
    @ApiModelProperty(value = "一般纳税,逗号分割")
    private String taxCommon;
    /**
     * 简易计税,逗号分割
     */
    @ApiModelProperty(value = "简易计税,逗号分割")
    private String taxSimple;
    /**
     * 小规模纳税,逗号分割
     */
    @ApiModelProperty(value = "小规模纳税,逗号分割")
    private String taxSmall;
}