package cn.superdesk.uniorder.dto.param.organisation;

import cn.superdesk.uniorder.common.pagination.AnBaseQueryCriteria;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.ToString;
import lombok.experimental.SuperBuilder;

import java.util.List;

/**
 * @Description: Java类作用描述
 * @Author: linjinyu
 * @CreateDate: 2021/5/14 下午1:51
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021/5/14 下午1:51
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@AllArgsConstructor
@NoArgsConstructor
@SuperBuilder(toBuilder = true)
@Data
@ToString
public class UnifiedSupplierQueryCriteria extends AnBaseQueryCriteria {

    @ApiModelProperty("sale_id = #{saleId}")
    private Long   saleId;
    @ApiModelProperty("sale_name like CONCAT('%',#{saleName},'%'")
    private String saleName;

    @ApiModelProperty("enabled = #{enabled}")
    private Integer enabled = 1;

    @Deprecated
    @ApiModelProperty("福利商城=FLSC_QCH,企业商城=QYSC_QCH")
    private String serviceNo;

    /**************************************** mark by linjinyu at 20220516 v2.3 start ****************************************/

    @ApiModelProperty("引用Enum CommonSourceFromEnum-支持多选")
    private List<String> sourceFromsSelected;
    @Deprecated
    @ApiModelProperty("引用Enum CommonServiceNoEnum-支持多选")
    private List<String> serviceNosSelected;

    /**************************************** mark by linjinyu at 20220516 v2.3   end ****************************************/

    /**
     * 供应商编码
     */
    @ApiModelProperty(value = "供应商编码")
    private String supplierCode;
    /**
     * 数据胡-供应商ID
     */
    @ApiModelProperty(value = "数据胡-供应商ID")
    private String sourceId;
    /**
     * 数据胡-供应商名称
     */
    @ApiModelProperty(value = "数据胡-供应商名称")
    private String sourceName;
}
