package cn.superdesk.uniorder.dto.param.sharecenter;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.List;

/**
 * 实际账单请求
 */
@Data
public class ActualPayableReportAccounting implements Serializable {

    /**
     * 业务人ID，取 sysBusinessUserVo.id
     */
    @ApiModelProperty("业务人ID")
    private Long bizUserId;

    @ApiModelProperty("绑定操作用户Id")
    private Long bindOperationUserid;
    @ApiModelProperty("绑定操作用户")
    private String bindOperationUser;

    /** 报账单头信息 不要改名，数据库存的json */
    @ApiModelProperty("报账单头信息")
    private ActualPayableReportAccountingHeader boeHeader;

    /** 收入明细：apportion 行信息 */
    @ApiModelProperty("明细：apportion 行信息")
    private ActualPayableReportAccountingLineForApportion actualPayableReportAccountingLineForApportion;

    /** 收款明细：zfsBoePayments  行信息 */
    @ApiModelProperty("收款明细：zfsBoePayments  行信息")
    private ActualPayableReportAccountingLineForZfs actualReceivedReportAccountingLineForZfs;

    /** 子信息 不要改名，数据库存的json */
    @ApiModelProperty("子信息")
    private ActualPayableReportAccountingHeaderChild boeHeaderChild;

    /** 附件信息 */
    @ApiModelProperty("附件信息")
    private List<ActualAccountingAttachment> attachments;
}
