package cn.superdesk.uniorder.dto.param.sharecenter;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.AccessLevel;
import lombok.Data;
import lombok.Setter;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;
import java.math.BigDecimal;

/**
 * 行类型  apportion 数据
 */
@Data
public class ActualPayableReportAccountingLineForApportion implements Serializable {

    public ActualPayableReportAccountingLineForApportion() {
        this.lineType = "apportion";
    }

    /**
     * 行类型  apportion
     */
    @ApiModelProperty("行类型  apportion")
    @NotBlank
    @Setter(AccessLevel.NONE)
    private String lineType;

    /** 责任部门编码 */
    @ApiModelProperty("责任部门编码")
    private String expenseDeptId;
    /** 责任部门名称 */
    @ApiModelProperty("责任部门名称")
    private String expenseDeptName;
    /** 成本中心编码 */
    @ApiModelProperty("成本中心编码")
    private String costcenterId;
    /** 成本中心名称 */
    @ApiModelProperty("成本中心名称")
    private String costcenterName;
    /** 金额 */
    @ApiModelProperty("金额")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private BigDecimal amount;
    /** 业务小类 */
    @ApiModelProperty("业务小类")
    private String operationSubTypeCode;
    /** 服务及商品编码 */
    @ApiModelProperty("服务及商品编码")
    private String serviceType;
    /** 业态类别编码 */
    @ApiModelProperty("业态类别编码")
    private String formatType;
    /** 客户编码 */
    @ApiModelProperty("客户编码")
    private String supplierCode;
    /** 客户名称 */
    @ApiModelProperty("客户名称")
    private String supplierName;

}
