package cn.superdesk.uniorder.dto.param.sharecenter;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.AccessLevel;
import lombok.Data;
import lombok.Setter;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;
import java.math.BigDecimal;

/**
 * 行类型  zfsBoePayments 数据
 */
@Data
public class ActualPayableReportAccountingLineForZfs implements Serializable {

    public ActualPayableReportAccountingLineForZfs() {
        this.lineType = "zfsBoePayments";
    }

    /**
     * 行类型  zfsBoePayments
     */
    @ApiModelProperty("行类型  zfsBoePayments")
    @NotBlank
    @Setter(AccessLevel.NONE)
    private String lineType;

    /**
     * 收款账号
     */
    @ApiModelProperty("收款账号")
    private String bankAccountNum;
    /**
     * 开户行信息
     */
    @ApiModelProperty("开户行信息")
    private String bankUnitedCode;

    /**
     * 收款账户名
     */
    @ApiModelProperty("收款账户名")
    private String bankAccountName;

    /**
     * 支付方式 枚举值：CTYHZZ/银行转账
     */
    @ApiModelProperty("支付方式 枚举值：CTYHZZ/银行转账")
    private String paymentModeCode;

    /**
     * 付款用途
     */
    @ApiModelProperty("付款用途")
    private String paymentMemo;

    /**
     * 支付金额
     */
    @ApiModelProperty("支付金额")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private BigDecimal paymentAmount;

}
