package cn.superdesk.uniorder.dto.param.sharecenter;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.List;

/**
 * 实际账单请求
 */
@Data
public class ActualReceivedReportAccounting implements Serializable {

    /**
     * 业务人ID，取 sysBusinessUserVo.id
     */
    @ApiModelProperty("业务人ID")
    private Long bizUserId;

    @ApiModelProperty("绑定操作用户Id")
    private Long bindOperationUserid;
    @ApiModelProperty("绑定操作用户")
    private String bindOperationUser;

    /** 报账单头信息 */
    @ApiModelProperty("报账单头信息")
    private ActualReceivedReportAccountingHeader header;

    /** 核销/费用明细：cost 行信息 */
    @ApiModelProperty("核销/费用明细：cost 行信息，非微信实收报账单才有")
    private ActualReceivedReportAccountingLineForCost actualReceivedReportAccountingLineForCost;

    /** 收入明细：income 行信息 */
    @ApiModelProperty("收入明细：income 行信息")
    private ActualReceivedReportAccountingLineForIncome actualReceivedReportAccountingLineForIncome;

    /** 收款明细：zfsBoeBankStatements  行信息 */
    @ApiModelProperty("收款明细：zfsBoeBankStatements  行信息")
    private ActualReceivedReportAccountingLineForZfs actualReceivedReportAccountingLineForZfs;

    /** 附件信息 */
    @ApiModelProperty("附件信息")
    private List<ActualAccountingAttachment> attachments;
}
