package cn.superdesk.uniorder.dto.param.sharecenter;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;

/**
 * 实际账单请求
 */
@Data
public class ActualReceivedReportAccountingHeader implements Serializable {

    /**
     * 数据来源 104
     */
    @ApiModelProperty("数据来源 104")
    @NotBlank
    private String dataSource;
    /**
     * 外系统唯一标识（单据流水号）
     */
    @ApiModelProperty("外系统唯一标识（单据流水号）")
    @NotBlank
    private String batchNo;
    /**
     * 集团编码 默认 OCT
     */
    @ApiModelProperty("集团编码 默认 OCT")
    @NotBlank
    private String groupCode;
    /**
     * 单据日期 yyyy-MM-dd
     */
    @ApiModelProperty("单据日期 yyyy-MM-dd")
    @NotBlank
    private String boeDate;
    /**
     * 业态类别
     */
    @ApiModelProperty("业态类别")
    @NotBlank
    private String businessCategory;
    /**
     * 纸质附件
     */
    @ApiModelProperty("纸质附件")
    @NotBlank
    private String paperAccessories;
    /**
     * 业务类型编码
     */
    @ApiModelProperty("业务类型编码")
    @NotBlank
    private String operationTypeCode;
    /**
     * 业务人工号
     */
    @ApiModelProperty("业务人工号")
    @NotBlank
    private String employeeId;
    /**
     * 业务人名称
     */
    @ApiModelProperty("业务人名称")
    private String employeeName = "";
    /**
     * 业务人岗位编码
     */
    @ApiModelProperty("业务人岗位编码")
    @NotBlank
    private String employeePostId;
    /**
     * 业务人岗位名称
     */
    @ApiModelProperty("业务人岗位名称")
    private String employeePostName = "";
    /**
     * 业务人部门编码
     */
    @ApiModelProperty("业务人部门编码")
    @NotBlank
    private String employeeDepartmentId;
    /**
     * 业务人部门名称
     */
    @ApiModelProperty("业务人部门名称")
    private String employeeDepartmentName = "";
    /**
     * 业务单位编码
     */
    @ApiModelProperty("业务单位编码")
    @NotBlank
    private String companyNum;
    /**
     * 业务单位名称
     */
    @ApiModelProperty("业务单位名称")
    @NotBlank
    private String companyName;
    /** 备注 */
    @ApiModelProperty("备注")
    @NotBlank
    private String remark;

}
