package cn.superdesk.uniorder.dto.param.sharecenter;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.AccessLevel;
import lombok.Data;
import lombok.Setter;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.RoundingMode;

/**
 * 行类型  zfsBoeBankStatements 数据 收款明细
 */
@Data
public class ActualReceivedReportAccountingLineForZfs implements Serializable {

    public ActualReceivedReportAccountingLineForZfs() {
        this.lineType = "zfsBoeBankStatements";
        this.sourceCurrency = "CNY";
        this.rateValue = BigDecimal.ONE.setScale(2, RoundingMode.UP);
    }

    /**
     * 行类型  zfsBoeBankStatements
     */
    @ApiModelProperty("行类型  zfsBoeBankStatements")
    @NotBlank
    @Setter(AccessLevel.NONE)
    private String lineType;
    /**
     * 收款形式
     */
    @ApiModelProperty("收款形式")
    private String receiveType = "";
    /**
     * 流水号
     */
    @ApiModelProperty("流水号")
    private String recordId = "";
    /**
     * 收款账号
     */
    @ApiModelProperty("收款账号")
    private String receiptBankAccNum = "";
    /**
     * 收款币种
     */
    @ApiModelProperty("收款币种")
    @Setter(AccessLevel.NONE)
    private String sourceCurrency;
    /**
     * 汇率
     */
    @ApiModelProperty("汇率")
    @Setter(AccessLevel.NONE)
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private BigDecimal rateValue;
    /**
     * 本位币金额
     */
    @ApiModelProperty("本位币金额")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private BigDecimal currencyAmount = BigDecimal.ZERO;
    /**
     * 原币金额
     */
    @ApiModelProperty("原币金额")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private BigDecimal amount = BigDecimal.ZERO;
    /**
     * 交易日期
     */
    @ApiModelProperty("交易日期")
    @NotNull
    private String signDate;
    /**
     * 流水备注
     */
    @ApiModelProperty("流水备注")
    private String boeAbstract = "";
}
