package cn.superdesk.uniorder.dto.param.system;


import cn.superdesk.uniorder.common.pagination.AnBaseQueryCriteria;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
* 实收报账单
*
* @author zhu 270897222@qq.com
* @since 1.0.0 2022-10-28
*/
@Data
@ApiModel(value = "实收报账单分页model")
public class SysAccountRealityReceivableQueryCriteria  extends AnBaseQueryCriteria {
	private static final long serialVersionUID = 1L;

	private Long id;

	@ApiModelProperty(value = "业态类别")
	private String businessCategory;

	@ApiModelProperty(value = "业务类型编码")
	private String operationTypeCode;

	@ApiModelProperty(value = "业务单位编码")
	private String companyNum;

	@ApiModelProperty(value = "业务单位名称")
	private String companyName;

	@ApiModelProperty(value = "业务小类-核销明细小类")
	private String operationSubTypeCode;

	@ApiModelProperty(value = "业务小类-收入明细小类")
	private String incomeDetailTypeCode;


	@ApiModelProperty(value = "成本中心编码")
	private String costcenterId;

	@ApiModelProperty(value = "成本中心名称")
	private String costcenterName;

	@ApiModelProperty(value = "收款账号")
	private String receiptBankAccNum;

	@ApiModelProperty(value = "微信流水号")
	private String wechatTradeNo;

	@ApiModelProperty(value = "业态类别编码")
	private String formatType;

	@ApiModelProperty(value = "企业商城-服务及商品编码")
	private String serviceType;

	@ApiModelProperty(value = "福利商城-服务及商品编码")
	private String welfareShopServiceType;

	@ApiModelProperty(value = "数据完整性")
	private Integer dataIsComplete;

	@ApiModelProperty(value = "项目编码")
	private String projectNum;

	@ApiModelProperty(value = "项目名称")
	private String projectName;

}
