package cn.superdesk.uniorder.dto.vo._statistics;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @author xc
 * @description 应收报表Page Vo
 * @date 2022/4/4 17:54
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class ReceivableStatisticsPageVo implements Serializable {

    private String seq;//序号

    @ApiModelProperty("客户Id")
    private  String  cusSettlementId;  //客户Id
    @ApiModelProperty("客户编码")
    private  String  settlementId;  //客户编码
    @ApiModelProperty("客户名称")
    private  String settlementName; //客户名称

    @ApiModelProperty("税率")
    private BigDecimal operationTaxRate; //税率
    @ApiModelProperty("税率/100")
    private BigDecimal formatOperationTaxRate; //税率/100

    @ApiModelProperty("收入")
    private BigDecimal incomeNoTax; //收入
    @ApiModelProperty("税额")
    private BigDecimal taxAmount;//税额
    @ApiModelProperty("应收账款")
    private BigDecimal receivableAmount;//应收账款
    private BigDecimal totalAmount;

}
