package cn.superdesk.uniorder.dto.vo.accounting.score.customer;

import cn.superdesk.uniorder.dto.vo.order.CreditTypeItemVo;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * @Description: 积分结算2.0-对账单-创建报账单详情
 */
@NoArgsConstructor
@AllArgsConstructor
@Builder(toBuilder = true)
@Data
public class CreateRmAccountingVo implements Serializable {

	@ApiModelProperty("对账单详情")
	private CreateRmAccountingDetailVo  accounting;
	@ApiModelProperty("应收报账单集合")
	private List<AccountingReceivablePayableVo> receivableVoList;
	@ApiModelProperty("应付报账单集合")
	private List<AccountingReceivablePayableVo> payableVoList;

	@Data
	public static class CreateRmAccountingDetailVo implements Serializable{
		private Long id;

		@ApiModelProperty("积分批次")
		private String batchs;

		@ApiModelProperty("业务平台编码")
		private String  serviceNo;
		@ApiModelProperty("业务平台名称")
		private String  serviceNoName;

		//	积分类型
		@ApiModelProperty("积分类型id(如果是微信支付,显示0)")
		private String                 creditType;
		@ApiModelProperty("积分类型")
		private String                 creditName;

		private String                 creditTypeStruct;
		private List<CreditTypeItemVo> creditTypeList;

		@ApiModelProperty("对账单编号")
		private String accountingOrderSn;
		@ApiModelProperty("企业Id")
		private Long   enterpriseId;
		@ApiModelProperty("企业名称")
		private String enterpriseName;

		@ApiModelProperty("对账单-订单金额")
		private String statisticsTotalAmount;
		@ApiModelProperty("对账单-结算金额")
		private String accountingAmount;
		@ApiModelProperty("对账单-微信金额")
		private String unAccountingAmount;
		@ApiModelProperty("对账单状态:0-未确认;1-已确认;-1-已取消;")
		private Integer accountingStatus;

		@ApiModelProperty("应收报账单数量")
		private Integer receivableCount;
		@ApiModelProperty("应付报账单数量")
		private Integer payableCount;

		@ApiModelProperty("总应收账款(非微信)")
		private String receivableAmount;
		@ApiModelProperty("总应收账款(微信)")
		private String wxReceivableAmount;
		@ApiModelProperty("总应付账款")
		private String payableAmount;

		@ApiModelProperty("报账完成-应收账款(非微信)")
		private String finalReceivableAmount;
		@ApiModelProperty("报账完成-应收账款(微信)")
		private String finalWxReceivableAmount;
		@ApiModelProperty("报账完成-应付账款")
		private String finalPayableAmount;

		@ApiModelProperty("未报账-应收账款(非微信)")
		private String unReceivableAmount;
		@ApiModelProperty("未报账-应收账款(微信)")
		private String unWxReceivableAmount;
		@ApiModelProperty("未报账-应付账款")
		private String unPayableAmount;

		@ApiModelProperty("对账时间")
		private Date createTime;

		@ApiModelProperty("对账单状态名称")
		private String accountingStatusName;
	}
}
