package cn.superdesk.uniorder.dto.vo.invoice.reportaccounting;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.List;

@Data
public class ActualReceivedReportAccountingVO implements Serializable {

    /****************************************** 对账单信息 start ******************************************/
    @ApiModelProperty("所属对账单Id-供应商结算2.0")
    private Long accountingOrderId;

    @ApiModelProperty("所属对账单编号-供应商结算2.0")
    private String accountingOrderSn;

    @ApiModelProperty("企业ID")
    private Long enterpriseId;
    @ApiModelProperty("企业名称")
    private String enterpriseName;

    @ApiModelProperty("业务平台编号")
    private String serviceNo;

    @ApiModelProperty("业务平台名称")
    private String serviceNoName;

    @ApiModelProperty("对账(结算)单 状态:0-未确认;1-已确认;-1-已取消;")
    private Integer accountingStatus;

    @ApiModelProperty("对账(结算)单 状态名称:0-未确认;1-已确认;-1-已取消;")
    private String accountingStatusName;

    @ApiModelProperty("订单金额: #公式= ∑(销售单价*商品数量)")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private BigDecimal invoiceApplyAmount;

    @ApiModelProperty("待实收微信金额")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private BigDecimal weChatAmount;

    @ApiModelProperty("结算金额 待实收单非微信应收总金额")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private BigDecimal settlementAmount;

    /****************************************** 实收报账信息 start ******************************************/
    @ApiModelProperty("实收为实收账款（微信），取该对账单下报账状态为“报账完成”所有实收报账单（微信）的金额总和，若该对账单的实收报账状态（微信）为“无需回款”，显示为“/”（前端处理）)")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private BigDecimal actualAmountWeChat;

    @ApiModelProperty("实收为实收账款（非微信），该对账单下报账状态为“报账完成”所有实收报账单（数据类型非微信）的金额总和，若该对账单的实收报账状态（非微信）为“无需回款”，显示为“/”（前端处理）")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private BigDecimal actualAmountNonWeChat;

    @ApiModelProperty(value = "实收报账状态(非微信) 0未回款/1部分回款/2全部回款/3无需回款")
    private Integer receivedAccountStatus;
    @ApiModelProperty(value = "实付报账状态(微信) 0未回款/1部分回款/2全部回款/3无需回款")
    private Integer wxReceivedAccountStatus;
    @ApiModelProperty("温馨提示，固定配置")
    private String tip;

    @ApiModelProperty("报账单列表")
    private List<ReportAccountingDetailVO> details;

}
