package cn.superdesk.uniorder.dto.vo.invoice.reportaccounting;

import cn.superdesk.uniorder.dto.param.sharecenter.ActualReceivedReportAccounting;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

@Data
public class ActualReportAccountingPreCheckVO implements Serializable {

    /****************************************** 所属对账单 start ******************************************/

    @ApiModelProperty("所属对账单Id-供应商结算2.0")
    private Long   accountingOrderId;
    @ApiModelProperty("所属对账单编号-供应商结算2.0")
    private String accountingOrderSn;

    @ApiModelProperty("企业ID")
    private Long enterpriseId;
    /**
     * 企业编码
     */
    @ApiModelProperty(value = "企业编码")
    private String enterpriseNo;
    @ApiModelProperty("企业名称")
    private String enterpriseName;

    @ApiModelProperty("业务平台编号")
    private String serviceNo;
    @ApiModelProperty("业务平台名称")
    private String serviceNoName;

    @ApiModelProperty("账款总金额（若为实收微信单，则为对账单微信账款总金额；若为若为实收非微信单，则为对账单非微信账款总金额）")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private BigDecimal accountingAmount;

    /****************************************** 实收报账信息 start ******************************************/
    @ApiModelProperty(value = "报账完成金额（若为实收微信单，则为微信实收报账金额；若为若为实收非微信单，则为非微信实收报账金额）")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private BigDecimal receivedAmount;

    @ApiModelProperty("单据类型 0应收报账单（非微信）/1应收报账单（微信）/2应付报账单/3实收报账单（非微信）/4实收报账单（微信）/5付款报账单")
    private Integer billType;

    @ApiModelProperty(value = "温馨提示")
    private String tip;

    @ApiModelProperty("报账单信息")
    private ActualReceivedReportAccounting actualReceivedReportAccounting;

}
