package cn.superdesk.uniorder.dto.vo.invoice.reportaccounting;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 实收报账单详细信息
 */
@Data
public class ReportAccountingDetailVO implements Serializable {
    @ApiModelProperty("报账单ID")
    private Long id;

    @ApiModelProperty("对账单编号")
    private String accountingOrderSn;
    @ApiModelProperty("单据类型 0应收报账单（非微信）/1应收报账单（微信）/2应付报账单/3实收报账单（非微信）/4实收报账单（微信）/5付款报账单")
    private Integer billType;
    @ApiModelProperty("单据类型名称")
    private String billTypeName;
    /** 报账主体业务方编号 */
    @ApiModelProperty(value = "报账主体业务方编号 供应商/企业编号")
    private String settlementCode;

    /** 报账主体业务方名称 */
    @ApiModelProperty(value = "报账主体业务方名称 供应商/企业名称")
    private String settlementName;
    /** 单据金额 */
    @ApiModelProperty(value = "单据金额")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private BigDecimal billAmount;

    @ApiModelProperty("业务平台编号")
    private String serviceNo;

    @ApiModelProperty("业务平台名称")
    private String serviceNoName;
    @ApiModelProperty("单据流水号")
    private String billNo;

    @ApiModelProperty("单据编号")
    private String billCode;
    @ApiModelProperty("数据类型,0非微信/1微信")
    private Integer dataType;
    @ApiModelProperty("数据类型名称")
    private String dataTypeName;
    @ApiModelProperty("报账状态")
    private Integer accountingState;
    @ApiModelProperty("报账状态 名称")
    private String accountingStateName;
    @ApiModelProperty("审批时间")
    private Date approveDate;
    @ApiModelProperty("推送共享消息内容，保存共享中心返回的msg")
    private String pusContent;
    @ApiModelProperty("后台备注")
    private String remark;
    @ApiModelProperty("创建者")
    private String createBy;
    @ApiModelProperty("创建者id")
    private Long createId;
    @ApiModelProperty("创建时间")
    private Date createTime;
    @ApiModelProperty("更新者")
    private String updateBy;
    @ApiModelProperty("更新者id")
    private Long updateId;
    @ApiModelProperty("更新时间")
    private Date updateTime;

}
