package cn.superdesk.uniorder.dto.vo.invoice.supplier.paymentReport;

import cn.superdesk.uniorder.dto.param.sharecenter.ActualPayableReportAccounting;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

@Data
public class AddPaymentReportEchoVo implements Serializable {

    /****************************************** 所属对账单 start ******************************************/

    @ApiModelProperty("所属对账单Id-供应商结算2.0")
    private Long   accountingOrderId;
    @ApiModelProperty("所属对账单编号-供应商结算2.0")
    private String accountingOrderSn;

    @ApiModelProperty("供应商记录ID")
    private Long id;

    @ApiModelProperty("供应商ID")
    private Long saleId;
    @ApiModelProperty("供应商名称")
    private String saleName;
    @ApiModelProperty("统一社会编码")
    private String supplierCode;

    @ApiModelProperty("业务平台编号")
    private String serviceNo;
    @ApiModelProperty("业务平台名称")
    private String serviceNoName;

    @ApiModelProperty("待付总金额")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private BigDecimal accountingAmount;

    @ApiModelProperty(value = "实付金额")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private BigDecimal paidAmount;

    @ApiModelProperty("单据类型 0应收报账单（非微信）/1应收报账单（微信）/2应付报账单/3实收报账单（非微信）/4实收报账单（微信）/5付款报账单")
    private Integer billType;

    @ApiModelProperty(value = "温馨提示")
    private String tip;

    @ApiModelProperty(value = "报账单信息")
    private ActualPayableReportAccounting actualPayableReportAccounting;

}
