package cn.superdesk.uniorder.dto.vo.invoice.supplier.paymentReport;

import cn.superdesk.uniorder.dto.vo.invoice.reportaccounting.ReportAccountingDetailVO;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.List;

@Data
public class PaymentReportEchoVo implements Serializable {
    @ApiModelProperty(value = "供应商名称:取当前所选该对账单的供应商名称内容")
    private String saleName;

    @ApiModelProperty(value = "对账单编号:取当前所选该对账单的对账单编号内容")
    private String accountingOrderSn;

    @ApiModelProperty(value = "业务平台:取该对账单所属的“service_no”字段服务编码对照的服务名称内容")
    private String serviceNo;

    @ApiModelProperty("业务平台名称")
    private String serviceNoName;

    @ApiModelProperty(value = "结算金额-取该对账单的结算金额")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private BigDecimal accountingOrderAmountWithFreight;

    @ApiModelProperty(value = "账单周期开始时间-取该对账单的账单周期")
    private String billingCycleStartTime;

    @ApiModelProperty(value = "账单周期结束时间-取该对账单的账单周期")
    private String billingCycleEndTime;

    //实付账款的“报账完成金额”：取该对账单下报账状态为“报账完成”所有付款报账单的金额总和
    @ApiModelProperty(value = "实付账款-报账完成金额")
    private String reportCompletedAmount;

    //实付账款的“账款总金额”：取该对账单的结算金额；
    @ApiModelProperty(value = "实付账款-账款总金额")
    private String totalAccountsAmount;

    @ApiModelProperty(value = "付款报账状态")
    private Integer paymentReportStatus;

    @ApiModelProperty(value = "付款报账状名称")
    private String paymentReportStatusName;

    @ApiModelProperty("报账单列表")
    private List<ReportAccountingDetailVO> details;
}
