package cn.superdesk.uniorder.dto.vo.organisation;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.util.List;

//数据库供应商、企业信息
@NoArgsConstructor
@AllArgsConstructor
@Builder(toBuilder = true)
@Data
public class SupplierDetailVo implements Serializable {
    private static final long serialVersionUID = 1L;

    @ApiModelProperty("法务供应商id")
    private String  uuid;
    @ApiModelProperty("供应商名称")
    private String  fullName;
    @ApiModelProperty("供应商简称")
    private String  nameAbbreviation;
    @ApiModelProperty("法务供应商编码")
    private String  supplierCode;

    @ApiModelProperty("供应商账户列表")
    List<BankInfoFw> bankInfoFw;

    @Data
    public static class BankInfoFw {
        @ApiModelProperty("银行账户（收款账号）")
        private String bankAccount;
        @ApiModelProperty("开户行")
        private String bankOfDeposit;
        @ApiModelProperty("账户名")
        private String accountName;
        @ApiModelProperty("联行号")
        private String number;
        @ApiModelProperty("账户分类")
        private String accountType;
    }
}
