package cn.superdesk.uniorder.dubbo.facade.biz;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.base.PageParamRequest;
import cn.superdesk.uniorder.dao.entity.biz.BizContract;
import cn.superdesk.uniorder.dto.param.biz.BizContractParam;

import java.util.List;

/**
 * 合同信息Service接口
 * 
 * @author ruoyi
 * @date 2022-10-23
 */
public interface IBizContractService 
{
    /**
     * 查询合同信息
     * 
     * @param id 合同信息主键
     * @return 合同信息
     */
    public BizContract selectBizContractById(Long id);

    /**
     * 合同列表
     * @param bizContract 分页参数
     * @return List
     */
    public R<List<BizContract>> getListPage(BizContractParam bizContract);

    /**
     * 查询合同信息列表
     *
     * @param bizContract 合同信息
     * @return 合同信息集合
     */
    public List<BizContract> selectBizContractList(BizContract bizContract);

    /**
     * 新增合同信息
     * 
     * @param bizContract 合同信息
     * @return 结果
     */
    public int insertBizContract(BizContract bizContract);

    /**
     * 修改合同信息
     * 
     * @param bizContract 合同信息
     * @return 结果
     */
    public int updateBizContract(BizContract bizContract);

    /**
     * 修改合同信息默认为N
     *
     * @return 结果
     */
    public int updateAllDefaultNo();

    /**
     * 批量删除合同信息
     * 
     * @param ids 需要删除的合同信息主键集合
     * @return 结果
     */
    public int deleteBizContractByIds(Long[] ids);

    /**
     * 删除合同信息信息
     * 
     * @param id 合同信息主键
     * @return 结果
     */
    public int deleteBizContractById(Long id);
}
