package cn.superdesk.uniorder.dubbo.facade.invoice.customer;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dto.param.invoice.customer.reportaccounting.*;
import cn.superdesk.uniorder.dto.vo.invoice.reportaccounting.ActualReceivedReportAccountingDetailVO;
import cn.superdesk.uniorder.dto.vo.invoice.reportaccounting.ActualReceivedReportAccountingVO;
import cn.superdesk.uniorder.dto.vo.invoice.reportaccounting.ActualReportAccountingPreCheckVO;

/**
 * @Description: 报账单
 * @Author: zhufeng
 * @CreateDate: 7/1/20 2:44 PM
 * @Version: 1.0
 */
public interface DubboReportAccountingService {
    /**
     * opt 修复账单回款状态
     *
     */
    void repairInvoiceStatus(InvoiceStatusRepair repair, LoginSysUser loginSysUser);

    /**
     * opt 积分结算-发票管理-实收报账详情（包括对账单列表）
     *
     */
    ActualReceivedReportAccountingVO getActualReceivedAccountingVO(ReportAccountingQueryParam param, LoginSysUser loginSysUser);

    /**
     * 积分结算-发票管理-实收报账单详情（包括对账单列表详情）
     */
    ActualReceivedReportAccountingDetailVO getActualReceivedReportAccountingDetail(ActualReportAccountingQueryParam param, LoginSysUser loginSysUser);

    /**
     * opt 积分结算-发票管理-实收报账详情（包括对账单列表详情）
     */
    R<ActualReportAccountingPreCheckVO> preCheckByCreateActualReceivedAccounting(ActualReportAccountingPreCheckParam param, LoginSysUser loginSysUser);

    /**
     * opt 积分结算-发票管理-实收报账单新增
     *
     * @return
     */
    R<?> createActualReceivedAccounting(ActualReportAccountingCreateParam param, LoginSysUser loginSysUser);

    /**
     * opt 积分结算-发票管理-实收报账单信息修改
     *
     */
    void modifyActualReceivedAccounting(ActualReportAccountingModifyParam param, LoginSysUser loginSysUser);

    /**
     * opt 积分结算-发票管理-报账状态查询(结果确认)
     *
     */
    R<?> confirmActualReceivedAccounting(ActualReportAccountingConfirmParam param, LoginSysUser loginSysUser);

}
