package cn.superdesk.uniorder.dubbo.provider.invoice.supplier;

import cn.superdesk.uniorder.common.exception.UnifiedOrderRuntimeException;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.rest.response.ResponseResultOuterUtils;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dto.param.invoice.customer.reportaccounting.ActualPayableReportAccountingCreateParam;
import cn.superdesk.uniorder.dto.param.invoice.customer.reportaccounting.ActualReportAccountingConfirmParam;
import cn.superdesk.uniorder.dto.param.invoice.customer.reportaccounting.InvoiceStatusRepair;
import cn.superdesk.uniorder.dto.vo.invoice.reportaccounting.ActualPayableReportAccountingDetailVO;
import cn.superdesk.uniorder.dto.vo.invoice.supplier.paymentReport.AddPaymentReportEchoVo;
import cn.superdesk.uniorder.dto.vo.invoice.supplier.paymentReport.PaymentReportEchoVo;
import cn.superdesk.uniorder.dubbo.facade.invoice.supplier.DubboAccountingReportPaymenService;
import cn.superdesk.uniorder.service.invoice.supplier.AccountingReportPaymenService;
import com.alibaba.dubbo.config.annotation.Service;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * zhuy 2022-11-27
 */
@Slf4j
@Service(version = "1.0.0", retries = -1, timeout = 10000)
public class DubboAccountingReportPaymentServiceImpl implements DubboAccountingReportPaymenService {
    @Autowired
    private AccountingReportPaymenService accountingReportPaymenService;

    @Override
    public PaymentReportEchoVo getPaymentReportEcho(String accountingOrderId) {
        return accountingReportPaymenService.getPaymentReportEcho(accountingOrderId);
    }

    @Override
    public R<AddPaymentReportEchoVo> getAddPaymentReportEcho(Long accountingOrderId, LoginSysUser loginSysUser) throws UnifiedOrderRuntimeException {
        try {
            return accountingReportPaymenService.getAddPaymentReportEcho(accountingOrderId, loginSysUser);
        } catch (UnifiedOrderRuntimeException ue) {
            return ResponseResultOuterUtils.createErrorResult(String.valueOf(ue.getCode()), ue.getMessage());
        }
    }

    @Override
    public ActualPayableReportAccountingDetailVO getPaymentReportDetail(Long id) {
        return accountingReportPaymenService.getPaymentReportDetail(id);
    }

    @Override
    public R<?> confirmPaymentReportList(ActualReportAccountingConfirmParam param, LoginSysUser loginSysUser) {
        return accountingReportPaymenService.confirmPaymentReportList(param, loginSysUser);
    }

    @Override
    public R<?> addPaymentReport(ActualPayableReportAccountingCreateParam param, LoginSysUser loginSysUser) {
        try {
            return accountingReportPaymenService.addPaymentReport(param, loginSysUser);
        } catch (UnifiedOrderRuntimeException ue) {
            return ResponseResultOuterUtils.createErrorResult(String.valueOf(ue.getCode()), ue.getMessage());
        }
    }

    @Override
    public void billPaymentStatusRepair(InvoiceStatusRepair repair, LoginSysUser loginSysUser) {
        accountingReportPaymenService.billPaymentStatusRepair(repair, loginSysUser);
    }
}
