package cn.superdesk.uniorder.dubbo.provider.organisation;

import cn.superdesk.uniorder.common.numerical.AnBeanUtils;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.organisation.SysBusinessUser;
import cn.superdesk.uniorder.dto.param.organisation.SysBusinessUserParam;
import cn.superdesk.uniorder.dto.param.organisation.SysBusinessUserQueryCriteria;
import cn.superdesk.uniorder.dto.param.organisation.SysOperationUserQueryCriteria;
import cn.superdesk.uniorder.dto.vo.sys.SysBusinessUserVo;
import cn.superdesk.uniorder.dto.vo.sys.SysOperationUserVo;
import cn.superdesk.uniorder.dubbo.facade.organisation.DubboSysBusinessUserService;
import cn.superdesk.uniorder.service.organisation.SysBusinessUserService;
import com.alibaba.dubbo.config.annotation.Service;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;

@Service(version = "1.0.0", retries = -1, timeout = 10000)
public class DubboSysBusinessUserServiceImpl implements DubboSysBusinessUserService {
    @Autowired
    private SysBusinessUserService sysBusinessUserService;

    @Override
    public int insert(SysBusinessUserParam param) {
        SysBusinessUser sysBusinessUser = AnBeanUtils.copy(param, SysBusinessUser.class);
        return sysBusinessUserService.insert(sysBusinessUser);
    }

    @Override
    public void deleteByIds(List<Long> ids) {
        sysBusinessUserService.deleteByIds(ids);
    }

    @Override
    public int updateByPrimaryKeySelective(SysBusinessUserParam param) {
        SysBusinessUser sysBusinessUser = AnBeanUtils.copy(param, SysBusinessUser.class);
        return sysBusinessUserService.updateByPrimaryKeySelective(sysBusinessUser);
    }

    @Override
    public SysBusinessUserVo findById(Long id) {
        return sysBusinessUserService.findById(id);
    }

    @Override
    public R<List<SysBusinessUserVo>> findByPaging(SysBusinessUserQueryCriteria queryCriteria) {
        return sysBusinessUserService.findByPaging(queryCriteria);
    }

    @Override
    public R<List<SysOperationUserVo>> queryOperationUserList(SysOperationUserQueryCriteria queryCriteria) {
        return sysBusinessUserService.queryOperationUserList(queryCriteria);
    }
}
