package cn.superdesk.uniorder.dubbo.provider.sys;

import cn.superdesk.uniorder.common.numerical.AnBeanUtils;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.sys.SysAccountConfig;
import cn.superdesk.uniorder.dto.param.system.SysAccountConfigParam;
import cn.superdesk.uniorder.dto.param.system.SysAccountConfigQueryCriteria;
import cn.superdesk.uniorder.dto.vo.sys.SysAccountConfigVo;
import cn.superdesk.uniorder.dubbo.facade.sys.DubboSysAccountConfigService;
import cn.superdesk.uniorder.service.sys.SysAccountConfigService;
import com.alibaba.dubbo.config.annotation.Service;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;

/**
 * 共享参数配置
 *
 * @author zhu 270897222@qq.com
 * @since 1.0.0 2022-10-28
 */
@Service(version = "1.0.0", retries = -1, timeout = 10000)
public class DbubboSysAccountConfigServiceImpl implements DubboSysAccountConfigService {

    @Autowired
    private SysAccountConfigService sysAccountConfigService;

    @Override
    public int insert(SysAccountConfigParam param) {
        SysAccountConfig sysAccountConfig = AnBeanUtils.copy(param, SysAccountConfig.class);
        return sysAccountConfigService.insert(sysAccountConfig);
    }

    @Override
    public void deleteByIds(List<Long> ids) {
        sysAccountConfigService.deleteByIds(ids);
    }

    @Override
    public int updateByPrimaryKeySelective(SysAccountConfigParam param) {
        SysAccountConfig sysAccountConfig = AnBeanUtils.copy(param, SysAccountConfig.class);
        return sysAccountConfigService.updateByPrimaryKeySelective(sysAccountConfig);
    }

    @Override
    public SysAccountConfigVo findById(Long id) {
        return sysAccountConfigService.findById(id);
    }

    @Override
    public R<List<SysAccountConfigVo>> findByPaging(SysAccountConfigQueryCriteria queryCriteria) {
        return sysAccountConfigService.findByPaging(queryCriteria);
    }

}
