package cn.superdesk.uniorder.dubbo.provider.sys;

import cn.superdesk.uniorder.common.numerical.AnBeanUtils;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.sys.SysAccountPayable;
import cn.superdesk.uniorder.dto.param.system.SysAccountPayableParam;
import cn.superdesk.uniorder.dto.param.system.SysAccountPayableQueryCriteria;
import cn.superdesk.uniorder.dto.vo.sys.SysAccountPayableVo;
import cn.superdesk.uniorder.dubbo.facade.sys.DubboSysAccountPayableService;
import cn.superdesk.uniorder.service.sys.SysAccountPayableService;
import com.alibaba.dubbo.config.annotation.Service;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;

/**
 * 应付款报账单
 *
 * @author zhu 270897222@qq.com
 * @since 1.0.0 2022-10-28
 */
@Service(version = "1.0.0", retries = -1, timeout = 10000)
public class DbubboSysAccountPayableServiceImpl  implements DubboSysAccountPayableService {


    @Autowired
    private SysAccountPayableService sysAccountPayableService;

    @Override
    public int insert(SysAccountPayableParam param) {
        SysAccountPayable sysAccountPayable = AnBeanUtils.copy(param, SysAccountPayable.class);
        return sysAccountPayableService.insert(sysAccountPayable);
    }

    @Override
    public void deleteByIds(List<Long> ids) {
        sysAccountPayableService.deleteByIds(ids);
    }

    @Override
    public int updateByPrimaryKeySelective(SysAccountPayableParam param) {
        SysAccountPayable sysAccountPayable = AnBeanUtils.copy(param, SysAccountPayable.class);
        return sysAccountPayableService.updateByPrimaryKeySelective(sysAccountPayable);
    }

    @Override
    public SysAccountPayableVo findById(Long id) {
        return sysAccountPayableService.findById(id);
    }

    @Override
    public R<List<SysAccountPayableVo>> findByPaging(SysAccountPayableQueryCriteria queryCriteria) {
        return sysAccountPayableService.findByPaging(queryCriteria);
    }

}
