package cn.superdesk.uniorder.dubbo.provider.sys;

import cn.superdesk.uniorder.common.numerical.AnBeanUtils;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.sys.SysAccountRealityPayable;
import cn.superdesk.uniorder.dto.param.system.SysAccountRealityPayableParam;
import cn.superdesk.uniorder.dto.param.system.SysAccountRealityPayableQueryCriteria;
import cn.superdesk.uniorder.dto.vo.sys.SysAccountRealityPayableVo;
import cn.superdesk.uniorder.dubbo.facade.sys.DubboSysAccountRealityPayableService;
import cn.superdesk.uniorder.service.sys.SysAccountRealityPayableService;
import com.alibaba.dubbo.config.annotation.Service;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;

/**
 * 实付款报账单
 *
 * @author 阿沐 270897222@qq.com
 * @since 1.0.0 2022-10-28
 */
@Service(version = "1.0.0", retries = -1, timeout = 10000)
public class DbubboSysAccountRealityPayableServiceImpl  implements DubboSysAccountRealityPayableService {

    @Autowired
    private SysAccountRealityPayableService sysAccountRealityPayableService;

    @Override
    public int insert(SysAccountRealityPayableParam param) {
        SysAccountRealityPayable sysAccountRealityPayable = AnBeanUtils.copy(param, SysAccountRealityPayable.class);
        return sysAccountRealityPayableService.insert(sysAccountRealityPayable);
    }

    @Override
    public void deleteByIds(List<Long> ids) {
        sysAccountRealityPayableService.deleteByIds(ids);
    }

    @Override
    public int updateByPrimaryKeySelective(SysAccountRealityPayableParam param) {
        SysAccountRealityPayable sysAccountRealityPayable = AnBeanUtils.copy(param, SysAccountRealityPayable.class);
        return sysAccountRealityPayableService.updateByPrimaryKeySelective(sysAccountRealityPayable);
    }

    @Override
    public SysAccountRealityPayableVo findById(Long id) {
        return sysAccountRealityPayableService.findById(id);
    }

    @Override
    public R<List<SysAccountRealityPayableVo>> findByPaging(SysAccountRealityPayableQueryCriteria queryCriteria) {
        return sysAccountRealityPayableService.findByPaging(queryCriteria);
    }
}
