package cn.superdesk.uniorder.dubbo.provider.sys;


import cn.superdesk.uniorder.common.numerical.AnBeanUtils;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.sys.SysAccountRealityReceivable;
import cn.superdesk.uniorder.dto.param.system.SysAccountRealityReceivableParam;
import cn.superdesk.uniorder.dto.param.system.SysAccountRealityReceivableQueryCriteria;
import cn.superdesk.uniorder.dto.vo.sys.SysAccountRealityReceivableVo;
import cn.superdesk.uniorder.dubbo.facade.sys.DubboSysAccountRealityReceivableService;
import cn.superdesk.uniorder.service.sys.SysAccountRealityReceivableService;
import com.alibaba.dubbo.config.annotation.Service;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;

/**
 * 实收报账单
 *
 * @author zhu 270897222@qq.com
 * @since 1.0.0 2022-10-28
 */
@Service(version = "1.0.0", retries = -1, timeout = 10000)
public class DbubboSysAccountRealityReceivableServiceImpl  implements DubboSysAccountRealityReceivableService {

    @Autowired
    private SysAccountRealityReceivableService sysAccountRealityReceivableService;

    @Override
    public int insert(SysAccountRealityReceivableParam param) {
        SysAccountRealityReceivable sysAccountRealityReceivable = AnBeanUtils.copy(param, SysAccountRealityReceivable.class);
        return sysAccountRealityReceivableService.insert(sysAccountRealityReceivable);
    }

    @Override
    public void deleteByIds(List<Long> ids) {
        sysAccountRealityReceivableService.deleteByIds(ids);
    }

    @Override
    public int updateByPrimaryKeySelective(SysAccountRealityReceivableParam param) {
        SysAccountRealityReceivable sysAccountRealityReceivable = AnBeanUtils.copy(param, SysAccountRealityReceivable.class);
        return sysAccountRealityReceivableService.updateByPrimaryKeySelective(sysAccountRealityReceivable);
    }

    @Override
    public SysAccountRealityReceivableVo findById(Long id) {
        return sysAccountRealityReceivableService.findById(id);
    }

    @Override
    public R<List<SysAccountRealityReceivableVo>> findByPaging(SysAccountRealityReceivableQueryCriteria queryCriteria) {
        return sysAccountRealityReceivableService.findByPaging(queryCriteria);
    }
}
