package cn.superdesk.uniorder.dubbo.provider.sys;

import cn.superdesk.uniorder.common.numerical.AnBeanUtils;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.sys.SysAccountReceivable;
import cn.superdesk.uniorder.dto.param.system.SysAccountReceivableParam;
import cn.superdesk.uniorder.dto.param.system.SysAccountReceivableQueryCriteria;
import cn.superdesk.uniorder.dto.vo.sys.SysAccountReceivableVo;
import cn.superdesk.uniorder.dubbo.facade.sys.DubboSysAccountReceivableService;
import cn.superdesk.uniorder.service.sys.SysAccountReceivableService;
import com.alibaba.dubbo.config.annotation.Service;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;

/**
 * 共享参数配置
 *
 * @author zhu 270897222@qq.com
 * @since 1.0.0 2022-10-28
 */
@Service(version = "1.0.0", retries = -1, timeout = 10000)
public class DbubboSysAccountReceivableServicelmpl implements DubboSysAccountReceivableService {

    @Autowired
    private SysAccountReceivableService sysAccountReceivableService;

    @Override
    public int insert(SysAccountReceivableParam param) {
        SysAccountReceivable sysAccountReceivable = AnBeanUtils.copy(param, SysAccountReceivable.class);
        return sysAccountReceivableService.insert(sysAccountReceivable);
    }

    @Override
    public void deleteByIds(List<Long> ids) {
        sysAccountReceivableService.deleteByIds(ids);
    }

    @Override
    public int updateByPrimaryKeySelective(SysAccountReceivableParam param) {
        SysAccountReceivable sysAccountReceivable = AnBeanUtils.copy(param, SysAccountReceivable.class);
        return sysAccountReceivableService.updateByPrimaryKeySelective(sysAccountReceivable);
    }

    @Override
    public SysAccountReceivableVo findById(Long id) {
        return sysAccountReceivableService.findById(id);
    }

    @Override
    public R<List<SysAccountReceivableVo>> findByPaging(SysAccountReceivableQueryCriteria queryCriteria) {
        return sysAccountReceivableService.findByPaging(queryCriteria);
    }

}
