package cn.superdesk.uniorder.dubbo.provider.thirdpart.jd;

import cn.hutool.json.JSONUtil;
import cn.superdesk.uniorder.common.numerical.AnBeanUtils;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.sys.notify.SysNotify;
import cn.superdesk.uniorder.dao.entity.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReport;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportParam;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.*;
import cn.superdesk.uniorder.dubbo.facade.sys.notify.DubboSysNotifyService;
import cn.superdesk.uniorder.dubbo.facade.thirdpart.jd.DubboAccountingUnifiedSupplierOrderJdCheckUpReportService;
import cn.superdesk.uniorder.service.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportExportExcelService;
import cn.superdesk.uniorder.service.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportService;
import com.alibaba.dubbo.config.annotation.Reference;
import com.alibaba.dubbo.config.annotation.Service;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;
import java.util.Map;
import java.util.concurrent.CompletableFuture;


/**
 * @Description: 京东对账单中的订单 算是临时 sheet eg 深圳市侨城汇网络科技有限公司-2021年8月1日集采账单.xlsx
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-10-14 17:04:08
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-10-14 17:04:08
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Service(version = "1.0.0", retries = -1, timeout = 10000)
public class DubboAccountingUnifiedSupplierOrderJdCheckUpReportServiceImpl implements DubboAccountingUnifiedSupplierOrderJdCheckUpReportService {

    @Autowired
    private AccountingUnifiedSupplierOrderJdCheckUpReportService accountingUnifiedSupplierOrderJdCheckUpReportService;

    @Autowired
    private AccountingUnifiedSupplierOrderJdCheckUpReportExportExcelService accountingUnifiedSupplierOrderJdCheckUpReportExportExcelService;

    /****************************************** 引用自身 Dubbo provider start ******************************************/
    @Reference(version = "1.0.0", timeout = 10000, retries = -1)
    private DubboSysNotifyService dubboSysNotifyService;

    /****************************************** 引用自身 Dubbo provider   end ******************************************/


    /****************************************** extends BaseService 部分 start ******************************************/

    @Override
    public void addObj(AccountingUnifiedSupplierOrderJdCheckUpReportParam param) {

        AccountingUnifiedSupplierOrderJdCheckUpReport accountingUnifiedSupplierOrderJdCheckUpReport = AnBeanUtils.copy(param, AccountingUnifiedSupplierOrderJdCheckUpReport.class);
        accountingUnifiedSupplierOrderJdCheckUpReportService.insertSelective(accountingUnifiedSupplierOrderJdCheckUpReport);

    }

    @Override
    public void updateObj(AccountingUnifiedSupplierOrderJdCheckUpReportParam param) {

        AccountingUnifiedSupplierOrderJdCheckUpReport accountingUnifiedSupplierOrderJdCheckUpReport = AnBeanUtils.copy(param, AccountingUnifiedSupplierOrderJdCheckUpReport.class);
        accountingUnifiedSupplierOrderJdCheckUpReportService.updateByPrimaryKeySelective(accountingUnifiedSupplierOrderJdCheckUpReport);
    }

    @Override
    public void deleteObj(Long id) {
        accountingUnifiedSupplierOrderJdCheckUpReportService.deleteObj(id);
    }

    @Override
    public AccountingUnifiedSupplierOrderJdCheckUpReport findById(Long id) {
        return accountingUnifiedSupplierOrderJdCheckUpReportService.findById(id);
    }

    @Override
    public PageInfo<AccountingUnifiedSupplierOrderJdCheckUpReport> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize) {
        return accountingUnifiedSupplierOrderJdCheckUpReportService.findByPaging(conditions, pageNun, pageSize);
    }

    @Override
    public List<AccountingUnifiedSupplierOrderJdCheckUpReport> findAll(Map<String, Object> queryMap) {

        return accountingUnifiedSupplierOrderJdCheckUpReportService.findAll(queryMap);
    }

    /****************************************** extends BaseService 部分   end ******************************************/


    @Override
    public void addAccountingUnifiedSupplierOrderJdCheckUpReport(AccountingUnifiedSupplierOrderJdCheckUpReportParam param) {

        AccountingUnifiedSupplierOrderJdCheckUpReport accountingUnifiedSupplierOrderJdCheckUpReport = AnBeanUtils.copy(param, AccountingUnifiedSupplierOrderJdCheckUpReport.class);
        accountingUnifiedSupplierOrderJdCheckUpReportService.addAccountingUnifiedSupplierOrderJdCheckUpReport(accountingUnifiedSupplierOrderJdCheckUpReport);
    }

    @Override
    public void updateAccountingUnifiedSupplierOrderJdCheckUpReport(AccountingUnifiedSupplierOrderJdCheckUpReportParam param) {

        AccountingUnifiedSupplierOrderJdCheckUpReport accountingUnifiedSupplierOrderJdCheckUpReport = AnBeanUtils.copy(param, AccountingUnifiedSupplierOrderJdCheckUpReport.class);
        accountingUnifiedSupplierOrderJdCheckUpReportService.updateAccountingUnifiedSupplierOrderJdCheckUpReport(accountingUnifiedSupplierOrderJdCheckUpReport);
    }

    @Override
    public void deleteAccountingUnifiedSupplierOrderJdCheckUpReport(Long id) {
        accountingUnifiedSupplierOrderJdCheckUpReportService.deleteAccountingUnifiedSupplierOrderJdCheckUpReport(id);
    }

    @Override
    public AccountingUnifiedSupplierOrderJdCheckUpReport findAccountingUnifiedSupplierOrderJdCheckUpReportById(Long id) {
        return accountingUnifiedSupplierOrderJdCheckUpReportService.findAccountingUnifiedSupplierOrderJdCheckUpReportById(id);
    }

    @Override
    public R<List<AccountingUnifiedSupplierOrderJdCheckUpReport>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize) {
        return accountingUnifiedSupplierOrderJdCheckUpReportService.pageQuery(conditions, pageNun, pageSize);
    }

    @Override
    public R<List<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVo>> pageQueryGenericParam(
            AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {
        return accountingUnifiedSupplierOrderJdCheckUpReportService.pageQueryGenericParam(queryCriteria, loginSysUser);
    }

    @Override
    public R<List<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVoWoof>> pageQueryGenericWoof(
            AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {
        return accountingUnifiedSupplierOrderJdCheckUpReportService.pageQueryGenericWoof(queryCriteria, loginSysUser);
    }

    @Override
    public AccountingUnifiedSupplierOrderJdCheckUpReportDetailStatisticsVo pageQueryHeadGenericParam(
            AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {
        return accountingUnifiedSupplierOrderJdCheckUpReportService.pageQueryHeadGenericParam(queryCriteria, loginSysUser);
    }

    @Override
    public List<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVo> queryGenericParam(
            AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria criteria,
            LoginSysUser loginSysUser) {
        return accountingUnifiedSupplierOrderJdCheckUpReportService.queryGenericParam(criteria, loginSysUser);
    }

    /****************************************** 检查 start ******************************************/

    @Override
    public R<String> checkUpAndReportDimOrder(
            SysQuartzScheduleTaskStatementOfAccountJdListItemVo listItemVo,
            AccountingUnifiedSupplierOrderJdListItemVo itemVo) {

        return accountingUnifiedSupplierOrderJdCheckUpReportService.opCompareOrderAndCheckUpProcessDimOrderOne(listItemVo, itemVo);
    }

    @Override
    public AccountingUnifiedSupplierOrderJdCheckUpReportSnapshotStruct readSnapshotJson(String batchId, String jdOrderSn) {

        log.info("\nopCheckUpDebug start \n{}\n{}\nopCheckUpDebug   end", batchId, jdOrderSn);

        return accountingUnifiedSupplierOrderJdCheckUpReportService.readSnapshotJson(batchId, jdOrderSn);
    }

    /****************************************** 检查   end ******************************************/

    /****************************************** export excel start ******************************************/

    @Override
    public String exportExcelJdCheckUpReportFullVersion(
            AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {

        log.info("\n异步操作 包裹 外层 exportExcelJdCheckUpReport params: \n{}", JSONUtil.toJsonPrettyStr(queryCriteria));

        CompletableFuture.runAsync(() -> {

            try {

                // 三步走 mark by linjinyu at 20210305
                // 1. 数据
                // 2. 生成excel
                // 3. 通知
                List<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVo> resultList = accountingUnifiedSupplierOrderJdCheckUpReportService.queryGenericParam(queryCriteria, loginSysUser);

                SysNotify sysNotify = accountingUnifiedSupplierOrderJdCheckUpReportExportExcelService
                        .exportExcelJdCheckUpReportFullVersion(
                                resultList,
                                queryCriteria.getBatchId(),
                                loginSysUser
                        );

                // 通知
                dubboSysNotifyService.notifyExportExcelDimUnifiedInvoiceRegister4E6(sysNotify, loginSysUser);

            } catch (Exception e2) {
                log.error("\n异步操作 包裹 内层 exportExcelJdCheckUpReport {} -> 执行 异常:{}", JSONUtil.toJsonStr(queryCriteria), e2);
            }
        });

        return "导出任务已经接收,正在处理中...";
    }

    @Override
    public String exportExcelJdCheckUpReportLiteVersion(
            AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria criteria,
            LoginSysUser loginSysUser) {

        log.info("\n异步操作 包裹 外层 exportExcelJdCheckUpReport params: \n{}", JSONUtil.toJsonPrettyStr(criteria));

        CompletableFuture.runAsync(() -> {

            try {

                // 三步走 mark by linjinyu at 20210305
                // 1. 数据
                // 2. 生成excel
                // 3. 通知
                List<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVo> resultList = accountingUnifiedSupplierOrderJdCheckUpReportService.queryGenericParam(criteria, loginSysUser);

                SysNotify sysNotify = accountingUnifiedSupplierOrderJdCheckUpReportExportExcelService
                        .exportExcelJdCheckUpReportLiteVersion(
                                resultList,
                                criteria.getBatchId(),
                                loginSysUser
                        );

                // 通知
                dubboSysNotifyService.notifyExportExcelDimUnifiedInvoiceRegister4E6(sysNotify, loginSysUser);

            } catch (Exception e2) {
                log.error("\n异步操作 包裹 内层 exportExcelJdCheckUpReport {} -> 执行 异常:{}", JSONUtil.toJsonStr(criteria), e2);
            }

        });

        return "导出任务已经接收,正在处理中...";
    }

    /****************************************** export excel   end ******************************************/
}
