package cn.superdesk.uniorder.dubbo.provider.thirdpart.jd;

import cn.hutool.json.JSONUtil;
import cn.superdesk.uniorder.common.numerical.AnBeanUtils;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.sys.notify.SysNotify;
import cn.superdesk.uniorder.dao.entity.thirdpart.jd.AccountingUnifiedSupplierOrderJd;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.*;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.AccountingUnifiedSupplierOrderJdDetailStatisticsVo;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.AccountingUnifiedSupplierOrderJdListItemVo;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.AccountingUnifiedSupplierOrderJdUpperLevelsStatisticsVo;
import cn.superdesk.uniorder.dubbo.facade.sys.notify.DubboSysNotifyService;
import cn.superdesk.uniorder.dubbo.facade.thirdpart.jd.DubboAccountingUnifiedSupplierOrderJdService;
import cn.superdesk.uniorder.service.thirdpart.jd.AccountingUnifiedSupplierOrderJdExportExcelService;
import cn.superdesk.uniorder.service.thirdpart.jd.AccountingUnifiedSupplierOrderJdService;
import com.alibaba.dubbo.config.annotation.Reference;
import com.alibaba.dubbo.config.annotation.Service;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;
import java.util.Map;
import java.util.concurrent.CompletableFuture;

/**
 * @Description: 京东对账单中的订单 算是临时 sheet eg 深圳市侨城汇网络科技有限公司-2021年8月1日集采账单.xlsx
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-10-12 11:29:24
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-10-12 11:29:24
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Service(version = "1.0.0", retries = -1, timeout = 10000)
public class DubboAccountingUnifiedSupplierOrderJdServiceImpl implements DubboAccountingUnifiedSupplierOrderJdService {

    @Autowired
    private AccountingUnifiedSupplierOrderJdService            accountingUnifiedSupplierOrderJdService;
    @Autowired
    private AccountingUnifiedSupplierOrderJdExportExcelService accountingUnifiedSupplierOrderJdExportExcelService;

    /****************************************** 引用自身 Dubbo provider start ******************************************/
    @Reference(version = "1.0.0", timeout = 10000, retries = -1)
    private DubboSysNotifyService dubboSysNotifyService;

    /****************************************** 引用自身 Dubbo provider   end ******************************************/


    /****************************************** extends BaseService 部分 start ******************************************/

    @Override
    public void addObj(AccountingUnifiedSupplierOrderJdParam param) {

        AccountingUnifiedSupplierOrderJd accountingUnifiedSupplierOrderJd = AnBeanUtils.copy(param, AccountingUnifiedSupplierOrderJd.class);
        accountingUnifiedSupplierOrderJdService.insertSelective(accountingUnifiedSupplierOrderJd);

    }

    @Override
    public void updateObj(AccountingUnifiedSupplierOrderJdParam param) {

        AccountingUnifiedSupplierOrderJd accountingUnifiedSupplierOrderJd = AnBeanUtils.copy(param, AccountingUnifiedSupplierOrderJd.class);
        accountingUnifiedSupplierOrderJdService.updateByPrimaryKeySelective(accountingUnifiedSupplierOrderJd);
    }

    @Override
    public void deleteObj(Long id) {
        accountingUnifiedSupplierOrderJdService.deleteObj(id);
    }

    @Override
    public AccountingUnifiedSupplierOrderJd findById(Long id) {
        return accountingUnifiedSupplierOrderJdService.findById(id);
    }

    @Override
    public PageInfo<AccountingUnifiedSupplierOrderJd> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize) {
        return accountingUnifiedSupplierOrderJdService.findByPaging(conditions, pageNun, pageSize);
    }

    @Override
    public List<AccountingUnifiedSupplierOrderJd> findAll(Map<String, Object> queryMap) {

        return accountingUnifiedSupplierOrderJdService.findAll(queryMap);
    }

    /****************************************** extends BaseService 部分   end ******************************************/


    @Override
    public void addAccountingUnifiedSupplierOrderJd(AccountingUnifiedSupplierOrderJdParam param) {

        AccountingUnifiedSupplierOrderJd accountingUnifiedSupplierOrderJd = AnBeanUtils.copy(param, AccountingUnifiedSupplierOrderJd.class);
        accountingUnifiedSupplierOrderJdService.addAccountingUnifiedSupplierOrderJd(accountingUnifiedSupplierOrderJd);
    }

    @Override
    public void updateAccountingUnifiedSupplierOrderJd(AccountingUnifiedSupplierOrderJdParam param) {

        AccountingUnifiedSupplierOrderJd accountingUnifiedSupplierOrderJd = AnBeanUtils.copy(param, AccountingUnifiedSupplierOrderJd.class);
        accountingUnifiedSupplierOrderJdService.updateAccountingUnifiedSupplierOrderJd(accountingUnifiedSupplierOrderJd);
    }

    @Override
    public void deleteAccountingUnifiedSupplierOrderJd(Long id) {
        accountingUnifiedSupplierOrderJdService.deleteAccountingUnifiedSupplierOrderJd(id);
    }

    @Override
    public AccountingUnifiedSupplierOrderJd findAccountingUnifiedSupplierOrderJdById(Long id) {
        return accountingUnifiedSupplierOrderJdService.findAccountingUnifiedSupplierOrderJdById(id);
    }

    @Override
    public R<List<AccountingUnifiedSupplierOrderJd>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize) {
        return accountingUnifiedSupplierOrderJdService.pageQuery(conditions, pageNun, pageSize);
    }

    @Override
    public R<List<AccountingUnifiedSupplierOrderJdListItemVo>> pageQueryGenericParam(
            AccountingUnifiedSupplierOrderJdQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {
        return accountingUnifiedSupplierOrderJdService.pageQueryGenericParam(queryCriteria, loginSysUser);
    }

    @Override
    public List<AccountingUnifiedSupplierOrderJdListItemVo> queryGenericParam(
            AccountingUnifiedSupplierOrderJdQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {
        return accountingUnifiedSupplierOrderJdService.queryGenericParam(queryCriteria, loginSysUser);
    }

    @Override
    public AccountingUnifiedSupplierOrderJdDetailStatisticsVo pageQueryHeadGenericParam(
            AccountingUnifiedSupplierOrderJdQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {
        return accountingUnifiedSupplierOrderJdService.pageQueryHeadGenericParam(queryCriteria, loginSysUser);
    }

    @Override
    public AccountingUnifiedSupplierOrderJdUpperLevelsStatisticsVo statisticsQuantityDimOrderNormalOrException(
            AccountingUnifiedSupplierOrderJdQueryCriteria queryCriteria, LoginSysUser loginSysUser) {
        return accountingUnifiedSupplierOrderJdService.statisticsQuantityDimOrderNormalOrException(queryCriteria, loginSysUser);
    }

    /**************************************** excel export start ****************************************/

    @Override
    public String exportExcelJdImportRecord(
            AccountingUnifiedSupplierOrderJdQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {

        log.info("\n异步操作 包裹 外层 exportExcelJdImportRecord params: \n{}", JSONUtil.toJsonPrettyStr(queryCriteria));

        CompletableFuture.runAsync(() -> {

            try {

                // 三步走 mark by linjinyu at 20210305
                // 1. 数据
                // 2. 生成excel
                // 3. 通知
                List<AccountingUnifiedSupplierOrderJdListItemVo> resultList = accountingUnifiedSupplierOrderJdService.queryGenericParam(queryCriteria, loginSysUser);

                SysNotify sysNotify = accountingUnifiedSupplierOrderJdExportExcelService
                        .exportExcelJdImportRecord(
                                resultList,
                                queryCriteria.getBatchId(),
                                loginSysUser
                        );

                // 通知
                dubboSysNotifyService.notifyExportExcelDimUnifiedInvoiceRegister4E6(sysNotify, loginSysUser);

            } catch (Exception e2) {
                log.error("\n异步操作 包裹 内层 exportExcelJdImportRecord {} -> 执行 异常:{}", JSONUtil.toJsonStr(queryCriteria), e2);
            }
        });

        return "任务已经接收,正在处理中...";

    }

    /**************************************** excel export start ****************************************/


    /****************************************** excel import start start ******************************************/


    @Override
    public SysNotify opExcelImportFullVersion(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            LoginSysUser loginSysUser) {

        // TODO !!!注意!!! 没有在此层开线程

        return accountingUnifiedSupplierOrderJdService.opImportExcelFullVersion(form, loginSysUser);
    }

    @Override
    public SysNotify opExcelImportLiteVersion(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            LoginSysUser loginSysUser) {

        // TODO !!!注意!!! 没有在此层开线程

        return accountingUnifiedSupplierOrderJdService.opImportExcelLiteVersion(form, loginSysUser);
    }

    @Override
    public void saveOrUpdate4ThirdPartJdReconciliationScheduleFullVersionExcelRow(
            AccountingUnifiedSupplierOrderJdImportFullVersionExcelRow excelRow,
            LoginSysUser loginSysUser) {

        if (null == excelRow) {
            return;
        }
        accountingUnifiedSupplierOrderJdService.saveOrUpdate4ThirdPartJdReconciliationScheduleFullVersionExcelRow(excelRow, loginSysUser);
    }

    @Override
    public void saveOrUpdate4ThirdPartJdReconciliationScheduleFullVersionExcelRowList(
            List<AccountingUnifiedSupplierOrderJdImportFullVersionExcelRow> excelRowList,
            LoginSysUser loginSysUser) {

        accountingUnifiedSupplierOrderJdService.saveOrUpdate4ThirdPartJdReconciliationScheduleFullVersionExcelRowList(excelRowList, loginSysUser);
    }

    @Override
    public void saveOrUpdate4ThirdPartJdReconciliationScheduleLiteVersionExcelRow(
            AccountingUnifiedSupplierOrderJdImportLiteVersionExcelRow excelRow,
            LoginSysUser loginSysUser) {
        if (null == excelRow) {
            return;
        }
        accountingUnifiedSupplierOrderJdService.saveOrUpdate4ThirdPartJdReconciliationScheduleLiteVersionExcelRow(excelRow, loginSysUser);
    }

    @Override
    public void saveOrUpdate4ThirdPartJdReconciliationScheduleLiteVersionExcelRowList(
            List<AccountingUnifiedSupplierOrderJdImportLiteVersionExcelRow> excelRowList,
            LoginSysUser loginSysUser) {
        accountingUnifiedSupplierOrderJdService.saveOrUpdate4ThirdPartJdReconciliationScheduleLiteVersionExcelRowList(excelRowList, loginSysUser);
    }

    /****************************************** excel import start   end ******************************************/

}
