package cn.superdesk.uniorder.dubbo.provider.thirdpart.jd;

import cn.hutool.core.date.DateUtil;
import cn.hutool.json.JSONUtil;
import cn.superdesk.uniorder.common.enums.scheduler.jd.ScheduleTaskAccountingStatusEnum;
import cn.superdesk.uniorder.common.enums.scheduler.jd.ScheduleTaskCheckStateEnum;
import cn.superdesk.uniorder.common.enums.scheduler.jd.ScheduleTaskProcessStateEnum;
import cn.superdesk.uniorder.common.enums.scheduler.jd.ScheduleTaskRunStatusEnum;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.sys.notify.SysNotify;
import cn.superdesk.uniorder.dao.entity.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJd;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.*;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdHeadVo;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdListItemVo;
import cn.superdesk.uniorder.dubbo.facade.sys.notify.DubboSysNotifyService;
import cn.superdesk.uniorder.dubbo.facade.thirdpart.jd.DubboSysQuartzScheduleTaskStatementOfAccountJdService;
import cn.superdesk.uniorder.service.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdExOpPartService;
import cn.superdesk.uniorder.service.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdService;
import com.alibaba.dubbo.config.annotation.Reference;
import com.alibaba.dubbo.config.annotation.Service;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;
import java.util.Map;
import java.util.concurrent.CompletableFuture;

/**
 * @Description: 定时任务-时刻任务-对账单
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-10-12 11:29:24
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-10-12 11:29:24
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Service(version = "1.0.0", retries = -1, timeout = 10000)
public class DubboSysQuartzScheduleTaskStatementOfAccountJdServiceImpl implements DubboSysQuartzScheduleTaskStatementOfAccountJdService {

    @Autowired
    private SysQuartzScheduleTaskStatementOfAccountJdService         sysQuartzScheduleTaskStatementOfAccountJdService;
    @Autowired
    private SysQuartzScheduleTaskStatementOfAccountJdExOpPartService sysQuartzScheduleTaskStatementOfAccountJdExOpPartService;


    /****************************************** 引用自身 Dubbo provider start ******************************************/
    @Reference(version = "1.0.0", timeout = 10000, retries = -1)
    private DubboSysNotifyService dubboSysNotifyService;


    /****************************************** extends BaseService 部分 start ******************************************/

    @Override
    public int insertSelective(SysQuartzScheduleTaskStatementOfAccountJd entity) {
        return sysQuartzScheduleTaskStatementOfAccountJdService.insertSelective(entity);
    }

    @Override
    public int updateByPrimaryKeySelective(SysQuartzScheduleTaskStatementOfAccountJd entity) {
        return sysQuartzScheduleTaskStatementOfAccountJdService.updateByPrimaryKeySelective(entity);
    }

    @Override
    public void deleteObj(Long id) {
        sysQuartzScheduleTaskStatementOfAccountJdService.deleteObj(id);
    }

    @Override
    public SysQuartzScheduleTaskStatementOfAccountJd findById(Long id) {
        return sysQuartzScheduleTaskStatementOfAccountJdService.findById(id);
    }

    @Override
    public PageInfo<SysQuartzScheduleTaskStatementOfAccountJd> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize) {
        return sysQuartzScheduleTaskStatementOfAccountJdService.findByPaging(conditions, pageNun, pageSize);
    }

    @Override
    public List<SysQuartzScheduleTaskStatementOfAccountJd> findAll(Map<String, Object> queryMap) {
        return sysQuartzScheduleTaskStatementOfAccountJdService.findAll(queryMap);
    }

    /****************************************** extends BaseService 部分   end ******************************************/


    @Override
    public int addSysQuartzScheduleTaskStatementOfAccountJd(SysQuartzScheduleTaskStatementOfAccountJdParam param, LoginSysUser loginSysUser) {

        return sysQuartzScheduleTaskStatementOfAccountJdService.addSysQuartzScheduleTaskStatementOfAccountJd(param, loginSysUser);
    }

    @Override
    public int updateSysQuartzScheduleTaskStatementOfAccountJd(SysQuartzScheduleTaskStatementOfAccountJdParam param, LoginSysUser loginSysUser) {

        return sysQuartzScheduleTaskStatementOfAccountJdService.updateSysQuartzScheduleTaskStatementOfAccountJd(param, loginSysUser);
    }

    @Override
    public int deleteSysQuartzScheduleTaskStatementOfAccountJd(Long id, LoginSysUser loginSysUser) {
        return sysQuartzScheduleTaskStatementOfAccountJdService.deleteSysQuartzScheduleTaskStatementOfAccountJd(id, loginSysUser);
    }

    @Override
    public SysQuartzScheduleTaskStatementOfAccountJdListItemVo findListItemVoById(Long id, LoginSysUser loginSysUser) {
        return sysQuartzScheduleTaskStatementOfAccountJdService.findListItemVoById(id, loginSysUser);
    }

    @Override
    public SysQuartzScheduleTaskStatementOfAccountJdListItemVo findListItemVoByBatchId(String batchId, LoginSysUser loginSysUser) {
        return sysQuartzScheduleTaskStatementOfAccountJdService.findListItemVoByBatchId(batchId, loginSysUser);
    }

    @Override
    public R<List<SysQuartzScheduleTaskStatementOfAccountJd>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize) {
        return sysQuartzScheduleTaskStatementOfAccountJdService.pageQuery(conditions, pageNun, pageSize);
    }

    @Override
    public R<List<SysQuartzScheduleTaskStatementOfAccountJdListItemVo>> pageQueryGenericParam(
            SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {
        return sysQuartzScheduleTaskStatementOfAccountJdService.pageQueryGenericParam(queryCriteria, loginSysUser);
    }

    @Override
    public SysQuartzScheduleTaskStatementOfAccountJdHeadVo queryHeadGenericParam(
            SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {
        return sysQuartzScheduleTaskStatementOfAccountJdService.queryHeadGenericParam(queryCriteria, loginSysUser);
    }

    @Override
    public List<SysQuartzScheduleTaskStatementOfAccountJdListItemVo> queryGenericParam(
            SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {
        return sysQuartzScheduleTaskStatementOfAccountJdService.queryGenericParam(queryCriteria, loginSysUser);
    }

    @Override
    public SysQuartzScheduleTaskStatementOfAccountJdListItemVo deQueueOneImportExcel(LoginSysUser loginSysUser) {
        return sysQuartzScheduleTaskStatementOfAccountJdService.deQueueOneImportExcel(loginSysUser);
    }

    @Override
    public SysQuartzScheduleTaskStatementOfAccountJdListItemVo deQueueOneCompareOrderAndCheckUpThenReport(LoginSysUser loginSysUser) {
        return sysQuartzScheduleTaskStatementOfAccountJdService.deQueueOneCompareOrderAndCheckUpThenReport(loginSysUser);
    }

    /**************************************** 操作 start ****************************************/


    @Override
    public int opSetRemark(SysQuartzScheduleTaskStatementOfAccountJdOpSetRemarkForm form, LoginSysUser loginSysUser) {

        return sysQuartzScheduleTaskStatementOfAccountJdService.updateByPrimaryKeySelective(
                SysQuartzScheduleTaskStatementOfAccountJd
                        .builder()

                        .id(form.getSysQuartzScheduleTaskStatementOfAccountJdId())

                        .remark(form.getRemark())

                        .updateTime(DateUtil.date())
                        .updateUserId(loginSysUser.getSysUserId())

                        .build()
        );

    }

    @Override
    public int opSetIsPause(SysQuartzScheduleTaskStatementOfAccountJdOpSetIsPauseForm form, LoginSysUser loginSysUser) {

        return sysQuartzScheduleTaskStatementOfAccountJdService.updateByBatchIdSelective(
                SysQuartzScheduleTaskStatementOfAccountJd
                        .builder()

                        .batchId(form.getBatchId())

                        .isPause(form.getIsPauseEnum().getKey())

                        .build()
        );
    }


    /**************************************** 操作 start ****************************************/


    /**************************************** 任务牵引方法 懒得做状态机 start ****************************************/


    @Override
    public int towImportExcel(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            ScheduleTaskRunStatusEnum runStatusEnum,
            ScheduleTaskProcessStateEnum processStateEnum,
            LoginSysUser loginSysUser) {

        return sysQuartzScheduleTaskStatementOfAccountJdService.towImportExcel(
                form,
                runStatusEnum,
                processStateEnum,
                loginSysUser
        );
    }

    @Override
    public int towCompareOrderAndCheckUpThenReport(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            ScheduleTaskRunStatusEnum runStatusEnum, ScheduleTaskAccountingStatusEnum statusEnum,
            LoginSysUser loginSysUser) {
        return sysQuartzScheduleTaskStatementOfAccountJdService.towCompareOrderAndCheckUpThenReport(
                form,
                runStatusEnum,
                statusEnum,
                loginSysUser
        );
    }


    /**************************************** 任务牵引方法 懒得做状态机   end ****************************************/


    /**************************************** 导入任务 start ****************************************/

    @Override
    public String asyncExcelImportFullVersion(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            LoginSysUser loginSysUser) {

        CompletableFuture<Void> voidCompletableFuture = CompletableFuture.runAsync(() -> {

            try {


                SysNotify sysNotify = sysQuartzScheduleTaskStatementOfAccountJdService
                        .dispatcherExcelImportFullVersion(
                                form,
                                loginSysUser
                        );

                SysQuartzScheduleTaskStatementOfAccountJdListItemVo listItemVo = sysQuartzScheduleTaskStatementOfAccountJdService.findListItemVoByBatchId(form.getBatchId(), loginSysUser);
                sysNotify.setContent(JSONUtil.toJsonStr(listItemVo));

                // 通知
                dubboSysNotifyService.notifyAsyncExcelImportFullVersion(sysNotify, form.getBatchId(), loginSysUser);

            } catch (Exception e2) {
                log.error("\n异步操作 包裹 内层 asyncExcelImportFullVersion{} -> 执行 异常:{}", JSONUtil.toJsonStr(form), e2);
            }

        });

        return "导入任务已经接收,正在处理中...";
    }

    @Override
    public String asyncExcelImportLiteVersion(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            LoginSysUser loginSysUser) {

        CompletableFuture<Void> voidCompletableFuture = CompletableFuture.runAsync(() -> {

            try {

                SysNotify sysNotify = sysQuartzScheduleTaskStatementOfAccountJdService
                        .dispatcherExcelImportLiteVersion(
                                form,
                                loginSysUser
                        );


                SysQuartzScheduleTaskStatementOfAccountJdListItemVo listItemVo = sysQuartzScheduleTaskStatementOfAccountJdService.findListItemVoByBatchId(form.getBatchId(), loginSysUser);
                sysNotify.setContent(JSONUtil.toJsonStr(listItemVo));


                // 通知
                dubboSysNotifyService.notifyAsyncExcelImportLiteVersion(sysNotify, form.getBatchId(), loginSysUser);

            } catch (Exception e2) {
                log.error("\n异步操作 包裹 内层 asyncExcelImportLiteVersion{} -> 执行 异常:{}", JSONUtil.toJsonStr(form), e2);

                sysQuartzScheduleTaskStatementOfAccountJdService.towImportExcel(
                        form,
                        ScheduleTaskRunStatusEnum.已导入,
                        ScheduleTaskProcessStateEnum.导入失败,
                        loginSysUser
                );
            }
        });

        return "导入任务已经接收,正在处理中...";
    }

    /**************************************** 导入任务 start ****************************************/

    /**************************************** 检查任务 start ****************************************/

    @Override
    public String asyncCompareOrderAndCheckUpThenReport(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            LoginSysUser loginSysUser) {

        CompletableFuture<Void> voidCompletableFuture = CompletableFuture.runAsync(() -> {

            try {

                SysNotify sysNotify = sysQuartzScheduleTaskStatementOfAccountJdService
                        .dispatcherCompareOrderAndCheckUpThenReport(
                                form,
                                loginSysUser
                        );

                // 通知
                dubboSysNotifyService.notifyAsyncCompareOrderAndCheckUpThenReport(sysNotify, form.getBatchId(), loginSysUser);

            } catch (Exception e2) {

                log.error("\n异步操作 包裹 内层 asyncExcelImportLiteVersion{} -> 执行 异常:{}", JSONUtil.toJsonStr(form), e2);

                sysQuartzScheduleTaskStatementOfAccountJdService.towCompareOrderAndCheckUpThenReportThrowException(
                        form,
                        ScheduleTaskRunStatusEnum.已对账,
                        ScheduleTaskAccountingStatusEnum.对账完成,
                        ScheduleTaskCheckStateEnum.异常,
                        loginSysUser
                );
            }
        });

        return "导入任务已经接收,正在处理中...";
    }

    @Override
    public String asyncCompareOrderAndCheckUpThenReportOnlyException(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            LoginSysUser loginSysUser) {

        CompletableFuture<Void> voidCompletableFuture = CompletableFuture.runAsync(() -> {

            try {

                SysNotify sysNotify = sysQuartzScheduleTaskStatementOfAccountJdService
                        .dispatcherCompareOrderAndCheckUpThenReportOnlyException(
                                form,
                                loginSysUser
                        );

                // 通知
                dubboSysNotifyService.notifyExportExcelUnifiedCustomerInvoice2GoodsDetail(sysNotify, loginSysUser);

            } catch (Exception e2) {

                log.error("\n异步操作 包裹 内层 asyncExcelImportLiteVersion{} -> 执行 异常:{}", JSONUtil.toJsonStr(form), e2);

                sysQuartzScheduleTaskStatementOfAccountJdService.towCompareOrderAndCheckUpThenReportThrowException(
                        form,
                        ScheduleTaskRunStatusEnum.已对账,
                        ScheduleTaskAccountingStatusEnum.对账完成,
                        ScheduleTaskCheckStateEnum.异常,
                        loginSysUser
                );
            }
        });

        return "导入任务已经接收,正在处理中...";
    }

}