package cn.superdesk.uniorder.openapi.annotation.impl;

import cn.superdesk.uniorder.openapi.annotation.BigDecimalLessThan;

import javax.validation.ConstraintValidator;
import javax.validation.ConstraintValidatorContext;
import java.math.BigDecimal;

/**
 * @author xc
 * @description
 * @date 2022/4/19 16:35
 */
public class BigDecimalLessThanValidator implements ConstraintValidator<BigDecimalLessThan, Object> {
    private String max;

    @Override
    public void initialize(BigDecimalLessThan constraintAnnotation) {
        this.max = constraintAnnotation.value();
    }

    @Override
    public boolean isValid(Object o, ConstraintValidatorContext constraintValidatorContext) {
        if (o == null) {
            return false;
        }

        if (o instanceof BigDecimal) {
            return ((BigDecimal) o).compareTo(new BigDecimal(max)) < 0;
        }

        return false;
    }
}
