package cn.superdesk.uniorder.service.accounting.score.customer.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.io.FileUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.extra.spring.SpringUtil;
import cn.hutool.json.JSONUtil;
import cn.superdesk.uniorder.common.HttpUtil;
import cn.superdesk.uniorder.common.enums.accounting.AccountingOrderInvoiceApplyStatusEnum;
import cn.superdesk.uniorder.common.enums.accounting.AccountingOrderIsSendEmailEnum;
import cn.superdesk.uniorder.common.enums.accounting.AccountingOrderTypeDimEnum;
import cn.superdesk.uniorder.common.enums.accounting.customer.*;
import cn.superdesk.uniorder.common.enums.common.*;
import cn.superdesk.uniorder.common.enums.invoice.customer.InvoiceApplyCustomerInvoiceProgressingStatusEnum;
import cn.superdesk.uniorder.common.enums.invoice.customer.InvoiceApplyCustomerMailTickStatusEnum;
import cn.superdesk.uniorder.common.enums.invoice.customer.ReceivedStatusEnum;
import cn.superdesk.uniorder.common.enums.order.UnifiedOrderCreditTypeDefaultEnum;
import cn.superdesk.uniorder.common.enums.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountRunStateEnum;
import cn.superdesk.uniorder.common.exception.BadRequestException;
import cn.superdesk.uniorder.common.json.AnJsonUtils;
import cn.superdesk.uniorder.common.lamda.AnLamdaUtils;
import cn.superdesk.uniorder.common.numerical.AnBeanUtils;
import cn.superdesk.uniorder.common.numerical.AnDateUtils;
import cn.superdesk.uniorder.common.numerical.AnIntegerUtils;
import cn.superdesk.uniorder.common.numerical.AnStringUtils;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.DESPlus;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.common.utils.DateUtils;
import cn.superdesk.uniorder.common.utils.IncUtils;
import cn.superdesk.uniorder.common.utils.KeyWorker;
import cn.superdesk.uniorder.common.utils.PageUtils;
import cn.superdesk.uniorder.dao.convert.DtoSugarUpUtils;
import cn.superdesk.uniorder.dao.entity.accounting.score.customer.AccountingScoreCustomer;
import cn.superdesk.uniorder.dao.entity.accounting.score.customer.AccountingScoreCustomerExample;
import cn.superdesk.uniorder.dao.entity.accounting.score.customer.AccountingScoreCustomerXCredit;
import cn.superdesk.uniorder.dao.entity.accounting.score.customer.AccountingScoreCustomerXCreditExample;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrderCredit;
import cn.superdesk.uniorder.dao.entity.biz.*;
import cn.superdesk.uniorder.dao.entity.invoice.common.InvoiceBankInfo;
import cn.superdesk.uniorder.dao.entity.organisation.SysEnterprise;
import cn.superdesk.uniorder.dao.entity.organisation.SysEnterpriseExample;
import cn.superdesk.uniorder.dao.entity.organisation.UnifiedSupplier;
import cn.superdesk.uniorder.dao.entity.sys.SysUser;
import cn.superdesk.uniorder.dao.entity.sys.notify.SysNotify;
import cn.superdesk.uniorder.dao.mapper.accounting.score.customer.AccountingScoreCustomerMapper;
import cn.superdesk.uniorder.dao.mapper.accounting.score.customer.AccountingScoreCustomerMapperEx;
import cn.superdesk.uniorder.dao.mapper.accounting.score.customer.AccountingScoreCustomerXCreditMapper;
import cn.superdesk.uniorder.dao.mapper.accounting.score.customer.AccountingScoreCustomerXCreditMapperEx;
import cn.superdesk.uniorder.dao.mapper.base.UnifiedOrderCreditMapper;
import cn.superdesk.uniorder.dao.mapper.biz.*;
import cn.superdesk.uniorder.dao.mapper.organisation.SysBusinessUserMapper;
import cn.superdesk.uniorder.dao.mapper.organisation.SysEnterpriseMapper;
import cn.superdesk.uniorder.dao.mapper.organisation.UnifiedSupplierMapper;
import cn.superdesk.uniorder.dao.mapper.sys.SysAccountPayableMapper;
import cn.superdesk.uniorder.dao.mapper.sys.SysAccountReceivableMapper;
import cn.superdesk.uniorder.dto._constant.ResourceConstant;
import cn.superdesk.uniorder.dto.param.accounting.score.customer.AccountingOrderScoreCustomerNotYetDimCreditScene3QueryCriteria;
import cn.superdesk.uniorder.dto.param.accounting.score.customer.AccountingOrderScoreCustomerOpDetailQueryCriteria;
import cn.superdesk.uniorder.dto.param.accounting.score.customer.AccountingOrderScoreCustomerQueryCriteria;
import cn.superdesk.uniorder.dto.param.accounting.unified.customer.AccountingReceivablePayableParam;
import cn.superdesk.uniorder.dto.param.accounting.unified.customer.PushAccountingParam;
import cn.superdesk.uniorder.dto.param.invoice.customer.InvoiceApplyCustomerQueryCriteriaV2_1;
import cn.superdesk.uniorder.dto.param.organisation.SysBusinessUserQueryCriteria;
import cn.superdesk.uniorder.dto.param.system.SysAccountPayableQueryCriteria;
import cn.superdesk.uniorder.dto.param.system.SysAccountReceivableQueryCriteria;
import cn.superdesk.uniorder.dto.vo.accounting.score.customer.*;
import cn.superdesk.uniorder.dto.vo.invoice.common.InvoiceBankInfoVo;
import cn.superdesk.uniorder.dto.vo.invoice.customer.InvoiceApplyCustomerPageVo;
import cn.superdesk.uniorder.dto.vo.invoice.customer.InvoiceApplyDetailDimCreditItemVo;
import cn.superdesk.uniorder.dto.vo.order.CreditTypeItemVo;
import cn.superdesk.uniorder.dto.vo.sys.SysAccountPayableVo;
import cn.superdesk.uniorder.dto.vo.sys.SysAccountReceivableVo;
import cn.superdesk.uniorder.dto.vo.sys.SysBusinessUserVo;
import cn.superdesk.uniorder.notify.NotifyUtils;
import cn.superdesk.uniorder.service.accounting.score.customer.AccountingScoreCustomerService;
import cn.superdesk.uniorder.service.accounting.score.customer.strategy.AccountingScoreCustomerStrategy;
import cn.superdesk.uniorder.service.accounting.score.customer.strategy.AccountingScoreCustomerStrategyContext;
import cn.superdesk.uniorder.service.invoice.common.InvoiceBankInfoService;
import cn.superdesk.uniorder.service.invoice.customer.InvoiceApplyCustomerService;
import cn.superdesk.uniorder.service.invoice.customer.InvoiceApplyXGoodsService;
import cn.superdesk.uniorder.service.order.base.ScoreOrderService;
import cn.superdesk.uniorder.service.order.base.UnifiedOrderCreditService;
import cn.superdesk.uniorder.service.setting.UnifiedSnConfigService;
import cn.superdesk.uniorder.service.sys.SysUserService;
import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.ExcelWriter;
import com.alibaba.excel.write.builder.ExcelWriterBuilder;
import com.alibaba.excel.write.metadata.WriteSheet;
import com.alibaba.excel.write.metadata.fill.FillConfig;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.google.common.collect.Lists;
import com.google.common.collect.Sets;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.collections.MapUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.io.File;
import java.math.BigDecimal;
import java.util.*;
import java.util.function.Function;
import java.util.function.Predicate;
import java.util.stream.Collectors;


/**
 * @Description: Java类作用描述
 * @Author: linjinyu
 * @CreateDate: 6/28/20 1:03 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 6/28/20 1:03 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Service
public class AccountingScoreCustomerServiceImpl implements AccountingScoreCustomerService {

    @Autowired
    private AccountingScoreCustomerMapper   accountingScoreCustomerMapper;
    @Autowired
    private AccountingScoreCustomerMapperEx accountingScoreCustomerMapperEx;
    @Autowired
    private FlowReceivableDetailMapper flowReceivableDetailMapper;
    @Autowired
    private FlowPayableDetailMapper flowPayableDetailMapper;
    @Autowired
    private FlowReceivableSummaryMapper flowReceivableSummaryMapper;
    @Autowired
    private FlowPayableSummaryMapper flowPayableSummaryMapper;
    @Autowired
    private AccountingPushShareDataMapper accountingPushShareDataMapper;
    @Autowired
    private AccountingScoreCustomerXCreditMapper   accountingScoreCustomerXCreditMapper;
    @Autowired
    private AccountingScoreCustomerXCreditMapperEx accountingScoreCustomerXCreditMapperEx;
    @Autowired
    private ResourceConstant resourceConstant;
    @Autowired
    private UnifiedOrderCreditService unifiedOrderCreditService;
    @Autowired
    private UnifiedOrderCreditMapper unifiedOrderCreditMapper;
    @Autowired
    private SysAccountPayableMapper sysAccountPayableMapper;
    @Autowired
    private SysAccountReceivableMapper sysAccountReceivableMapper;
    @Autowired
    private InvoiceBankInfoService invoiceBankInfoService;

    @Autowired
    private ScoreOrderService scoreOrderService;

//	@Autowired
//	private SysConfigService sysConfigService;

    @Autowired
    private UnifiedSnConfigService unifiedSnConfigService;

    @Autowired
    private SysUserService sysUserService;

    @Autowired
    private InvoiceApplyCustomerService invoiceApplyCustomerService;

    @Autowired
    private InvoiceApplyXGoodsService invoiceApplyXGoodsService;
    @Autowired
    private AccountingReceivablePayableMapper accountingReceivablePayableMapper;
    @Autowired
    private SysBusinessUserMapper sysBusinessUserMapper;
    @Autowired
    private SysEnterpriseMapper sysEnterpriseMapper;
    @Autowired
    private UnifiedSupplierMapper unifiedSupplierMapper;
    @Autowired
    private BizContractMapper bizContractMapper;
    @Autowired
    private AccountingScoreCustomerStrategyContext accountingScoreCustomerStrategyContext;
    @Autowired
    private IncUtils incUtils;
    @Value("${uniorder.pushReceivableDataUrl:''}")
    private String pushReceivableDataUrl;
    @Value("${uniorder.pushPayableDataUrl:''}")
    private String pushPayableDataUrl;
    @Value("${uniorder.queryPushDataUrl:''}")
    private String queryPushDataUrl;
    @Value("${uniorder.fileBaseUrl:''}")
    private String fileBaseUrl;

    @Override
    public int insertSelective(AccountingScoreCustomer scoreAccountingCustomer) {
        return accountingScoreCustomerMapper.insertSelective(scoreAccountingCustomer);
    }

    @Override
    public int updateByPrimaryKeySelective(AccountingScoreCustomer scoreAccountingCustomer) {

        return accountingScoreCustomerMapper.updateByPrimaryKeySelective(scoreAccountingCustomer);
    }

    public int opUpdateByPrimaryKeySelective(AccountingScoreCustomer scoreAccountingCustomer, LoginSysUser loginSysUser) {

        return accountingScoreCustomerMapper.updateByPrimaryKeySelective(scoreAccountingCustomer);

    }


    @Override
    public void deleteObj(Long id) {
        accountingScoreCustomerMapper.deleteByPrimaryKey(id);
    }


    @Override
    public AccountingScoreCustomer findById(Long id) {
        return accountingScoreCustomerMapper.selectByPrimaryKey(id);
    }

    @Deprecated
    @Override
    public PageInfo<AccountingScoreCustomer> findByPaging(Map<String, Object> params, Integer pageNo, Integer pageSize) {
        return null;
    }

    @Override
    public List<AccountingScoreCustomer> findByIds(List<Long> accountingOrderIds) {

        AccountingScoreCustomerExample example = new AccountingScoreCustomerExample();
        example.createCriteria()
                .andIdIn(accountingOrderIds);

        List<AccountingScoreCustomer> resultList = accountingScoreCustomerMapper.selectByExample(example);

        return resultList;

    }

    public Map<Long, AccountingScoreCustomer> convertAccountingScoreCustomerList2MapAccountingOrderIdEntity(List<Long> accountingOrderIds) {

        Map<Long, AccountingScoreCustomer> resultMap = new HashMap<>();

        List<AccountingScoreCustomer> resultList = findByIds(accountingOrderIds);

        resultMap = resultList.stream().collect(Collectors.toMap(AccountingScoreCustomer::getId, v -> v, (k, v) -> v));

        return resultMap;
    }


    public int opResetNeedReviseMark(Long accountingOrderId) {

        int ret = 0;

        AccountingScoreCustomer forUpdate = new AccountingScoreCustomer();

        forUpdate.setId(accountingOrderId);
        forUpdate.setNeedReviseMark(CommonNeedReviseMarkEnum.正常.getKey());

        ret = accountingScoreCustomerMapper.updateByPrimaryKeySelective(forUpdate);

        return ret;
    }

    @Override
    public List<AccountingScoreCustomer> findAll(Map<String, Object> queryMap) {
        return null;
    }


    public AccountingScoreCustomer findByAccountingOrderSn(String accountingOrderSn) {

        AccountingScoreCustomerExample example = new AccountingScoreCustomerExample();
        example.createCriteria()
                .andAccountingOrderSnEqualTo(accountingOrderSn);

        List<AccountingScoreCustomer> result = accountingScoreCustomerMapper.selectByExample(example);

        if (CollUtil.isNotEmpty(result)) {
            return result.get(0);
        } else {
            return null;
        }

    }

    /****************************************** 积分结算 对账单 start ******************************************/

    /**
     * 积分结算2.1 整改 mark by linjinyu at 2022022
     *
     * @param queryCriteria
     * @return
     */
    @Override
    public List<Long> getAccountingXCreditIdsByQueryCriteria(AccountingOrderScoreCustomerOpDetailQueryCriteria queryCriteria) {

        AccountingScoreCustomer search = accountingScoreCustomerMapper.selectByPrimaryKey(queryCriteria.getAccountingOrderId());

        AccountingScoreCustomerXCreditExample          example  = new AccountingScoreCustomerXCreditExample();
        AccountingScoreCustomerXCreditExample.Criteria criteria = example.createCriteria();

        criteria.andAccountingOrderSnEqualTo(search.getAccountingOrderSn());

        if (ObjectUtil.isNotNull(queryCriteria.getCreditAccountingState()) && queryCriteria.getCreditAccountingState().compareTo(0) != 0) {
            criteria.andAccountingStateEqualTo(queryCriteria.getCreditAccountingState());
        }

        List<AccountingScoreCustomerXCredit> tempResult = accountingScoreCustomerXCreditMapper.selectByExample(example);

        log.info("getAccountingXCreditIds \n{}", JSONUtil.toJsonStr(tempResult));
        log.info("getAccountingXCreditIds \n{}", JSONUtil.toJsonStr(tempResult
                .stream()
                .map(AccountingScoreCustomerXCredit::getUnifiedOrderCreditId)
                .collect(Collectors.toList())));

        return tempResult
                .stream()
                .map(AccountingScoreCustomerXCredit::getUnifiedOrderCreditId)
                .collect(Collectors.toList());
    }


    @Override
    public R<List<AccountingOrderScoreCustomerListItemVo>> pageQueryAccountingOrderList(AccountingOrderScoreCustomerQueryCriteria queryCriteria, LoginSysUser loginSysUser) {


        PageHelper.startPage(queryCriteria.getPageNumber(), queryCriteria.getPageSize());
//        List<AccountingOrderScoreCustomerListItemVo>     resultList = accountingScoreCustomerMapperEx.getAccountingOrderList(queryCriteria);
        List<AccountingOrderScoreCustomerListItemVo>     resultList = getAccountingOrderList(queryCriteria, loginSysUser);
        PageInfo<AccountingOrderScoreCustomerListItemVo> page       = new PageInfo<AccountingOrderScoreCustomerListItemVo>(resultList);
        PageHelper.clearPage();

//        // 附加信息
//        additionalInfoGetAccountingList(resultList);
//
//        // sugarUp
//        DtoSugarUpUtils.sugarUpAccountingOrderScoreCustomerVoList(resultList);

        /**************************************** 补丁程序 start ****************************************/

        /**
         * mark by linjinyu at 2022-05-139 06:56:45 脱钩 转 xxl job 发起

         // 修正 v2.1 统计信息
         patchNeedReviseMarkStatistics(resultList, loginSysUser);

         // 修正 v2.1 申请状态 fix invoiceStatus
         //	patchReviseInvoiceStatus(resultList, loginSysUser);

         // 修正 v2.2 寄票业务 逻辑
         patchNeedReviseMarkMailTickStatus(resultList, loginSysUser);

         // 修正 v2.3 serviceNo sourceFrom
         patchNeedReviseMarkServiceNoSourceFrom(resultList, loginSysUser);
         */

        /**************************************** 补丁程序   end ****************************************/


        return new R<List<AccountingOrderScoreCustomerListItemVo>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), resultList);
    }

    @Override
    public List<AccountingOrderScoreCustomerListItemVo> getAccountingOrderList(AccountingOrderScoreCustomerQueryCriteria queryCriteria, LoginSysUser loginSysUser) {

        List<AccountingOrderScoreCustomerListItemVo> resultList = new ArrayList<>();

        resultList = accountingScoreCustomerMapperEx.getAccountingOrderList(queryCriteria);

        // 附加信息
        additionalInfoGetAccountingList(resultList);

        // sugarUp
        DtoSugarUpUtils.sugarUpAccountingOrderScoreCustomerVoList(resultList);

        /**************************************** 补丁程序 start ****************************************/

        /**
         * mark by linjinyu at 2022-05-19 06:56:45 脱钩 转 xxl job 发起

         // 修正 v2.1 统计信息
         patchNeedReviseMarkStatistics(resultList, loginSysUser);

         // 修正 v2.1 申请状态 fix invoiceStatus
         //	patchReviseInvoiceStatus(resultList, loginSysUser);

         // 修正 v2.2 寄票业务 逻辑
         patchNeedReviseMarkMailTickStatus(resultList, loginSysUser);

         // 修正 v2.3 serviceNo sourceFrom
         patchNeedReviseMarkServiceNoSourceFrom(resultList, loginSysUser);
         */

        /**************************************** 补丁程序   end ****************************************/
        if(CollectionUtils.isNotEmpty(resultList)){
            resultList.forEach(data ->{
                data.setReceivableDataStatusName(AccountingDataStatusEnum.getDesc(data.getReceivableDataStatus()));
                data.setPayableDataStatusName(AccountingDataStatusEnum.getDesc(data.getPayableDataStatus()));
                data.setReceivableAccountStatusName(AccountingRmStatusEnum.getDesc(data.getReceivableAccountStatus()));
                data.setWxReceivableAccountStatusName(AccountingRmStatusEnum.getDesc(data.getWxReceivableAccountStatus()));
                data.setPayableAccountStatusName(AccountingRmStatusEnum.getDesc(data.getPayableAccountStatus()));
                data.setReceivedAccountStatusName(ReceivedStatusEnum.getDesc(data.getReceivedAccountStatus()));
                data.setWxReceivedAccountStatusName(ReceivedStatusEnum.getDesc(data.getWxReceivedAccountStatus()));
            });
        }

        return resultList;
    }

    /**
     * 修正统计信息
     *
     * @param resultList
     * @param loginSysUser
     */
    public void patchNeedReviseMarkStatistics(List<AccountingOrderScoreCustomerListItemVo> resultList, LoginSysUser loginSysUser) {

        log.info("进入 patchNeedReviseMarkStatistics");

        if (CollUtil.isEmpty(resultList)) {
            return;
        }

        resultList.forEach(vo -> {
            if (ObjectUtil.isNotNull(vo.getNeedReviseMark())
                    && vo.getNeedReviseMark().compareTo(CommonNeedReviseMarkEnum.修正.getKey()) == 0) {

                List<Long> idsCredit = getAccountingXCreditIdsByQueryCriteria(
                        AccountingOrderScoreCustomerOpDetailQueryCriteria
                                .builder()
                                .accountingOrderId(vo.getId())
                                .build()
                );

                AccountingScoreCustomer accountingScoreCustomer = new AccountingScoreCustomer();
                List<InvoiceApplyDetailDimCreditItemVo> invoiceApplyDetailDimCreditItemVoList = scoreOrderService.getScoreOrderReconciliationNotYetScene3(
                        AccountingOrderScoreCustomerNotYetDimCreditScene3QueryCriteria
                                .builder()
                                .idsCredit(idsCredit)
                                .build(),
                        loginSysUser
                );

                // 重新统计
                statisticsScoreAccountingCustomerByCredit(accountingScoreCustomer, invoiceApplyDetailDimCreditItemVoList);

//                accountingScoreCustomer.setId(vo.getId());
//                accountingScoreCustomer.setNeedReviseMark(CommonNeedReviseMarkEnum.正常.getKey());
//
//                updateByPrimaryKeySelective(accountingScoreCustomer);
                int retReset = opResetNeedReviseMark(vo.getId());
            }
        });

    }

    /**
     * 修正申请状态 fix invoiceStatus
     *
     * @param resultList
     * @param loginSysUser
     */
    public void patchNeedReviseMarkInvoiceStatus(List<AccountingOrderScoreCustomerListItemVo> resultList, LoginSysUser loginSysUser) {

        log.info("进入 patchNeedReviseMarkInvoiceStatus");

        if (CollUtil.isEmpty(resultList)) {
            return;
        }

        resultList.forEach(vo -> {
            if (ObjectUtil.isNotNull(vo.getNeedReviseMark())
                    && vo.getNeedReviseMark().compareTo(CommonNeedReviseMarkEnum.修数据_20220518.getKey()) == 0) {

                invoiceApplyXGoodsService.checkInvoiceStatusByAccountingOrderIdAndUpdateAccountingEntityFocusScore(
                        vo.getId(),
                        CommonBeRelatedEnum.失联,
                        loginSysUser
                );

//                AccountingScoreCustomer accountingScoreCustomer = new AccountingScoreCustomer();
//                accountingScoreCustomer.setId(vo.getId());
//                accountingScoreCustomer.setNeedReviseMark(CommonNeedReviseMarkEnum.正常.getKey());
//
//                updateByPrimaryKeySelective(accountingScoreCustomer);

                int retReset = opResetNeedReviseMark(vo.getId());

            }


        });

    }

    /**
     * 【2. 积分结算-2.3 发票管理-2.3.4 线上历史数据处理-已整理-20220425-后端待处理-20220427】
     * https://www.tapd.cn/33003868/prong/stories/view/1133003868001004189
     *
     * @param resultList
     * @param loginSysUser
     */
    public void patchNeedReviseMarkMailTickStatus(List<AccountingOrderScoreCustomerListItemVo> resultList, LoginSysUser loginSysUser) {

        log.info("进入 patchNeedReviseMarkMailTickStatus");

        if (CollUtil.isEmpty(resultList)) {
            return;
        }

        resultList.forEach(vo -> {

            if (ObjectUtil.isNotNull(vo.getNeedReviseMark())
                    && vo.getNeedReviseMark().compareTo(CommonNeedReviseMarkEnum.修数据_20220505.getKey()) == 0) {

                /** mark by linjinyu at 20220505
                 2.3.4 线上历史数据处理
                 原积分结算开票申请下的“快递公司&快递单号”和“发票文件”数据需合并后挂靠到该开票申请所属的对账单下，不再挂靠在开票申请下。
                 合并后处理方式：
                 ①对账单内的快递公司只取第一个开票申请的快递公司，其他快递公司无需保留；
                 ②对账单内按快递单号的内容需去重，去重后挂靠到对账单下；
                 ③对账单内按发票文件的名称内容去重，去重后挂靠到对账单下；
                 */

                Integer[] invoiceProgressingStatusContains = {
                        InvoiceApplyCustomerInvoiceProgressingStatusEnum.待寄票.getKey(),
                        InvoiceApplyCustomerInvoiceProgressingStatusEnum.待回款.getKey(),
                        InvoiceApplyCustomerInvoiceProgressingStatusEnum.已完成.getKey()
                };

                Integer[] invoiceMailTickContains = {
                        InvoiceApplyCustomerMailTickStatusEnum.已寄票.getKey()
                };

                List<InvoiceApplyCustomerPageVo> applyCustomerPageVoList = invoiceApplyCustomerService.queryInvoiceApplyListFocusScoreV2_1(
                        InvoiceApplyCustomerQueryCriteriaV2_1
                                .builder()

                                .accountingOrderId(vo.getId())
                                .accountingOrderSn(vo.getAccountingOrderSn())

                                .invoiceProgressingStatusSelected(Arrays.asList(invoiceProgressingStatusContains))
                                .mailTickStatusSelected(Arrays.asList(invoiceMailTickContains))

                                .build()
                );


                AccountingScoreCustomer accountingScoreCustomer = new AccountingScoreCustomer();
                accountingScoreCustomer.setId(vo.getId());

                /**************************************** 逻辑 start ****************************************/

                log.info("\npatchReviseMailTickStatus\n{}", JSONUtil.toJsonPrettyStr(applyCustomerPageVoList));

                if (CollUtil.isNotEmpty(applyCustomerPageVoList)) {

                    Long   expressCompanyId;
                    String expressNo;
                    String attachmentUploadFilesUids;
                    String attachmentUploadFilesUidsDistinct;

                    List<Long>   expressCompanyIdList          = applyCustomerPageVoList.stream().map(o -> o.getExpressCompanyId()).distinct().collect(Collectors.toList());
                    List<String> expressNoList                 = applyCustomerPageVoList.stream().map(o -> o.getExpressNo()).distinct().collect(Collectors.toList());
                    List<String> attachmentUploadFilesUidsList = applyCustomerPageVoList.stream().map(o -> o.getAttachmentUploadFilesUids()).collect(Collectors.toList());


                    expressCompanyId = expressCompanyIdList.get(0);
                    expressNo = expressNoList.get(0);
                    attachmentUploadFilesUids = AnStringUtils.stringListConvertToString(attachmentUploadFilesUidsList);
                    attachmentUploadFilesUidsDistinct = AnStringUtils.stringArrayConvertToStringList(attachmentUploadFilesUids, ",").stream().distinct().collect(Collectors.joining());

                    accountingScoreCustomer.setExpressCompanyId(expressCompanyId);
                    accountingScoreCustomer.setExpressNo(expressNo);
                    accountingScoreCustomer.setAttachmentUploadFilesUids(attachmentUploadFilesUidsDistinct);

                }

                /**************************************** 逻辑   end ****************************************/

                updateByPrimaryKeySelective(accountingScoreCustomer);

                int retReset = opResetNeedReviseMark(vo.getId());

            }
        });

    }

    /**
     * 【5. 积分结算 5.7 线上历史数据处理_积分结算 5.7.2 发票申请管理-20220513-初步整理】
     * https://www.tapd.cn/33003868/prong/stories/view/1133003868001004351
     * 【5. 积分结算 5.7 线上历史数据处理_积分结算 5.7.3 金税盘发票-20220513-初步整理】
     * https://www.tapd.cn/33003868/prong/stories/view/1133003868001004352
     *
     * @param resultList
     * @param loginSysUser
     */
    public void patchNeedReviseMarkServiceNoSourceFrom(List<AccountingOrderScoreCustomerListItemVo> resultList, LoginSysUser loginSysUser) {

        log.info("进入 patchReviseServiceNoSourceFrom");

        if (CollUtil.isEmpty(resultList)) {
            return;
        }

        for (AccountingOrderScoreCustomerListItemVo vo : resultList) {


            if (ObjectUtil.isNotNull(vo.getNeedReviseMark())
                    && vo.getNeedReviseMark().compareTo(CommonNeedReviseMarkEnum.修数据_20220519.getKey()) == 0) {


                log.info("{}", JSONUtil.toJsonStr(vo));

                Long                       accountingOrderId          = vo.getId();
                String                     accountingOrderSn          = vo.getAccountingOrderSn();
                AccountingOrderTypeDimEnum accountingOrderTypeDimEnum = AccountingOrderTypeDimEnum.积分订单;


                String serviceNo  = vo.getServiceNo();
                String sourceFrom = vo.getSourceFrom();

                // 目的
                // 1. 首先是传导

                /**************************************** 验证 start ****************************************/

                if (StrUtil.isBlank(sourceFrom)) {
                    continue;
                }

                /**************************************** 验证 start ****************************************/

                int retFix = invoiceApplyCustomerService.pathFixFieldServiceNoSourceFrom(accountingOrderSn, accountingOrderTypeDimEnum, serviceNo, sourceFrom, loginSysUser);

                int retReset = opResetNeedReviseMark(accountingOrderId);

            } else {
                log.info("{} {}", vo.getNeedReviseMark(), JSONUtil.toJsonStr(vo));
            }
        }

    }

    // 附加信息
    public void additionalInfoGetAccountingList(List<AccountingOrderScoreCustomerListItemVo> result) {

        if (CollUtil.isEmpty(result)) {
            return;
        }

        List<Long> sysUserIds = new ArrayList<>();

        List<Long> createUserIds = result.stream().filter(o -> o.getCreateUserId() != null).filter(AnLamdaUtils.distinctByKey(o -> o.getCreateUserId())).map(o -> o.getCreateUserId()).collect(Collectors.toList());
        List<Long> updateUserIds = result.stream().filter(o -> o.getUpdateUserId() != null).filter(AnLamdaUtils.distinctByKey(o -> o.getUpdateUserId())).map(o -> o.getUpdateUserId()).collect(Collectors.toList());

        sysUserIds.addAll(createUserIds);
        sysUserIds.addAll(updateUserIds);

        sysUserIds = sysUserIds.stream().distinct().collect(Collectors.toList());

        log.info("\n{}", JSONUtil.toJsonStr(sysUserIds));

        Map<Long, SysUser> sysUserMap = sysUserService.convertSysUserIds2MapSysUserId2Entity(sysUserIds);

        for (AccountingOrderScoreCustomerListItemVo vo : result) {

            vo.setAccountingStatusName(AccountingOrderCustomerAccountingStatusEnum.getDesc(vo.getAccountingStatus()));
            vo.setInvoiceStatusName(AccountingOrderInvoiceApplyStatusEnum.getDesc(vo.getInvoiceStatus()));
            vo.setSendEmailStatusName(AccountingOrderIsSendEmailEnum.getDesc(vo.getIsSendEmail()));

            /**************************************** mark by linjinyu at 20220516 v2.3 start ****************************************/

            // 补 订单类型-订单来源-引用enum CommonServiceNoEnum
            if (ObjectUtil.isNotNull(vo.getServiceNo())) {
                vo.setServiceNoName(CommonServiceNoEnum.getByServiceNo(vo.getServiceNo()).getServiceName());
            } else {
                vo.setServiceNoName(CommonServiceNoEnum.UNKNOW.getServiceName());
            }
            // 补 操作来源-引用enum CommonSourceFromEnum
            if (ObjectUtil.isNotNull(vo.getSourceFrom())) {
                vo.setSourceFromName(CommonSourceFromEnum.getBySourceFromCode(vo.getSourceFrom()).getSourceFromName());
            } else {
                vo.setSourceFromName(CommonSourceFromEnum.UNKNOW.getSourceFromName());
            }

            /**************************************** mark by linjinyu at 20220516 v2.3 start ****************************************/

            // 修人
            if (sysUserMap.get(vo.getCreateUserId()) != null) {
                vo.setCreateUserName(sysUserMap.get(vo.getCreateUserId()).getFullname());
            } else if (vo.getCreateUserId().equals(1L)) {
                vo.setCreateUserName("系统");
            }

            if (sysUserMap.get(vo.getUpdateUserId()) != null) {
                vo.setUpdateUserName(sysUserMap.get(vo.getUpdateUserId()).getFullname());
            } else if (vo.getCreateUserId().equals(1L)) {
                vo.setUpdateUserName("系统");
            }

            // 修积分类型
            if (StrUtil.isNotBlank(vo.getCreditTypeStruct())) {
                vo.setCreditTypeList(AnJsonUtils.toList(vo.getCreditTypeStruct(), CreditTypeItemVo.class));
            }

        }

        // 这个不知道是什么需求的,这样查,会超级慢
//			for (int i = 0; i < viewUnifiedOrderGoodsList.size(); i++) {
//
//				ViewUnifiedOrderGoods item = viewUnifiedOrderGoodsList.get(i);
//
//				item.setGoodsAmount(new BigDecimal(item.getPrice().doubleValue() * item.getQuantity()));
//
//				ViewUnifiedOrderGoodsUtils.setInvStateName(item);
//				ViewUnifiedOrderGoodsUtils.setPayTypeName(item);
//
//				// 临时 查找发票信息
//
//				Map<String, Object> invQuery = new HashMap<>();
//				invQuery.put("sn", item.getOrderSn());
//				List<InvoiceApply> applies = invoiceApplyDubboConsumerService.findInvoiceBySn(invQuery);
//
//				if (applies != null && applies.size() == 1) {
//					item.setInvNumber(applies.get(0).getInvoiceNumber());
//					item.setInvSn(applies.get(0).getInvoiceNo());
//				}
//			}
    }


    /**
     * @param queryCriteria
     * @return
     */
    @Override
    public AccountingOrderScoreCustomerHeadVo getAccountingOrderListHeadSum(AccountingOrderScoreCustomerQueryCriteria queryCriteria) {

        return accountingScoreCustomerMapperEx.getAccountingOrderListHeadSum(queryCriteria);

    }

    /****************************************** 积分结算 对账单   end ******************************************/


    /****************************************** 积分结算 对账单 详情 start ******************************************/


    @Override
    public AccountingOrderScoreCustomerListItemVo getAccountingOrderScoreCustomerVoByAccountingOrderId(AccountingOrderScoreCustomerOpDetailQueryCriteria queryCriteria, LoginSysUser loginSysUser) {

        List<AccountingOrderScoreCustomerListItemVo> setAccountingObj = getAccountingOrderList(
                AccountingOrderScoreCustomerQueryCriteria
                        .builder()
                        .accountingOrderIds(Arrays.asList(queryCriteria.getAccountingOrderId()))
                        .build(),
                loginSysUser
        );

        if (CollUtil.isNotEmpty(setAccountingObj)) {
            return setAccountingObj.get(0);
        } else {
            return null;
        }
    }


    @Override
    public AccountingOrderScoreCustomerDetailVo commonStatementOfAccountDetailDimCredit(AccountingOrderScoreCustomerOpDetailQueryCriteria queryCriteria, LoginSysUser loginSysUser) {


        // 修正 申请状态 fix invoiceStatus
        invoiceApplyXGoodsService.checkInvoiceStatusByAccountingOrderIdAndUpdateAccountingEntityFocusScore(queryCriteria.getAccountingOrderId(), CommonBeRelatedEnum.失联, loginSysUser);

        log.info("commonStatementOfAccountDetailDimCredit ->\n{}\n{}", JSONUtil.toJsonStr(queryCriteria), JSONUtil.toJsonStr(loginSysUser));

        AccountingOrderScoreCustomerDetailVo accountingScoreCustomerDetailVo = new AccountingOrderScoreCustomerDetailVo();

        /****************************************** 得到 对账单 主体 start ******************************************/

            AccountingOrderScoreCustomerListItemVo accountingOrderScoreCustomerVo = getAccountingOrderScoreCustomerVoByAccountingOrderId(queryCriteria, loginSysUser);

        if (ObjectUtil.isNull(accountingOrderScoreCustomerVo)) {
            return accountingScoreCustomerDetailVo;
        }


        // sugarUp
        DtoSugarUpUtils.sugarUpAccountingOrderScoreCustomerVo(accountingOrderScoreCustomerVo);

        accountingScoreCustomerDetailVo.setAccounting(accountingOrderScoreCustomerVo);

        /****************************************** 得到 对账单 主体   end ******************************************/

        /****************************************** 得到 对账单 X 积分流水 start ******************************************/

        // 关键点 这个判定 是否包含 不对账
        List<Long> idsCredit = getAccountingXCreditIdsByQueryCriteria(queryCriteria);

        List<InvoiceApplyDetailDimCreditItemVo> setCreditListObj = scoreOrderService.getScoreOrderReconciliationNotYetScene3(
                AccountingOrderScoreCustomerNotYetDimCreditScene3QueryCriteria
                        .builder()
                        .idsCredit(idsCredit)
                        .build(),
                loginSysUser
        );

        accountingScoreCustomerDetailVo.setCreditList(setCreditListObj);

        /****************************************** 得到 对账单 X 积分流水   end ******************************************/

        /****************************************** 得到 对账单 X 销方信息 收款方信息 start ******************************************/

        InvoiceBankInfoVo invoiceBankInfoVo = null;
        if (StrUtil.isNotBlank(accountingOrderScoreCustomerVo.getInvoiceBankInfoSnapshot())) {
            invoiceBankInfoVo = AnJsonUtils.toObject(accountingOrderScoreCustomerVo.getInvoiceBankInfoSnapshot(), InvoiceBankInfoVo.class);
        } else {
            InvoiceBankInfo invoiceBankInfo = invoiceBankInfoService.getInvoiceBankInfoByIdOrNullByDefault(accountingOrderScoreCustomerVo.getBankInfoId());
            invoiceBankInfoVo = AnBeanUtils.copy(invoiceBankInfo, InvoiceBankInfoVo.class);
        }
        accountingScoreCustomerDetailVo.setBankInfo(invoiceBankInfoVo);

        /****************************************** 得到 对账单 X 销方信息 收款方信息   end ******************************************/

        return accountingScoreCustomerDetailVo;
    }

    //创建报账单详情页面
    @Override
    public CreateRmAccountingVo getCreateRmAccountDetail(Long accountingOrderId, LoginSysUser loginSysUser) {
        AccountingOrderScoreCustomerOpDetailQueryCriteria queryCriteria = new AccountingOrderScoreCustomerOpDetailQueryCriteria();
        queryCriteria.setAccountingOrderId(accountingOrderId);
        AccountingOrderScoreCustomerListItemVo accountingOrderScoreCustomerVo = getAccountingOrderScoreCustomerVoByAccountingOrderId(queryCriteria, loginSysUser);
        CreateRmAccountingVo createRmAccountingVo = new CreateRmAccountingVo();
        if (ObjectUtil.isNull(accountingOrderScoreCustomerVo)) {
            return createRmAccountingVo;
        }
        DtoSugarUpUtils.sugarUpAccountingOrderScoreCustomerVo(accountingOrderScoreCustomerVo);
        CreateRmAccountingVo.CreateRmAccountingDetailVo accounting = new CreateRmAccountingVo.CreateRmAccountingDetailVo();
        BeanUtils.copyProperties(accountingOrderScoreCustomerVo,accounting);
        accounting.setAccountingStatusName(AccountingOrderCustomerAccountingStatusEnum.getDesc(accounting.getAccountingStatus()));

        //未报账应收账款(非微信)
        BigDecimal unReceivableAmount = BigDecimal.ZERO;
        //未报账-应收账款(微信)
        BigDecimal unWxReceivableAmount = BigDecimal.ZERO;
        //未报账-应付账款
        BigDecimal unPayableAmount = BigDecimal.ZERO;
        //应收账款(非微信)
        BigDecimal receivableAmount = BigDecimal.ZERO;
        //应收账款(微信)
        BigDecimal wxReceivableAmount = BigDecimal.ZERO;
        //应付账款
        BigDecimal payableAmount = BigDecimal.ZERO;

        //应收流水汇总
        FlowReceivableSummary receivableSummaryParam = new FlowReceivableSummary();
        receivableSummaryParam.setAccountingOrderSn(accounting.getAccountingOrderSn());
        receivableSummaryParam.setType(0);
        List<FlowReceivableSummary> allReceivableSummaryList = flowReceivableSummaryMapper.selectFlowReceivableSummaryList(receivableSummaryParam);

        FlowPayableSummary payableSummaryParam = new FlowPayableSummary();
        payableSummaryParam.setAccountingOrderSn(accounting.getAccountingOrderSn());
        payableSummaryParam.setType(0);
        List<FlowPayableSummary> allPayableSummaryList = flowPayableSummaryMapper.selectFlowPayableSummaryList(payableSummaryParam);

        if(CollectionUtils.isNotEmpty(allReceivableSummaryList)){
            for (FlowReceivableSummary receivable: allReceivableSummaryList){
                //积分类型 0-微信 1-福利积分
                if(receivable.getCreditType() == 0){
                    if(receivable.getRmAccountState() == 0 ){
                        unWxReceivableAmount = wxReceivableAmount.add(receivable.getReceivableAmount());
                    }
                    wxReceivableAmount = wxReceivableAmount.add(receivable.getReceivableAmount());
                }else{
                    if(receivable.getRmAccountState() == 0){
                        unReceivableAmount = receivableAmount.add(receivable.getReceivableAmount());
                    }
                    receivableAmount = receivableAmount.add(receivable.getReceivableAmount());
                }
            }
        }
        if(CollectionUtils.isNotEmpty(allPayableSummaryList)) {
            for (FlowPayableSummary payable : allPayableSummaryList) {
                if(payable.getRmAccountState() == 0 ){
                    unPayableAmount = unPayableAmount.add(payable.getPayableAmount());
                }
                payableAmount = payableAmount.add(payable.getPayableAmount());
            }
        }

        accounting.setFinalWxReceivableAmount("0.00");
        accounting.setFinalReceivableAmount("0.00");
        accounting.setReceivableAmount(receivableAmount.setScale(2,BigDecimal.ROUND_HALF_UP).toString());
        accounting.setUnReceivableAmount(unReceivableAmount.setScale(2,BigDecimal.ROUND_HALF_UP).toString());
        accounting.setWxReceivableAmount(wxReceivableAmount.setScale(2,BigDecimal.ROUND_HALF_UP).toString());
        accounting.setUnWxReceivableAmount(unWxReceivableAmount.setScale(2,BigDecimal.ROUND_HALF_UP).toString());
        //积分类型 0-微信 1-福利积分
        if(!allReceivableSummaryList.stream().anyMatch(data -> data.getCreditType() == 0)){
            accounting.setWxReceivableAmount("");
            accounting.setUnWxReceivableAmount("/");
            accounting.setFinalWxReceivableAmount("");
        }
        if(!allReceivableSummaryList.stream().anyMatch(data -> data.getCreditType() != 0)){
            accounting.setReceivableAmount("");
            accounting.setUnReceivableAmount("/");
            accounting.setFinalReceivableAmount("");
        }

        //报账完成-应收账款(非微信)
        BigDecimal finalReceivableAmount = BigDecimal.ZERO;
        //报账完成-应收账款(微信)
        BigDecimal finalWxReceivableAmount = BigDecimal.ZERO;
        //报账完成-应付账款
        BigDecimal finalPayableAmount = BigDecimal.ZERO;
        List<AccountingReceivablePayable> receivableList = Lists.newArrayList();
        List<AccountingReceivablePayable> payableList = Lists.newArrayList();
        //获取报账单集合
        AccountingReceivablePayable accountingReceivablePayableParam = new AccountingReceivablePayable();
        accountingReceivablePayableParam.setAccountingOrderSn(accounting.getAccountingOrderSn());
        accountingReceivablePayableParam.setBillTypeList(Lists.newArrayList(0,1,2));
        List<AccountingReceivablePayable> accountingList = accountingReceivablePayableMapper.selectAccountingReceivablePayableList(accountingReceivablePayableParam);
        if(CollectionUtils.isNotEmpty(accountingList)){
            receivableList = accountingList.stream().filter(data -> Lists.newArrayList(0,1)
                    .contains(data.getBillType())).collect(Collectors.toList());
            payableList = accountingList.stream().filter(data -> data.getBillType() == 2).collect(Collectors.toList());
            if(CollectionUtils.isNotEmpty(receivableList)){
                List<AccountingReceivablePayableVo> receivableVoList = new ArrayList<>();
                for (AccountingReceivablePayable receivable: receivableList){
                    AccountingReceivablePayableVo receivableVo = new AccountingReceivablePayableVo();
                    BeanUtils.copyProperties(receivable,receivableVo);
                    receivableVo.setAccountingStateName(CommonReportAccountingStateEnum.getDesc(receivableVo.getAccountingState()));
                    receivableVo.setDataTypeName(CommonReportAccountingDataTypeEnum.getDesc(receivableVo.getDataType()));
                    receivableVo.setBillTypeName(CommonReportAccountingTypeEnum.getDesc(receivableVo.getBillType()));
                    receivableVo.setBillAmount(Optional.ofNullable(receivable.getBillAmount()).orElse(BigDecimal.ZERO).setScale(2,BigDecimal.ROUND_HALF_UP).toString());
                    receivableVoList.add(receivableVo);

                    if(receivable.getDataType() == 0){
                        if(receivable.getAccountingState() == 3){
                            finalReceivableAmount = finalReceivableAmount.add(receivable.getBillAmount());
                        }
                    }else{
                        if(receivable.getAccountingState() == 3 ){
                            finalWxReceivableAmount = finalWxReceivableAmount.add(receivable.getBillAmount());
                        }
                    }
                }
                receivableVoList = receivableVoList.stream().sorted(Comparator.comparing(AccountingReceivablePayableVo::getUpdateTime).reversed()).collect(Collectors.toList());
                createRmAccountingVo.setReceivableVoList(receivableVoList);
            }

            if(CollectionUtils.isNotEmpty(payableList)){
                List<AccountingReceivablePayableVo> payableVoList = new ArrayList<>();
                for (AccountingReceivablePayable payable: payableList){
                    AccountingReceivablePayableVo payableVo = new AccountingReceivablePayableVo();
                    BeanUtils.copyProperties(payable,payableVo);
                    payableVo.setAccountingStateName(CommonReportAccountingStateEnum.getDesc(payableVo.getAccountingState()));
                    payableVo.setDataTypeName(CommonReportAccountingDataTypeEnum.getDesc(payableVo.getDataType()));
                    payableVo.setBillTypeName(CommonReportAccountingTypeEnum.getDesc(payableVo.getBillType()));
                    payableVo.setBillAmount(Optional.ofNullable(payable.getBillAmount()).orElse(BigDecimal.ZERO).setScale(2,BigDecimal.ROUND_HALF_UP).toString());
                    payableVoList.add(payableVo);

                    if(payable.getAccountingState() == 3){
                        finalPayableAmount = finalPayableAmount.add(payable.getBillAmount());
                    }
                }
                payableVoList = payableVoList.stream().sorted(Comparator.comparing(AccountingReceivablePayableVo::getUpdateTime).reversed()).collect(Collectors.toList());
                createRmAccountingVo.setPayableVoList(payableVoList);
            }
        }
        //数据类型,0非微信/1微信
        if(CollectionUtils.isNotEmpty(receivableList)){
            if(receivableList.stream().anyMatch(data -> data.getDataType() == 1)){
                accounting.setFinalWxReceivableAmount(finalWxReceivableAmount.setScale(2,BigDecimal.ROUND_HALF_UP).toString());
            }
            if(receivableList.stream().anyMatch(data -> data.getDataType() == 0)){
                accounting.setFinalReceivableAmount(finalReceivableAmount.setScale(2,BigDecimal.ROUND_HALF_UP).toString());
            }
        }
        accounting.setFinalPayableAmount(finalPayableAmount.setScale(2,BigDecimal.ROUND_HALF_UP).toString());

        accounting.setStatisticsTotalAmount(accountingOrderScoreCustomerVo.getStatisticsTotalAmount().setScale(2,BigDecimal.ROUND_HALF_UP).toString());
        accounting.setAccountingAmount(accountingOrderScoreCustomerVo.getAccountingAmount().setScale(2,BigDecimal.ROUND_HALF_UP).toString());
        accounting.setUnAccountingAmount(accountingOrderScoreCustomerVo.getUnAccountingAmount().setScale(2,BigDecimal.ROUND_HALF_UP).toString());
        accounting.setReceivableCount(receivableList != null ? receivableList.size() : 0);
        accounting.setPayableCount(payableList != null ? payableList.size() : 0);
        accounting.setPayableAmount(payableAmount.setScale(2,BigDecimal.ROUND_HALF_UP).toString());
        accounting.setUnPayableAmount(unPayableAmount.setScale(2,BigDecimal.ROUND_HALF_UP).toString());
        createRmAccountingVo.setAccounting(accounting);
        return createRmAccountingVo;
    }

    //推送报账单详情页面
    @Override
    public PushRmAccountingVo getPushRmAccountDetail(Long id, LoginSysUser loginSysUser) {
        AccountingReceivablePayable receivablePayable = accountingReceivablePayableMapper.selectAccountingReceivablePayableById(id);
        if(receivablePayable == null){
            return null;
        }
        AccountingPushShareData pushShareData = new AccountingPushShareData();
        pushShareData.setAccountingRpId(id);
        pushShareData.setAccountingOrderSn(receivablePayable.getAccountingOrderSn());
        List<AccountingPushShareData> shareDataList = accountingPushShareDataMapper.selectAccountingPushShareDataList(pushShareData);

        if(CollectionUtils.isNotEmpty(shareDataList)){
            pushShareData = shareDataList.get(0);
        }

        PushRmAccountingVo.PushRmAccountingDetailVo detailVo = new PushRmAccountingVo.PushRmAccountingDetailVo();
        BeanUtils.copyProperties(receivablePayable,detailVo);
        detailVo.setAccountingStateName(CommonReportAccountingStateEnum.getDesc(detailVo.getAccountingState()));
        detailVo.setBillTypeName(CommonReportAccountingTypeEnum.getDesc(detailVo.getBillType()));
        detailVo.setBillAmount(Optional.ofNullable(receivablePayable.getBillAmount()).orElse(BigDecimal.ZERO).setScale(2,BigDecimal.ROUND_HALF_UP).toString());

        SysBusinessUserVo businessUserVo = new SysBusinessUserVo();
        //账款类型 0应收款项/1应付款项
        Integer accountType = receivablePayable.getAccountType();
        String headData = pushShareData.getHeadData();
        if(StringUtils.isNotBlank(headData)){
            JSONObject jsonObject = JSONObject.parseObject(headData);
            detailVo.setBusinessCategory(jsonObject.getString("businessCategory"));
            detailVo.setOperationTypeCode(jsonObject.getString("operationTypeCode"));

            businessUserVo.setUserName(jsonObject.getString("employeeName"));
            businessUserVo.setJobName(jsonObject.getString("employeePostName"));
            businessUserVo.setDepartmentName(jsonObject.getString("employeeDepartmentName"));
            if(accountType == 0){
                detailVo.setRemark(jsonObject.getString("remark"));
                detailVo.setCompanyNum(jsonObject.getString("companyNum"));
                detailVo.setCompanyName(jsonObject.getString("companyName"));

                businessUserVo.setWorkNumber(jsonObject.getString("employeeId"));
                businessUserVo.setJobCode(jsonObject.getString("employeePostId"));
                businessUserVo.setDepartmentCode(jsonObject.getString("employeeDepartmentId"));
            }else{
                detailVo.setRemark(jsonObject.getString("boeAbstract"));
                detailVo.setCompanyNum(jsonObject.getString("leCode"));
                detailVo.setCompanyName(jsonObject.getString("leName"));

                businessUserVo.setWorkNumber(jsonObject.getString("employeeCode"));
                businessUserVo.setJobCode(jsonObject.getString("postCode"));
                businessUserVo.setDepartmentCode(jsonObject.getString("expenseDeptCode"));
            }
        }

        PushRmAccountingVo pushRmAccountingVo = new PushRmAccountingVo();

        String rowData = pushShareData.getRowData();
        if(StringUtils.isNotBlank(rowData)){
            if(accountType == 0){
                List<PushRmAccountingVo.PushReceivableVo> receivableVoList = JSONObject.parseArray(rowData,PushRmAccountingVo.PushReceivableVo.class);
                detailVo.setTotalCount(0);
                if(CollectionUtils.isNotEmpty(receivableVoList)){
                    detailVo.setTotalCount(receivableVoList.size());

                    BigDecimal totalAmount = BigDecimal.ZERO;
                    BigDecimal totalTaxAmount = BigDecimal.ZERO;
                    for (PushRmAccountingVo.PushReceivableVo receivable: receivableVoList){
                        totalAmount = totalAmount.add(new BigDecimal(Optional.ofNullable(receivable.getAmount()).orElse("0")));
                        totalTaxAmount = totalTaxAmount.add(new BigDecimal(Optional.ofNullable(receivable.getTaxAmount()).orElse("0")));

                        BigDecimal taxRate = new BigDecimal(Objects.toString(receivable.getTaxRate(),"0"));
                        receivable.setTaxType(AccountingTaxTypeEnum.getEnum(taxRate).getRemark()+"("+receivable.getTaxType()+")");
                        receivable.setTaxRate(Objects.toString(new BigDecimal(Objects.toString(receivable.getTaxRate(),"0")).intValue()));
                    }
                    detailVo.setTotalAmount(totalAmount.setScale(2,BigDecimal.ROUND_HALF_UP).toString());
                    detailVo.setTotalTaxAmount(totalTaxAmount.setScale(2,BigDecimal.ROUND_HALF_UP).toString());
                }
                receivableVoList = receivableVoList.stream().sorted(Comparator.comparing(data -> new BigDecimal(Objects.toString(data.getTaxRate(),"0")))).collect(Collectors.toList());
                pushRmAccountingVo.setReceivableVoList(receivableVoList);
            }else{
                Map<String,BizContract> bizContractMap = new HashMap<>();

                List<PushRmAccountingVo.PushPayableVo> pushPayableVosList = JSONObject.parseArray(rowData,PushRmAccountingVo.PushPayableVo.class);
                detailVo.setTotalCount(0);
                if(CollectionUtils.isNotEmpty(pushPayableVosList)){
                    detailVo.setTotalCount(pushPayableVosList.size());

                    BigDecimal totalAmount = BigDecimal.ZERO;
                    BigDecimal totalTaxAmount = BigDecimal.ZERO;
                    for (PushRmAccountingVo.PushPayableVo receivable: pushPayableVosList){
                        totalAmount = totalAmount.add(new BigDecimal(Optional.ofNullable(receivable.getExpenseAmount()).orElse("0")));
                        totalTaxAmount = totalTaxAmount.add(new BigDecimal(Optional.ofNullable(receivable.getTaxAmount()).orElse("0")));
                        BigDecimal taxRate = new BigDecimal(Objects.toString(receivable.getTaxRate(),"0"));
                        receivable.setTaxCode(AccountingTaxTypeEnum.getEnum(taxRate).getRemark()+"("+receivable.getTaxCode()+")");
                        receivable.setTaxRate(Objects.toString(new BigDecimal(Objects.toString(receivable.getTaxRate(),"0")).intValue()));

                        BizContract bizContract = bizContractMap.get(receivable.getVendorId());
                        if (bizContract == null) {
                            BizContract bizContractParam = new BizContract();
                            bizContractParam.setSupplierId(Long.valueOf(Objects.toString(receivable.getVendorId(),"0")));
                            bizContractParam.setIsDefault("Y");
                            List<BizContract> contractList = bizContractMapper.selectBizContractList(bizContractParam);
                            if (CollectionUtils.isNotEmpty(contractList)) bizContract = contractList.get(0);
                            if (bizContract != null) {
                                bizContractMap.put(receivable.getVendorId(), bizContract);
                            }
                        }
                        if (bizContract != null) {
                            receivable.setContractId(bizContract.getId().toString());
                            receivable.setContractNum(bizContract.getContractCode());
                            receivable.setContractName(bizContract.getContractName());
                        }
                    }
                    detailVo.setTotalAmount(totalAmount.setScale(2,BigDecimal.ROUND_HALF_UP).toString());
                    detailVo.setTotalTaxAmount(totalTaxAmount.setScale(2,BigDecimal.ROUND_HALF_UP).toString());
                }
                Map<Long,UnifiedSupplier> supplierMap = new HashMap<>();
                List<PushRmAccountingVo.PushReceivableVo> receivableVoList = pushPayableVosList.stream().map(data ->{
                    PushRmAccountingVo.PushReceivableVo pushReceivableVo = new PushRmAccountingVo.PushReceivableVo();
                    BeanUtils.copyProperties(data,pushReceivableVo);
                    pushReceivableVo.setTaxType(data.getTaxCode());
                    pushReceivableVo.setAmount(data.getExpenseAmount());
                    pushReceivableVo.setCostcenterId(data.getCcCode());
                    pushReceivableVo.setCostcenterName(data.getCcName());
                    pushReceivableVo.setFormatType(data.getBusinessType());
                    pushReceivableVo.setServiceType(data.getDimensionFwjsp());
                    pushReceivableVo.setProjectNum(data.getProjectCode());

                    Long cusSettlementId = Long.valueOf(Objects.toString(pushReceivableVo.getVendorId(),"0"));
                    UnifiedSupplier supplier = supplierMap.get(pushReceivableVo.getVendorId());
                    if (supplier == null) {
                        supplier = unifiedSupplierMapper.selectByPrimaryKey(cusSettlementId);
                        if (supplier != null) {
                            supplierMap.put(cusSettlementId, supplier);
                        }
                    }
                    if (supplier != null) {
                        String taxCommon = supplier.getTaxCommon();
                        String taxSimple = supplier.getTaxSimple();
                        String taxSmall = supplier.getTaxSmall();
                        Set<String> taxRateList = Sets.newHashSet();
                        if(StringUtils.isNotBlank(taxCommon)){
                            taxRateList.addAll(Sets.newHashSet(taxCommon.replace("%","").split(",")));
                        }
                        if(StringUtils.isNotBlank(taxSimple)){
                            taxRateList.addAll(Sets.newHashSet(taxSimple.replace("%","").split(",")));
                        }
                        if(StringUtils.isNotBlank(taxSmall)){
                            taxRateList.addAll(Sets.newHashSet(taxSmall.replace("%","").split(",")));
                        }
                        if(!taxRateList.contains(pushReceivableVo.getTaxRate())){
                            pushReceivableVo.setTaxType("");
                        }
                    }

                    return pushReceivableVo;
                }).collect(Collectors.toList());

                receivableVoList = receivableVoList.stream().sorted(Comparator.comparing(data -> new BigDecimal(Objects.toString(data.getTaxRate(),"0")))).collect(Collectors.toList());
                pushRmAccountingVo.setPayableVoList(receivableVoList);
            }
        }
        pushRmAccountingVo.setAccounting(detailVo);

        //业务员信息
        SysBusinessUserVo businessUser = null;
        if(detailVo.getBizUserId() != null){
            businessUser = sysBusinessUserMapper.selectByPrimaryKey(detailVo.getBizUserId());
            businessUserVo.setBindOperationUser(businessUser.getBindOperationUser());
            businessUserVo.setBindOperationUserid(businessUser.getBindOperationUserid());
            businessUserVo.setId(businessUser.getId());
            businessUserVo.setDutyDepartmentCode(businessUser.getDutyDepartmentCode());
            businessUserVo.setDutyDepartmentName(businessUser.getDutyDepartmentName());
        }
        pushRmAccountingVo.setBusinessUserVo(businessUserVo);

        return pushRmAccountingVo;
    }

    //导出应收应付流水
    @Override
    public SysNotify exportAccountingFlow(Long id, LoginSysUser loginSysUser){
        AccountingScoreCustomer scoreCustomer = accountingScoreCustomerMapper.selectByPrimaryKey(id);
        if (ObjectUtil.isNull(scoreCustomer)) {
            return null;
        }

        String accountingOrderSn = scoreCustomer.getAccountingOrderSn();
        //应收流水汇总
        FlowReceivableSummary receivableSummaryParam = new FlowReceivableSummary();
        receivableSummaryParam.setAccountingOrderSn(accountingOrderSn);
        receivableSummaryParam.setType(0);
        List<FlowReceivableSummary> receivableSummaryList = flowReceivableSummaryMapper.selectFlowReceivableSummaryList(receivableSummaryParam);

        //应付流水汇总
        FlowPayableSummary payableSummaryParam = new FlowPayableSummary();
        payableSummaryParam.setAccountingOrderSn(accountingOrderSn);
        payableSummaryParam.setType(0);
        List<FlowPayableSummary> payableSummaryList = flowPayableSummaryMapper.selectFlowPayableSummaryList(payableSummaryParam);

        //对账单应收应付流水明细
        FlowReceivableDetail receivableParam = new FlowReceivableDetail();
        receivableParam.setAccountingOrderSn(scoreCustomer.getAccountingOrderSn());
        List<FlowReceivableDetail>  receivableDetailList = flowReceivableDetailMapper.selectFlowReceivableDetailList(receivableParam);

        //对账单应付应付流水明细
        FlowPayableDetail payableParam = new FlowPayableDetail();
        payableParam.setAccountingOrderSn(scoreCustomer.getAccountingOrderSn());
        List<FlowPayableDetail> payableDetailList = flowPayableDetailMapper.selectFlowPayableDetailList(payableParam);

        String excelExportPathRoot = resourceConstant.getPathRoot();
        String excelExportRelativePathTemplate = resourceConstant.getPathTemplate();
        String excelExportRelativePathStorage  = resourceConstant.getPathStorage();

        String relativePath = File.separator + "excel" + File.separator + "accounting" + File.separator + "score" + File.separator + "customer" + File.separator;
        String templateRelativePath = excelExportPathRoot + excelExportRelativePathTemplate + relativePath;
        String templateFullPath = templateRelativePath + TEMPLATE_EXCEL_EXPORT_RM_ACCOUNTING_FLOW_FPTXX_PRE;
        String targetFileName  =  accountingOrderSn + "_对账单应收&应付流水" + DateUtils.dateTime() + ".xlsx";

        String targetFullPath = excelExportPathRoot + excelExportRelativePathStorage;
        String targetWriteFileFullPath = targetFullPath + relativePath + targetFileName;

        FileUtil.touch(targetWriteFileFullPath);

        ExcelWriterBuilder excelWriterBuilder = EasyExcel.write(targetWriteFileFullPath);
        ExcelWriter excelWriter = excelWriterBuilder.withTemplate(templateFullPath).build();

        WriteSheet writeSheet0 = EasyExcel.writerSheet(0, "应收流水汇总_对账单").build();
        WriteSheet writeSheet1 = EasyExcel.writerSheet(1, "应收流水明细_对账单").build();
        WriteSheet writeSheet2 = EasyExcel.writerSheet(2, "应付流水汇总_对账单").build();
        WriteSheet writeSheet3 = EasyExcel.writerSheet(3, "应付流水明细_对账单").build();
        FillConfig fillConfig  = FillConfig.builder().forceNewRow(Boolean.FALSE).build();

        if(CollectionUtils.isNotEmpty(receivableSummaryList)){
            receivableSummaryList.forEach(data ->{
                data.setRmAccountStateName(RmAccountStateEnum.getDesc(data.getRmAccountState()));
                data.setInAccountTypeName(InAccountTypeEnum.getDesc(data.getInAccountType()));
            });
        }
        if(CollectionUtils.isNotEmpty(payableSummaryList)){
            payableSummaryList.forEach(data ->{
                data.setRmAccountStateName(RmAccountStateEnum.getDesc(data.getRmAccountState()));
                data.setInAccountTypeName(InAccountTypeEnum.getDesc(data.getInAccountType()));
            });
        }
        if(CollectionUtils.isNotEmpty(receivableDetailList)){
            receivableDetailList.forEach(data ->{
                data.setAccountingStateName(AccountingStateEnum.getDesc(data.getAccountingState()));
                data.setInAccountStateName(InAccountStateEnum.getDesc(data.getInAccountState()));
                data.setChargeStatusName(ChargeStatusEnum.getDesc(data.getChargeStatus()));
            });
        }
        if(CollectionUtils.isNotEmpty(payableDetailList)){
            payableDetailList.forEach(data ->{
                data.setAccountingStateName(AccountingStateEnum.getDesc(data.getAccountingState()));
                data.setInAccountStateName(InAccountStateEnum.getDesc(data.getInAccountState()));
            });
        }
        excelWriter.fill(receivableSummaryList, fillConfig, writeSheet0);
        excelWriter.fill(receivableDetailList, fillConfig, writeSheet1);
        excelWriter.fill(payableSummaryList, fillConfig, writeSheet2);
        excelWriter.fill(payableDetailList, fillConfig, writeSheet3);

        excelWriter.finish();

        return NotifyUtils.createSysNotify(targetFileName, relativePath + targetFileName, SysQuartzScheduleTaskStatementOfAccountRunStateEnum.成功);
    }

    /****************************************** 积分结算 对账单 详情   end ******************************************/


    /****************************************** 积分结算 对账单 操作 start ******************************************/


    /**
     * 效率优化 mark by linjinyu at 20211203
     *
     * @param accountingScoreCustomer
     * @param scoreAccountingCustomerXCreditList
     * @return
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public AccountingScoreCustomer createScoreAccountingCustomer(
            AccountingScoreCustomer accountingScoreCustomer,
            List<AccountingScoreCustomerXCredit> scoreAccountingCustomerXCreditList) {

        if (StringUtils.isBlank(accountingScoreCustomer.getAccountingOrderSn())) {
            accountingScoreCustomer.setAccountingOrderSn(unifiedSnConfigService.getCustomerStatementOfAccountSnBySnowflake(""));
        }

        accountingScoreCustomerMapper.insert(accountingScoreCustomer);

        // 慢的原因 已优化 mark by linjinyu at 20211203
        for (AccountingScoreCustomerXCredit x : scoreAccountingCustomerXCreditList) {

            x.setAccountingOrderId(accountingScoreCustomer.getId());
            x.setAccountingOrderSn(accountingScoreCustomer.getAccountingOrderSn());
//			accountingScoreCustomerXCreditMapper.insert(x);

        }

        log.info("AccountingScoreCustomerXCredit \n{}", JSONUtil.toJsonStr(scoreAccountingCustomerXCreditList));

        // 4401
        int ret = accountingScoreCustomerXCreditMapperEx.insertBatch(scoreAccountingCustomerXCreditList);

        log.info("AccountingScoreCustomerXCredit.insertBatch ret = {}", ret);

        List<Long> processUnifiedOrderCreditIds = scoreAccountingCustomerXCreditList.stream()
                .map(AccountingScoreCustomerXCredit::getUnifiedOrderCreditId)
                .collect(Collectors.toList());

        unifiedOrderCreditService.updateFieldAccountingStateCustomerByUnifiedOrderCreditIds(processUnifiedOrderCreditIds, CommonAccountingStateEnum.已对账);

        return accountingScoreCustomer;
    }


    private static String fetchGroupKeyByCreditTypecreditName(InvoiceApplyDetailDimCreditItemVo e) {
        return StrUtil.format("{}^_^{}", e.getCreditType(), e.getCreditName());
    }

    @Override
    public void statisticsScoreAccountingCustomerByCredit(AccountingScoreCustomer accountingScoreCustomer, List<InvoiceApplyDetailDimCreditItemVo> invoiceApplyDetailDimCreditItemVoList) {

        /****************************************** 统计积分批次 start ******************************************/

        List<String> batchsList = invoiceApplyDetailDimCreditItemVoList.stream()
                // 是要去掉 这个会导致一个订单多个积分批次只统计一个的问题
//				.filter(AnLamdaUtils.distinctByKey(o -> o.getUnifiedOrderId()))
                .map(r -> r.getBatchs())
                .distinct()
                .collect(Collectors.toList());

        accountingScoreCustomer.setBatchs(AnStringUtils.stringListConvertToString(batchsList));

        /****************************************** 统计积分批次   end ******************************************/

        /****************************************** 统计积分类型 start ******************************************/

        // 结构体形态
        Map<String, List<InvoiceApplyDetailDimCreditItemVo>> creditTypeMap = invoiceApplyDetailDimCreditItemVoList
                .parallelStream()
                .collect(Collectors.groupingBy(AccountingScoreCustomerServiceImpl::fetchGroupKeyByCreditTypecreditName, Collectors.toList()));

        List<CreditTypeItemVo> creditTypeItemVoList = new ArrayList<>();
        List<Integer>          creditTypeKeyList    = new ArrayList<>();
        List<String>           creditNameValueList  = new ArrayList<>();

        for (Map.Entry<String, List<InvoiceApplyDetailDimCreditItemVo>> entry : creditTypeMap.entrySet()) {
            String[] keyItem = StrUtil.split(entry.getKey(), "^_^");
            creditTypeItemVoList.add(CreditTypeItemVo.builder()
                    .creditType(AnIntegerUtils.getInteger(keyItem[0]))
                    .creditName(AnStringUtils.getString(keyItem[1]))
                    .build());

            creditTypeKeyList.add(AnIntegerUtils.getInteger(keyItem[0]));
            creditNameValueList.add(AnStringUtils.getString(keyItem[1]));
        }

        accountingScoreCustomer.setCreditTypeStruct(JSONUtil.toJsonStr(creditTypeItemVoList));
        accountingScoreCustomer.setCreditType(AnStringUtils.integerListConvertToString(creditTypeKeyList));
        accountingScoreCustomer.setCreditName(AnStringUtils.stringListConvertToString(creditNameValueList));

        /****************************************** 统计积分类型 start ******************************************/

        /****************************************** 统计各项数量 start ******************************************/

        Integer quantityOrder       = 0;
        Integer quantityOrderGoods  = 0;
        Integer quantityOrderCredit = 0;

        quantityOrder = invoiceApplyDetailDimCreditItemVoList.stream().filter(AnLamdaUtils.distinctByKey(o -> o.getUnifiedOrderId())).collect(Collectors.toList()).size();
        quantityOrderGoods = invoiceApplyDetailDimCreditItemVoList.stream().filter(AnLamdaUtils.distinctByKey(o -> o.getUnifiedOrderGoodsId())).collect(Collectors.toList()).size();
        quantityOrderCredit = invoiceApplyDetailDimCreditItemVoList.size();

        accountingScoreCustomer.setQuantityOrder(quantityOrder);
        accountingScoreCustomer.setQuantityOrderGoods(quantityOrderGoods);
        accountingScoreCustomer.setQuantityOrderCredit(quantityOrderCredit);

        /****************************************** 统计各项数量   end ******************************************/

        /****************************************** 统计各项金额 start ******************************************/

        // 对账单-订单金额 - 积分结算2.1 新加 取该对账单中所有流水的结算金额总和 等于 结算金额+微信金额 也称之为统计金额
        BigDecimal statisticsTotalAmount = BigDecimal.ZERO;
        // 对账单-结算金额 - 之前的 - 取该对账单中所有积分类型为非`微信支付`的结算金额总和,目前创建对账单成功时服务端默认`微信支付`流水不参与结算,其他积分类型的流水参与结算,未来由业务操作人员选择结算积分类型来计算
        BigDecimal accountingAmount = BigDecimal.ZERO;
        // 对账单-微信金额 - 积分结算2.1 新加 取该对账单中所有积分类型为`微信支付`的结算金额总和 也称之为不对账金额 不结算金额
        BigDecimal unAccountingAmount = BigDecimal.ZERO;

        List<Predicate<InvoiceApplyDetailDimCreditItemVo>> predicatesByAccounting = new ArrayList<>();
        predicatesByAccounting.add(
                r -> null != r.getCreditType()
                        && r.getCreditType().compareTo(UnifiedOrderCreditTypeDefaultEnum.微信支付.getKey()) != 0
        );

        List<Predicate<InvoiceApplyDetailDimCreditItemVo>> predicatesByUnAccounting = new ArrayList<>();
        predicatesByUnAccounting.add(
                r -> null != r.getCreditType()
                        && r.getCreditType().compareTo(UnifiedOrderCreditTypeDefaultEnum.微信支付.getKey()) == 0
        );

        // 如果本来数据 是没这个流水Id 是找不出来的
        List<InvoiceApplyDetailDimCreditItemVo> findByAccountingCreditList   = AnLamdaUtils.filters(invoiceApplyDetailDimCreditItemVoList, predicatesByAccounting);
        List<InvoiceApplyDetailDimCreditItemVo> findByUnAccountingCreditList = AnLamdaUtils.filters(invoiceApplyDetailDimCreditItemVoList, predicatesByUnAccounting);

        statisticsTotalAmount = invoiceApplyDetailDimCreditItemVoList
                .stream()
                .map(item -> item.getBalance() == null ? BigDecimal.ZERO : item.getBalance())
                .reduce(BigDecimal.ZERO, BigDecimal::add);

        if (CollUtil.isNotEmpty(findByAccountingCreditList)) {
            accountingAmount = findByAccountingCreditList
                    .stream()
                    .map(item -> item.getBalance() == null ? BigDecimal.ZERO : item.getBalance())
                    .reduce(BigDecimal.ZERO, BigDecimal::add);
        }

        if (CollUtil.isNotEmpty(findByUnAccountingCreditList)) {
            unAccountingAmount = findByUnAccountingCreditList
                    .stream()
                    .map(item -> item.getBalance() == null ? BigDecimal.ZERO : item.getBalance())
                    .reduce(BigDecimal.ZERO, BigDecimal::add);
        }

        accountingScoreCustomer.setAccountingAmount(accountingAmount);
        accountingScoreCustomer.setUnAccountingAmount(unAccountingAmount);
        accountingScoreCustomer.setStatisticsTotalAmount(statisticsTotalAmount);

        /****************************************** 统计各项金额   end ******************************************/

    }

    /**
     * 拒绝对账 重新对账 取消对账
     *
     * @param accountingOrderId
     * @param accountingStatus
     * @param loginSysUser
     * @return
     */

    @Override
    @Transactional(rollbackFor = Exception.class)
    public R opCancelAccounting(Long accountingOrderId,
            /* 对账单状态:0-未确认;1-已确认;-1-已取消; */Integer accountingStatus,
                                  LoginSysUser loginSysUser) {
        // 查出 对账单
        AccountingScoreCustomer existDB = accountingScoreCustomerMapper.selectByPrimaryKey(accountingOrderId);
        if(existDB.getReceivableDataStatus().equals(1) || existDB.getPayableDataStatus().equals(1)){
            return R.fail("该对账单的应收或应付数据状态处于“生成中”，请生成完成后再重新对账");
        }
        //获取报账单集合
        AccountingReceivablePayable accountingReceivablePayableParam = new AccountingReceivablePayable();
        accountingReceivablePayableParam.setAccountingOrderSn(existDB.getAccountingOrderSn());
        List<AccountingReceivablePayable> accountingList = accountingReceivablePayableMapper.selectAccountingReceivablePayableList(accountingReceivablePayableParam);
        if(CollectionUtils.isNotEmpty(accountingList)){
            boolean result = accountingList.stream().filter(data -> Lists.newArrayList(0,1,2).contains(data.getBillType()))
                    .anyMatch(data -> data.getAccountingState() == 2);
            if(result){
                return R.fail("该对账单存在“审批中”的应收或应付报账单，待共享完成或作废后才允许重新对账");
            }
            result = accountingList.stream().filter(data -> Lists.newArrayList(3,4).contains(data.getBillType()))
                    .anyMatch(data -> data.getAccountingState() == 2 || data.getAccountingState() == 3);
            if(result){
                return R.fail("该对账单存在“审批中/报账完成”的实收报账单，不允许重新对账");
            }
        }

        //获取账单来源对应的策略
        AccountingScoreCustomerStrategy instance = accountingScoreCustomerStrategyContext.getInstance(existDB.getSourceFrom());

        Map<String,String> chargeIdMap = new HashMap<>();

        String accountingOrderSn = existDB.getAccountingOrderSn();
        FlowReceivableSummary flowReceivableSummaryParam = new FlowReceivableSummary();
        flowReceivableSummaryParam.setAccountingOrderSn(accountingOrderSn);
        flowReceivableSummaryParam.setType(0);
        List<FlowReceivableSummary> receivableSummaryList = flowReceivableSummaryMapper.selectFlowReceivableSummaryList(flowReceivableSummaryParam);
        if(CollectionUtils.isNotEmpty(receivableSummaryList)){
            receivableSummaryList.stream()
                    .filter(data -> data.getRmAccountState() == 0 && data.getInAccountType() == 1)
                    .forEach(data ->{
                        data.setRmAccountState(3);
                        data.setInAccountType(2);
                        data.setUpdateId(loginSysUser.getSysUserId());
                        data.setUpdateBy(loginSysUser.getFullName());
                        data.setUpdateTime(new Date());
                        flowReceivableSummaryMapper.updateFlowReceivableSummary(data);
                    });

            //报账状态为“已报账”&入账类型为“正常入账”的数据,生成一条对应“撤销入账”类型的“应收流水汇总”数据
            receivableSummaryList.stream()
                    .filter(data -> data.getRmAccountState() == 2 && data.getInAccountType() == 1)
                    .forEach(data ->{
                        chargeIdMap.put("chargeReceivableDayId",data.getInAccountId());
                        data.setShareApproveDate(new Date());
                        data.setInAccountId(data.getInAccountId()+"R");
                        data.setInAccountType(2);
                        data.setInAccountWay(0);
                        data.setInAccountDate(new Date());
                        data.setRmAccountUserId(loginSysUser.getSysUserId());
                        data.setRmAccountUserName(loginSysUser.getFullName());
                        data.setRmAccountState(2);
                        data.setIncomeNoTax(data.getIncomeNoTax().negate());
                        data.setTaxAmount(data.getTaxAmount().negate());
                        data.setReceivableAmount(data.getReceivableAmount().negate());
                        data.setCreateId(loginSysUser.getSysUserId());
                        data.setCreateBy(loginSysUser.getFullName());
                        data.setCreateTime(new Date());
                        data.setUpdateId(loginSysUser.getSysUserId());
                        data.setUpdateBy(loginSysUser.getFullName());
                        data.setUpdateTime(new Date());
                        flowReceivableSummaryMapper.insertFlowReceivableSummary(data);
                    });
        }
        FlowPayableSummary flowPayableSummaryParam = new FlowPayableSummary();
        flowPayableSummaryParam.setAccountingOrderSn(accountingOrderSn);
        flowPayableSummaryParam.setType(0);
        List<FlowPayableSummary> payableSummaryList = flowPayableSummaryMapper.selectFlowPayableSummaryList(flowPayableSummaryParam);
        if(CollectionUtils.isNotEmpty(payableSummaryList)){
            payableSummaryList.stream()
                    .filter(data -> data.getRmAccountState() == 0 && data.getInAccountType() == 1)
                    .forEach(data ->{
                        data.setRmAccountState(3);
                        data.setInAccountType(2);
                        data.setUpdateId(loginSysUser.getSysUserId());
                        data.setUpdateBy(loginSysUser.getFullName());
                        data.setUpdateTime(new Date());
                        flowPayableSummaryMapper.updateFlowPayableSummary(data);
            });

            //报账状态为“已报账”&入账类型为“正常入账”的数据,生成一条对应“撤销入账”类型的“应付流水汇总”数据
            payableSummaryList.stream()
                    .filter(data -> data.getRmAccountState() == 2 && data.getInAccountType() == 1)
                    .forEach(data ->{
                        chargeIdMap.put("chargePayableDayId",data.getInAccountId());
                        data.setShareApproveDate(new Date());
                        data.setInAccountId(data.getInAccountId()+"R");
                        data.setInAccountType(2);
                        data.setInAccountWay(0);
                        data.setInAccountDate(new Date());
                        data.setRmAccountUserId(loginSysUser.getSysUserId());
                        data.setRmAccountUserName(loginSysUser.getFullName());
                        data.setRmAccountState(2);
                        data.setCostNoTax(data.getCostNoTax().negate());
                        data.setTaxAmount(data.getTaxAmount().negate());
                        data.setPayableAmount(data.getPayableAmount().negate());
                        data.setCreateId(loginSysUser.getSysUserId());
                        data.setCreateBy(loginSysUser.getFullName());
                        data.setCreateTime(new Date());
                        data.setUpdateId(loginSysUser.getSysUserId());
                        data.setUpdateBy(loginSysUser.getFullName());
                        data.setUpdateTime(new Date());
                        flowPayableSummaryMapper.insertFlowPayableSummary(data);
                    });
        }

        FlowReceivableDetail flowReceivableDetailParam = new FlowReceivableDetail();
        flowReceivableDetailParam.setAccountingOrderSn(accountingOrderSn);
        List<FlowReceivableDetail> receivableDetailList = flowReceivableDetailMapper.selectFlowReceivableDetailList(flowReceivableDetailParam);
        if(CollectionUtils.isNotEmpty(receivableDetailList)){
            receivableDetailList.stream().forEach(data ->{
                data.setAccountingState(existDB.getAccountingStatus());
                data.setInAccountState(3);
                data.setChargeReceivableDayId(chargeIdMap.get("chargeReceivableDayId"));
                data.setChargeStatus(3);
                data.setChargeUserId(loginSysUser.getSysUserId());
                data.setChargeUserName(loginSysUser.getFullName());
                data.setChargeCreatedAt(new Date());
                data.setUpdateId(loginSysUser.getSysUserId());
                data.setUpdateBy(loginSysUser.getFullName());
                data.setUpdateTime(new Date());
                flowReceivableDetailMapper.updateFlowReceivableDetail(data);
            });
        }

        FlowPayableDetail flowPayableDetailParam = new FlowPayableDetail();
        flowPayableDetailParam.setAccountingOrderSn(accountingOrderSn);
        List<FlowPayableDetail> payableDetailList = flowPayableDetailMapper.selectFlowPayableDetailList(flowPayableDetailParam);
        if(CollectionUtils.isNotEmpty(payableDetailList)){
            payableDetailList.stream().forEach(data ->{
                data.setAccountingState(existDB.getAccountingStatus());
                data.setInAccountState(3);
                data.setChargeReceivableDayId(chargeIdMap.get("chargePayableDayId"));
                data.setChargeStatus(3);
                data.setChargeUserId(loginSysUser.getSysUserId());
                data.setChargeUserName(loginSysUser.getFullName());
                data.setChargeCreatedAt(new Date());
                data.setUpdateId(loginSysUser.getSysUserId());
                data.setUpdateBy(loginSysUser.getFullName());
                data.setUpdateTime(new Date());
                flowPayableDetailMapper.updateFlowPayableDetail(data);
            });
        }

        //交给策略处理
        instance.opCancelAccounting(existDB, accountingStatus, loginSysUser);
        return R.ok();
    }

    /**
     * 删除对账单
     *
     * @param accountingOrderId
     * @param loginSysUser
     * @return
     */
    public int opDeleteAccounting(Long accountingOrderId, LoginSysUser loginSysUser) {

        int ret  = 0;
        int ret1 = 0;
        int ret2 = 0;

        // 查出 对账单
        AccountingScoreCustomer existDB = accountingScoreCustomerMapper.selectByPrimaryKey(accountingOrderId);

        if (ObjectUtil.isNull(existDB)) {
            return 0;
        }

        // 查出 对账单 与 积分流水 关联
        AccountingScoreCustomerXCreditExample xExample = new AccountingScoreCustomerXCreditExample();
        xExample.createCriteria()
                .andAccountingOrderSnEqualTo(existDB.getAccountingOrderSn());

        List<AccountingScoreCustomerXCredit> x = accountingScoreCustomerXCreditMapper.selectByExample(xExample);

        log.info("查出 对账单 与 积分流水 关联,\n {}", AnJsonUtils.toPrettyJson(x));

        List<Long> xIds = x.stream()
                .map(AccountingScoreCustomerXCredit::getId)
                .collect(Collectors.toList());

        // 删除关联
        if (CollUtil.isNotEmpty(xIds)) {
            // 删除 x
            AccountingScoreCustomerXCreditExample xDeleteExample = new AccountingScoreCustomerXCreditExample();
            xDeleteExample.createCriteria()
                    .andIdIn(xIds);
            ret1 = accountingScoreCustomerXCreditMapper.deleteByExample(xDeleteExample);
        }

        // 删除主体
        // accountingScoreCustomerMapper.deleteByPrimaryKey(id);
        // TODO 改为软删除
        AccountingScoreCustomer forSoftDelete = new AccountingScoreCustomer();

        forSoftDelete.setId(accountingOrderId);
        forSoftDelete.setDeleted(CommonSoftDeleteEnum.删除.getKey());

        forSoftDelete.setUpdateTime(DateUtil.date());
        forSoftDelete.setUpdateUserId(loginSysUser.getSysUserId());

        ret2 = accountingScoreCustomerMapper.updateByPrimaryKeySelective(forSoftDelete);

        if (ret1 > 0 && ret2 > 0) {
            ret = 1;
        }
        return ret;
    }

    /**
     * 确认对账
     */
    @Transactional(rollbackFor = Exception.class)
    public R opConfirmAccounting(Long accountingOrderId, LoginSysUser loginSysUser) throws BadRequestException{

        AccountingScoreCustomer scoreCustomer = accountingScoreCustomerMapper.selectByPrimaryKey(accountingOrderId);
        if (ObjectUtil.isNull(scoreCustomer)) {
            return R.fail("对账单不存在");
        }

        if(scoreCustomer.getAccountingStatus().equals(2)){
            return R.fail("对账单已确认");
        }

        String accountingOrderSn = scoreCustomer.getAccountingOrderSn();
        String serviceNo = scoreCustomer.getServiceNo();
        FlowReceivableSummary receivableSummary = new FlowReceivableSummary();
        receivableSummary.setRmAccountState(0);
        receivableSummary.setInAccountId(KeyWorker.orderId());
        receivableSummary.setInAccountDate(new Date());
        receivableSummary.setInAccountType(1);
        receivableSummary.setInAccountWay(0);
        receivableSummary.setAccountingOrderSn(accountingOrderSn);
        receivableSummary.setBizPlatformId(serviceNo);
        receivableSummary.setBizPlatformName(CommonServiceNoEnum.getByServiceNo(serviceNo).getServiceName());

        // 查出 对账单 与 积分流水 关联
        AccountingScoreCustomerXCreditExample xExample = new AccountingScoreCustomerXCreditExample();
        xExample.createCriteria().andAccountingOrderSnEqualTo(accountingOrderSn);
        List<AccountingScoreCustomerXCredit> creditList = accountingScoreCustomerXCreditMapper.selectByExample(xExample);

        //零星客户固定ID
        SysEnterpriseExample example = new SysEnterpriseExample();
        example.createCriteria().andEnterpriseIdEqualTo(1000000L);
        List<SysEnterprise> sysEnterpriseList = sysEnterpriseMapper.selectByExample(example);
        SysEnterprise sysEnterprise = new SysEnterprise();
        if(CollectionUtils.isNotEmpty(sysEnterpriseList)){
            sysEnterprise = sysEnterpriseList.get(0);
        }

        //查询对账单，可生成的应收流水记录
        FlowReceivableDetail receivableParam = new FlowReceivableDetail();
        receivableParam.setAccountingOrderSn(scoreCustomer.getAccountingOrderSn());
        List<FlowReceivableDetail> receivableDetailList = flowReceivableDetailMapper.getReceivableDetailList(receivableParam);
        for (FlowReceivableDetail receivableDetail : receivableDetailList){
            receivableDetail.setInAccountState(0);
            receivableDetail.setAccountingState(AccountingOrderCustomerAccountingStatusEnum.已确认.getKey());
            Integer backStatus = receivableDetail.getBackStatus();
            if(backStatus != null && 0==backStatus){
                receivableDetail.setChargeStatus(1);
                receivableDetail.setChargeUserId(null);
                receivableDetail.setChargeUserName(null);
                receivableDetail.setChargeCreatedAt(null);
            }else if(backStatus != null && 1==backStatus){
                receivableDetail.setChargeStatus(2);
            }
            if(scoreCustomer.getAccountingStatus() != null && 2 == scoreCustomer.getAccountingStatus()){
                receivableDetail.setChargeStatus(3);
            }
            if(UnifiedOrderCreditTypeDefaultEnum.微信支付.getKey().equals(receivableDetail.getCreditType())){
                receivableDetail.setCusSettlementId(sysEnterprise.getId());
                receivableDetail.setCusBizCode(Objects.toString(sysEnterprise.getEnterpriseId(),""));
                receivableDetail.setCusBizName(sysEnterprise.getEnterpriseName());
            }else{
                receivableDetail.setCreditName(UnifiedOrderCreditTypeDefaultEnum.积分支付.getDesc());
            }
            receivableDetail.setCreateId(loginSysUser.getSysUserId());
            receivableDetail.setCreateBy(loginSysUser.getFullName());
            receivableDetail.setCreateTime(new Date());
            receivableDetail.setUpdateId(loginSysUser.getSysUserId());
            receivableDetail.setUpdateBy(loginSysUser.getFullName());
            receivableDetail.setUpdateTime(new Date());
            receivableDetail.setReceivableAmount(receivableDetail.getIncomeNoTax().add(receivableDetail.getTaxAmount()));
        }

        //对账单编号&同客户（客户结算中心id）&同订单类型&同积分类型（积分支付/微信支付）&同税率的应收流水数据进行汇总统计出“应收流水汇总”数据
        Function<FlowReceivableDetail,String> receivableKey = data -> data.getAccountingOrderSn()+"_"+data.getCusSettlementId()+"_"
                +data.getServiceNo()+"_"+data.getCreditType()+"_"+data.getOperationTaxRate();
        Map<String,List<FlowReceivableDetail>> receivableDetailListMap  = receivableDetailList.stream().collect(Collectors.groupingBy(receivableKey));

        for (List<FlowReceivableDetail> receivableDetailGroupList: receivableDetailListMap.values()) {
            BigDecimal incomeNoTax = BigDecimal.ZERO;
            BigDecimal taxAmount = BigDecimal.ZERO;
            BigDecimal receivableAmount = BigDecimal.ZERO;

            for (FlowReceivableDetail receivableDetail : receivableDetailGroupList){
                incomeNoTax = incomeNoTax.add(Optional.ofNullable(receivableDetail.getIncomeNoTax()).orElse(BigDecimal.ZERO).setScale(2,BigDecimal.ROUND_HALF_UP));
                taxAmount = taxAmount.add(Optional.ofNullable(receivableDetail.getTaxAmount()).orElse(BigDecimal.ZERO).setScale(2,BigDecimal.ROUND_HALF_UP));
                receivableAmount = receivableAmount.add(Optional.ofNullable(receivableDetail.getReceivableAmount()).orElse(BigDecimal.ZERO).setScale(2,BigDecimal.ROUND_HALF_UP));
            }

            FlowReceivableDetail receivableDetail = receivableDetailGroupList.get(0);
            receivableSummary.setCusSettlementId(receivableDetail.getCusSettlementId());
            receivableSummary.setCusBizCode(receivableDetail.getCusBizCode());
            receivableSummary.setCusBizName(receivableDetail.getCusBizName());
            receivableSummary.setCreditType(receivableDetail.getCreditType());
            receivableSummary.setCreditName(receivableDetail.getCreditName());
            receivableSummary.setOperationTaxRate(receivableDetail.getOperationTaxRate());
            receivableSummary.setIncomeNoTax(incomeNoTax);
            receivableSummary.setTaxAmount(taxAmount);
            receivableSummary.setReceivableAmount(receivableAmount);
            receivableSummary.setCreateId(loginSysUser.getSysUserId());
            receivableSummary.setCreateBy(loginSysUser.getFullName());
            receivableSummary.setCreateTime(new Date());
            receivableSummary.setUpdateId(loginSysUser.getSysUserId());
            receivableSummary.setUpdateBy(loginSysUser.getFullName());
            receivableSummary.setUpdateTime(new Date());
            flowReceivableSummaryMapper.insertFlowReceivableSummary(receivableSummary);

            for (FlowReceivableDetail detail : receivableDetailGroupList){
                detail.setInAccountId(receivableSummary.getId().toString());
                detail.setInAccountState(1);
                detail.setInAccountDate(new Date());
            }
        }

        for (FlowReceivableDetail receivableDetail : receivableDetailList){
            flowReceivableDetailMapper.insertFlowReceivableDetail(receivableDetail);
        }

        FlowPayableSummary payableSummary = new FlowPayableSummary();
        payableSummary.setRmAccountState(0);
        payableSummary.setInAccountId(KeyWorker.orderId());
        payableSummary.setInAccountDate(new Date());
        payableSummary.setInAccountType(1);
        payableSummary.setInAccountWay(0);
        payableSummary.setAccountingOrderSn(accountingOrderSn);
        payableSummary.setBizPlatformId(serviceNo);
        payableSummary.setBizPlatformName(CommonServiceNoEnum.getByServiceNo(serviceNo).getServiceName());

        //查询对账单，可生成的应付流水记录
        FlowPayableDetail payableParam = new FlowPayableDetail();
        payableParam.setAccountingOrderSn(scoreCustomer.getAccountingOrderSn());
        List<FlowPayableDetail> payableDetailList = flowPayableDetailMapper.getPayableDetailList(payableParam);

        //该客户对账单中所有订单流水所属的商品订单是否存在“运费”商品订单
        if(CollectionUtils.isNotEmpty(payableDetailList)){
            List<Long> goodIdList  = payableDetailList.stream().map(FlowPayableDetail::getGoodsId).collect(Collectors.toList());
            List<String> orderSnList  = payableDetailList.stream().map(FlowPayableDetail::getOrderSn).collect(Collectors.toList());
            payableParam.setOrderSnList(orderSnList);
            List<FlowPayableDetail> freightDetailList = flowPayableDetailMapper.getPayableFreightDetail(payableParam);
            if(CollectionUtils.isNotEmpty(freightDetailList)){
                freightDetailList = freightDetailList.stream().filter(data -> !goodIdList.contains(data.getGoodsId())).collect(Collectors.toList());
                freightDetailList.forEach(data -> {
                    data.setAccountingOrderSn(accountingOrderSn);
                    data.setAccountingState(AccountingOrderCustomerAccountingStatusEnum.已确认.getKey());
                    data.setDataType(1);
                });
            }
            //查询相同订单编号已经生成过运费的应付流水
            FlowPayableDetail hasPayableParam = new FlowPayableDetail();
            hasPayableParam.setOrderSnList(orderSnList);
            List<FlowPayableDetail> hasFreightDetailList = flowPayableDetailMapper.getHasFreightDetail(hasPayableParam);
            List<Long> hasGoodsId= hasFreightDetailList.stream().map(data -> data.getGoodsId()).distinct().collect(Collectors.toList());
            if(CollectionUtils.isNotEmpty(hasGoodsId)){
                freightDetailList = freightDetailList.stream().filter(data -> !hasGoodsId.contains(data.getGoodsId())).collect(Collectors.toList());
            }

            payableDetailList.addAll(freightDetailList);
        }

        for (FlowPayableDetail payableDetail:payableDetailList) {
            payableDetail.setAccountingState(AccountingOrderCustomerAccountingStatusEnum.已确认.getKey());
            Integer backStatus = payableDetail.getBackStatus();
            if(backStatus != null && 0==backStatus){
                payableDetail.setChargeStatus(1);
                payableDetail.setChargeUserId(null);
                payableDetail.setChargeUserName(null);
                payableDetail.setChargeCreatedAt(null);
            }else if(backStatus != null && 1==backStatus){
                payableDetail.setChargeStatus(2);
            }
            if(scoreCustomer.getAccountingStatus() != null && 2 == scoreCustomer.getAccountingStatus()){
                payableDetail.setChargeStatus(3);
            }
            if( payableDetail.getDataType() == null || payableDetail.getDataType() != 1){
                payableDetail.setDataType(0);
            }
            payableDetail.setPayableAmount(payableDetail.getCostNoTax().add(payableDetail.getTaxAmount()));
            payableDetail.setCreateId(loginSysUser.getSysUserId());
            payableDetail.setCreateBy(loginSysUser.getFullName());
            payableDetail.setCreateTime(new Date());
            payableDetail.setUpdateId(loginSysUser.getSysUserId());
            payableDetail.setUpdateBy(loginSysUser.getFullName());
            payableDetail.setUpdateTime(new Date());
        }

        //对账单编号&同客户（客户结算中心id）&同订单类型&同税率的应收流水数据进行汇总统计出“应收流水汇总”数据
        Function<FlowPayableDetail,String> payableKey = data -> data.getAccountingOrderSn()+"_"+data.getCusSettlementId()+"_"
                +data.getServiceNo()+"_"+data.getOperationTaxRate();
        Map<String,List<FlowPayableDetail>> payableDetailListMap  = payableDetailList.stream().collect(Collectors.groupingBy(payableKey));
        for (List<FlowPayableDetail> payableDetailGroupList: payableDetailListMap.values()) {
            BigDecimal costNoTax = BigDecimal.ZERO;
            BigDecimal taxAmount = BigDecimal.ZERO;
            BigDecimal payableAmount = BigDecimal.ZERO;

            for (FlowPayableDetail payableDetail : payableDetailGroupList) {
                costNoTax = costNoTax.add(Optional.ofNullable(payableDetail.getCostNoTax()).orElse(BigDecimal.ZERO).setScale(2,BigDecimal.ROUND_HALF_UP));
                taxAmount = taxAmount.add(Optional.ofNullable(payableDetail.getTaxAmount()).orElse(BigDecimal.ZERO).setScale(2,BigDecimal.ROUND_HALF_UP));
                payableAmount = payableAmount.add(Optional.ofNullable(payableDetail.getPayableAmount()).orElse(BigDecimal.ZERO).setScale(2,BigDecimal.ROUND_HALF_UP));
            }
            FlowPayableDetail payableDetail = payableDetailGroupList.get(0);
            payableSummary.setCusSettlementId(payableDetail.getCusSettlementId());
            payableSummary.setCusBizCode(payableDetail.getCusBizCode());
            payableSummary.setCusBizName(payableDetail.getCusBizName());
            payableSummary.setOperationTaxRate(payableDetail.getOperationTaxRate());
            payableSummary.setCostNoTax(costNoTax);
            payableSummary.setTaxAmount(taxAmount);
            payableSummary.setPayableAmount(payableAmount);
            payableSummary.setCreateId(loginSysUser.getSysUserId());
            payableSummary.setCreateBy(loginSysUser.getFullName());
            payableSummary.setCreateTime(new Date());
            payableSummary.setUpdateId(loginSysUser.getSysUserId());
            payableSummary.setUpdateBy(loginSysUser.getFullName());
            payableSummary.setUpdateTime(new Date());
            flowPayableSummaryMapper.insertFlowPayableSummary(payableSummary);

            for (FlowPayableDetail detail : payableDetailGroupList){
                detail.setInAccountId(receivableSummary.getId().toString());
                detail.setInAccountState(1);
                detail.setInAccountDate(new Date());
            }
        }

        for (FlowPayableDetail payableDetail:payableDetailList) {
            flowPayableDetailMapper.insertFlowPayableDetail(payableDetail);
        }

        creditList.stream().forEach(data ->{
            UnifiedOrderCredit orderCreditUpdate = new UnifiedOrderCredit();
            orderCreditUpdate.setId(data.getUnifiedOrderCreditId());
            orderCreditUpdate.setReceivableStatisticsState(1);
            orderCreditUpdate.setPayableStatisticsState(1);
            unifiedOrderCreditMapper.updateByPrimaryKeySelective(orderCreditUpdate);
        });
        AccountingScoreCustomer accountingScoreCustomer = new AccountingScoreCustomer();
        accountingScoreCustomer.setId(accountingOrderId);
        accountingScoreCustomer.setAccountingStatus(AccountingOrderCustomerAccountingStatusEnum.已确认.getKey());
        accountingScoreCustomer.setReceivableDataStatus(3);
        accountingScoreCustomer.setPayableDataStatus(3);
        accountingScoreCustomer.setUpdateTime(DateUtil.date());
        accountingScoreCustomer.setUpdateUserId(loginSysUser.getSysUserId());
        accountingScoreCustomerMapper.updateByPrimaryKeySelective(accountingScoreCustomer);

        return R.ok();
    }

    /****************************************** 积分结算 对账单 操作   end ******************************************/

    /**
     * 生成应收&应付数据
     */
    @Transactional(rollbackFor = Exception.class)
    public R opStartFlowData(Long accountingOrderId, LoginSysUser loginSysUser) throws BadRequestException{
        AccountingScoreCustomer scoreCustomer = accountingScoreCustomerMapper.selectByPrimaryKey(accountingOrderId);
        if (ObjectUtil.isNull(scoreCustomer)) {
            return R.fail("对账单不存在");
        }
        if(!scoreCustomer.getAccountingStatus().equals(1)){
            return R.fail("该对账单状态已取消，无需生成");
        }
        if((scoreCustomer.getReceivableDataStatus().equals(1) || scoreCustomer.getReceivableDataStatus().equals(3))
            && (scoreCustomer.getPayableDataStatus().equals(1) || scoreCustomer.getPayableDataStatus().equals(3))){
            return R.fail("该对账单的应收和应付数据“生成中或已生成”，无需重复生成");
        }
        if((scoreCustomer.getReceivedAccountStatus().equals(2) || scoreCustomer.getReceivedAccountStatus().equals(3))
            && (scoreCustomer.getWxReceivedAccountStatus().equals(2) || scoreCustomer.getWxReceivedAccountStatus().equals(3))){
            return R.fail("该对账单的实收报账状态已全部回款，无需再生成，请返回检查");
        }
        String accountingOrderSn = scoreCustomer.getAccountingOrderSn();
        String serviceNo = scoreCustomer.getServiceNo();
        FlowReceivableSummary receivableSummary = new FlowReceivableSummary();
        receivableSummary.setRmAccountState(0);
        receivableSummary.setInAccountDate(new Date());
        receivableSummary.setInAccountType(1);
        receivableSummary.setInAccountWay(0);
        receivableSummary.setAccountingOrderSn(accountingOrderSn);
        receivableSummary.setBizPlatformId(serviceNo);
        receivableSummary.setBizPlatformName(CommonServiceNoEnum.getByServiceNo(serviceNo).getServiceName());

        // 查出 对账单 与 积分流水 关联
        AccountingScoreCustomerXCreditExample xExample = new AccountingScoreCustomerXCreditExample();
        xExample.createCriteria().andAccountingOrderSnEqualTo(accountingOrderSn);
        List<AccountingScoreCustomerXCredit> creditList = accountingScoreCustomerXCreditMapper.selectByExample(xExample);

        //零星客户固定ID
        SysEnterpriseExample example = new SysEnterpriseExample();
        example.createCriteria().andEnterpriseIdEqualTo(1000000L);
        List<SysEnterprise> sysEnterpriseList = sysEnterpriseMapper.selectByExample(example);
        SysEnterprise sysEnterprise = new SysEnterprise();
        if(CollectionUtils.isNotEmpty(sysEnterpriseList)){
            sysEnterprise = sysEnterpriseList.get(0);
        }

        //查询对账单，可生成的应收流水记录
        FlowReceivableDetail receivableParam = new FlowReceivableDetail();
        receivableParam.setAccountingOrderSn(scoreCustomer.getAccountingOrderSn());
        List<FlowReceivableDetail> receivableDetailList = flowReceivableDetailMapper.getReceivableDetailList(receivableParam);
        for (FlowReceivableDetail receivableDetail : receivableDetailList){
            receivableDetail.setInAccountState(0);
            receivableDetail.setAccountingState(AccountingOrderCustomerAccountingStatusEnum.已确认.getKey());
            Integer backStatus = receivableDetail.getBackStatus();
            if(backStatus != null && 0==backStatus){
                receivableDetail.setChargeStatus(1);
                receivableDetail.setChargeUserId(null);
                receivableDetail.setChargeUserName(null);
                receivableDetail.setChargeCreatedAt(null);
            }else if(backStatus != null && 1==backStatus){
                receivableDetail.setChargeStatus(2);
            }
            if(scoreCustomer.getAccountingStatus() != null && 2 == scoreCustomer.getAccountingStatus()){
                receivableDetail.setChargeStatus(3);
            }
            if(UnifiedOrderCreditTypeDefaultEnum.微信支付.getKey().equals(receivableDetail.getCreditType())){
                receivableDetail.setCusSettlementId(sysEnterprise.getId());
                receivableDetail.setCusBizCode(Objects.toString(sysEnterprise.getEnterpriseId(),""));
                receivableDetail.setCusBizName(sysEnterprise.getEnterpriseName());
            }else{
                receivableDetail.setCreditName(UnifiedOrderCreditTypeDefaultEnum.积分支付.getDesc());
            }
            receivableDetail.setCreateId(loginSysUser.getSysUserId());
            receivableDetail.setCreateBy(loginSysUser.getFullName());
            receivableDetail.setCreateTime(new Date());
            receivableDetail.setUpdateId(loginSysUser.getSysUserId());
            receivableDetail.setUpdateBy(loginSysUser.getFullName());
            receivableDetail.setUpdateTime(new Date());
            receivableDetail.setReceivableAmount(receivableDetail.getIncomeNoTax().add(receivableDetail.getTaxAmount()));
        }

        //对账单编号&同客户（客户结算中心id）&同订单类型&同积分类型（积分支付/微信支付）&同税率的应收流水数据进行汇总统计出“应收流水汇总”数据
        Function<FlowReceivableDetail,String> receivableKey = data -> data.getAccountingOrderSn()+"_"+data.getCusSettlementId()+"_"
                +data.getServiceNo()+"_"+data.getCreditType()+"_"+data.getOperationTaxRate();
        Map<String,List<FlowReceivableDetail>> receivableDetailListMap  = receivableDetailList.stream().collect(Collectors.groupingBy(receivableKey));

        for (List<FlowReceivableDetail> receivableDetailGroupList: receivableDetailListMap.values()) {
            BigDecimal incomeNoTax = BigDecimal.ZERO;
            BigDecimal taxAmount = BigDecimal.ZERO;
            BigDecimal receivableAmount = BigDecimal.ZERO;

            for (FlowReceivableDetail receivableDetail : receivableDetailGroupList){
                incomeNoTax = incomeNoTax.add(Optional.ofNullable(receivableDetail.getIncomeNoTax()).orElse(BigDecimal.ZERO).setScale(2,BigDecimal.ROUND_HALF_UP));
                taxAmount = taxAmount.add(Optional.ofNullable(receivableDetail.getTaxAmount()).orElse(BigDecimal.ZERO).setScale(2,BigDecimal.ROUND_HALF_UP));
                receivableAmount = receivableAmount.add(Optional.ofNullable(receivableDetail.getReceivableAmount()).orElse(BigDecimal.ZERO).setScale(2,BigDecimal.ROUND_HALF_UP));
            }

            FlowReceivableDetail receivableDetail = receivableDetailGroupList.get(0);
            receivableSummary.setCusSettlementId(receivableDetail.getCusSettlementId());
            receivableSummary.setCusBizCode(receivableDetail.getCusBizCode());
            receivableSummary.setCusBizName(receivableDetail.getCusBizName());
            receivableSummary.setCreditType(receivableDetail.getCreditType());
            receivableSummary.setCreditName(receivableDetail.getCreditName());
            receivableSummary.setOperationTaxRate(receivableDetail.getOperationTaxRate());
            receivableSummary.setIncomeNoTax(incomeNoTax);
            receivableSummary.setTaxAmount(taxAmount);
            receivableSummary.setReceivableAmount(receivableAmount);
            receivableSummary.setCreateId(loginSysUser.getSysUserId());
            receivableSummary.setCreateBy(loginSysUser.getFullName());
            receivableSummary.setCreateTime(new Date());
            receivableSummary.setUpdateId(loginSysUser.getSysUserId());
            receivableSummary.setUpdateBy(loginSysUser.getFullName());
            receivableSummary.setUpdateTime(new Date());
            flowReceivableSummaryMapper.insertFlowReceivableSummary(receivableSummary);

            for (FlowReceivableDetail detail : receivableDetailGroupList){
                detail.setInAccountId(receivableSummary.getId().toString());
                detail.setInAccountState(1);
                detail.setInAccountDate(new Date());
            }
        }

        for (FlowReceivableDetail receivableDetail : receivableDetailList){
            flowReceivableDetailMapper.insertFlowReceivableDetail(receivableDetail);
        }

        FlowPayableSummary payableSummary = new FlowPayableSummary();
        payableSummary.setRmAccountState(0);
        payableSummary.setInAccountId(KeyWorker.orderId());
        payableSummary.setInAccountDate(new Date());
        payableSummary.setInAccountType(1);
        payableSummary.setInAccountWay(0);
        payableSummary.setAccountingOrderSn(accountingOrderSn);
        payableSummary.setBizPlatformId(serviceNo);
        payableSummary.setBizPlatformName(CommonServiceNoEnum.getByServiceNo(serviceNo).getServiceName());

        //查询对账单，可生成的应付流水记录
        FlowPayableDetail payableParam = new FlowPayableDetail();
        payableParam.setAccountingOrderSn(scoreCustomer.getAccountingOrderSn());
        List<FlowPayableDetail> payableDetailList = flowPayableDetailMapper.getPayableDetailList(payableParam);

        //该客户对账单中所有订单流水所属的商品订单是否存在“运费”商品订单
        if(CollectionUtils.isNotEmpty(payableDetailList)){
            List<Long> goodIdList  = payableDetailList.stream().map(FlowPayableDetail::getGoodsId).collect(Collectors.toList());
            List<String> orderSnList  = payableDetailList.stream().map(FlowPayableDetail::getOrderSn).collect(Collectors.toList());
            payableParam.setOrderSnList(orderSnList);
            List<FlowPayableDetail> freightDetailList = flowPayableDetailMapper.getPayableFreightDetail(payableParam);
            if(CollectionUtils.isNotEmpty(freightDetailList)){
                freightDetailList = freightDetailList.stream().filter(data -> !goodIdList.contains(data.getGoodsId())).collect(Collectors.toList());
                freightDetailList.forEach(data -> {
                    data.setAccountingOrderSn(accountingOrderSn);
                    data.setAccountingState(AccountingOrderCustomerAccountingStatusEnum.已确认.getKey());
                    data.setDataType(1);
                });
            }
            //查询相同订单编号已经生成过运费的应付流水
            FlowPayableDetail hasPayableParam = new FlowPayableDetail();
            hasPayableParam.setOrderSnList(orderSnList);
            List<FlowPayableDetail> hasFreightDetailList = flowPayableDetailMapper.getHasFreightDetail(hasPayableParam);
            List<Long> hasGoodsId= hasFreightDetailList.stream().map(data -> data.getGoodsId()).distinct().collect(Collectors.toList());
            if(CollectionUtils.isNotEmpty(hasGoodsId)){
                freightDetailList = freightDetailList.stream().filter(data -> !hasGoodsId.contains(data.getGoodsId())).collect(Collectors.toList());
            }

            payableDetailList.addAll(freightDetailList);
        }

        for (FlowPayableDetail payableDetail:payableDetailList) {
            payableDetail.setAccountingState(AccountingOrderCustomerAccountingStatusEnum.已确认.getKey());
            Integer backStatus = payableDetail.getBackStatus();
            if(backStatus != null && 0==backStatus){
                payableDetail.setChargeStatus(1);
                payableDetail.setChargeUserId(null);
                payableDetail.setChargeUserName(null);
                payableDetail.setChargeCreatedAt(null);
            }else if(backStatus != null && 1==backStatus){
                payableDetail.setChargeStatus(2);
            }
            if(scoreCustomer.getAccountingStatus() != null && 2 == scoreCustomer.getAccountingStatus()){
                payableDetail.setChargeStatus(3);
            }
            if( payableDetail.getDataType() == null || payableDetail.getDataType() != 1){
                payableDetail.setDataType(0);
            }
            payableDetail.setPayableAmount(payableDetail.getCostNoTax().add(payableDetail.getTaxAmount()));
            payableDetail.setCreateId(loginSysUser.getSysUserId());
            payableDetail.setCreateBy(loginSysUser.getFullName());
            payableDetail.setCreateTime(new Date());
            payableDetail.setUpdateId(loginSysUser.getSysUserId());
            payableDetail.setUpdateBy(loginSysUser.getFullName());
            payableDetail.setUpdateTime(new Date());
        }

        //对账单编号&同客户（客户结算中心id）&同订单类型&同税率的应收流水数据进行汇总统计出“应收流水汇总”数据
        Function<FlowPayableDetail,String> payableKey = data -> data.getAccountingOrderSn()+"_"+data.getCusSettlementId()+"_"
                +data.getServiceNo()+"_"+data.getOperationTaxRate();
        Map<String,List<FlowPayableDetail>> payableDetailListMap  = payableDetailList.stream().collect(Collectors.groupingBy(payableKey));
        for (List<FlowPayableDetail> payableDetailGroupList: payableDetailListMap.values()) {
            BigDecimal costNoTax = BigDecimal.ZERO;
            BigDecimal taxAmount = BigDecimal.ZERO;
            BigDecimal payableAmount = BigDecimal.ZERO;

            for (FlowPayableDetail payableDetail : payableDetailGroupList) {
                costNoTax = costNoTax.add(Optional.ofNullable(payableDetail.getCostNoTax()).orElse(BigDecimal.ZERO).setScale(2,BigDecimal.ROUND_HALF_UP));
                taxAmount = taxAmount.add(Optional.ofNullable(payableDetail.getTaxAmount()).orElse(BigDecimal.ZERO).setScale(2,BigDecimal.ROUND_HALF_UP));
                payableAmount = payableAmount.add(Optional.ofNullable(payableDetail.getPayableAmount()).orElse(BigDecimal.ZERO).setScale(2,BigDecimal.ROUND_HALF_UP));
            }
            FlowPayableDetail payableDetail = payableDetailGroupList.get(0);
            payableSummary.setCusSettlementId(payableDetail.getCusSettlementId());
            payableSummary.setCusBizCode(payableDetail.getCusBizCode());
            payableSummary.setCusBizName(payableDetail.getCusBizName());
            payableSummary.setOperationTaxRate(payableDetail.getOperationTaxRate());
            payableSummary.setCostNoTax(costNoTax);
            payableSummary.setTaxAmount(taxAmount);
            payableSummary.setPayableAmount(payableAmount);
            payableSummary.setCreateId(loginSysUser.getSysUserId());
            payableSummary.setCreateBy(loginSysUser.getFullName());
            payableSummary.setCreateTime(new Date());
            payableSummary.setUpdateId(loginSysUser.getSysUserId());
            payableSummary.setUpdateBy(loginSysUser.getFullName());
            payableSummary.setUpdateTime(new Date());
            flowPayableSummaryMapper.insertFlowPayableSummary(payableSummary);

            for (FlowPayableDetail detail : payableDetailGroupList){
                detail.setInAccountId(receivableSummary.getId().toString());
                detail.setInAccountState(1);
                detail.setInAccountDate(new Date());
            }
        }

        for (FlowPayableDetail payableDetail:payableDetailList) {
            flowPayableDetailMapper.insertFlowPayableDetail(payableDetail);
        }

        creditList.stream().forEach(data ->{
            UnifiedOrderCredit orderCreditUpdate = new UnifiedOrderCredit();
            orderCreditUpdate.setId(data.getUnifiedOrderCreditId());
            orderCreditUpdate.setReceivableStatisticsState(1);
            orderCreditUpdate.setPayableStatisticsState(1);
            unifiedOrderCreditMapper.updateByPrimaryKeySelective(orderCreditUpdate);
        });
        AccountingScoreCustomer accountingScoreCustomer = new AccountingScoreCustomer();
        accountingScoreCustomer.setId(accountingOrderId);
        accountingScoreCustomer.setReceivableDataStatus(3);
        accountingScoreCustomer.setPayableDataStatus(3);
        accountingScoreCustomer.setUpdateTime(DateUtil.date());
        accountingScoreCustomer.setUpdateUserId(loginSysUser.getSysUserId());
        accountingScoreCustomerMapper.updateByPrimaryKeySelective(accountingScoreCustomer);
        return R.ok();
    }

    /**
     * 创建报账单
     */
    @Transactional(rollbackFor = Exception.class)
    public R createRmAccounting(Long accountingOrderId, LoginSysUser loginSysUser) throws BadRequestException{
        AccountingScoreCustomer scoreCustomer = accountingScoreCustomerMapper.selectByPrimaryKey(accountingOrderId);
        if (ObjectUtil.isNull(scoreCustomer)) {
            return R.fail("对账单不存在");
        }

        String accountingOrderSn = scoreCustomer.getAccountingOrderSn();
        String serviceNo = scoreCustomer.getServiceNo();

        SysEnterprise sysEnterprise = sysEnterpriseMapper.selectByPrimaryKey(scoreCustomer.getEnterpriseId());

        //业务员配置
        SysBusinessUserQueryCriteria userCriteria = new SysBusinessUserQueryCriteria();
        userCriteria.setBindOperationUserid(loginSysUser.getSysUserId());
        List<SysBusinessUserVo> userVoList = sysBusinessUserMapper.findByPaging(userCriteria);
        if(CollectionUtils.isEmpty(userVoList)){
            return R.fail("当前操作账号未管理业务人员，请联系管理员关联绑定");
        }
        //应收报账单基础配置
        SysAccountReceivableQueryCriteria receivableCriteria = new SysAccountReceivableQueryCriteria();
        List<SysAccountReceivableVo> receivableVoList = sysAccountReceivableMapper.findByPaging(receivableCriteria);
        if(CollectionUtils.isEmpty(receivableVoList)){
            return R.fail("共享参数配置信息不完整：请前往“系统管理-共享参数配置-完善“应收和成本数据同步接口");
        }
        //应付报账单基础配置
        SysAccountPayableQueryCriteria payableCriteria = new SysAccountPayableQueryCriteria();
        List<SysAccountPayableVo> payableVoList = sysAccountPayableMapper.findByPaging(payableCriteria);
        if(CollectionUtils.isEmpty(payableVoList)){
            return R.fail("共享参数配置信息不完整：请前往“系统管理-共享参数配置-完善“应收和成本数据同步接口");
        }

        //对账单明细列表
        AccountingScoreCustomerXCreditExample example  = new AccountingScoreCustomerXCreditExample();
        AccountingScoreCustomerXCreditExample.Criteria criteria = example.createCriteria();
        criteria.andAccountingOrderSnEqualTo(scoreCustomer.getAccountingOrderSn());
        List<AccountingScoreCustomerXCredit> tempResult = accountingScoreCustomerXCreditMapper.selectByExample(example);

        List<Long> creditIdList = tempResult.stream()
                .map(AccountingScoreCustomerXCredit::getUnifiedOrderCreditId)
                .collect(Collectors.toList());
        List<InvoiceApplyDetailDimCreditItemVo> creditList = scoreOrderService.getScoreOrderReconciliationNotYetScene3(
                AccountingOrderScoreCustomerNotYetDimCreditScene3QueryCriteria
                        .builder()
                        .idsCredit(creditIdList)
                        .build(),
                loginSysUser
        );
        if(CollectionUtils.isNotEmpty(creditList)){
            creditList.stream().forEach(data -> data.setAccountingOrderSn(scoreCustomer.getAccountingOrderSn()));
        }

        //其他发票信息
        InvoiceBankInfo invoiceBankInfo = invoiceBankInfoService.getInvoiceBankInfoByIdOrNullByDefault(scoreCustomer.getBankInfoId());

        //应收流水汇总
        FlowReceivableSummary receivableSummaryParam = new FlowReceivableSummary();
        receivableSummaryParam.setAccountingOrderSn(accountingOrderSn);
        receivableSummaryParam.setRmAccountState(0);
        receivableSummaryParam.setType(0);
        List<FlowReceivableSummary> allReceivableSummaryList = flowReceivableSummaryMapper.selectFlowReceivableSummaryList(receivableSummaryParam);

        //零星客户固定ID
        SysEnterpriseExample exampleZero = new SysEnterpriseExample();
        exampleZero.createCriteria().andEnterpriseIdEqualTo(1000000L);
        List<SysEnterprise> sysEnterpriseZeroList = sysEnterpriseMapper.selectByExample(exampleZero);
        SysEnterprise sysEnterpriseZero = new SysEnterprise();
        if(CollectionUtils.isNotEmpty(sysEnterpriseZeroList)){
            sysEnterpriseZero = sysEnterpriseZeroList.get(0);
        }

        log.info("createRmAccounting accountingOrderSn={} receivableSummaryList={}",accountingOrderSn,allReceivableSummaryList.size());
        if(CollectionUtils.isNotEmpty(allReceivableSummaryList)) {
            //将流水分为微信、非微信
            Map<Integer,List<FlowReceivableSummary>> receivableSummaryMap = allReceivableSummaryList.stream()
                    .filter(data -> StringUtils.isBlank(data.getShareBillNo()))
                    .collect(Collectors.groupingBy(data ->data.getCreditType()));
            for (Integer creditType : receivableSummaryMap.keySet()) {
                List<FlowReceivableSummary> receivableSummaryList =receivableSummaryMap.get(creditType);
                FlowReceivableSummary receivableSummary = receivableSummaryList.get(0);
                BigDecimal billAmount = BigDecimal.valueOf(receivableSummaryList.stream().mapToDouble(data -> data.getReceivableAmount().doubleValue()).sum());

                AccountingReceivablePayable accountingParam = new AccountingReceivablePayable();
                String shareBillNo = "";
                if (CommonServiceNoEnum.企业福利_侨城汇.getServiceNo().equals(serviceNo)) {
                    shareBillNo = incUtils.getShareId("OCTLIFE01");
                } else if (CommonServiceNoEnum.企业商城_侨城汇.getServiceNo().equals(serviceNo)) {
                    shareBillNo = incUtils.getShareId("OCTLIFE02");
                }
                accountingParam.setAccountingOrderSn(accountingOrderSn);

                if (creditType == 0) {
                    accountingParam.setDataType(1);
                    accountingParam.setBillType(1);
                } else {
                    accountingParam.setDataType(0);
                    accountingParam.setBillType(0);
                }
                accountingParam.setAccountType(0);
                accountingParam.setBillNo(shareBillNo);
                accountingParam.setBizPlatformId(serviceNo);
                accountingParam.setBizPlatformName(CommonServiceNoEnum.getByServiceNo(serviceNo).getServiceName());
                accountingParam.setBillAmount(billAmount);
                accountingParam.setAccountingState(1);
                accountingParam.setFromSettlementId(sysEnterprise != null ? sysEnterprise.getId() : null);
                accountingParam.setSettlementId(receivableSummary.getCusSettlementId());
                accountingParam.setSettlementCode(receivableSummary.getCusBizCode());
                accountingParam.setSettlementName(receivableSummary.getCusBizName());
                accountingParam.setCreateId(loginSysUser.getSysUserId());
                accountingParam.setCreateBy(loginSysUser.getFullName());
                accountingParam.setCreateTime(new Date());
                accountingParam.setUpdateId(loginSysUser.getSysUserId());
                accountingParam.setUpdateBy(loginSysUser.getFullName());
                accountingParam.setUpdateTime(new Date());
                accountingParam.setBizUserId(userVoList.get(0).getId());
                accountingParam.setBizUserName(userVoList.get(0).getUserName());
                accountingReceivablePayableMapper.insertAccountingReceivablePayable(accountingParam);

                FlowReceivableSummary receivableSummaryUpdate = new FlowReceivableSummary();
                receivableSummaryUpdate.setIds(receivableSummaryList.stream().map(data -> data.getId()).collect(Collectors.toList()));
                receivableSummaryUpdate.setShareBillNo(shareBillNo);
                receivableSummaryUpdate.setRmAccountState(1);
                receivableSummaryUpdate.setRmAccountUserId(loginSysUser.getSysUserId());
                receivableSummaryUpdate.setRmAccountUserName(loginSysUser.getFullName());
                receivableSummaryUpdate.setUpdateId(loginSysUser.getSysUserId());
                receivableSummaryUpdate.setUpdateBy(loginSysUser.getFullName());
                receivableSummaryUpdate.setUpdateTime(new Date());
                flowReceivableSummaryMapper.updateFlowReceivableSummaryOrderSn(receivableSummaryUpdate);

                createRmAccountingExcel(scoreCustomer, accountingParam, invoiceBankInfo, creditList, creditType);

                AccountingPushShareData shareData = new AccountingPushShareData();
                shareData.setAccountingOrderSn(accountingOrderSn);
                shareData.setAccountType(0);
                shareData.setAccountingRpId(accountingParam.getId());
                if (creditType == 0) {
                    shareData.setDataType(1);
                    shareData.setBillType(1);
                } else{
                    shareData.setDataType(0);
                    shareData.setBillType(0);
                }
                String fileDetailLink = accountingParam.getFileDetailLink().replace("\\", "/");
                shareData.setHeadData(getReceivableShareDataHead(receivableVoList, scoreCustomer, accountingParam, userVoList));
                shareData.setFileData("[{\"fileName\":\"" + accountingParam.getFileTitle() + "\",\"fileUrl\":\"" + fileBaseUrl + fileDetailLink + "\"}]");
                shareData.setRowData(getReceivableShareDataRow(receivableVoList, scoreCustomer, receivableSummaryList, userVoList));
                shareData.setCreateId(loginSysUser.getSysUserId());
                shareData.setCreateBy(loginSysUser.getFullName());
                shareData.setCreateTime(new Date());
                accountingPushShareDataMapper.insertAccountingPushShareData(shareData);
            }
        }

        FlowPayableSummary payableSummaryParam = new FlowPayableSummary();
        payableSummaryParam.setAccountingOrderSn(accountingOrderSn);
        payableSummaryParam.setRmAccountState(0);
        payableSummaryParam.setType(0);
        List<FlowPayableSummary> allPayableSummaryList = flowPayableSummaryMapper.selectFlowPayableSummaryList(payableSummaryParam);

        log.info("createRmAccounting accountingOrderSn={} payableSummaryList={}",accountingOrderSn,allPayableSummaryList.size());
        if(CollectionUtils.isNotEmpty(allPayableSummaryList)){
            Map<Long,UnifiedSupplier> supplierMap = new HashMap<>();
            Map<Long,BizContract> bizContractMap = new HashMap<>();

            //将流水按照供应商分组
            Map<Long,List<FlowPayableSummary>> payableSummaryMap = allPayableSummaryList.stream()
                    .filter(data -> StringUtils.isBlank(data.getShareBillNo()) && data.getCusSettlementId() != null)
                    .collect(Collectors.groupingBy(data ->data.getCusSettlementId()));
            if(MapUtils.isEmpty(payableSummaryMap)) return R.ok();

            for (Long cusSettlementId : payableSummaryMap.keySet()) {
                List<FlowPayableSummary> payableSummaryGroupList = payableSummaryMap.get(cusSettlementId);
                UnifiedSupplier supplier = supplierMap.get(cusSettlementId);
                if (supplier == null) {
                    supplier = unifiedSupplierMapper.selectByPrimaryKey(cusSettlementId);
                    if (supplier != null) {
                        supplierMap.put(cusSettlementId, supplier);
                    }
                }
                if (supplier == null) {
                    supplier = new UnifiedSupplier();
                }

                BizContract bizContract = bizContractMap.get(cusSettlementId);
                if (bizContract == null) {
                    BizContract bizContractParam = new BizContract();
                    bizContractParam.setSupplierId(cusSettlementId);
                    bizContractParam.setIsDefault("Y");
                    List<BizContract> contractList = bizContractMapper.selectBizContractList(bizContractParam);
                    if (CollectionUtils.isNotEmpty(contractList)) bizContract = contractList.get(0);
                    if (bizContract != null) {
                        bizContractMap.put(cusSettlementId, bizContract);
                    }
                }
                if (bizContract == null) {
                    bizContract = new BizContract();
                }

                //应付流水汇总最大50一批
                List<List<FlowPayableSummary>> payableSummaryListPage = PageUtils.getSplitList(50, payableSummaryGroupList);
                for (int i = 0; i < payableSummaryListPage.size(); i++) {
                    List<FlowPayableSummary> payableSummaryList = payableSummaryListPage.get(i);
                    FlowPayableSummary payableSummary = payableSummaryList.get(0);
                    BigDecimal billAmount = BigDecimal.valueOf(payableSummaryList.stream().mapToDouble(data -> data.getPayableAmount().doubleValue()).sum());

                    String shareBillNo = "";
                    if (CommonServiceNoEnum.企业福利_侨城汇.getServiceNo().equals(serviceNo)) {
                        shareBillNo = incUtils.getShareId("OCTLIFE01");
                    } else if (CommonServiceNoEnum.企业商城_侨城汇.getServiceNo().equals(serviceNo)) {
                        shareBillNo = incUtils.getShareId("OCTLIFE02");
                    }

                    AccountingReceivablePayable accountingParam = new AccountingReceivablePayable();
                    accountingParam.setAccountingOrderSn(accountingOrderSn);
                    accountingParam.setAccountType(1);
                    accountingParam.setBillType(2);
                    accountingParam.setBillNo(shareBillNo);
                    accountingParam.setBizPlatformId(serviceNo);
                    accountingParam.setBizPlatformName(CommonServiceNoEnum.getByServiceNo(serviceNo).getServiceName());
                    accountingParam.setBillAmount(billAmount);
                    accountingParam.setAccountingState(1);
                    accountingParam.setFromSettlementId(sysEnterprise != null ? sysEnterprise.getId() : null);
                    accountingParam.setSettlementId(payableSummary.getCusSettlementId());
                    accountingParam.setSettlementCode(payableSummary.getCusBizCode());
                    accountingParam.setSettlementName(payableSummary.getCusBizName());
                    accountingParam.setCreateId(loginSysUser.getSysUserId());
                    accountingParam.setCreateBy(loginSysUser.getFullName());
                    accountingParam.setCreateTime(new Date());
                    accountingParam.setUpdateId(loginSysUser.getSysUserId());
                    accountingParam.setUpdateBy(loginSysUser.getFullName());
                    accountingParam.setUpdateTime(new Date());
                    accountingParam.setBizUserId(userVoList.get(0).getId());
                    accountingParam.setBizUserName(userVoList.get(0).getUserName());
                    accountingReceivablePayableMapper.insertAccountingReceivablePayable(accountingParam);

                    createRmAccountingExcel(scoreCustomer, accountingParam, invoiceBankInfo, creditList, i);

                    String fileDetailLink = accountingParam.getFileDetailLink().replace("\\", "/");
                    AccountingPushShareData shareData = new AccountingPushShareData();
                    shareData.setAccountingOrderSn(accountingOrderSn);
                    shareData.setAccountType(1);
                    shareData.setAccountingRpId(accountingParam.getId());
                    shareData.setHeadData(getPayableShareDataHead(payableVoList, scoreCustomer, accountingParam, userVoList));
                    shareData.setFileData("[{\"name\":\"" + accountingParam.getFileTitle() + "\",\"url\":\"" + fileBaseUrl + fileDetailLink + "\"}]");
                    shareData.setRowData(getPayableShareDataRow(payableVoList, scoreCustomer, payableSummaryList, userVoList, supplier,sysEnterpriseZero, bizContract));
                    shareData.setCreateId(loginSysUser.getSysUserId());
                    shareData.setCreateBy(loginSysUser.getFullName());
                    shareData.setCreateTime(new Date());
                    accountingPushShareDataMapper.insertAccountingPushShareData(shareData);

                    FlowPayableSummary payableSummaryUpdate = new FlowPayableSummary();
                    payableSummaryUpdate.setIds(payableSummaryList.stream().map(data -> data.getId()).collect(Collectors.toList()));
                    payableSummaryUpdate.setShareBillNo(shareBillNo);
                    payableSummaryUpdate.setRmAccountState(1);
                    payableSummaryUpdate.setRmAccountUserId(loginSysUser.getSysUserId());
                    payableSummaryUpdate.setRmAccountUserName(loginSysUser.getFullName());
                    payableSummaryUpdate.setUpdateId(loginSysUser.getSysUserId());
                    payableSummaryUpdate.setUpdateBy(loginSysUser.getFullName());
                    payableSummaryUpdate.setUpdateTime(new Date());
                    flowPayableSummaryMapper.updateFlowPayableSummaryOrderSn(payableSummaryUpdate);
                }
            }
        }
        return R.ok();
    }

    /**
     * 推送报账单
     */
    public R pushRmAccounting(PushAccountingParam pushAccountingParam, LoginSysUser loginSysUser) throws BadRequestException{
        AccountingReceivablePayable receivablePayable = accountingReceivablePayableMapper.selectAccountingReceivablePayableById(pushAccountingParam.getId());
        if(receivablePayable == null){
            return R.fail("报账单不存在");
        }
        if(receivablePayable.getAccountingState() != 1){
            return R.fail("该报账单的报账状态发生变更，不允许推送，请返回检查");
        }
        AccountingScoreCustomerExample example = new AccountingScoreCustomerExample();
        example.createCriteria().andAccountingOrderSnEqualTo(receivablePayable.getAccountingOrderSn());
        List<AccountingScoreCustomer> scoreCustomerList = accountingScoreCustomerMapper.selectByExample(example);
        if (ObjectUtil.isNull(scoreCustomerList)) {
            return R.fail("对账单不存在");
        }
        AccountingScoreCustomer scoreCustomer = scoreCustomerList.get(0);
        if(scoreCustomer.getAccountingStatus() != 1){
            return R.fail("该报账单所属的对账单状态发生变更，不允许推送，请返回检查");
        }

        //账款类型 0应收款项/1应付款项
        Integer accountType = receivablePayable.getAccountType();
        //单据类型,0应收报账单（非微信）/1应收报账单（微信）/2应付报账单
        Integer billType = receivablePayable.getBillType();
        if(billType == 0){
            if(scoreCustomer.getReceivableAccountStatus() == 2){
                return R.fail("该报账单所属单据类型的应收报账状态已全部报账，无需再报账，请返回检查");
            }
        }else if(accountType == 1){
            if(scoreCustomer.getWxReceivableAccountStatus() == 2){
                return R.fail("该报账单所属单据类型的应收报账状态已全部报账，无需再报账，请返回检查");
            }
        }else if(accountType == 2){
            if(scoreCustomer.getPayableAccountStatus() == 2){
                return R.fail("该报账单所属单据类型的应付报账状态已全部报账，无需再报账，请返回检查");
            }
        }

        AccountingPushShareData pushShareData = new AccountingPushShareData();
        pushShareData.setAccountingRpId(pushAccountingParam.getId());
        pushShareData.setAccountingOrderSn(receivablePayable.getAccountingOrderSn());
        List<AccountingPushShareData> shareDataList = accountingPushShareDataMapper.selectAccountingPushShareDataList(pushShareData);

        if(CollectionUtils.isNotEmpty(shareDataList)){
            pushShareData = shareDataList.get(0);
        }

        PushRmAccountingVo.PushRmAccountingDetailVo detailVo = new PushRmAccountingVo.PushRmAccountingDetailVo();
        BeanUtils.copyProperties(receivablePayable,detailVo);

        String headData = pushShareData.getHeadData();
        JSONObject boeHeader = null;
        if(StringUtils.isNotBlank(headData)){
            boeHeader = JSONObject.parseObject(headData);
            detailVo.setBusinessCategory(boeHeader.getString("businessCategory"));
            detailVo.setOperationTypeCode(boeHeader.getString("operationTypeCode"));
            detailVo.setCompanyNum(boeHeader.getString("companyNum"));
            detailVo.setCompanyName(boeHeader.getString("companyName"));
        }

        if(StringUtils.isNotBlank(pushAccountingParam.getRemark())){
            boeHeader.put("remark",pushAccountingParam.getRemark());
            boeHeader.put("boeAbstract",pushAccountingParam.getRemark());
        }

        JSONArray rowDataList = null;
        String rowData = pushShareData.getRowData();
        if(StringUtils.isNotBlank(rowData)){
            rowDataList = JSONObject.parseArray(rowData);
            List<PushAccountingParam.PushAccountingDetail> pushDetailList = pushAccountingParam.getPushDetailList();
            //应付合同可以根据前端进行动态传递
            if(receivablePayable.getAccountType() == 1 && CollectionUtils.isNotEmpty(rowDataList) && CollectionUtils.isNotEmpty(pushDetailList)){
                List<BizContract> bizContractList = bizContractMapper.selectBizContractList(new BizContract());
                Map<String,BizContract> bizContractMap  = bizContractList.stream()
                        .collect(Collectors.toMap(data -> String.valueOf(data.getId()), data -> data, (k, v) -> v));

                Map<String,PushAccountingParam.PushAccountingDetail> pushAccountingDetailMap  = pushDetailList.stream().
                        filter(data -> StringUtils.isNotBlank(data.getId()))
                        .collect(Collectors.toMap(data ->data.getId(), data -> data, (k, v) -> v));
                for (int i = 0; i < rowDataList.size(); i++) {
                    JSONObject jsonObject = rowDataList.getJSONObject(i);
                    String id = jsonObject.getString("id");
                    PushAccountingParam.PushAccountingDetail accountingDetail = pushAccountingDetailMap.get(id);
                    if(accountingDetail != null && StringUtils.isNotBlank(accountingDetail.getContractId()) && StringUtils.isBlank(accountingDetail.getContractNum())){
                        BizContract bizContract = bizContractMap.get(accountingDetail.getContractId());
                        if(bizContract != null){
                            jsonObject.put("contractId",bizContract.getId());
                            jsonObject.put("contractNum",bizContract.getContractCode());
                            jsonObject.put("contractName",bizContract.getContractName());
                        }
                    }
                }

                AccountingPushShareData pushShareDataUpdate = new AccountingPushShareData();
                pushShareDataUpdate.setId(pushShareData.getId());
                pushShareDataUpdate.setRowData(JSON.toJSONString(rowDataList));
                accountingPushShareDataMapper.updateAccountingPushShareData(pushShareDataUpdate);
            }
        }

        JSONArray boeAttachments = null;
        String fileData = pushShareData.getFileData();
        if(StringUtils.isNotBlank(fileData)){
            boeAttachments = JSONObject.parseArray(fileData);
            for (int i = 0; i < boeAttachments.size(); i++) {
                JSONObject jsonObject = boeAttachments.getJSONObject(i);
                String fileUrl = jsonObject.getString("fileUrl");
                //文件加密
                if(StringUtils.isNotBlank(fileUrl)){
                    jsonObject.put("fileUrl", DESPlus.encode(fileUrl));
                }
                String url = jsonObject.getString("url");
                //文件加密
                if(StringUtils.isNotBlank(url)){
                    jsonObject.put("url", DESPlus.encode(url));
                }
            }
        }
        JSONObject apiParamMap = new JSONObject();
        apiParamMap.put("boeHeader",boeHeader);

        if(CollectionUtils.isNotEmpty(rowDataList)){
            for (int i = 0; i < rowDataList.size(); i++) {
                JSONObject jsonObject = rowDataList.getJSONObject(i);
                jsonObject.remove("id");
            }
        }
        String apiUrl = "";
        if(accountType == 0){
            apiUrl = pushReceivableDataUrl;
            apiParamMap.put("boeLines",rowDataList);
            apiParamMap.put("boeAttachments",boeAttachments);
        }else{
            apiUrl = pushPayableDataUrl;
            apiParamMap.put("zfsBoeLines",rowDataList);
            apiParamMap.put("zfsAttachmentDtos",boeAttachments);
        }
        String result = null;
        try {
            result = HttpUtil.post(JSONObject.toJSONString(apiParamMap),apiUrl);
        } catch (Exception e) {
            log.error("pushRmAccounting error apiParamMap={} result={}",JSONObject.toJSONString(apiParamMap),result,e);
        }

        log.info("pushRmAccounting apiParamMap={} result={}",JSONObject.toJSONString(apiParamMap),result);

        if(StringUtils.isBlank(result)) return R.fail();

        JSONObject jsonObject = JSONObject.parseObject(result);
        if(jsonObject == null) return R.ok();

        Integer code = jsonObject.getInteger("code");
        String msg = jsonObject.getString("msg");
        if(code != null && code == 0){
            String boeNo = "";
            if(accountType == 1){
                JSONObject jsonData = jsonObject.getJSONObject("data");
                if(jsonData != null){
                    boeNo = jsonData.getString("boeNo");
                }
            }else{
                boeNo = jsonObject.getString("boeNo");
            }
            AccountingReceivablePayable receivablePayableUpdate = new AccountingReceivablePayable();
            receivablePayableUpdate.setId(pushAccountingParam.getId());
            receivablePayableUpdate.setBillCode(boeNo);
            receivablePayableUpdate.setAccountingState(2);
            receivablePayableUpdate.setUpdateId(loginSysUser.getSysUserId());
            receivablePayableUpdate.setUpdateBy(loginSysUser.getFullName());
            receivablePayableUpdate.setUpdateTime(new Date());
            accountingReceivablePayableMapper.updateAccountingReceivablePayable(receivablePayableUpdate);
            return R.ok("该报账单已推送至共享中心");
        }else{
            return R.fail(msg);
        }
    }

    /**
     * 查询推送报账单
     */
    @Transactional(rollbackFor = Exception.class)
    public R queryPushRmAccounting(Long accountingId,String accountingOrderSn, LoginSysUser loginSysUser) throws BadRequestException{
        AccountingScoreCustomer accountingScoreCustomer = null;
        if(accountingId != null && accountingId > 0L){
            accountingScoreCustomer = accountingScoreCustomerMapper.selectByPrimaryKey(accountingId);
        }else if(StringUtils.isNotBlank(accountingOrderSn)){
            AccountingScoreCustomerExample example = new AccountingScoreCustomerExample();
            example.createCriteria().andAccountingOrderSnEqualTo(accountingOrderSn);
            List<AccountingScoreCustomer> scoreCustomerList = accountingScoreCustomerMapper.selectByExample(example);
            if(CollectionUtils.isNotEmpty(scoreCustomerList)){
                accountingScoreCustomer = scoreCustomerList.get(0);
            }
        }
        if (accountingScoreCustomer == null) {
            return R.fail("对账单不存在");
        }
        accountingId = accountingScoreCustomer.getId();
        accountingOrderSn = accountingScoreCustomer.getAccountingOrderSn();
        //获取报账单集合
        AccountingReceivablePayable accountingReceivablePayableParam = new AccountingReceivablePayable();
        accountingReceivablePayableParam.setAccountingOrderSn(accountingOrderSn);
        accountingReceivablePayableParam.setBillTypeList(Lists.newArrayList(0,1,2));
        accountingReceivablePayableParam.setAccountingState(2);//只查询审批中的数据
        List<AccountingReceivablePayable> accountingList = accountingReceivablePayableMapper.selectAccountingReceivablePayableList(accountingReceivablePayableParam);
        if (CollectionUtils.isEmpty(accountingList)) {
            return R.fail("该对账单暂无审批中的报账单可查询");
        }

        List<JSONObject> apiParamMap = accountingList.stream().map(receivablePayable ->{
            JSONObject apiParam = new JSONObject();
            apiParam.put("dataSource","104");
            apiParam.put("groupCode","OCT");
            apiParam.put("batchNo",receivablePayable.getBillNo());
            return apiParam;
        }).collect(Collectors.toList());

        Map<String,AccountingReceivablePayable> accountingMap = accountingList.stream().collect(Collectors.toMap(data ->data.getBillNo(), data -> data, (k, v) -> v));

        String result = null;
        try {
            result = HttpUtil.post(JSONArray.toJSONString(apiParamMap),queryPushDataUrl);
        } catch (Exception e) {
            log.error("queryPushRmAccounting error apiParamMap={} result={}",JSONObject.toJSONString(apiParamMap),result,e);
        }

        log.info("queryPushRmAccounting apiParamMap={} result={}",JSONObject.toJSONString(apiParamMap),result);

        if(StringUtils.isBlank(result)) return R.fail();

        JSONObject jsonObject = JSONObject.parseObject(result);
        if(jsonObject == null) return R.ok();

        Integer code = jsonObject.getInteger("code");
        String msg = jsonObject.getString("msg");
        if(code != null && code == 0){
            JSONArray dataJson = jsonObject.getJSONArray("data");
            for (int i = 0; i < dataJson.size(); i++) {
                JSONObject dataItem = (JSONObject) dataJson.get(i);
                //单据编号
                String batchNo = dataItem.getString("batchNo");
                if(StringUtils.isBlank(batchNo)) continue;

                //共享单据编号
                String boeNo = dataItem.getString("boeNo");
                //数据状态,N（未处理） P（处理中）S（处理成功）E（处理失败）
                String dataStatus = dataItem.getString("DATA_STATUS");
                //单据审批状态,30完成,0作废
                String boeStatus = dataItem.getString("BOE_STATUS");
                //单据支付状态
                String payStatus = dataItem.getString("BOE_PAY_STATUS");
                //付款失败原因
                String erMsg = dataItem.getString("ErMsg");
                String error = dataItem.getString("error");
                if(StringUtils.isNotBlank(error)) error = "，"+error;
                //完结时间
                String endtime = dataItem.getString("endtime");
                if(StringUtils.isBlank(batchNo)) continue;

                AccountingReceivablePayable accounting = accountingMap.get(batchNo);
                if(accounting == null) continue;
                Long id = accounting.getId();

                String shareBillNo = batchNo;
                //报账状态 0生成中/1待提交/2审批中/3审批完成/4处理失败/5报账作废
                Integer accountingState = null;
                //报账状态 0未报账/1报账中/2已报账/3已撤销
                Integer rmAccountState = null;
                Date approveDate = null;
                if("S".equals(dataStatus)){
                    if("30".equals(boeStatus)){
                        accountingState = 3;
                        approveDate = StringUtils.isNotBlank(endtime) ? DateUtils.parseDate(endtime) : null;
                        rmAccountState = 2;

                        /*BigDecimal billAmount = accounting.getBillAmount();
                        AccountingScoreCustomer accountingScoreCustomerUpdate = new AccountingScoreCustomer();
                        accountingScoreCustomerUpdate.setId(accountingScoreCustomer.getId());
                        accountingScoreCustomerMapper.updateByPrimaryKeySelective(accountingScoreCustomerUpdate);*/
                    }else if("0".equals(boeStatus)){
                        accountingState = 5;
                        rmAccountState = 0;
                        shareBillNo = "";
                        approveDate = StringUtils.isNotBlank(endtime) ? DateUtils.parseDate(endtime) : null;
                    }else{
                        accountingState = 2;
                    }

                }else if("E".equals(dataStatus)){
                    accountingState = 4;
                    rmAccountState = 0;
                    shareBillNo = "";
                }

                AccountingReceivablePayable receivablePayableUpdate = new AccountingReceivablePayable();
                receivablePayableUpdate.setId(id);
                receivablePayableUpdate.setBillCode(boeNo);
                receivablePayableUpdate.setAccountingState(accountingState);
                receivablePayableUpdate.setShareDataState(dataStatus);
                receivablePayableUpdate.setShareApproveState(boeStatus);
                receivablePayableUpdate.setSharePayState(payStatus);
                receivablePayableUpdate.setApproveDate(approveDate);
                receivablePayableUpdate.setUpdateId(loginSysUser.getSysUserId());
                receivablePayableUpdate.setUpdateBy(loginSysUser.getFullName());
                receivablePayableUpdate.setUpdateTime(new Date());
                receivablePayableUpdate.setPusContent(erMsg+error);
                accountingReceivablePayableMapper.updateAccountingReceivablePayable(receivablePayableUpdate);

                FlowPayableSummary flowPayableSummary = new FlowPayableSummary();
                flowPayableSummary.setAccountingOrderSn(accounting.getAccountingOrderSn());
                flowPayableSummary.setShareBillNo(shareBillNo);
                flowPayableSummary.setOldShareBillNo(batchNo);
                flowPayableSummary.setShareBillCode(boeNo);
                flowPayableSummary.setRmAccountState(rmAccountState);
                flowPayableSummary.setShareApproveDate(approveDate);
                flowPayableSummary.setUpdateId(loginSysUser.getSysUserId());
                flowPayableSummary.setUpdateBy(loginSysUser.getFullName());
                flowPayableSummary.setUpdateTime(new Date());
                flowPayableSummaryMapper.updateFlowPayableSummaryOrderSn(flowPayableSummary);

                FlowReceivableSummary flowReceivableSummary = new FlowReceivableSummary();
                flowReceivableSummary.setAccountingOrderSn(accounting.getAccountingOrderSn());
                flowReceivableSummary.setShareBillNo(shareBillNo);
                flowReceivableSummary.setOldShareBillNo(batchNo);
                flowReceivableSummary.setShareBillCode(boeNo);
                flowReceivableSummary.setRmAccountState(rmAccountState);
                flowReceivableSummary.setShareApproveDate(approveDate);
                flowReceivableSummary.setUpdateId(loginSysUser.getSysUserId());
                flowReceivableSummary.setUpdateBy(loginSysUser.getFullName());
                flowReceivableSummary.setUpdateTime(new Date());
                flowReceivableSummaryMapper.updateFlowReceivableSummaryOrderSn(flowReceivableSummary);

                if("S".equals(dataStatus) && "30".equals(boeStatus)){
                    accountingReceivablePayableParam.setAccountingState(null);
                    accountingReceivablePayableParam.setAccountingStateList(Lists.newArrayList(1,2,3));
                    accountingList = accountingReceivablePayableMapper.selectAccountingReceivablePayableList(accountingReceivablePayableParam);
                    Map<Integer, List<AccountingReceivablePayable>> accountingGroupMap = accountingList
                            .stream().collect(Collectors.groupingBy(data -> data.getBillType(), Collectors.toList()));
                    for (Integer billType : accountingGroupMap.keySet()){
                        List<AccountingReceivablePayable> detailList = accountingGroupMap.get(billType);
                        if(CollectionUtils.isEmpty(detailList)) continue;

                        //应收报账状态(非微信) 0未报账/1部分报账/2全部报账/3无需报账
                        Integer receivableAccountStatus = null;
                        //应收报账状态(微信) 0未报账/1部分报账/2全部报账/3无需报账
                        Integer wxReceivableAccountStatus = null;
                        //应付报账状态 0未报账/1部分报账/2全部报账
                        Integer payableAccountStatus = null;

                        Integer finalSize = detailList.stream().filter(data -> data.getAccountingState() == 3).collect(Collectors.toList()).size();
                        if(finalSize != null && finalSize >= detailList.size()){//已全部完成
                            AccountingScoreCustomer scoreCustomer = new AccountingScoreCustomer();
                            scoreCustomer.setId(accountingId);
                            if(billType == 0){
                                receivableAccountStatus = 2;
                            }else if(billType == 1){
                                wxReceivableAccountStatus = 2;
                            }else if(billType == 2){
                                payableAccountStatus = 2;
                            }
                            scoreCustomer.setReceivableAccountStatus(receivableAccountStatus);
                            scoreCustomer.setWxReceivableAccountStatus(wxReceivableAccountStatus);
                            scoreCustomer.setPayableAccountStatus(payableAccountStatus);
                            accountingScoreCustomerMapper.updateByPrimaryKeySelective(scoreCustomer);
                        }else if(finalSize != null && finalSize > 0){//部分完成
                            AccountingScoreCustomer scoreCustomer = new AccountingScoreCustomer();
                            scoreCustomer.setId(accountingId);
                            if(billType == 0){
                                receivableAccountStatus = 1;
                            }else if(billType == 1){
                                wxReceivableAccountStatus = 1;
                            }else if(billType == 2){
                                payableAccountStatus = 1;
                            }
                            scoreCustomer.setReceivableAccountStatus(receivableAccountStatus);
                            scoreCustomer.setWxReceivableAccountStatus(wxReceivableAccountStatus);
                            scoreCustomer.setPayableAccountStatus(payableAccountStatus);
                            accountingScoreCustomerMapper.updateByPrimaryKeySelective(scoreCustomer);
                        }
                    }
                }
            }
            return R.ok("报账状态查询完成，请返回查看");
        }else{
            return R.fail(msg);
        }
    }

    /**
     * 删除报账单
     */
    @Transactional(rollbackFor = Exception.class)
    public R delRmAccounting(Long id, LoginSysUser loginSysUser){
        AccountingReceivablePayable receivablePayable = accountingReceivablePayableMapper.selectAccountingReceivablePayableById(id);
        if(receivablePayable == null){
            return R.fail("报账单不存在");
        }
        if(receivablePayable.getAccountingState() != 1){
            return R.fail("只允许删除待提交的报账单，请返回检查");
        }
        String accountingOrderSn = receivablePayable.getAccountingOrderSn();
        String billNo = receivablePayable.getBillNo();
        Integer accountType = receivablePayable.getAccountType();
        if(accountType == 0){
            //应收流水汇总
            FlowReceivableSummary receivableSummaryParam = new FlowReceivableSummary();
            receivableSummaryParam.setAccountingOrderSn(accountingOrderSn);
            receivableSummaryParam.setShareBillNo(billNo);
            receivableSummaryParam.setType(0);
            List<FlowReceivableSummary> receivableSummaryList = flowReceivableSummaryMapper.selectFlowReceivableSummaryList(receivableSummaryParam);
            if(CollectionUtils.isNotEmpty(receivableSummaryList)){
                receivableSummaryParam = receivableSummaryList.get(0);
                FlowReceivableSummary receivableSummaryUpdate = new FlowReceivableSummary();
                receivableSummaryUpdate.setId(receivableSummaryParam.getId());
                receivableSummaryUpdate.setRmAccountState(0);
                receivableSummaryUpdate.setShareBillNo("");
                receivableSummaryUpdate.setUpdateId(loginSysUser.getSysUserId());
                receivableSummaryUpdate.setUpdateBy(loginSysUser.getFullName());
                receivableSummaryUpdate.setUpdateTime(new Date());
                flowReceivableSummaryMapper.updateFlowReceivableSummary(receivableSummaryUpdate);
            }
        }else if(accountType == 1){
            //应付流水汇总
            FlowPayableSummary payableSummaryParam = new FlowPayableSummary();
            payableSummaryParam.setAccountingOrderSn(accountingOrderSn);
            payableSummaryParam.setShareBillNo(billNo);
            payableSummaryParam.setType(0);
            List<FlowPayableSummary> payableSummaryList = flowPayableSummaryMapper.selectFlowPayableSummaryList(payableSummaryParam);
            if(CollectionUtils.isNotEmpty(payableSummaryList)){
                payableSummaryParam = payableSummaryList.get(0);
                FlowPayableSummary payableSummaryUpdate = new FlowPayableSummary();
                payableSummaryUpdate.setId(payableSummaryParam.getId());
                payableSummaryUpdate.setRmAccountState(0);
                payableSummaryUpdate.setShareBillNo("");
                payableSummaryUpdate.setUpdateId(loginSysUser.getSysUserId());
                payableSummaryUpdate.setUpdateBy(loginSysUser.getFullName());
                payableSummaryUpdate.setUpdateTime(new Date());
                flowPayableSummaryMapper.updateFlowPayableSummary(payableSummaryUpdate);
            }
        }
        accountingReceivablePayableMapper.deleteAccountingReceivablePayableById(id);
        return R.ok("该报账单已删除");
    }

    /**
     * 设置备注-报账单
     */
    public R setRemarkRmAccounting(AccountingReceivablePayableParam accountingParam, LoginSysUser loginSysUser){
        AccountingReceivablePayable receivablePayable = accountingReceivablePayableMapper.selectAccountingReceivablePayableById(accountingParam.getId());
        if(receivablePayable == null){
            return R.fail("报账单不存在");
        }
        AccountingReceivablePayable accountingUpdate = new AccountingReceivablePayable();
        accountingUpdate.setId(accountingParam.getId());
        accountingUpdate.setRemark(accountingParam.getRemark());
        accountingUpdate.setUpdateId(loginSysUser.getSysUserId());
        accountingUpdate.setUpdateBy(loginSysUser.getFullName());
        accountingUpdate.setUpdateTime(new Date());
        accountingReceivablePayableMapper.updateAccountingReceivablePayable(accountingUpdate);
        return R.ok();
    }

    private static final String TEMPLATE_EXCEL_EXPORT_RM_ACCOUNTING_RECEIVABLE_FPTXX_PRE = "accounting_receivable.xls";
    private static final String TEMPLATE_EXCEL_EXPORT_RM_ACCOUNTING_PAYABLE_FPTXX_PRE = "accounting_payable.xls";
    private static final String TEMPLATE_EXCEL_EXPORT_RM_ACCOUNTING_FLOW_FPTXX_PRE = "accounting_flow.xls";
    /**
     * 侨城汇 积分结算
     * 积分结算 > 创建报账单,创建文件
     * @return
     */
    public void createRmAccountingExcel(AccountingScoreCustomer scoreCustomer,AccountingReceivablePayable accountingParam,
                                        InvoiceBankInfo invoiceBankInfo,
                                        List<InvoiceApplyDetailDimCreditItemVo> creditList,
                                        Integer index) {

        AccountingScoreCustomerCreateVo scoreCustomerCreateVo = new AccountingScoreCustomerCreateVo();
        BeanUtils.copyProperties(scoreCustomer,scoreCustomerCreateVo);
        scoreCustomerCreateVo.setEnterpriseName(accountingParam.getSettlementName());
        scoreCustomerCreateVo.setInvoiceCompanyName(invoiceBankInfo.getCompanyName());
        scoreCustomerCreateVo.setBizPlatformName(accountingParam.getBizPlatformName());

        String startTime = AnDateUtils.format(scoreCustomer.getStartTime(), "yyyy年MM月dd日");
        String endTime = AnDateUtils.format(scoreCustomer.getEndTime(), "yyyy年MM月dd日");
        scoreCustomerCreateVo.setCycleTimeStr(StrUtil.format("{}-{}", startTime, endTime));
        scoreCustomerCreateVo.setAccountingStatusName(AccountingOrderCustomerAccountingStatusEnum.getDesc(scoreCustomer.getAccountingStatus()));
        scoreCustomerCreateVo.setInvoiceStatusName(AccountingOrderInvoiceApplyStatusEnum.getDesc(scoreCustomer.getInvoiceStatus()));

        String excelExportPathRoot = resourceConstant.getPathRoot();
        String excelExportRelativePathTemplate = resourceConstant.getPathTemplate();
        String excelExportRelativePathStorage  = resourceConstant.getPathStorage();

        String relativePath = File.separator + "excel" + File.separator + "accounting" + File.separator + "score" + File.separator + "customer" + File.separator;
        String templateRelativePath = excelExportPathRoot + excelExportRelativePathTemplate + relativePath;
        String templateFullPath = "";
        String targetFileName  = accountingParam.getBillNo() + "_" + accountingParam.getAccountingOrderSn() + "_";

        List<FlowReceivableDetail> receivableDetailList = null;
        List<FlowPayableDetail> payableDetailList = null;
        String targetFullPath = excelExportPathRoot + excelExportRelativePathStorage;
        if(accountingParam.getAccountType() == 0){
            templateFullPath = templateRelativePath + TEMPLATE_EXCEL_EXPORT_RM_ACCOUNTING_RECEIVABLE_FPTXX_PRE;
            //对账单应收应付流水明细
            FlowReceivableDetail receivableParam = new FlowReceivableDetail();
            receivableParam.setAccountingOrderSn(scoreCustomer.getAccountingOrderSn());
            receivableDetailList = flowReceivableDetailMapper.selectFlowReceivableDetailList(receivableParam);

            if(CollectionUtils.isNotEmpty(receivableDetailList)){
                if(accountingParam.getDataType() == 0){
                    receivableDetailList = receivableDetailList.stream().filter(data -> 0 != data.getCreditType()).collect(Collectors.toList());
                }else{
                    receivableDetailList = receivableDetailList.stream().filter(data -> 0 == data.getCreditType()).collect(Collectors.toList());
                }
                receivableDetailList.stream().forEach(data ->{
                    data.setAccountingStateName(AccountingStateEnum.getDesc(data.getAccountingState()));
                    data.setInAccountStateName(InAccountStateEnum.getDesc(data.getInAccountState()));
                });
            }
            targetFileName  = targetFileName + "应收报账单";
        }else if(accountingParam.getAccountType() == 1){
            templateFullPath = templateRelativePath + TEMPLATE_EXCEL_EXPORT_RM_ACCOUNTING_PAYABLE_FPTXX_PRE;
            //对账单应付应付流水明细
            FlowPayableDetail payableParam = new FlowPayableDetail();
            payableParam.setAccountingOrderSn(scoreCustomer.getAccountingOrderSn());
            payableDetailList = flowPayableDetailMapper.selectFlowPayableDetailList(payableParam);

            if(CollectionUtils.isNotEmpty(payableDetailList)){
                payableDetailList.stream().forEach(data ->{
                    data.setAccountingStateName(AccountingStateEnum.getDesc(data.getAccountingState()));
                    data.setInAccountStateName(InAccountStateEnum.getDesc(data.getInAccountState()));
                    data.setDataTypeName(AccountingOrderTypeEnum.getDesc(data.getDataType()));
                });
            }
            targetFileName  = targetFileName + "应付报账单";
        }

        String targetWriteFileFullPath = targetFullPath + relativePath + targetFileName + DateUtils.dateTime()+ index + ".xlsx";

        FileUtil.touch(targetWriteFileFullPath);

        ExcelWriterBuilder excelWriterBuilder = EasyExcel.write(targetWriteFileFullPath);
        ExcelWriter excelWriter = excelWriterBuilder.withTemplate(templateFullPath).build();

        WriteSheet writeSheet0 = EasyExcel.writerSheet(0, "对账单").build();
        WriteSheet writeSheet1 = EasyExcel.writerSheet(1, "对账单明细").build();
        WriteSheet writeSheet2 = EasyExcel.writerSheet(2, "应收/应付流水明细").build();
        FillConfig fillConfig  = FillConfig.builder().forceNewRow(Boolean.FALSE).build();

        excelWriter.fill(scoreCustomerCreateVo, writeSheet0);
        excelWriter.fill(creditList, fillConfig, writeSheet1);
        if(accountingParam.getAccountType() == 0){
            excelWriter.fill(receivableDetailList, fillConfig, writeSheet2);
        }else if(accountingParam.getAccountType() == 1){
            excelWriter.fill(payableDetailList, fillConfig, writeSheet2);
        }

        excelWriter.finish();

        accountingParam.setFileTitle(targetFileName + DateUtils.dateTime() + ".xlsx");
        accountingParam.setFileDetailLink(targetWriteFileFullPath.replace(excelExportPathRoot,""));
        accountingReceivablePayableMapper.updateAccountingReceivablePayable(accountingParam);
    }

    /**
     * 共享中心接口业务数据
     */
    public String getReceivableShareDataHead (List<SysAccountReceivableVo> receivableVoList,
                                    AccountingScoreCustomer scoreCustomer,
                                    AccountingReceivablePayable accountingParam,
                                    List<SysBusinessUserVo> userVoList){

        String startTime = AnDateUtils.format(scoreCustomer.getStartTime(), "yyyy年MM月dd日");
        String endTime = AnDateUtils.format(scoreCustomer.getEndTime(), "yyyy年MM月dd日");
        String cycleTimeStr = StrUtil.format("{}至{}", startTime, endTime);
        String remark = cycleTimeStr + accountingParam.getBizPlatformName() +"_" + accountingParam.getSettlementName() +"_" + scoreCustomer.getAccountingOrderSn()+"_应收数据";

        SysAccountReceivableVo accountReceivableVo = CollectionUtils.isNotEmpty(receivableVoList) ? receivableVoList.get(0) : new SysAccountReceivableVo();
        SysBusinessUserVo businessUserVo = CollectionUtils.isNotEmpty(userVoList) ? userVoList.get(0) : new SysBusinessUserVo();
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("dataSource","104");
        jsonObject.put("batchNo",accountingParam.getBillNo());
        jsonObject.put("groupCode","OCT");
        jsonObject.put("boeDate",DateUtils.dateTime(accountingParam.getCreateTime(),DateUtils.YYYY_MM_DD_HH_MM_SS));
        jsonObject.put("businessCategory",accountReceivableVo.getBusinessCategory());
        jsonObject.put("paperAccessories","N");
        jsonObject.put("operationTypeCode",accountReceivableVo.getOperationTypeCode());
        jsonObject.put("companyNum",accountReceivableVo.getCompanyNum());
        jsonObject.put("companyName",accountReceivableVo.getCompanyName());
        jsonObject.put("remark",remark);
        jsonObject.put("employeeId",businessUserVo.getWorkNumber());
        jsonObject.put("employeeName",businessUserVo.getUserName());
        jsonObject.put("employeePostId",businessUserVo.getJobCode());
        jsonObject.put("employeePostName",businessUserVo.getJobName());
        jsonObject.put("employeeDepartmentId",businessUserVo.getDepartmentCode());
        jsonObject.put("employeeDepartmentName",businessUserVo.getDepartmentName());
        return jsonObject.toJSONString();
    }

    /**
     * 共享中心接口业务数据
     */
    public String getPayableShareDataHead (List<SysAccountPayableVo> payableVoList,
                                           AccountingScoreCustomer scoreCustomer,
                                           AccountingReceivablePayable accountingParam,
                                           List<SysBusinessUserVo> userVoList){

        String startTime = AnDateUtils.format(scoreCustomer.getStartTime(), "yyyy年MM月dd日");
        String endTime = AnDateUtils.format(scoreCustomer.getEndTime(), "yyyy年MM月dd日");
        String cycleTimeStr = StrUtil.format("{}至{}", startTime, endTime);
        String remark = cycleTimeStr + accountingParam.getBizPlatformName() +"_" + scoreCustomer.getAccountingOrderSn()+"_成本数据";

        SysAccountPayableVo accountPayableVo = CollectionUtils.isNotEmpty(payableVoList) ? payableVoList.get(0) : new SysAccountPayableVo();
        SysBusinessUserVo businessUserVo = CollectionUtils.isNotEmpty(userVoList) ? userVoList.get(0) : new SysBusinessUserVo();
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("sourceSystemCode","104");
        jsonObject.put("batchNo",accountingParam.getBillNo());
        jsonObject.put("groupCode","OCT");
        jsonObject.put("boeDate",DateUtils.dateTime(accountingParam.getCreateTime(),DateUtils.YYYY_MM_DD_HH_MM_SS));
        jsonObject.put("boeTypeCode","WSYC_NEW_COST_CARRY_FORWARD_BOE");
        jsonObject.put("boeTypeName","");
        jsonObject.put("businessCategory",accountPayableVo.getBusinessCategory());
        jsonObject.put("paperAccessories","N");
        jsonObject.put("operationTypeCode",accountPayableVo.getOperationTypeCode());
        jsonObject.put("leCode",accountPayableVo.getLeCode());
        jsonObject.put("leName",accountPayableVo.getLeName());
        jsonObject.put("boeAbstract",remark);
        jsonObject.put("employeeCode",businessUserVo.getWorkNumber());
        jsonObject.put("employeeName",businessUserVo.getUserName());
        jsonObject.put("postCode",businessUserVo.getJobCode());
        jsonObject.put("employeePostName",businessUserVo.getJobName());
        jsonObject.put("expenseDeptCode",businessUserVo.getDepartmentCode());
        jsonObject.put("employeeDepartmentName",businessUserVo.getDepartmentName());
        return jsonObject.toJSONString();
    }

    /**
     * 共享中心接口业务数据
     */
    public String getReceivableShareDataRow(List<SysAccountReceivableVo> receivableVoList,
                                    AccountingScoreCustomer scoreCustomer,
                                    List<FlowReceivableSummary> receivableSummaryList,
                                    List<SysBusinessUserVo> userVoList){

        JSONArray jsonArray = new JSONArray();
        for (FlowReceivableSummary receivableSummary : receivableSummaryList) {
            SysEnterprise sysEnterprise = sysEnterpriseMapper.selectByPrimaryKey(receivableSummary.getCusSettlementId());
            if (sysEnterprise == null) sysEnterprise = new SysEnterprise();

            SysAccountReceivableVo accountReceivableVo = CollectionUtils.isNotEmpty(receivableVoList) ? receivableVoList.get(0) : new SysAccountReceivableVo();
            SysBusinessUserVo businessUserVo = CollectionUtils.isNotEmpty(userVoList) ? userVoList.get(0) : new SysBusinessUserVo();
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("id", receivableSummary.getId());
            jsonObject.put("lineType", "cost");
            jsonObject.put("currencyAmount", receivableSummary.getReceivableAmount());
            jsonObject.put("amount", receivableSummary.getReceivableAmount());
            jsonObject.put("taxAmount", receivableSummary.getTaxAmount());
            jsonObject.put("taxRate", receivableSummary.getOperationTaxRate());
            jsonObject.put("taxType", AccountingTaxTypeEnum.getDesc(receivableSummary.getOperationTaxRate()));
            jsonObject.put("customerId",sysEnterprise.getId().toString());
            jsonObject.put("customerNum", Optional.ofNullable(sysEnterprise.getCustomerUuid()).orElse(""));
            jsonObject.put("customerName", Optional.ofNullable(sysEnterprise.getCustomerName()).orElse(""));
            jsonObject.put("contractNum", "");
            jsonObject.put("contractName", "");
            jsonObject.put("yydy", "");
            jsonObject.put("billingMethod", "Money_bank");
            jsonObject.put("sourceCurrency", "CNY");
            jsonObject.put("rateValue", "1.0");
            jsonObject.put("operationSubTypeCode", accountReceivableVo.getOperationSubTypeCode());
            jsonObject.put("costcenterId", accountReceivableVo.getCostcenterId());
            jsonObject.put("costcenterName", accountReceivableVo.getCostcenterName());
            jsonObject.put("projectNum", accountReceivableVo.getProjectNum());
            jsonObject.put("projectName", accountReceivableVo.getProjectName());
            jsonObject.put("formatType", accountReceivableVo.getFormatType());
            if (CommonServiceNoEnum.企业福利_侨城汇.getServiceNo().equals(scoreCustomer.getServiceNo())) {
                jsonObject.put("serviceType", accountReceivableVo.getWelfareShopServiceType());
            } else if (CommonServiceNoEnum.企业商城_侨城汇.getServiceNo().equals(scoreCustomer.getServiceNo())) {
                jsonObject.put("serviceType", accountReceivableVo.getServiceType());
            }
            jsonObject.put("expenseDeptId", businessUserVo.getDepartmentCode());
            jsonObject.put("expenseDeptName", businessUserVo.getDepartmentName());
            jsonArray.add(jsonObject);
        }
        return jsonArray.toJSONString();
    }

    /**
     * 共享中心接口业务数据
     */
    public String getPayableShareDataRow(List<SysAccountPayableVo> payableVoList,
                                         AccountingScoreCustomer scoreCustomer,
                                         List<FlowPayableSummary> payableSummaryList,
                                         List<SysBusinessUserVo> userVoList,
                                         UnifiedSupplier supplier,SysEnterprise sysEnterpriseZero,
                                         BizContract bizContractParam){
        JSONArray jsonArray = new JSONArray();
        for (FlowPayableSummary payableSummary : payableSummaryList) {
            SysAccountPayableVo accountPayableVo = CollectionUtils.isNotEmpty(payableVoList) ? payableVoList.get(0) : new SysAccountPayableVo();
            SysBusinessUserVo businessUserVo = CollectionUtils.isNotEmpty(userVoList) ? userVoList.get(0) : new SysBusinessUserVo();
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("id", payableSummary.getId());
            jsonObject.put("expenseAmount", payableSummary.getPayableAmount());
            jsonObject.put("taxAmount", payableSummary.getTaxAmount());
            jsonObject.put("taxRate", payableSummary.getOperationTaxRate());
            jsonObject.put("taxCode", AccountingTaxTypeEnum.getDesc(payableSummary.getOperationTaxRate()));
            jsonObject.put("vendorId",supplier.getId().toString());
            jsonObject.put("vendorCode",Optional.ofNullable(supplier.getSourceId()).orElse(""));
            jsonObject.put("vendorName",Optional.ofNullable(supplier.getSourceName()).orElse(""));
            jsonObject.put("customerId",sysEnterpriseZero.getId().toString());
            jsonObject.put("customerNum",Optional.ofNullable(sysEnterpriseZero.getCustomerUuid()).orElse(""));
            jsonObject.put("customerName",Optional.ofNullable(sysEnterpriseZero.getCustomerName()).orElse(""));
            jsonObject.put("contractId",bizContractParam.getId());
            jsonObject.put("contractNum",Optional.ofNullable(bizContractParam.getContractCode()).orElse(""));
            jsonObject.put("contractName",Optional.ofNullable(bizContractParam.getContractName()).orElse(""));
            jsonObject.put("ccCode",accountPayableVo.getCcCode());
            jsonObject.put("ccName",accountPayableVo.getCcName());
            jsonObject.put("businessType",accountPayableVo.getBusinessType());
            jsonObject.put("dimensionCblb",accountPayableVo.getDimensionCblb());
            if (CommonServiceNoEnum.企业福利_侨城汇.getServiceNo().equals(scoreCustomer.getServiceNo())) {
                jsonObject.put("dimensionFwjsp",accountPayableVo.getShopDimensionFwjsp());
            } else if (CommonServiceNoEnum.企业商城_侨城汇.getServiceNo().equals(scoreCustomer.getServiceNo())) {
                jsonObject.put("dimensionFwjsp",accountPayableVo.getDimensionFwjsp());
            }
            jsonObject.put("operationSubTypeCode",accountPayableVo.getOperationSubTypeCode());
            jsonObject.put("projectCode",accountPayableVo.getProjectNum());
            jsonObject.put("projectName",accountPayableVo.getProjectName());
            jsonObject.put("expenseDeptId",businessUserVo.getDepartmentCode());
            jsonObject.put("expenseDeptName",businessUserVo.getDepartmentName());
            jsonArray.add(jsonObject);
        }
        return jsonArray.toJSONString();
    }
}
