package cn.superdesk.uniorder.service.invoice.supplier;

import cn.superdesk.uniorder.common.exception.UnifiedOrderRuntimeException;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dto.param.invoice.customer.reportaccounting.ActualPayableReportAccountingCreateParam;
import cn.superdesk.uniorder.dto.param.invoice.customer.reportaccounting.ActualReportAccountingConfirmParam;
import cn.superdesk.uniorder.dto.param.invoice.customer.reportaccounting.InvoiceStatusRepair;
import cn.superdesk.uniorder.dto.vo.invoice.reportaccounting.ActualPayableReportAccountingDetailVO;
import cn.superdesk.uniorder.dto.vo.invoice.supplier.paymentReport.AddPaymentReportEchoVo;
import cn.superdesk.uniorder.dto.vo.invoice.supplier.paymentReport.PaymentReportEchoVo;
import org.springframework.web.bind.annotation.RequestBody;

public interface AccountingReportPaymenService {
    PaymentReportEchoVo getPaymentReportEcho (String accountingOrderId);

    R<AddPaymentReportEchoVo> getAddPaymentReportEcho(Long accountingOrderId, LoginSysUser loginSysUser) throws UnifiedOrderRuntimeException;

    ActualPayableReportAccountingDetailVO getPaymentReportDetail(Long id);

    R<?> confirmPaymentReportList(@RequestBody ActualReportAccountingConfirmParam param, LoginSysUser loginSysUser);

    R<?> addPaymentReport(@RequestBody ActualPayableReportAccountingCreateParam param, LoginSysUser loginSysUser);

    void billPaymentStatusRepair(InvoiceStatusRepair repair, LoginSysUser loginSysUser);
}
