package cn.superdesk.uniorder.service.organisation.impl;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.organisation.SysBusinessUser;
import cn.superdesk.uniorder.dao.mapper.organisation.SysBusinessUserMapper;
import cn.superdesk.uniorder.dto.param.organisation.SysBusinessUserQueryCriteria;
import cn.superdesk.uniorder.dto.param.organisation.SysOperationUserQueryCriteria;
import cn.superdesk.uniorder.dto.vo.sys.SysBusinessUserVo;
import cn.superdesk.uniorder.dto.vo.sys.SysOperationUserVo;
import cn.superdesk.uniorder.service.organisation.SysBusinessUserService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 业人员
 */
@Slf4j
@Service
public class SysBusinessUserServiceImpl implements SysBusinessUserService {

    @Autowired
    private SysBusinessUserMapper sysBusinessUserMapper;

    @Override
    public int insert(SysBusinessUser sysBusinessUser) {
        return sysBusinessUserMapper.insert(sysBusinessUser);
    }

    @Override
    public int updateByPrimaryKeySelective(SysBusinessUser sysBusinessUser) {
        return sysBusinessUserMapper.updateByPrimaryKeySelective(sysBusinessUser);
    }

    @Override
    public void deleteByIds(List<Long> ids) {
        sysBusinessUserMapper.deleteByIds(ids);
    }

    @Override
    public SysBusinessUserVo findById(Long id) {
        return sysBusinessUserMapper.selectByPrimaryKey(id);
    }

    @Override
    public R<List<SysBusinessUserVo>> findByPaging(SysBusinessUserQueryCriteria queryCriteria) {
        PageHelper.startPage(queryCriteria.getPageNumber(), queryCriteria.getPageSize());
        List<SysBusinessUserVo> resultList = sysBusinessUserMapper.findByPaging(queryCriteria);
        PageInfo<SysBusinessUserVo> page = new PageInfo<>(resultList);
        PageHelper.clearPage();
        return new R<List<SysBusinessUserVo>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), resultList);
    }

    @Override
    public R<List<SysOperationUserVo>> queryOperationUserList(SysOperationUserQueryCriteria queryCriteria) {
        PageHelper.startPage(queryCriteria.getPageNumber(), queryCriteria.getPageSize());
        List<SysOperationUserVo> resultList = sysBusinessUserMapper.queryOperationUserList(queryCriteria);
        PageInfo<SysOperationUserVo> page = new PageInfo<>(resultList);
        PageHelper.clearPage();
        return new R<List<SysOperationUserVo>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), resultList);
    }

}
