package cn.superdesk.uniorder.service.sys.impl;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.sys.SysAccountConfig;
import cn.superdesk.uniorder.dao.mapper.sys.SysAccountConfigMapper;
import cn.superdesk.uniorder.dto.param.system.SysAccountConfigQueryCriteria;
import cn.superdesk.uniorder.dto.vo.sys.SysAccountConfigVo;
import cn.superdesk.uniorder.service.sys.SysAccountConfigService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 共享参数配置
 *
 * @author zhu 270897222@qq.com
 * @since 1.0.0 2022-10-28
 */
@Slf4j
@Service
public class SysAccountConfigServiceImpl  implements SysAccountConfigService {



        @Autowired
        private SysAccountConfigMapper sysAccountConfigMapper;

        @Override
        public int insert(SysAccountConfig SysAccountConfig) {
            return sysAccountConfigMapper.insert(SysAccountConfig);
        }

        @Override
        public int updateByPrimaryKeySelective(SysAccountConfig SysAccountConfig) {
            return sysAccountConfigMapper.updateByPrimaryKeySelective(SysAccountConfig);
        }

        @Override
        public void deleteByIds(List<Long> ids) {
            sysAccountConfigMapper.deleteByIds(ids);
        }

        @Override
        public SysAccountConfigVo findById(Long id) {
            return sysAccountConfigMapper.selectByPrimaryKey(id);
        }

        @Override
        public R<List<SysAccountConfigVo>> findByPaging(SysAccountConfigQueryCriteria queryCriteria) {
            PageHelper.startPage(queryCriteria.getPageNumber(), queryCriteria.getPageSize());
            List<SysAccountConfigVo> resultList = sysAccountConfigMapper.findByPaging(queryCriteria);
            PageInfo<SysAccountConfigVo> page = new PageInfo<>(resultList);
            PageHelper.clearPage();
            return new R<List<SysAccountConfigVo>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), resultList);
        }
}
