package cn.superdesk.uniorder.service.sys.impl;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.sys.SysAccountPayable;
import cn.superdesk.uniorder.dao.mapper.sys.SysAccountPayableMapper;
import cn.superdesk.uniorder.dto.param.system.SysAccountPayableQueryCriteria;
import cn.superdesk.uniorder.dto.vo.sys.SysAccountPayableVo;
import cn.superdesk.uniorder.service.sys.SysAccountPayableService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 应付款报账单
 *
 * @author zhu 270897222@qq.com
 * @since 1.0.0 2022-10-28
 */
@Slf4j
@Service
public class SysAccountPayableServiceImpl  implements SysAccountPayableService {


    @Autowired
    private SysAccountPayableMapper sysAccountPayableMapper;

    @Override
    public int insert(SysAccountPayable SysAccountPayable) {
        return sysAccountPayableMapper.insert(SysAccountPayable);
    }

    @Override
    public int updateByPrimaryKeySelective(SysAccountPayable SysAccountPayable) {
        return sysAccountPayableMapper.updateByPrimaryKeySelective(SysAccountPayable);
    }

    @Override
    public void deleteByIds(List<Long> ids) {
        sysAccountPayableMapper.deleteByIds(ids);
    }

    @Override
    public SysAccountPayableVo findById(Long id) {
        return sysAccountPayableMapper.selectByPrimaryKey(id);
    }

    @Override
    public R<List<SysAccountPayableVo>> findByPaging(SysAccountPayableQueryCriteria queryCriteria) {
        PageHelper.startPage(queryCriteria.getPageNumber(), queryCriteria.getPageSize());
        List<SysAccountPayableVo> resultList = sysAccountPayableMapper.findByPaging(queryCriteria);
        PageInfo<SysAccountPayableVo> page = new PageInfo<>(resultList);
        PageHelper.clearPage();
        return new R<List<SysAccountPayableVo>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), resultList);
    }

}
