package cn.superdesk.uniorder.service.sys.impl;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.sys.SysAccountRealityPayable;
import cn.superdesk.uniorder.dao.mapper.sys.SysAccountRealityPayableMapper;
import cn.superdesk.uniorder.dto.param.system.SysAccountRealityPayableQueryCriteria;
import cn.superdesk.uniorder.dto.vo.sys.SysAccountRealityPayableVo;
import cn.superdesk.uniorder.service.sys.SysAccountRealityPayableService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 实付款报账单
 *
 * @author 阿沐 270897222@qq.com
 * @since 1.0.0 2022-10-28
 */
@Slf4j
@Service
public class SysAccountRealityPayableServiceImpl   implements SysAccountRealityPayableService {

    @Autowired
    private SysAccountRealityPayableMapper sysAccountRealityPayableMapper;

    @Override
    public int insert(SysAccountRealityPayable SysAccountRealityPayable) {
        return sysAccountRealityPayableMapper.insert(SysAccountRealityPayable);
    }

    @Override
    public int updateByPrimaryKeySelective(SysAccountRealityPayable SysAccountRealityPayable) {
        return sysAccountRealityPayableMapper.updateByPrimaryKeySelective(SysAccountRealityPayable);
    }

    @Override
    public void deleteByIds(List<Long> ids) {
        sysAccountRealityPayableMapper.deleteByIds(ids);
    }

    @Override
    public SysAccountRealityPayableVo findById(Long id) {
        return sysAccountRealityPayableMapper.selectByPrimaryKey(id);
    }

    @Override
    public R<List<SysAccountRealityPayableVo>> findByPaging(SysAccountRealityPayableQueryCriteria queryCriteria) {
        PageHelper.startPage(queryCriteria.getPageNumber(), queryCriteria.getPageSize());
        List<SysAccountRealityPayableVo> resultList = sysAccountRealityPayableMapper.findByPaging(queryCriteria);
        PageInfo<SysAccountRealityPayableVo> page = new PageInfo<>(resultList);
        PageHelper.clearPage();
        return new R<List<SysAccountRealityPayableVo>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), resultList);
    }


}
