package cn.superdesk.uniorder.service.sys.impl;


import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.sys.SysAccountRealityReceivable;
import cn.superdesk.uniorder.dao.mapper.sys.SysAccountRealityReceivableMapper;
import cn.superdesk.uniorder.dto.param.system.SysAccountRealityReceivableQueryCriteria;
import cn.superdesk.uniorder.dto.vo.sys.SysAccountRealityReceivableVo;
import cn.superdesk.uniorder.service.sys.SysAccountRealityReceivableService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 实收报账单
 *
 * @author zhu 270897222@qq.com
 * @since 1.0.0 2022-10-28
 */
@Slf4j
@Service
public class SysAccountRealityReceivableServiceImpl implements SysAccountRealityReceivableService {

    @Autowired
    private SysAccountRealityReceivableMapper sysAccountRealityReceivableMapper;

    @Override
    public int insert(SysAccountRealityReceivable SysAccountRealityReceivable) {
        return sysAccountRealityReceivableMapper.insert(SysAccountRealityReceivable);
    }

    @Override
    public int updateByPrimaryKeySelective(SysAccountRealityReceivable SysAccountRealityReceivable) {
        return sysAccountRealityReceivableMapper.updateByPrimaryKeySelective(SysAccountRealityReceivable);
    }

    @Override
    public void deleteByIds(List<Long> ids) {
        sysAccountRealityReceivableMapper.deleteByIds(ids);
    }

    @Override
    public SysAccountRealityReceivableVo findById(Long id) {
        return sysAccountRealityReceivableMapper.selectByPrimaryKey(id);
    }

    @Override
    public R<List<SysAccountRealityReceivableVo>> findByPaging(SysAccountRealityReceivableQueryCriteria queryCriteria) {
        PageHelper.startPage(queryCriteria.getPageNumber(), queryCriteria.getPageSize());
        List<SysAccountRealityReceivableVo> resultList = sysAccountRealityReceivableMapper.findByPaging(queryCriteria);
        PageInfo<SysAccountRealityReceivableVo> page = new PageInfo<>(resultList);
        PageHelper.clearPage();
        return new R<List<SysAccountRealityReceivableVo>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), resultList);
    }

    @Override
    public SysAccountRealityReceivableVo find() {
        return sysAccountRealityReceivableMapper.selectAll().get(0);
    }
}
