package cn.superdesk.uniorder.service.sys.impl;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.sys.SysAccountReceivable;
import cn.superdesk.uniorder.dao.mapper.sys.SysAccountReceivableMapper;
import cn.superdesk.uniorder.dto.param.system.SysAccountReceivableQueryCriteria;
import cn.superdesk.uniorder.dto.vo.sys.SysAccountReceivableVo;
import cn.superdesk.uniorder.service.sys.SysAccountReceivableService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 应收报账单
 *
 * @author zhu 270897222@qq.com
 * @since 1.0.0 2022-10-28
 */
@Slf4j
@Service
public class SysAccountReceivableServiceImpl implements SysAccountReceivableService {


    @Autowired
    private SysAccountReceivableMapper sysAccountReceivableMapper;

    @Override
    public int insert(SysAccountReceivable SysAccountReceivable) {
        return sysAccountReceivableMapper.insert(SysAccountReceivable);
    }

    @Override
    public int updateByPrimaryKeySelective(SysAccountReceivable SysAccountReceivable) {
        return sysAccountReceivableMapper.updateByPrimaryKeySelective(SysAccountReceivable);
    }

    @Override
    public void deleteByIds(List<Long> ids) {
        sysAccountReceivableMapper.deleteByIds(ids);
    }

    @Override
    public SysAccountReceivableVo findById(Long id) {
        return sysAccountReceivableMapper.selectByPrimaryKey(id);
    }

    @Override
    public R<List<SysAccountReceivableVo>> findByPaging(SysAccountReceivableQueryCriteria queryCriteria) {
        PageHelper.startPage(queryCriteria.getPageNumber(), queryCriteria.getPageSize());
        List<SysAccountReceivableVo> resultList = sysAccountReceivableMapper.findByPaging(queryCriteria);
        PageInfo<SysAccountReceivableVo> page = new PageInfo<>(resultList);
        PageHelper.clearPage();
        return new R<List<SysAccountReceivableVo>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), resultList);
    }
}
