package cn.superdesk.uniorder.service.thirdpart.jd;


import cn.hutool.core.date.DateTime;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.sys.notify.SysNotify;
import cn.superdesk.uniorder.dao.entity.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReport;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.AccountingUnifiedSupplierJdOpCreateParamDimGoodsSimulateSelectedDimOrder;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportTaskQueryCriteria;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.*;
import cn.superdesk.uniorder.service.base.BaseService;
import com.github.pagehelper.PageInfo;

import java.util.List;
import java.util.Map;


/**
 * @Description: 京东对账单中的订单 算是临时 sheet eg 深圳市侨城汇网络科技有限公司-2021年8月1日集采账单.xlsx
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-10-14 17:04:08
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-10-14 17:04:08
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
public interface AccountingUnifiedSupplierOrderJdCheckUpReportService extends BaseService<AccountingUnifiedSupplierOrderJdCheckUpReport> {


    /****************************************** extends BaseService 部分 start ******************************************/

    @Override
    int insertSelective(AccountingUnifiedSupplierOrderJdCheckUpReport entity);

    @Override
    int updateByPrimaryKeySelective(AccountingUnifiedSupplierOrderJdCheckUpReport entity);

    int saveOrUpdateByPrimaryKeySelective(AccountingUnifiedSupplierOrderJdCheckUpReport entityCheckUpReport, DateTime now);

    @Override
    @Deprecated
    void deleteObj(Long id);

    @Override
    @Deprecated
    AccountingUnifiedSupplierOrderJdCheckUpReport findById(Long id);

    @Override
    @Deprecated
    PageInfo<AccountingUnifiedSupplierOrderJdCheckUpReport> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize);

    @Override
    @Deprecated
    List<AccountingUnifiedSupplierOrderJdCheckUpReport> findAll(Map<String, Object> queryMap);

    /****************************************** extends BaseService 部分   end ******************************************/


    int addAccountingUnifiedSupplierOrderJdCheckUpReport(AccountingUnifiedSupplierOrderJdCheckUpReport entity);

    int updateAccountingUnifiedSupplierOrderJdCheckUpReport(AccountingUnifiedSupplierOrderJdCheckUpReport entity);

    int deleteAccountingUnifiedSupplierOrderJdCheckUpReport(Long id);

    int deleteByBatchId(String batchId);

    AccountingUnifiedSupplierOrderJdCheckUpReport findAccountingUnifiedSupplierOrderJdCheckUpReportById(Long id);

    AccountingUnifiedSupplierOrderJdCheckUpReport findByBatchIdAndJdOrderSn(String batchId, String jdOrderSn);

    AccountingUnifiedSupplierOrderJdCheckUpReport findByBatchIdAndJdOrderSnAndAccountingUnifiedSupplierOrderJdId(
            String batchId,
            String jdOrderSn,
            Long accountingUnifiedSupplierOrderJdId);

    R<List<AccountingUnifiedSupplierOrderJdCheckUpReport>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize);

    R<List<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVo>> pageQueryGenericParam(
            AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria queryCriteria,
            LoginSysUser loginSysUser);

    R<List<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVoWoof>> pageQueryGenericWoof(
            AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria queryCriteria,
            LoginSysUser loginSysUser);

    AccountingUnifiedSupplierOrderJdCheckUpReportDetailStatisticsVo pageQueryHeadGenericParam(
            AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria queryCriteria,
            LoginSysUser loginSysUser);

    List<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVo> queryGenericParam(
            AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria criteria,
            LoginSysUser loginSysUser);

    List<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVoWoof> queryGenericWoof(
            AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria criteria,
            LoginSysUser loginSysUser);

    AccountingUnifiedSupplierOrderJdCheckUpReportUpperLevelsStatisticsVo statisticsQuantityDimOrderNormalOrException(
            AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria queryCriteria,
            LoginSysUser loginSysUser);


    /****************************************** 检查 start ******************************************/


    List<AccountingUnifiedSupplierJdOpCreateParamDimGoodsSimulateSelectedDimOrder> simulateGoodsSelectedDimOrder(
            AccountingUnifiedSupplierOrderJdCheckUpReportTaskQueryCriteria queryCriteria);

    R<String> opCompareOrderAndCheckUpProcessDimOrderOne(
            SysQuartzScheduleTaskStatementOfAccountJdListItemVo listItemVo,
            AccountingUnifiedSupplierOrderJdListItemVo itemVo);

    AccountingUnifiedSupplierOrderJdCheckUpReportSnapshotStruct readSnapshotJson(String batchId, String jdOrderSn);

    SysNotify opCompareOrderAndCheckUp(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            SysQuartzScheduleTaskStatementOfAccountJdListItemVo listItemVo, LoginSysUser loginSysUser);

    SysNotify opCompareOrderAndCheckUpOnlyException(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            SysQuartzScheduleTaskStatementOfAccountJdListItemVo listItemVo,
            LoginSysUser loginSysUser);

//	SELECT order_sn FROM `accounting_unified_supplier_order_jd_check_up_report` WHERE process_result = 1 and batch_id = '1450042895204749312'

//	SELECT *
//	FROM
//	    unified_order_goods uog
//	    LEFT JOIN unified_order uo ON uog.order_sn = uo.order_sn
//	WHERE uo.order_sn in (
//			SELECT order_sn FROM `accounting_unified_supplier_order_jd_check_up_report` WHERE process_result = 1 and batch_id = '1450042895204749312'
//	)

//	19960
//	SELECT
//	uo.id as unified_order_id,
//	uog.id as unified_order_goods_id
//			FROM
//	unified_order_goods uog
//	LEFT JOIN unified_order uo ON uog.order_sn = uo.order_sn
//	WHERE uo.order_sn in (
//			SELECT order_sn FROM `accounting_unified_supplier_order_jd_check_up_report` WHERE process_result = 1 and batch_id = '1450042895204749312'
//	)


//	19985
//	SELECT
//	uo.id as unified_order_id,
//	uog.id as unified_order_goods_id
//			FROM
//	unified_order_goods uog
//	LEFT JOIN unified_order uo ON uog.order_sn = uo.order_sn
//	WHERE uo.order_sn in (
//			SELECT order_sn FROM `accounting_unified_supplier_order_jd_check_up_report` WHERE process_result = 1 and batch_id = '1450042895204749312'
//	) or uo.refund_order_sn in (
//			SELECT order_sn FROM `accounting_unified_supplier_order_jd_check_up_report` WHERE process_result = 1 and batch_id = '1450042895204749312'
//	)

    /****************************************** 检查   end ******************************************/

}
