package cn.superdesk.uniorder.service.thirdpart.jd;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.sys.notify.SysNotify;
import cn.superdesk.uniorder.dao.entity.thirdpart.jd.AccountingUnifiedSupplierOrderJd;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.AccountingUnifiedSupplierOrderJdImportFullVersionExcelRow;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.AccountingUnifiedSupplierOrderJdImportLiteVersionExcelRow;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.AccountingUnifiedSupplierOrderJdQueryCriteria;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.AccountingUnifiedSupplierOrderJdDetailStatisticsVo;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.AccountingUnifiedSupplierOrderJdListItemVo;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.AccountingUnifiedSupplierOrderJdUpperLevelsStatisticsVo;
import cn.superdesk.uniorder.service.base.BaseService;
import com.github.pagehelper.PageInfo;

import java.util.List;
import java.util.Map;


/**
 * @Description: 京东对账单中的订单 算是临时 sheet eg 深圳市侨城汇网络科技有限公司-2021年8月1日集采账单.xlsx
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-10-12 11:29:24
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-10-12 11:29:24
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
public interface AccountingUnifiedSupplierOrderJdService extends BaseService<AccountingUnifiedSupplierOrderJd> {


    /****************************************** extends BaseService 部分 start ******************************************/

    int insertSelective(AccountingUnifiedSupplierOrderJd entity);

    int updateByPrimaryKeySelective(AccountingUnifiedSupplierOrderJd entity);

    @Deprecated
    void deleteObj(Long id);

    @Deprecated
    AccountingUnifiedSupplierOrderJd findById(Long id);

    AccountingUnifiedSupplierOrderJd findByBatchIdAndJdOrderSn(String batchId, String jdOrderSn);

    @Deprecated
    PageInfo<AccountingUnifiedSupplierOrderJd> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize);

    @Deprecated
    List<AccountingUnifiedSupplierOrderJd> findAll(Map<String, Object> queryMap);

    /****************************************** extends BaseService 部分   end ******************************************/


    void addAccountingUnifiedSupplierOrderJd(AccountingUnifiedSupplierOrderJd entity);

    void updateAccountingUnifiedSupplierOrderJd(AccountingUnifiedSupplierOrderJd entity);

    void updateAccountingUnifiedSupplierOrderJdByPrimaryKeySelective(AccountingUnifiedSupplierOrderJd entity);

    void deleteAccountingUnifiedSupplierOrderJd(Long id);

    int deleteByBatchId(String batchId);

    AccountingUnifiedSupplierOrderJd findAccountingUnifiedSupplierOrderJdById(Long id);

    R<List<AccountingUnifiedSupplierOrderJd>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize);

    R<List<AccountingUnifiedSupplierOrderJdListItemVo>> pageQueryGenericParam(
            AccountingUnifiedSupplierOrderJdQueryCriteria criteria,
            LoginSysUser loginSysUser);

    List<AccountingUnifiedSupplierOrderJdListItemVo> queryGenericParam(
            AccountingUnifiedSupplierOrderJdQueryCriteria criteria,
            LoginSysUser loginSysUser);

    AccountingUnifiedSupplierOrderJdDetailStatisticsVo pageQueryHeadGenericParam(
            AccountingUnifiedSupplierOrderJdQueryCriteria queryCriteria,
            LoginSysUser loginSysUser);

    AccountingUnifiedSupplierOrderJdUpperLevelsStatisticsVo statisticsQuantityDimOrderNormalOrException(
            AccountingUnifiedSupplierOrderJdQueryCriteria queryCriteria, LoginSysUser loginSysUser);


    /****************************************** excel import start start ******************************************/

    SysNotify opImportExcelFullVersion(SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form, LoginSysUser loginSysUser);

    SysNotify opImportExcelLiteVersion(SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form, LoginSysUser loginSysUser);

    void saveOrUpdate4ThirdPartJdReconciliationScheduleFullVersionExcelRow(
            AccountingUnifiedSupplierOrderJdImportFullVersionExcelRow excelRow,
            LoginSysUser loginSysUser);

    void saveOrUpdate4ThirdPartJdReconciliationScheduleFullVersionExcelRowList(
            List<AccountingUnifiedSupplierOrderJdImportFullVersionExcelRow> excelRowList,
            LoginSysUser loginSysUser);

    int insertBatch4ThirdPartJdReconciliationScheduleFullVersionExcelRowList(
            List<AccountingUnifiedSupplierOrderJdImportFullVersionExcelRow> excelRowList,
            LoginSysUser loginSysUser);

    int insertBatch(List<AccountingUnifiedSupplierOrderJd> processList);

    int replaceBatch(List<AccountingUnifiedSupplierOrderJd> processList);

    void basisCheckUpForV2_5(AccountingUnifiedSupplierOrderJd entity);

    void saveOrUpdate4ThirdPartJdReconciliationScheduleLiteVersionExcelRow(
            AccountingUnifiedSupplierOrderJdImportLiteVersionExcelRow excelRow,
            LoginSysUser loginSysUser);

    void saveOrUpdate4ThirdPartJdReconciliationScheduleLiteVersionExcelRowList(
            List<AccountingUnifiedSupplierOrderJdImportLiteVersionExcelRow> excelRowList,
            LoginSysUser loginSysUser);

    int insertBatch4ThirdPartJdReconciliationScheduleLiteVersionExcelRowList(
            List<AccountingUnifiedSupplierOrderJdImportLiteVersionExcelRow> excelRowList,
            LoginSysUser loginSysUser);

    /****************************************** excel import start   end ******************************************/


}