package cn.superdesk.uniorder.service.thirdpart.jd;


import cn.superdesk.uniorder.common.enums.scheduler.jd.ScheduleTaskAccountingStatusEnum;
import cn.superdesk.uniorder.common.enums.scheduler.jd.ScheduleTaskCheckStateEnum;
import cn.superdesk.uniorder.common.enums.scheduler.jd.ScheduleTaskProcessStateEnum;
import cn.superdesk.uniorder.common.enums.scheduler.jd.ScheduleTaskRunStatusEnum;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.sys.notify.SysNotify;
import cn.superdesk.uniorder.dao.entity.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJd;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdParam;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdHeadVo;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdListItemVo;
import cn.superdesk.uniorder.service.base.BaseService;
import com.github.pagehelper.PageInfo;

import java.util.List;
import java.util.Map;


/**
 * @Description: 定时任务-时刻任务-对账单
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-10-12 11:29:24
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-10-12 11:29:24
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
public interface SysQuartzScheduleTaskStatementOfAccountJdService extends BaseService<SysQuartzScheduleTaskStatementOfAccountJd> {


    /****************************************** extends BaseService 部分 start ******************************************/

    @Override
    int insertSelective(SysQuartzScheduleTaskStatementOfAccountJd entity);

    @Override
    int updateByPrimaryKeySelective(SysQuartzScheduleTaskStatementOfAccountJd entity);

    int updateByBatchIdSelective(SysQuartzScheduleTaskStatementOfAccountJd entity);

    @Override
    @Deprecated
    void deleteObj(Long id);

    @Override
    SysQuartzScheduleTaskStatementOfAccountJd findById(Long id);

    SysQuartzScheduleTaskStatementOfAccountJd findByBatchId(String batchId);

    @Override
    @Deprecated
    PageInfo<SysQuartzScheduleTaskStatementOfAccountJd> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize);

    @Override
    @Deprecated
    List<SysQuartzScheduleTaskStatementOfAccountJd> findAll(Map<String, Object> queryMap);

    /****************************************** extends BaseService 部分   end ******************************************/


    int addSysQuartzScheduleTaskStatementOfAccountJd(SysQuartzScheduleTaskStatementOfAccountJdParam param, LoginSysUser loginSysUser);

    int updateSysQuartzScheduleTaskStatementOfAccountJd(SysQuartzScheduleTaskStatementOfAccountJdParam param, LoginSysUser loginSysUser);

    int deleteSysQuartzScheduleTaskStatementOfAccountJd(Long id, LoginSysUser loginSysUser);

    SysQuartzScheduleTaskStatementOfAccountJdListItemVo findListItemVoById(Long id, LoginSysUser loginSysUser);

    SysQuartzScheduleTaskStatementOfAccountJdListItemVo findListItemVoByBatchId(String batchId, LoginSysUser loginSysUser);

    R<List<SysQuartzScheduleTaskStatementOfAccountJd>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize);

    R<List<SysQuartzScheduleTaskStatementOfAccountJdListItemVo>> pageQueryGenericParam(
            SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria criteria,
            LoginSysUser loginSysUser);

    SysQuartzScheduleTaskStatementOfAccountJdHeadVo queryHeadGenericParam(
            SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria queryCriteria,
            LoginSysUser loginSysUser);

    List<SysQuartzScheduleTaskStatementOfAccountJdListItemVo> queryGenericParam(
            SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria criteria,
            LoginSysUser loginSysUser);

    SysQuartzScheduleTaskStatementOfAccountJdListItemVo getListItemVoByBatchId(String batchId, LoginSysUser loginSysUser);


    /**************************************** 任务牵引方法 懒得做状态机 start ****************************************/

    int towImportExcel(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            ScheduleTaskRunStatusEnum runStatusEnum,
            ScheduleTaskProcessStateEnum processStateEnum,
            LoginSysUser loginSysUser);

    int towCompareOrderAndCheckUpThenReport(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            ScheduleTaskRunStatusEnum runStatusEnum,
            ScheduleTaskAccountingStatusEnum accountingStatusEnum,
            LoginSysUser loginSysUser);

    int towCompareOrderAndCheckUpThenReportThrowException(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            ScheduleTaskRunStatusEnum runStatusEnum,
            ScheduleTaskAccountingStatusEnum accountingStatusEnum,
            ScheduleTaskCheckStateEnum checkStateEnum,
            LoginSysUser loginSysUser);

    SysQuartzScheduleTaskStatementOfAccountJdListItemVo deQueueOneImportExcel(LoginSysUser loginSysUser);

    SysQuartzScheduleTaskStatementOfAccountJdListItemVo deQueueOneCompareOrderAndCheckUpThenReport(LoginSysUser loginSysUser);


    /**************************************** 任务牵引方法 懒得做状态机   end ****************************************/

    /**************************************** 任务调度方法 start ****************************************/

    SysNotify dispatcherExcelImportLiteVersion(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            LoginSysUser loginSysUser);

    SysNotify dispatcherExcelImportFullVersion(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            LoginSysUser loginSysUser);

    SysNotify dispatcherCompareOrderAndCheckUpThenReport(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            LoginSysUser loginSysUser);

    SysNotify dispatcherCompareOrderAndCheckUpThenReportOnlyException(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            LoginSysUser loginSysUser);

    /**************************************** 任务调度方法 start ****************************************/


}