package cn.superdesk.uniorder.service.thirdpart.jd.impl;

import cn.hutool.core.util.StrUtil;
import com.alibaba.excel.metadata.CellData;
import com.alibaba.excel.metadata.Head;
import com.alibaba.excel.write.handler.AbstractCellWriteHandler;
import com.alibaba.excel.write.metadata.holder.WriteSheetHolder;
import com.alibaba.excel.write.metadata.holder.WriteTableHolder;
import lombok.extern.slf4j.Slf4j;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;

import java.util.List;

/**
 * @Description: excel 公式
 * @Author: linjinyu
 * @CreateDate: 2021/11/8 下午3:18
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021/11/8 下午3:18
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
public class AccountingUnifiedSupplierOrderJdCheckUpReportExportExcelCellWriteHandler extends AbstractCellWriteHandler {

	@Override
	public void beforeCellCreate(WriteSheetHolder writeSheetHolder, WriteTableHolder writeTableHolder, Row row,
	                             Head head, Integer columnIndex, Integer relativeRowIndex, Boolean isHead) {


	}

	@Override
	public void afterCellCreate(WriteSheetHolder writeSheetHolder, WriteTableHolder writeTableHolder, Cell cell,
	                            Head head, Integer relativeRowIndex, Boolean isHead) {

		// 这里可以对cell进行任何操作
//			log.info("第 {} 行,第 {} 列 数据...", cell.getRowIndex(), cell.getColumnIndex());
	}

	@Override
	public void afterCellDataConverted(WriteSheetHolder writeSheetHolder, WriteTableHolder writeTableHolder, CellData cellData, Cell cell, Head head, Integer integer, Boolean aBoolean) {

	}

	@Override
	public void afterCellDispose(WriteSheetHolder writeSheetHolder, WriteTableHolder writeTableHolder,
	                             List<CellData> cellDataList, Cell cell, Head head, Integer relativeRowIndex, Boolean isHead) {

		// 这里可以对cell进行任何操作
		log.info("afterCellDispose 第 {} 行,第 {} 列 数据...", cell.getRowIndex(), cell.getColumnIndex());

		// 结算金额(订单)N
		if (cell.getRowIndex() >= 1 && 13 == cell.getColumnIndex()) {

			// 结算金额(订单)N = 订单金额(订单)H + 退款金额(订单)I * 商户承担运费(订单)K
			// 以第1行数据为例:N1 = H1 + I1 + K1
			int actualCellRowNum01 = cell.getRowIndex();

			String formulaStr01 = StrUtil.format("=H{}+I{}+K{}", actualCellRowNum01, actualCellRowNum01, actualCellRowNum01);
			cell.setCellFormula(formulaStr01);

			log.info("第{}行,第{}列 公式 {} 完成", cell.getRowIndex(), cell.getColumnIndex(), formulaStr01);
		}

		// 结算金额(商品)O
		if (cell.getRowIndex() >= 1 && 14 == cell.getColumnIndex()) {

			// 结算金额(订单)N = 订单金额(订单)H + 退款金额(订单)I * 商户承担运费(订单)K
			// 以第1行数据为例:O1 = L1 + M1 + K1
			int actualCellRowNum02 = cell.getRowIndex();

			String formulaStr02 = StrUtil.format("=L{}+M{}+K{}", actualCellRowNum02, actualCellRowNum02, actualCellRowNum02);
			cell.setCellFormula(formulaStr02);

			log.info("第{}行,第{}列 公式 {} 完成", cell.getRowIndex(), cell.getColumnIndex(), formulaStr02);
		}
	}

	/****************************************** 填充公式   end ******************************************/
}
