package cn.superdesk.uniorder.service.thirdpart.jd.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.io.FileUtil;
import cn.hutool.core.util.ArrayUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.json.JSONUtil;
import cn.superdesk.uniorder.common.enums.accounting.AccountingOrderDimCreateByEnum;
import cn.superdesk.uniorder.common.enums.common.CommonAccountingLockingEnum;
import cn.superdesk.uniorder.common.enums.common.CommonAccountingStateEnum;
import cn.superdesk.uniorder.common.enums.common.CommonOrderCompletStateEnum;
import cn.superdesk.uniorder.common.enums.scheduler.jd.ScheduleTaskCheckStateEnum;
import cn.superdesk.uniorder.common.enums.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountDefineErrorEnum;
import cn.superdesk.uniorder.common.lamda.AnLamdaUtils;
import cn.superdesk.uniorder.common.numerical.AnStringUtils;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrder;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrderGoods;
import cn.superdesk.uniorder.dao.entity.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReport;
import cn.superdesk.uniorder.dto._constant.ResourceConstant;
import cn.superdesk.uniorder.dto._variable.ThirdpartJdAccountingVariable;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.AccountingUnifiedSupplierOrderJdListItemVo;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdListItemVo;
import cn.superdesk.uniorder.service.order.base.UnifiedOrderGoodsService;
import cn.superdesk.uniorder.service.order.base.UnifiedOrderService;
import cn.superdesk.uniorder.service.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportService;
import cn.superdesk.uniorder.service.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsService;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.extern.slf4j.Slf4j;

import java.io.File;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Predicate;
import java.util.stream.Collectors;

/**
 * @Description: opCompareOrderAndCheckUpProcess 操作拆分而已
 * @Author: linjinyu
 * @CreateDate: 2022/6/29 4:07 下午
 * @UpdateUser: linjinyu
 * @UpdateDate: 2022/6/29 4:07 下午
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@NoArgsConstructor
@AllArgsConstructor
@Data
@Builder(toBuilder = true)
@Slf4j
public class AccountingUnifiedSupplierOrderJdCheckUpReportOpCompareOrderAndCheckUpProcessDimOrderOneService {


    /**************************************** builder set start ****************************************/

    private UnifiedOrderService      unifiedOrderService;
    private UnifiedOrderGoodsService unifiedOrderGoodsService;

    private AccountingUnifiedSupplierOrderJdCheckUpReportService       accountingUnifiedSupplierOrderJdCheckUpReportService;
    private AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsService accountingUnifiedSupplierOrderJdCheckUpReportXGoodsService;

    private ResourceConstant              resourceConstant;
    private ThirdpartJdAccountingVariable thirdpartJdAccountingVariable;

    /**************************************** builder set   end ****************************************/

    /**************************************** biz-传导进来 start ****************************************/

    private SysQuartzScheduleTaskStatementOfAccountJdListItemVo taskMainIntro;
    private AccountingUnifiedSupplierOrderJdListItemVo          taskDataIntro;

    /**************************************** biz-传导进来   end ****************************************/


    private String batchId;
    private Long   accountingUnifiedSupplierOrderJdId;


    /****************************************  start ****************************************/

    private AccountingUnifiedSupplierOrderJdCheckUpReport entityCheckUpReport;

    private UnifiedOrder orderFromDb; /* 正单 ---- 从京东单作为引子 这里必定是正单 */

    private List<String> refundOrderSns; /* 退单 ---- 订单号 */
    private List<String> orderSnAsshole; /* 整单 ---- 订单号 */
    private List<String> orderSnAssholeCompletStateEq1Filter; /* 整单(完成状态-已完成) ---- 订单号 */


    /**************************************** 订单 start ****************************************/

    private List<UnifiedOrder> refundOrderListFromDb;  /* 退单 ---- 三种情况 0 1 N */
    private List<UnifiedOrder> orderAssholeListFromDb; /* 整体 ---- (作为整体)实体*/

    private List<UnifiedOrder> predicatesUnifiedOrderByFieldCompletStateEq1Filter; // 订单完成状态 - 已完成
    private List<UnifiedOrder> predicatesUnifiedOrderByFieldCompletStateEq2Filter; // 订单完成状态 - 未完成
    private List<UnifiedOrder> predicatesUnifiedOrderByFieldCompletStateEq3Filter; // 订单完成状态 - 已作废

    /**************************************** 订单   end ****************************************/


    /**************************************** 订单商品 start ****************************************/

    private List<UnifiedOrderGoods> orderGoodsAssholeListFromDB;
    private List<UnifiedOrderGoods> orderGoodsAssholeCompletStateEq1FilterListFromDB;

    private List<UnifiedOrderGoods> predicatesUnifiedOrderGoodsByAccountingStateSupplierNotEqMinus1Filter;                  // 供应商对账状态-对账的 - 排除单向结算(只留下供应商结算的)
    private List<UnifiedOrderGoods> predicatesUnifiedOrderGoodsByAccountingStateSupplierEqMinus1Filter;                     // 供应商对账状态-不对账
    private List<UnifiedOrderGoods> predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2Filter;                          // 供应商对账状态-未对账
    private List<UnifiedOrderGoods> predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2GoodsLockingSupplierEq0Filter;   // 供应商对账状态-未对账-非售后锁定
    private List<UnifiedOrderGoods> predicatesUnifiedOrderGoodsByAccountingStateSupplierEq1Filter;                          // 供应商对账状态-已对账
    private List<UnifiedOrderGoods> predicatesUnifiedOrderGoodsByAccountingStateSupplierEq4Filter;                          // 供应商对账状态-已锁定

    /**************************************** 订单商品   end ****************************************/

    private DateTime     now;
    private StringBuffer processReport;
    private Integer      processResult;
    private Integer      defineError;

    private Boolean isLimitSale = Boolean.FALSE;

    /**
     * 初始化-传导
     */
    public AccountingUnifiedSupplierOrderJdCheckUpReportOpCompareOrderAndCheckUpProcessDimOrderOneService initConduct() {

        isLimitSale = thirdpartJdAccountingVariable.getIsLimitSale();

        batchId = taskDataIntro.getBatchId();
        accountingUnifiedSupplierOrderJdId = taskDataIntro.getId();

        entityCheckUpReport = accountingUnifiedSupplierOrderJdCheckUpReportService.findByBatchIdAndJdOrderSnAndAccountingUnifiedSupplierOrderJdId(
                taskDataIntro.getBatchId(),
                taskDataIntro.getJdOrderSn(),
                taskDataIntro.getId()
        );

        if (ObjectUtil.isNull(entityCheckUpReport)) {

            entityCheckUpReport = new AccountingUnifiedSupplierOrderJdCheckUpReport();

            entityCheckUpReport.setBatchId(taskDataIntro.getBatchId());
            entityCheckUpReport.setJdOrderSn(taskDataIntro.getJdOrderSn());
            entityCheckUpReport.setAccountingUnifiedSupplierOrderJdId(taskDataIntro.getId());
        }


        /****************************************** 京东对账单 - 订单信息 start ******************************************/

        entityCheckUpReport.setJdAccountingOrderSn(taskDataIntro.getJdAccountingOrderSn());

        entityCheckUpReport.setJdOriginalOrderSn(taskDataIntro.getJdOriginalOrderSn());
        entityCheckUpReport.setJdOrderAmount(taskDataIntro.getJdOrderAmount());

        /**************************************** |---- LiteVersion 有可能为空 start ****************************************/

        entityCheckUpReport.setJdRepaymentAmount(ObjectUtil.isNull(taskDataIntro.getJdRepaymentAmount()) ? BigDecimal.ZERO : taskDataIntro.getJdRepaymentAmount());
        entityCheckUpReport.setJdRefundAmount(ObjectUtil.isNull(taskDataIntro.getJdRepaymentAmount()) ? BigDecimal.ZERO : taskDataIntro.getJdRefundAmount());
        entityCheckUpReport.setJdOutStandingAmount(ObjectUtil.isNull(taskDataIntro.getJdRepaymentAmount()) ? BigDecimal.ZERO : taskDataIntro.getJdOutStandingAmount());

        /**************************************** |---- LiteVersion 有可能为空 start ****************************************/

        entityCheckUpReport.setJdOrderState(taskDataIntro.getJdOrderState());
        entityCheckUpReport.setJdOrderStateName(taskDataIntro.getJdOrderStateName());
        entityCheckUpReport.setWereAccountedState(taskDataIntro.getWereAccountedState());
        entityCheckUpReport.setWereAccountedStateName(taskDataIntro.getWereAccountedStateName());
        entityCheckUpReport.setAfterSaleState(taskDataIntro.getAfterSaleState());
        entityCheckUpReport.setAfterSaleStateName(taskDataIntro.getAfterSaleStateName());

        /****************************************** 京东对账单 - 订单信息   end ******************************************/

        return this;
    }

    public AccountingUnifiedSupplierOrderJdCheckUpReportOpCompareOrderAndCheckUpProcessDimOrderOneService initIntroVar() {

        this.now = DateUtil.date();
        this.processReport = new StringBuffer();
        this.processResult = ScheduleTaskCheckStateEnum.待对账.getKey();
        this.defineError = SysQuartzScheduleTaskStatementOfAccountDefineErrorEnum.初始.getKey();

        //
        if (isLimitSale.compareTo(Boolean.TRUE) == 0) {

            this.orderFromDb = unifiedOrderService.findByJdOrderSnAndSaleId(
                    taskDataIntro.getJdOrderSn(),
                    taskMainIntro.getOutMerchantId()
            );
        } else {

            this.orderFromDb = unifiedOrderService.findByJdOrderSn(
                    taskDataIntro.getJdOrderSn()
            );
        }

        refundOrderSns = new ArrayList<>();                         /* 退单 ---- 订单号 */
        orderSnAsshole = new ArrayList<>();                         /* 整单 ---- 订单号 */
        orderSnAssholeCompletStateEq1Filter = new ArrayList<>();    /* 整单(完成状态-已完成) ---- 订单号 */

        refundOrderListFromDb = new ArrayList<>();  /* 退单 ---- 三种情况 0 1 N */
        orderAssholeListFromDb = new ArrayList<>(); /* 整体 ---- (作为整体)实体*/

        return this;
    }

    /**
     * 翻滚吧
     *
     * @return
     */
    public AccountingUnifiedSupplierOrderJdCheckUpReportOpCompareOrderAndCheckUpProcessDimOrderOneService run() {
        return this.verdictIntro();
    }

    public AccountingUnifiedSupplierOrderJdCheckUpReportOpCompareOrderAndCheckUpProcessDimOrderOneService verdictIntro() {

        // 情况1:  订单没找到 -> finalRecord100();
        if (ObjectUtil.isNull(orderFromDb)) {

            processReport.append("情况1:  订单都没找到;");

            entityCheckUpReport.setOrderSn(null); // ---- 差异

            /**************************************** 初始化一些字段 start ****************************************/

            entityCheckUpReport.setOrderAmount(BigDecimal.ZERO);
            entityCheckUpReport.setOrderCostAmount(BigDecimal.ZERO);

            entityCheckUpReport.setRefundOrderAmount(BigDecimal.ZERO);
            entityCheckUpReport.setRefundOrderCostAmount(BigDecimal.ZERO);

            entityCheckUpReport.setTransportAmount(BigDecimal.ZERO);
            entityCheckUpReport.setTransportMerchantAssumeAmount(BigDecimal.ZERO);

            entityCheckUpReport.setGoodsAmount(BigDecimal.ZERO);
            entityCheckUpReport.setGoodsCostAmount(BigDecimal.ZERO);

            entityCheckUpReport.setRefundGoodsAmount(BigDecimal.ZERO);
            entityCheckUpReport.setRefundGoodsCostAmount(BigDecimal.ZERO);

            entityCheckUpReport.setOrderState(0);
            entityCheckUpReport.setCompletState(0);

            // entityCheckUpReport.setOrderAccountingStateSupplier();

            // entityCheckUpReport.setWholeOrderAmount();
            // entityCheckUpReport.setComparedWholeAmount();

            /**************************************** 初始化一些字段   end ****************************************/

            processReport.append("");
            processResult = ScheduleTaskCheckStateEnum.异常.getKey();
            defineError = SysQuartzScheduleTaskStatementOfAccountDefineErrorEnum.结算中心未找到符合条件的商品订单.getKey();

            return this.finalRecord100();

        }
        // 情况2:  订单找到后 才能开始做判定逻辑; -> initAssholeIntro() -> initAssholeOrder()
        else {

            processReport.append("情况2:  订单找到后才能开始做判定逻辑;");

            Integer[] scheduleTaskCheckStateEnumContains = {
                    ScheduleTaskCheckStateEnum.待对账.getKey(),
                    ScheduleTaskCheckStateEnum.异常.getKey()
            };

            processReport.append(StrUtil.format("\n[doggod]" +
                            "\norderAsWholeListFromDB:{}" +
                            "\norderSnAsWhole:       {}" +
                            "\nOrderSn:               {}" +
                            "\ncheckState[待对账,异常]: {}" +
                            "\n[/doggod]\n",
                    JSONUtil.toJsonStr(orderAssholeListFromDb),
                    JSONUtil.toJsonStr(orderSnAsshole),
                    StrUtil.isBlank(entityCheckUpReport.getOrderSn()),
                    ArrayUtil.contains(
                            scheduleTaskCheckStateEnumContains,
                            entityCheckUpReport.getProcessResult()
                    )
            ));


            // 情况2 : 自身没有订单编号 - 证明是以下两种情况 这个判定主要是第二次会改变结果的问题
            // |---- 1. 可能是第一次
            // |---- 2. 可能是上一次存在错误
//            if (StrUtil.isBlank(entityCheckUpReport.getOrderSn())
//                    || ArrayUtil.contains(
//                    scheduleTaskCheckStateEnumContains,
//                    entityCheckUpReport.getProcessResult())) {}

            /**************************************** 初始化一些字段 start ****************************************/

            // entityCheckUpReport.setOrderSn(null); // ---- 差异 后边才处理

            entityCheckUpReport.setOrderAmount(orderFromDb.getAmount());
            entityCheckUpReport.setOrderCostAmount(orderFromDb.getCostAmount());

            // 退单相关字段先初始化 后边再验证
            entityCheckUpReport.setRefundOrderAmount(BigDecimal.ZERO);
            entityCheckUpReport.setRefundOrderCostAmount(BigDecimal.ZERO);

            entityCheckUpReport.setTransportAmount(orderFromDb.getTransportAmount());
            entityCheckUpReport.setTransportMerchantAssumeAmount(orderFromDb.getTransportMerchantAssumeAmount());

            entityCheckUpReport.setGoodsAmount(orderFromDb.getGoodsAmount());
            entityCheckUpReport.setGoodsCostAmount(orderFromDb.getGoodsCostAmount());

            entityCheckUpReport.setRefundGoodsAmount(BigDecimal.ZERO);
            entityCheckUpReport.setRefundGoodsCostAmount(BigDecimal.ZERO);

            entityCheckUpReport.setOrderState(orderFromDb.getOrderState());
            entityCheckUpReport.setCompletState(orderFromDb.getCompletState());

            entityCheckUpReport.setOrderAccountingStateSupplier(orderFromDb.getAccountingStateSupplier());

            entityCheckUpReport.setWholeOrderAmount(
                    entityCheckUpReport.getGoodsCostAmount()
                            .add(entityCheckUpReport.getTransportMerchantAssumeAmount()
                            )
            );
            entityCheckUpReport.setComparedWholeAmount(
                    entityCheckUpReport.getJdOrderAmount()
                            .subtract(entityCheckUpReport.getGoodsCostAmount()
                                    .add(entityCheckUpReport.getTransportMerchantAssumeAmount())
                            )
            );

            /**************************************** 初始化一些字段   end ****************************************/

            return this.initAssholeIntro();

        }
    }

    /**
     * 此归整 基于 引子不为空
     *
     * @return
     */
    public AccountingUnifiedSupplierOrderJdCheckUpReportOpCompareOrderAndCheckUpProcessDimOrderOneService initAssholeIntro() {

        processReport.append(" -> initAssholeIntro();");

        /**************************************** 归整 start ****************************************/

        if (isLimitSale.compareTo(Boolean.TRUE) == 0) {

            refundOrderListFromDb = unifiedOrderService.findByRefundOrderSnAndSaleId(
                    orderFromDb.getOrderSn(),
                    taskMainIntro.getOutMerchantId()
            );
        } else {

            refundOrderListFromDb = unifiedOrderService.findByRefundOrderSn(
                    orderFromDb.getOrderSn()
            );
        }


        orderAssholeListFromDb.add(orderFromDb);
        orderSnAsshole.add(orderFromDb.getOrderSn());

        if (CollUtil.isNotEmpty(refundOrderListFromDb)) {

            orderAssholeListFromDb.addAll(refundOrderListFromDb);

            refundOrderSns = refundOrderListFromDb
                    .stream()
                    .map(UnifiedOrder::getOrderSn)
                    .collect(Collectors.toList());

            orderSnAsshole.addAll(refundOrderSns);

        }

        /**************************************** 归整   end ****************************************/

        return this.initAssholeOrder();
    }

    public AccountingUnifiedSupplierOrderJdCheckUpReportOpCompareOrderAndCheckUpProcessDimOrderOneService initAssholeOrder() {

        processReport.append(" -> initAssholeOrder();");

        /**************************************** 订单-完成状态-已完成 start ****************************************/

        List<Predicate<UnifiedOrder>> predicatesByFieldCompletStateEq1 = new ArrayList<>();
        predicatesByFieldCompletStateEq1.add(
                r -> r.getCompletState() != null
                        && r.getCompletState().compareTo(CommonOrderCompletStateEnum.已完成.getKey()) == 0
        );
        predicatesUnifiedOrderByFieldCompletStateEq1Filter = AnLamdaUtils.filters(orderAssholeListFromDb, predicatesByFieldCompletStateEq1);

        /**************************************** 订单-完成状态-已完成   end ****************************************/


        /**************************************** 订单-完成状态-未完成 start ****************************************/

        List<Predicate<UnifiedOrder>> predicatesByFieldCompletStateEq2 = new ArrayList<>();
        predicatesByFieldCompletStateEq2.add(
                r -> r.getCompletState() != null
                        && r.getCompletState().compareTo(CommonOrderCompletStateEnum.未完成.getKey()) == 0
        );
        predicatesUnifiedOrderByFieldCompletStateEq2Filter = AnLamdaUtils.filters(orderAssholeListFromDb, predicatesByFieldCompletStateEq2);

        /**************************************** 订单-完成状态-未完成   end ****************************************/


        /**************************************** 订单-完成状态-已作废 start ****************************************/

        List<Predicate<UnifiedOrder>> predicatesByFieldCompletStateEq3 = new ArrayList<>();
        predicatesByFieldCompletStateEq3.add(
                r -> r.getCompletState() != null
                        && r.getCompletState().compareTo(CommonOrderCompletStateEnum.已作废.getKey()) == 0
        );
        predicatesUnifiedOrderByFieldCompletStateEq3Filter = AnLamdaUtils.filters(orderAssholeListFromDb, predicatesByFieldCompletStateEq3);

        /**************************************** 订单-完成状态-已作废   end ****************************************/

        return verdictOrder();
    }

    public AccountingUnifiedSupplierOrderJdCheckUpReportOpCompareOrderAndCheckUpProcessDimOrderOneService verdictOrder() {

        processReport.append(" -> verdictOrder();");
        processReport.append(StrUtil.format("[doggod]verdictOrder 总体订单: {}[/doggod];",
                AnStringUtils.stringListConvertToString(
                        orderSnAsshole
                )
        ));

        // 作为一个整体后 订单 存在 [完成状态][未完成] 时 可以直接判定? [完成状态][已完成] 不满的情况
        // 作为一个整体后 订单 不存在 [完成状态][已完成] 时 可以直接判定?


        orderSnAssholeCompletStateEq1Filter = predicatesUnifiedOrderByFieldCompletStateEq1Filter
                .stream()
                .map(UnifiedOrder::getOrderSn)
                .collect(Collectors.toList());

        // [完成状态][已完成] 没有
        if (CollUtil.isEmpty(predicatesUnifiedOrderByFieldCompletStateEq1Filter)) {

            processReport.append(StrUtil.format("[doggod]verdictOrder 判定条件: Asshole订单List[Filter=[完成状态]=[已完成]] 为空;"));
            processReport.append(StrUtil.format("信息记录:订单({}:{})存在[完成状态]=[已完成];[/doggod]\n",
                    AnStringUtils.stringListConvertToString(
                            orderSnAssholeCompletStateEq1Filter
                    ),
                    predicatesUnifiedOrderByFieldCompletStateEq1Filter.size()
            ));
            processResult = ScheduleTaskCheckStateEnum.异常.getKey();
            defineError = SysQuartzScheduleTaskStatementOfAccountDefineErrorEnum.结算中心未找到符合条件的商品订单.getKey();

            return finalRecord101();
        }
        // [完成状态][已完成] 不满
        else if ((orderAssholeListFromDb.size() - predicatesUnifiedOrderByFieldCompletStateEq3Filter.size()) > predicatesUnifiedOrderByFieldCompletStateEq1Filter.size()) {

            processReport.append(StrUtil.format("[doggod]verdictOrder 判定条件:Asshole订单List[Filter=[完成状态]=[已完成]] 不满;"));
            processReport.append(StrUtil.format("信息记录:订单({}:{})存在[完成状态]=[已完成];[/doggod]\n",
                    AnStringUtils.stringListConvertToString(
                            orderSnAssholeCompletStateEq1Filter
                    ),
                    predicatesUnifiedOrderByFieldCompletStateEq1Filter.size()
            ));
            processResult = ScheduleTaskCheckStateEnum.异常.getKey();
            defineError = SysQuartzScheduleTaskStatementOfAccountDefineErrorEnum.结算中心未找到符合条件的商品订单.getKey();

            return finalRecord101();
        }
        // [完成状态][已完成] 满
        else if ((orderAssholeListFromDb.size() - predicatesUnifiedOrderByFieldCompletStateEq3Filter.size()) == predicatesUnifiedOrderByFieldCompletStateEq1Filter.size()) {
            return initAssholeOrderGoods();
        }

        return this;
    }

    public AccountingUnifiedSupplierOrderJdCheckUpReportOpCompareOrderAndCheckUpProcessDimOrderOneService initAssholeOrderGoods() {

        /****************************************** 结算中心 订单 商品层面 start ******************************************/

        // ---- 正单退单商品               ---- 包含
        orderGoodsAssholeListFromDB = unifiedOrderGoodsService.findByOrderSns(orderSnAsshole);
        // ---- 正单退单(完成状态=已完成)商品 ---- 包含
        orderGoodsAssholeCompletStateEq1FilterListFromDB = unifiedOrderGoodsService.findByOrderSns(orderSnAssholeCompletStateEq1Filter);

//        log.info("[doggod]processOrderGoods****************************************" +
//                        "\nentityCheckUpReport: {}" +
//                        "\norderFromDB: {}" +
//                        "\nrefundOrderListFromDB: {}" +
//                        "\norderAsWholeListFromDB: {}" +
//                        "\norderSnAsWhole: {}" +
//                        "\norderSnAsWholeCompletStateEq1Filter: {}" +
//                        "\norderGoodsListFromDB: {}" +
//                        "\nprocessReport: {}" +
//                        "\nprocessResult: {}" +
//                        "\ndefineError: {}\n****************************************",
//                JSONUtil.toJsonStr(entityCheckUpReport),
//                JSONUtil.toJsonStr(orderFromDb),
//                JSONUtil.toJsonStr(refundOrderListFromDb),
//                JSONUtil.toJsonStr(orderAssholeListFromDb),
//                JSONUtil.toJsonStr(orderSnAsshole),
//                JSONUtil.toJsonStr(orderSnAssholeCompletStateEq1Filter),
//                JSONUtil.toJsonStr(orderGoodsAssholeListFromDB),
//                processReport.toString(),
//                ScheduleTaskCheckStateEnum.getDesc(processResult),
//                SysQuartzScheduleTaskStatementOfAccountDefineErrorEnum.getDesc(defineError)
//        );

//        String report00 = StrUtil.format("[doggod]processOrderGoods****************************************" +
//                        "\nentityCheckUpReport: {}" +
//                        "\norderFromDB: {}" +
//                        "\nrefundOrderListFromDB: {}" +
//                        "\norderAsWholeListFromDB: {}" +
//                        "\norderSnAsWhole: {}" +
//                        "\norderSnAsWholeCompletStateEq1Filter: {}" +
//                        "\norderGoodsListFromDB: {}" +
//                        "\nprocessReport: {}" +
//                        "\nprocessResult: {}" +
//                        "\ndefineError: {}\n****************************************",
//                JSONUtil.toJsonStr(entityCheckUpReport),
//                JSONUtil.toJsonStr(orderFromDb),
//                JSONUtil.toJsonStr(refundOrderListFromDb),
//                JSONUtil.toJsonStr(orderAssholeListFromDb),
//                JSONUtil.toJsonStr(orderSnAsshole),
//                JSONUtil.toJsonStr(orderSnAssholeCompletStateEq1Filter),
//                JSONUtil.toJsonStr(orderGoodsAssholeListFromDB),
//                processReport.toString(),
//                ScheduleTaskCheckStateEnum.getDesc(processResult),
//                SysQuartzScheduleTaskStatementOfAccountDefineErrorEnum.getDesc(defineError));
//        tmpLog(
//                entityCheckUpReport.getBatchId() + "_00",
//                entityCheckUpReport.getJdOrderSn(),
//                AnStringUtils.stringListConvertToString(orderSnAsshole),
//                report00,
//                DateUtil.now()
//        );


        // 按 供应商对账状态 分切
        // |---- 不对账(-1, "不对账"),
        // |---- 已对账(1, "已对账"), // ----
        // |---- 未对账(2, "未对账"), // ----
        // |---- 已作废(3, "已作废"), // ---- mark by linjinyu 20200713 为了作废订单
        // |---- 已锁定(4, "已锁定"), // ---- mark by linjinyu 20220615 为了京东对账

        /**************************************** 对账的 - 排除单向结算(只留下供应商结算的) start ****************************************/

        List<Predicate<UnifiedOrderGoods>> predicatesUnifiedOrderGoodsByFieldAccountingStateSupplierNotEqMinus1 = new ArrayList<>();
        predicatesUnifiedOrderGoodsByFieldAccountingStateSupplierNotEqMinus1.add(
                r -> r.getAccountingStateSupplier() != null
                        && r.getAccountingStateSupplier().compareTo(CommonAccountingStateEnum.不对账.getKey()) != 0
        );
        predicatesUnifiedOrderGoodsByAccountingStateSupplierNotEqMinus1Filter = AnLamdaUtils.filters(
                orderGoodsAssholeCompletStateEq1FilterListFromDB,
                predicatesUnifiedOrderGoodsByFieldAccountingStateSupplierNotEqMinus1
        );

        /**************************************** 对账的 - 排除单向结算(只留下供应商结算的)   end ****************************************/

        /**************************************** 不对账 start ****************************************/

        List<Predicate<UnifiedOrderGoods>> predicatesUnifiedOrderGoodsByFieldAccountingStateSupplierEqMinus1 = new ArrayList<>();
        predicatesUnifiedOrderGoodsByFieldAccountingStateSupplierEqMinus1.add(
                r -> r.getAccountingStateSupplier() != null
                        && r.getAccountingStateSupplier().compareTo(CommonAccountingStateEnum.不对账.getKey()) == 0
        );
        predicatesUnifiedOrderGoodsByAccountingStateSupplierEqMinus1Filter = AnLamdaUtils.filters(
                orderGoodsAssholeCompletStateEq1FilterListFromDB,
                predicatesUnifiedOrderGoodsByFieldAccountingStateSupplierEqMinus1
        );

        /**************************************** 不对账   end ****************************************/

        /**************************************** 对账的-未对账 start ****************************************/

        List<Predicate<UnifiedOrderGoods>> predicatesUnifiedOrderGoodsByFieldAccountingStateSupplierEq2 = new ArrayList<>();
        predicatesUnifiedOrderGoodsByFieldAccountingStateSupplierEq2.add(
                r -> r.getAccountingStateSupplier() != null
                        && r.getAccountingStateSupplier().compareTo(CommonAccountingStateEnum.未对账.getKey()) == 0
        );
        predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2Filter = AnLamdaUtils.filters(
                predicatesUnifiedOrderGoodsByAccountingStateSupplierNotEqMinus1Filter,
                predicatesUnifiedOrderGoodsByFieldAccountingStateSupplierEq2
        );

        /**************************************** 对账的-未对账   end ****************************************/

        /**************************************** 对账的-未对账-非售后锁定 start ****************************************/

//        goods_locking_supplier=1(锁定)

        List<Predicate<UnifiedOrderGoods>> predicatesUnifiedOrderGoodsByFieldAccountingStateSupplierEq2GoodsLockingSupplierEq0 = new ArrayList<>();
        predicatesUnifiedOrderGoodsByFieldAccountingStateSupplierEq2GoodsLockingSupplierEq0.add(
                r -> r.getAccountingStateSupplier() != null
                        && r.getAccountingStateSupplier().compareTo(CommonAccountingStateEnum.未对账.getKey()) == 0
                        && r.getGoodsLockingSupplier() != null
                        && r.getGoodsLockingSupplier().compareTo(CommonAccountingLockingEnum.正常.getKey()) == 0
        );
        predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2GoodsLockingSupplierEq0Filter = AnLamdaUtils.filters(
                predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2Filter,
                predicatesUnifiedOrderGoodsByFieldAccountingStateSupplierEq2GoodsLockingSupplierEq0
        );

        /**************************************** 对账的-未对账-非售后锁定   end ****************************************/

        /**************************************** 对账的-已对账 start ****************************************/

        List<Predicate<UnifiedOrderGoods>> predicatesUnifiedOrderGoodsByFieldAccountingStateSupplierEq1 = new ArrayList<>();
        predicatesUnifiedOrderGoodsByFieldAccountingStateSupplierEq1.add(
                r -> r.getAccountingStateSupplier() != null
                        && r.getAccountingStateSupplier().compareTo(CommonAccountingStateEnum.已对账.getKey()) == 0
        );
        predicatesUnifiedOrderGoodsByAccountingStateSupplierEq1Filter = AnLamdaUtils.filters(
                predicatesUnifiedOrderGoodsByAccountingStateSupplierNotEqMinus1Filter,
                predicatesUnifiedOrderGoodsByFieldAccountingStateSupplierEq1
        );

        /**************************************** 对账的-已对账   end ****************************************/

        /**************************************** 对账的-已锁定 start ****************************************/

        List<Predicate<UnifiedOrderGoods>> predicatesUnifiedOrderGoodsByFieldAccountingStateSupplierEq4 = new ArrayList<>();
        predicatesUnifiedOrderGoodsByFieldAccountingStateSupplierEq4.add(
                r -> r.getAccountingStateSupplier() != null
                        && r.getAccountingStateSupplier().compareTo(CommonAccountingStateEnum.已锁定.getKey()) == 0
        );
        predicatesUnifiedOrderGoodsByAccountingStateSupplierEq4Filter = AnLamdaUtils.filters(
                predicatesUnifiedOrderGoodsByAccountingStateSupplierNotEqMinus1Filter,
                predicatesUnifiedOrderGoodsByFieldAccountingStateSupplierEq4
        );

        /**************************************** 对账的-已锁定   end ****************************************/

        Map<String, Integer> mapDoggod = new HashMap<>();
        mapDoggod.put("非不对账", predicatesUnifiedOrderGoodsByAccountingStateSupplierNotEqMinus1Filter.size());
        mapDoggod.put(CommonAccountingStateEnum.不对账.getDesc(), predicatesUnifiedOrderGoodsByAccountingStateSupplierEqMinus1Filter.size());
        mapDoggod.put(CommonAccountingStateEnum.未对账.getDesc(), predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2Filter.size());
        mapDoggod.put("未对账-售后锁定(正常)", predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2GoodsLockingSupplierEq0Filter.size());
        mapDoggod.put(CommonAccountingStateEnum.已对账.getDesc(), predicatesUnifiedOrderGoodsByAccountingStateSupplierEq1Filter.size());
        mapDoggod.put(CommonAccountingStateEnum.已锁定.getDesc(), predicatesUnifiedOrderGoodsByAccountingStateSupplierEq4Filter.size());

        log.info("[doggod]{}", JSONUtil.toJsonPrettyStr(mapDoggod));

//        String report01 = StrUtil.format("[doggod]{}", JSONUtil.toJsonPrettyStr(mapDoggod));
//        tmpLog(
//                entityCheckUpReport.getBatchId() + "_01",
//                entityCheckUpReport.getJdOrderSn(),
//                AnStringUtils.stringListConvertToString(orderSnAsshole),
//                report01,
//                DateUtil.now()
//        );

//        String report02 = StrUtil.format("[doggod]processOrderGoods" +
//                        "\n****************************************" +
//                        "\n非不对账: \n{}\n" +
//                        "\n不对账: \n{}\n" +
//                        "\n未对账: \n{}\n" +
//                        "\n未对账-售后锁定(正常): \n{}\n" +
//                        "\n已对账: \n{}\n" +
//                        "\n已锁定: \n{}\n" +
//                        "\n****************************************",
//                JSONUtil.toJsonStr(predicatesUnifiedOrderGoodsByAccountingStateSupplierNotEqMinus1Filter),
//                JSONUtil.toJsonStr(predicatesUnifiedOrderGoodsByAccountingStateSupplierEqMinus1Filter),
//                JSONUtil.toJsonStr(predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2Filter),
//                JSONUtil.toJsonStr(predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2GoodsLockingSupplierEq0Filter),
//                JSONUtil.toJsonStr(predicatesUnifiedOrderGoodsByAccountingStateSupplierEq1Filter),
//                JSONUtil.toJsonStr(predicatesUnifiedOrderGoodsByAccountingStateSupplierEq4Filter)
//        );
//        tmpLog(
//                entityCheckUpReport.getBatchId() + "_02",
//                entityCheckUpReport.getJdOrderSn(),
//                AnStringUtils.stringListConvertToString(orderSnAsshole),
//                report02,
//                DateUtil.now()
//        );


        entityCheckUpReport.setOrderAccountingStateSupplier(orderFromDb.getAccountingStateSupplier());
        entityCheckUpReport.setOrderGoodsItemQuantity(orderGoodsAssholeListFromDB.size());
        entityCheckUpReport.setGoodsAccountingStateSupplierEqMinus1(predicatesUnifiedOrderGoodsByAccountingStateSupplierEqMinus1Filter.size());
        entityCheckUpReport.setGoodsAccountingStateSupplierEq2(predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2Filter.size());
//        entityCheckUpReport.setGoodsAccountingStateSupplierEq2(predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2GoodsLockingSupplierEq0Filter.size());
        entityCheckUpReport.setGoodsAccountingStateSupplierEq1(predicatesUnifiedOrderGoodsByAccountingStateSupplierEq1Filter.size());
        entityCheckUpReport.setGoodsAccountingStateSupplierEq4(predicatesUnifiedOrderGoodsByAccountingStateSupplierEq4Filter.size());


        return verdictOrderGoods();

    }

    public AccountingUnifiedSupplierOrderJdCheckUpReportOpCompareOrderAndCheckUpProcessDimOrderOneService verdictOrderGoods() {
        // mark by linjinyu at 2022-06-21 10:23:08 - 如果存在此种情况，大概率是存在订单维度部分商品已对账
        // 意思是 订单下 能对账'数量 != 未对账(售后锁定(正常)(未锁定))'数量


//        predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2GoodsLockingSupplierEq0Filter
//        predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2Filter

        // 为空
        if (CollUtil.isEmpty(predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2GoodsLockingSupplierEq0Filter)) {

            processReport.append(StrUtil.format("[doggod]verdictOrderGoods 判定条件: AssholeOrderGoodsList[Filter=[供应商对账状态][未对账](售后锁定(未对账->未锁定))] 为空;"));
            processReport.append(StrUtil.format("订单商品([供应商对账状态][非不对账总数]{}:[未对账](售后锁定(未对账->未锁定))]{});[/doggod]",
                    predicatesUnifiedOrderGoodsByAccountingStateSupplierNotEqMinus1Filter.size(),
                    predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2GoodsLockingSupplierEq0Filter.size()
            ));
            processResult = ScheduleTaskCheckStateEnum.异常.getKey();
            defineError = SysQuartzScheduleTaskStatementOfAccountDefineErrorEnum.结算中心未找到符合条件的商品订单.getKey();

            entityCheckUpReport.setWholeOrderAmount(BigDecimal.ZERO);
            entityCheckUpReport.setComparedWholeAmount(
                    /* 产品要求的 这里的京东订单金额 有可能不是一个整单的金额，而是人为改的 */
                    entityCheckUpReport.getJdOrderAmount()
                            .subtract(BigDecimal.ZERO)
            );

            return finalRecord101();
        }
        // 不满 可能为部分对账
        else if (predicatesUnifiedOrderGoodsByAccountingStateSupplierNotEqMinus1Filter.size() > predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2GoodsLockingSupplierEq0Filter.size()) {

            processReport.append(StrUtil.format("[doggod]verdictOrderGoods 判定条件: AssholeOrderGoodsList[Filter=[供应商对账状态][未对账](售后锁定(未对账->未锁定))] 不满;"));
            processReport.append(StrUtil.format("订单商品\n[供应商对账状态]\n[非不对账总数]#数量:{}#\n[未对账](售后锁定(未对账->未锁定))]#数量:{}#);[/doggod]",
                    predicatesUnifiedOrderGoodsByAccountingStateSupplierNotEqMinus1Filter.size(),
                    predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2GoodsLockingSupplierEq0Filter.size()
            ));

            processResult = ScheduleTaskCheckStateEnum.异常.getKey();
            defineError = SysQuartzScheduleTaskStatementOfAccountDefineErrorEnum.第三方与结算中心的对账金额不相等.getKey();

            // 此处包含 正单的部分 未对账 商品
            BigDecimal goodsCostAmountAccountingStateSupplierEq2GoodsLockingSupplierEq0 = predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2GoodsLockingSupplierEq0Filter
                    .stream()
                    .map(item -> item.getCostPrice() == null ? BigDecimal.ZERO : item.getCostPrice().multiply(new BigDecimal(item.getQuantity())))
                    .reduce(BigDecimal.ZERO, BigDecimal::add);

            entityCheckUpReport.setWholeOrderAmount(goodsCostAmountAccountingStateSupplierEq2GoodsLockingSupplierEq0);
            entityCheckUpReport.setComparedWholeAmount(
                    /* 产品要求的 这里的京东订单金额 有可能不是一个整单的金额，而是人为改的 */
                    entityCheckUpReport.getJdOrderAmount()
                            .subtract(goodsCostAmountAccountingStateSupplierEq2GoodsLockingSupplierEq0)
            );

            // 意思是 订单下 能对账'数量 != 未对账'数量 说明存在部分对账 但如果 另外的部分未对账 金额 = 导入的 人为修改过的京东订单金额 也视为 正常
            if (entityCheckUpReport.getJdOrderAmount().compareTo(goodsCostAmountAccountingStateSupplierEq2GoodsLockingSupplierEq0) == 0) {

//                processReport.append(StrUtil.format("[doggod]判定条件:意思是 订单商品下 虽然 能对账'数量=>{} != 未对账(售后锁定(正常)(未锁定))'数量=>{},但 未对账(售后锁定(正常)(未锁定))'金额=>{} = 京东'金额=>{};",
//                        predicatesUnifiedOrderGoodsByAccountingStateSupplierNotEqMinus1Filter.size(),
//                        predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2GoodsLockingSupplierEq0Filter.size(),
//                        entityCheckUpReport.getJdOrderAmount(),
//                        goodsCostAmountAccountingStateSupplierEq2GoodsLockingSupplierEq0
//                ));
//                processReport.append(StrUtil.format("记录信息:部分对账情况 未对账({}) 京东金额({}) 中心金额({});",
//                        predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2GoodsLockingSupplierEq0Filter.size(),
//                        entityCheckUpReport.getJdOrderAmount(),
//                        goodsCostAmountAccountingStateSupplierEq2GoodsLockingSupplierEq0
//                ));
                processReport.append("#结论#[对账结果]=[正常];[差异原因]=[正常];[/doggod]");

                processResult = ScheduleTaskCheckStateEnum.正常.getKey();
                defineError = SysQuartzScheduleTaskStatementOfAccountDefineErrorEnum.正常.getKey();

                return finalRecord101();

            } else {

//                processReport.append(StrUtil.format("[doggod]判定条件:意思是 订单下 未对账'金额=>{} != 京东'金额=>{};",
//                        goodsCostAmountAccountingStateSupplierEq2GoodsLockingSupplierEq0Else,
//                        entityCheckUpReport.getJdOrderAmount()
//                ));
                processReport.append("#结论#[对账结果]=[异常];[差异原因]=[第三方与结算中心的对账金额不相等];[/doggod]");

                processResult = ScheduleTaskCheckStateEnum.异常.getKey();
                defineError = SysQuartzScheduleTaskStatementOfAccountDefineErrorEnum.第三方与结算中心的对账金额不相等.getKey();

                return finalRecord101();
            }

        }
        //
        else if (predicatesUnifiedOrderGoodsByAccountingStateSupplierNotEqMinus1Filter.size() == predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2GoodsLockingSupplierEq0Filter.size()) {


            processReport.append(StrUtil.format("[doggod]verdictOrderGoods 判定条件: AssholeOrderGoodsList[Filter=[供应商对账状态][未对账](售后锁定(未对账->未锁定))] 相等;"));
            processReport.append(StrUtil.format("订单商品\n[供应商对账状态]\n[非不对账总数]#数量:{}#\n[未对账](售后锁定(未对账->未锁定))]#数量:{}#);[/doggod]",
                    predicatesUnifiedOrderGoodsByAccountingStateSupplierNotEqMinus1Filter.size(),
                    predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2GoodsLockingSupplierEq0Filter.size()
            ));

            /**
             * 这个条数相等的情况下还要分金额相等与金额不等
             */

            // 此处包含 正负单的所有 未对账 商品
            BigDecimal goodsCostAmountAccountingStateSupplierEq2GoodsLockingSupplierEq0Else = predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2GoodsLockingSupplierEq0Filter
                    .stream()
                    .map(item -> item.getCostPrice() == null ? BigDecimal.ZERO : item.getCostPrice().multiply(new BigDecimal(item.getQuantity())))
                    .reduce(BigDecimal.ZERO, BigDecimal::add);

            entityCheckUpReport.setWholeOrderAmount(goodsCostAmountAccountingStateSupplierEq2GoodsLockingSupplierEq0Else);
            entityCheckUpReport.setComparedWholeAmount(
                    /* 产品要求的 这里的京东订单金额 有可能不是一个整单的金额，而是人为改的 */
                    entityCheckUpReport.getJdOrderAmount()
                            .subtract(goodsCostAmountAccountingStateSupplierEq2GoodsLockingSupplierEq0Else)
            );

            // 意思是 订单下 未对账'金额 == 京东'金额
            if (entityCheckUpReport.getJdOrderAmount().compareTo(goodsCostAmountAccountingStateSupplierEq2GoodsLockingSupplierEq0Else) == 0) {
//
//                processReport.append(StrUtil.format("[doggod]判定条件:意思是 订单商品下 未对账'金额=>{} == 京东'金额=>{};",
//                        goodsCostAmountAccountingStateSupplierEq2GoodsLockingSupplierEq0Else,
//                        entityCheckUpReport.getJdOrderAmount()
//                ));
                processReport.append("#结论#[对账结果]=[正常];[差异原因]=[正常];[/doggod]");

                processResult = ScheduleTaskCheckStateEnum.正常.getKey();
                defineError = SysQuartzScheduleTaskStatementOfAccountDefineErrorEnum.正常.getKey();

                return finalRecord101();

            } else {

//                processReport.append(StrUtil.format("[doggod]判定条件:意思是 订单下 未对账'金额=>{} != 京东'金额=>{};",
//                        goodsCostAmountAccountingStateSupplierEq2GoodsLockingSupplierEq0Else,
//                        entityCheckUpReport.getJdOrderAmount()
//                ));
                processReport.append("#结论#[对账结果]=[异常];[差异原因]=[第三方与结算中心的对账金额不相等];[/doggod]");

                processResult = ScheduleTaskCheckStateEnum.异常.getKey();
                defineError = SysQuartzScheduleTaskStatementOfAccountDefineErrorEnum.第三方与结算中心的对账金额不相等.getKey();

                return finalRecord101();
            }
        }

        return this;
    }

//    private void goddogLog(){
//
//
//        Map<String,String>
//
//
//        processReport.append(StrUtil.format("记录信息:订单商品下({}:{}) 对账状态 = 不对账({}) 未对账({}) 未对账(售后锁定(正常)(未锁定))({}) 已对账({}) 已锁定({}) 大概率是存在订单维度部分商品已对账;",
//                orderFromDb.getOrderSn(),
//                orderGoodsAssholeListFromDB.size(),
//                predicatesUnifiedOrderGoodsByAccountingStateSupplierEqMinus1Filter.size(),
//                predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2Filter.size(),
//                predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2GoodsLockingSupplierEq0Filter.size(),
//                predicatesUnifiedOrderGoodsByAccountingStateSupplierEq1Filter.size(),
//                predicatesUnifiedOrderGoodsByAccountingStateSupplierEq4Filter.size()
//        ));
//
//    }


    /**
     * 100-结算中心未找到符合条件的商品订单
     */
    public AccountingUnifiedSupplierOrderJdCheckUpReportOpCompareOrderAndCheckUpProcessDimOrderOneService finalRecord100() {

        processReport.append(" -> finalRecord100();");

        entityCheckUpReport.setProcessReport(processReport.toString());
        entityCheckUpReport.setProcessResult(processResult);
        entityCheckUpReport.setDefineError(defineError);

        entityCheckUpReport.setComparedWholeAmount(
                entityCheckUpReport.getJdOrderAmount()
                        .subtract(BigDecimal.ZERO)
        );

        accountingUnifiedSupplierOrderJdCheckUpReportService.saveOrUpdateByPrimaryKeySelective(entityCheckUpReport, now);

        return this;
    }

    /**
     * 101-第三方与结算中心的对账金额不相等
     */
    public AccountingUnifiedSupplierOrderJdCheckUpReportOpCompareOrderAndCheckUpProcessDimOrderOneService finalRecord101() {

        processReport.append(" -> finalRecord101();");

        if (ScheduleTaskCheckStateEnum.正常.getKey().compareTo(processResult) == 0) {

            entityCheckUpReport.setOrderSn(orderFromDb.getOrderSn());

            entityCheckUpReport.setProcessReport(processReport.toString());
            entityCheckUpReport.setProcessResult(processResult);
            entityCheckUpReport.setDefineError(defineError);

            accountingUnifiedSupplierOrderJdCheckUpReportService.saveOrUpdateByPrimaryKeySelective(entityCheckUpReport, now);

            accountingUnifiedSupplierOrderJdCheckUpReportXGoodsService.insertXBySingleOrder(
                    taskDataIntro.getBatchId(),
                    taskDataIntro.getId(),
                    orderFromDb,
                    orderAssholeListFromDb,
                    predicatesUnifiedOrderByFieldCompletStateEq1Filter,
                    predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2GoodsLockingSupplierEq0Filter,
                    AccountingOrderDimCreateByEnum.商品,
                    ScheduleTaskCheckStateEnum.正常,
                    now);

            accountingUnifiedSupplierOrderJdCheckUpReportXGoodsService.lockXBySingleOrder(
                    taskDataIntro.getBatchId(),
                    orderFromDb,
                    orderAssholeListFromDb,
                    predicatesUnifiedOrderByFieldCompletStateEq1Filter,
                    predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2GoodsLockingSupplierEq0Filter
            );

        } else {

            entityCheckUpReport.setOrderSn(orderFromDb.getOrderSn());

            entityCheckUpReport.setProcessReport(processReport.toString());
            entityCheckUpReport.setProcessResult(processResult);
            entityCheckUpReport.setDefineError(defineError);

            accountingUnifiedSupplierOrderJdCheckUpReportService.saveOrUpdateByPrimaryKeySelective(entityCheckUpReport, now);

            accountingUnifiedSupplierOrderJdCheckUpReportXGoodsService.insertXBySingleOrder(
                    taskDataIntro.getBatchId(),
                    taskDataIntro.getId(),
                    orderFromDb,
                    orderAssholeListFromDb,
                    predicatesUnifiedOrderByFieldCompletStateEq1Filter,
                    predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2GoodsLockingSupplierEq0Filter,
                    AccountingOrderDimCreateByEnum.商品,
                    ScheduleTaskCheckStateEnum.异常,
                    now
            );

            accountingUnifiedSupplierOrderJdCheckUpReportXGoodsService.lockXBySingleOrder(
                    taskDataIntro.getBatchId(),
                    orderFromDb,
                    orderAssholeListFromDb,
                    predicatesUnifiedOrderByFieldCompletStateEq1Filter,
                    predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2GoodsLockingSupplierEq0Filter
            );
        }

        return this;

    }

    public void end() {

//        recordJson(
//                entityCheckUpReport.getBatchId() + "_debug",
//                entityCheckUpReport.getJdOrderSn() + "_订单引子_orderFromDb",
//                AnStringUtils.stringListConvertToString(orderSnAsshole),
//                JSONUtil.toJsonPrettyStr(orderFromDb),
//                DateUtil.now()
//        );

        // 订单整体
        recordJson(
                entityCheckUpReport.getBatchId() + "_debug",
                entityCheckUpReport.getJdOrderSn() + "_orderAssholeListFromDb",
                JSONUtil.toJsonPrettyStr(orderAssholeListFromDb)
        );
//        recordJson(
//                entityCheckUpReport.getBatchId() + "_debug",
//                entityCheckUpReport.getJdOrderSn() + "_订单整体_过滤_已完成",
//                AnStringUtils.stringListConvertToString(orderSnAsshole),
//                JSONUtil.toJsonPrettyStr(predicatesUnifiedOrderByFieldCompletStateEq1Filter),
//                DateUtil.now()
//        );


//        private List<UnifiedOrderGoods> orderGoodsAssholeListFromDB;
//        private List<UnifiedOrderGoods> orderGoodsAssholeCompletStateEq1FilterListFromDB;
//
//        private List<UnifiedOrderGoods> predicatesUnifiedOrderGoodsByAccountingStateSupplierNotEqMinus1Filter;                  // 供应商对账状态-对账的 - 排除单向结算(只留下供应商结算的)
//        private List<UnifiedOrderGoods> predicatesUnifiedOrderGoodsByAccountingStateSupplierEqMinus1Filter;                     // 供应商对账状态-不对账
//        private List<UnifiedOrderGoods> predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2Filter;                          // 供应商对账状态-未对账
//        private List<UnifiedOrderGoods> predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2GoodsLockingSupplierEq0Filter;   // 供应商对账状态-未对账-非售后锁定
//        private List<UnifiedOrderGoods> predicatesUnifiedOrderGoodsByAccountingStateSupplierEq1Filter;                          // 供应商对账状态-已对账
//        private List<UnifiedOrderGoods> predicatesUnifiedOrderGoodsByAccountingStateSupplierEq4Filter;                          // 供应商对账状态-已锁定

        // 订单商品整体
        recordJson(
                entityCheckUpReport.getBatchId() + "_debug",
                entityCheckUpReport.getJdOrderSn() + "_orderGoodsAssholeListFromDB",
                JSONUtil.toJsonPrettyStr(orderGoodsAssholeListFromDB)
        );

//        recordJson(
//                entityCheckUpReport.getBatchId() + "_debug",
//                entityCheckUpReport.getJdOrderSn() + "_订单[完成状态=已完成]商品整体",
//                AnStringUtils.stringListConvertToString(orderSnAsshole),
//                JSONUtil.toJsonPrettyStr(orderGoodsAssholeCompletStateEq1FilterListFromDB),
//                DateUtil.now()
//        );

//        recordJson(
//                entityCheckUpReport.getBatchId() + "_debug",
//                entityCheckUpReport.getJdOrderSn() + "_订单商品整体_供应商对账状态-未对账-非售后锁定",
//                AnStringUtils.stringListConvertToString(orderSnAsshole),
//                JSONUtil.toJsonPrettyStr(predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2GoodsLockingSupplierEq0Filter),
//                DateUtil.now()
//        );

    }


//    public void tmpLog(String batchId,
//                       String jdOrderSn,
//                       String orderSns,
//                       String report,
//                       String now) {
//
//        String excelExportPathRoot             = resourceConstant.getPathRoot();
//        String excelExportRelativePathTemplate = resourceConstant.getPathTemplate();
//        String excelExportRelativePathStorage  = resourceConstant.getPathStorage();
//
//        String relativePath = File.separator + "thirdpart" +
//                File.separator + "jd" +
//                File.separator + "opCompareOrderAndCheckUpProcessDimOrderOne" +
//                File.separator + batchId +
//                File.separator;
//
////		String templateRelativePath = excelExportPathRoot + excelExportRelativePathTemplate + relativePath;
////		String templateFullPath;
//
//        String targetFullPath = excelExportPathRoot + excelExportRelativePathStorage;
//
//        // 请求记录
//        String targetResponseFileName          = StrUtil.format("{}_{}_{}.md", jdOrderSn, orderSns, now);
//        String targetResponseWriteFileFullPath = targetFullPath + relativePath + targetResponseFileName;
//        FileUtil.touch(targetResponseWriteFileFullPath);
//        FileUtil.writeUtf8String(report, targetResponseWriteFileFullPath);// CharsetUtil.CHARSET_UTF_8
//    }


    public void recordJson(String batchId,
                           String jdOrderSn,
                           String report) {

        String excelExportPathRoot             = resourceConstant.getPathRoot();
        String excelExportRelativePathTemplate = resourceConstant.getPathTemplate();
        String excelExportRelativePathStorage  = resourceConstant.getPathStorage();

        String relativePath = File.separator + "thirdpart" +
                File.separator + "jd" +
                File.separator + "opCompareOrderAndCheckUpProcessDimOrderOne" +
                File.separator + batchId +
                File.separator;

//		String templateRelativePath = excelExportPathRoot + excelExportRelativePathTemplate + relativePath;
//		String templateFullPath;

        String targetFullPath = excelExportPathRoot + excelExportRelativePathStorage;

        // 请求记录
        String targetResponseFileName          = StrUtil.format("{}.json", jdOrderSn);
        String targetResponseWriteFileFullPath = targetFullPath + relativePath + targetResponseFileName;
        FileUtil.touch(targetResponseWriteFileFullPath);
        FileUtil.writeUtf8String(report, targetResponseWriteFileFullPath);// CharsetUtil.CHARSET_UTF_8
    }
}
