package cn.superdesk.uniorder.service.thirdpart.jd.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.io.FileUtil;
import cn.hutool.core.io.IORuntimeException;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import cn.superdesk.uniorder.common.enums.scheduler.jd.ScheduleTaskCheckStateEnum;
import cn.superdesk.uniorder.common.enums.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountDefineErrorEnum;
import cn.superdesk.uniorder.common.enums.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountRunStateEnum;
import cn.superdesk.uniorder.common.json.AnJsonUtils;
import cn.superdesk.uniorder.common.lamda.AnLamdaUtils;
import cn.superdesk.uniorder.common.numerical.AnBeanUtils;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.rest.response.ResponseResultOuterUtils;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.sys.notify.SysNotify;
import cn.superdesk.uniorder.dao.entity.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReport;
import cn.superdesk.uniorder.dao.entity.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportExample;
import cn.superdesk.uniorder.dao.mapper.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportMapper;
import cn.superdesk.uniorder.dao.mapper.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportMapperEx;
import cn.superdesk.uniorder.dto._constant.ResourceConstant;
import cn.superdesk.uniorder.dto._variable.ThirdpartJdAccountingVariable;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.*;
import cn.superdesk.uniorder.dto.vo.order.UnifiedOrderDebugVo;
import cn.superdesk.uniorder.dto.vo.order.UnifiedOrderGoodsDebugVo;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.*;
import cn.superdesk.uniorder.notify.NotifyUtils;
import cn.superdesk.uniorder.service.order.base.UnifiedOrderGoodsService;
import cn.superdesk.uniorder.service.order.base.UnifiedOrderService;
import cn.superdesk.uniorder.service.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportService;
import cn.superdesk.uniorder.service.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsService;
import cn.superdesk.uniorder.service.thirdpart.jd.AccountingUnifiedSupplierOrderJdService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @Description: 京东对账单中的订单 算是临时 sheet eg 深圳市侨城汇网络科技有限公司-2021年8月1日集采账单.xlsx
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-10-14 17:04:08
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-10-14 17:04:08
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@RequiredArgsConstructor
@Slf4j
@Service
public class AccountingUnifiedSupplierOrderJdCheckUpReportServiceImpl implements AccountingUnifiedSupplierOrderJdCheckUpReportService {

    private final AccountingUnifiedSupplierOrderJdCheckUpReportMapper   accountingUnifiedSupplierOrderJdCheckUpReportMapper;
    private final AccountingUnifiedSupplierOrderJdCheckUpReportMapperEx accountingUnifiedSupplierOrderJdCheckUpReportMapperEx;

    private final AccountingUnifiedSupplierOrderJdService                    accountingUnifiedSupplierOrderJdService;
    private final AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsService accountingUnifiedSupplierOrderJdCheckUpReportXGoodsService;

    /****************************************** 正单/退单 start ******************************************/

//    private UnifiedOrderMapper                   unifiedOrderMapper;
//    private final UnifiedOrderMapperEx                 unifiedOrderMapperEx;
//    private UnifiedOrderMapperExSupplierDimOrder unifiedOrderMapperExSupplierDimOrder;
//    private UnifiedOrderMapperExSupplierDimGoods unifiedOrderMapperExSupplierDimGoods;
    private final UnifiedOrderService      unifiedOrderService;
    private final UnifiedOrderGoodsService unifiedOrderGoodsService;

    /****************************************** 正单/退单   end ******************************************/


    /****************************************** 退单 start ******************************************/

//    @Autowired
//    private UnifiedOrderReturnMapper   unifiedOrderReturnMapper;
//    @Autowired
//    private UnifiedOrderReturnMapperEx unifiedOrderReturnMapperEx;
//    @Autowired
//    private UnifiedOrderReturnService  unifiedOrderReturnService;

    /****************************************** 退单   end ******************************************/

    private final ResourceConstant              resourceConstant;
    private final ThirdpartJdAccountingVariable thirdpartJdAccountingVariable;


    /****************************************** extends BaseService 部分 start ******************************************/

    @Override
    public int insertSelective(AccountingUnifiedSupplierOrderJdCheckUpReport entity) {
        return accountingUnifiedSupplierOrderJdCheckUpReportMapper.insertSelective(entity);
    }

    @Override
    public int updateByPrimaryKeySelective(AccountingUnifiedSupplierOrderJdCheckUpReport entity) {
        return accountingUnifiedSupplierOrderJdCheckUpReportMapper.updateByPrimaryKeySelective(entity);
    }

    public int saveOrUpdateByPrimaryKeySelective(AccountingUnifiedSupplierOrderJdCheckUpReport entityCheckUpReport, DateTime now) {

        if (ObjectUtil.isNull(entityCheckUpReport.getId())) {
            entityCheckUpReport.setCreateTime(now);
            return insertSelective(entityCheckUpReport);
        } else {
            entityCheckUpReport.setCreateTime(now);
            return updateByPrimaryKeySelective(entityCheckUpReport);
        }

    }

    @Override
    public void deleteObj(Long id) {
    }

    @Override
    public AccountingUnifiedSupplierOrderJdCheckUpReport findById(Long id) {
        return accountingUnifiedSupplierOrderJdCheckUpReportMapper.selectByPrimaryKey(id);
    }

    @Override
    public PageInfo<AccountingUnifiedSupplierOrderJdCheckUpReport> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize) {
        return null;
    }

    @Override
    public List<AccountingUnifiedSupplierOrderJdCheckUpReport> findAll(Map<String, Object> queryMap) {
        return null;
    }

    /****************************************** extends BaseService 部分   end ******************************************/


    @Override
    public int addAccountingUnifiedSupplierOrderJdCheckUpReport(AccountingUnifiedSupplierOrderJdCheckUpReport entity) {
        return accountingUnifiedSupplierOrderJdCheckUpReportMapper.insertSelective(entity);
    }

    @Override
    public int updateAccountingUnifiedSupplierOrderJdCheckUpReport(AccountingUnifiedSupplierOrderJdCheckUpReport entity) {

        AccountingUnifiedSupplierOrderJdCheckUpReport originEntity = accountingUnifiedSupplierOrderJdCheckUpReportMapper.selectByPrimaryKey(entity.getId());
        AnBeanUtils.copy(entity, originEntity);
        return accountingUnifiedSupplierOrderJdCheckUpReportMapper.updateByPrimaryKeySelective(originEntity);
    }

    @Override
    public int deleteAccountingUnifiedSupplierOrderJdCheckUpReport(Long id) {
        return accountingUnifiedSupplierOrderJdCheckUpReportMapper.deleteByPrimaryKey(id);
    }

    @Override
    public int deleteByBatchId(String batchId) {

        if (StrUtil.isBlank(batchId)) {
            return 0;
        }

        AccountingUnifiedSupplierOrderJdCheckUpReportExample          example  = new AccountingUnifiedSupplierOrderJdCheckUpReportExample();
        AccountingUnifiedSupplierOrderJdCheckUpReportExample.Criteria criteria = example.createCriteria();

        criteria
                .andBatchIdEqualTo(batchId);

        return accountingUnifiedSupplierOrderJdCheckUpReportMapper.deleteByExample(example);
    }

    @Override
    public AccountingUnifiedSupplierOrderJdCheckUpReport findAccountingUnifiedSupplierOrderJdCheckUpReportById(Long id) {
        AccountingUnifiedSupplierOrderJdCheckUpReport entity = accountingUnifiedSupplierOrderJdCheckUpReportMapper.selectByPrimaryKey(id);
//		AssertUtil.notNull(entity);
        return entity;
    }

    @Override
    public AccountingUnifiedSupplierOrderJdCheckUpReport findByBatchIdAndJdOrderSn(String batchId, String jdOrderSn) {

        if (StrUtil.isBlank(batchId)) {
            return null;
        }
        if (StrUtil.isBlank(jdOrderSn)) {
            return null;
        }

        AccountingUnifiedSupplierOrderJdCheckUpReportExample          example  = new AccountingUnifiedSupplierOrderJdCheckUpReportExample();
        AccountingUnifiedSupplierOrderJdCheckUpReportExample.Criteria criteria = example.createCriteria();

        criteria
                .andBatchIdEqualTo(batchId)
                .andJdOrderSnEqualTo(jdOrderSn);

        List<AccountingUnifiedSupplierOrderJdCheckUpReport> resultList = accountingUnifiedSupplierOrderJdCheckUpReportMapper.selectByExampleWithBLOBs(example);

        if (CollUtil.isNotEmpty(resultList)) {
            return resultList.get(0);
        } else {
            return null;
        }

    }

    @Override
    public AccountingUnifiedSupplierOrderJdCheckUpReport findByBatchIdAndJdOrderSnAndAccountingUnifiedSupplierOrderJdId(
            String batchId,
            String jdOrderSn,
            Long accountingUnifiedSupplierOrderJdId) {

        if (StrUtil.isBlank(batchId)) {
            return null;
        }

        if (StrUtil.isBlank(jdOrderSn)) {
            return null;
        }

        if (ObjectUtil.isNull(accountingUnifiedSupplierOrderJdId)) {
            return null;
        }

        AccountingUnifiedSupplierOrderJdCheckUpReportExample          example  = new AccountingUnifiedSupplierOrderJdCheckUpReportExample();
        AccountingUnifiedSupplierOrderJdCheckUpReportExample.Criteria criteria = example.createCriteria();

        criteria
                .andBatchIdEqualTo(batchId)
                .andJdOrderSnEqualTo(jdOrderSn)
                .andAccountingUnifiedSupplierOrderJdIdEqualTo(accountingUnifiedSupplierOrderJdId);

        List<AccountingUnifiedSupplierOrderJdCheckUpReport> resultList = accountingUnifiedSupplierOrderJdCheckUpReportMapper.selectByExampleWithBLOBs(example);

        if (CollUtil.isNotEmpty(resultList)) {
            return resultList.get(0);
        } else {
            return null;
        }
    }


    @Override
    public R<List<AccountingUnifiedSupplierOrderJdCheckUpReport>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize) {

        AccountingUnifiedSupplierOrderJdCheckUpReportExample          example  = new AccountingUnifiedSupplierOrderJdCheckUpReportExample();
        AccountingUnifiedSupplierOrderJdCheckUpReportExample.Criteria criteria = example.createCriteria();

        // TODO 喜欢用Map 还是 Bean 自己喜欢... 后期添加 转 AccountingUnifiedSupplierOrderJdCheckUpReportExample.Criteria
        // AccountingUnifiedSupplierOrderJdCheckUpReport accountingUnifiedSupplierOrderJdCheckUpReportConditions = AnBeanUtils.mapToBean(conditions,AccountingUnifiedSupplierOrderJdCheckUpReport.class);

        PageHelper.startPage(pageNun, pageSize);
        List<AccountingUnifiedSupplierOrderJdCheckUpReport>     resultList = accountingUnifiedSupplierOrderJdCheckUpReportMapper.selectByExample(example);
        PageInfo<AccountingUnifiedSupplierOrderJdCheckUpReport> page       = new PageInfo<AccountingUnifiedSupplierOrderJdCheckUpReport>(resultList);
        PageHelper.clearPage();

        return new R<List<AccountingUnifiedSupplierOrderJdCheckUpReport>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), resultList);

    }

    @Override
    public R<List<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVo>> pageQueryGenericParam(
            AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {

        PageHelper.startPage(queryCriteria.getPageNumber(), queryCriteria.getPageSize());

        List<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVo> resultList = queryGenericParam(queryCriteria, loginSysUser);

        PageInfo<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVo> page = new PageInfo<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVo>(resultList);
        PageHelper.clearPage();

        return new R<List<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVo>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), resultList);

    }


    @Override
    public AccountingUnifiedSupplierOrderJdCheckUpReportDetailStatisticsVo pageQueryHeadGenericParam(
            AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {

        return accountingUnifiedSupplierOrderJdCheckUpReportMapperEx.pageQueryHeadGenericParam(queryCriteria);
    }

    @Override
    public List<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVo> queryGenericParam(
            AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {

        if (ObjectUtil.isEmpty(queryCriteria.getBatchId())) {
            return null;
        }

        List<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVo> resultList = accountingUnifiedSupplierOrderJdCheckUpReportMapperEx.queryGenericParam(queryCriteria);

        additionalInfoQueryGenericParam(resultList);

        return resultList;
    }


    @Override
    public R<List<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVoWoof>> pageQueryGenericWoof(
            AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {

        PageHelper.startPage(queryCriteria.getPageNumber(), queryCriteria.getPageSize());

        List<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVoWoof> resultList = queryGenericWoof(queryCriteria, loginSysUser);

        PageInfo<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVoWoof> page = new PageInfo<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVoWoof>(resultList);
        PageHelper.clearPage();

        return new R<List<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVoWoof>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), resultList);

    }

    @Override
    public List<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVoWoof> queryGenericWoof(
            AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {

        if (ObjectUtil.isEmpty(queryCriteria.getBatchId())) {
            return null;
        }

        List<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVoWoof> resultList = accountingUnifiedSupplierOrderJdCheckUpReportMapperEx.pageQueryGenericWoof(queryCriteria);

        additionalInfoQueryGenericWoof(resultList);

        return resultList;
    }

    public void additionalInfoQueryGenericWoof(List<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVoWoof> resultList) {

        if (CollUtil.isEmpty(resultList)) {
            return;
        }

        List<String> batchIdSelected = resultList
                .stream()
                .filter(AnLamdaUtils.distinctByKey(o -> o.getBatchId()))
                .map(o -> o.getBatchId())
                .collect(Collectors.toList());

        String batchId = null;

        if (CollUtil.isNotEmpty(batchIdSelected)) {
            batchId = batchIdSelected.get(0);
        }


        List<Long> accountingUnifiedSupplierOrderJdIdSelected = resultList
                .stream()
                .filter(AnLamdaUtils.distinctByKey(o -> o.getAccountingUnifiedSupplierOrderJdId()))
                .map(o -> o.getAccountingUnifiedSupplierOrderJdId())
                .collect(Collectors.toList());

        Map<Long, List<AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsListItemVoWoof>> mapCheckUpReportXGoodsWoof =
                accountingUnifiedSupplierOrderJdCheckUpReportXGoodsService.mapQueryGenericWoof(
                        AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsQueryCriteria
                                .builder()
                                .batchId(batchId)
                                .accountingUnifiedSupplierOrderJdIdSelected(accountingUnifiedSupplierOrderJdIdSelected)
                                .build()
                );


        for (AccountingUnifiedSupplierOrderJdCheckUpReportListItemVoWoof vo : resultList) {

            /**************************************** 补 start ****************************************/

            vo.setProcessResultName(ScheduleTaskCheckStateEnum.getDesc(vo.getProcessResult()));
            vo.setDefineErrorName(SysQuartzScheduleTaskStatementOfAccountDefineErrorEnum.getDesc(vo.getDefineError()));

            if (CollUtil.isNotEmpty(mapCheckUpReportXGoodsWoof.get(vo.getAccountingUnifiedSupplierOrderJdId()))) {
                vo.setProductWoof(mapCheckUpReportXGoodsWoof.get(vo.getAccountingUnifiedSupplierOrderJdId()));
            }

            /**************************************** 子格子 start ****************************************/

        }
    }


    @Override
    public AccountingUnifiedSupplierOrderJdCheckUpReportUpperLevelsStatisticsVo statisticsQuantityDimOrderNormalOrException(
            AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {

        return accountingUnifiedSupplierOrderJdCheckUpReportMapperEx.statisticsQuantityDimOrderNormalOrException(queryCriteria);
    }

    private void additionalInfoQueryGenericParam(List<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVo> resultList) {

        if (CollUtil.isEmpty(resultList)) {
            return;
        }


        for (AccountingUnifiedSupplierOrderJdCheckUpReportListItemVo vo : resultList) {

            /**************************************** 补 start ****************************************/

            vo.setProcessResultName(ScheduleTaskCheckStateEnum.getDesc(vo.getProcessResult()));
            vo.setDefineErrorName(SysQuartzScheduleTaskStatementOfAccountDefineErrorEnum.getDesc(vo.getDefineError()));

        }

    }

    /****************************************** 检查 start ******************************************/


    @Override
    public List<AccountingUnifiedSupplierJdOpCreateParamDimGoodsSimulateSelectedDimOrder> simulateGoodsSelectedDimOrder(
            AccountingUnifiedSupplierOrderJdCheckUpReportTaskQueryCriteria queryCriteria) {

        return accountingUnifiedSupplierOrderJdCheckUpReportMapperEx.simulateGoodsSelectedDimOrder(queryCriteria);

    }


    /**
     * 单个检查 TODO mark by linjinyu at 2022-06-168 03:24:06 - 差锁定
     *
     * @param listItemVo
     * @param itemVo
     * @return
     */
    @Override
    public R<String> opCompareOrderAndCheckUpProcessDimOrderOne(
            SysQuartzScheduleTaskStatementOfAccountJdListItemVo listItemVo,
            AccountingUnifiedSupplierOrderJdListItemVo itemVo) {

        try {

            AccountingUnifiedSupplierOrderJdCheckUpReportOpCompareOrderAndCheckUpProcessDimOrderOneService processDimOrderOneService =
                    AccountingUnifiedSupplierOrderJdCheckUpReportOpCompareOrderAndCheckUpProcessDimOrderOneService
                            .builder()

                            .unifiedOrderService(unifiedOrderService)
                            .unifiedOrderGoodsService(unifiedOrderGoodsService)
                            .accountingUnifiedSupplierOrderJdCheckUpReportService(this)
                            .accountingUnifiedSupplierOrderJdCheckUpReportXGoodsService(accountingUnifiedSupplierOrderJdCheckUpReportXGoodsService)

                            .resourceConstant(resourceConstant)
                            .thirdpartJdAccountingVariable(thirdpartJdAccountingVariable)

                            .taskMainIntro(listItemVo)
                            .taskDataIntro(itemVo)

                            .build();

            processDimOrderOneService
                    .initConduct()
                    .initIntroVar()
                    .run()
                    // .翻滚吧...
                    .end();


            /**************************************** 按v2.5的需求，此逻辑是没有被考量的   end ****************************************/


            log.info("\ncheckUpReport {}", AnJsonUtils.toJson(itemVo));

        } catch (Exception e) {
            e.printStackTrace();
        }


        return ResponseResultOuterUtils.createSuccesResult();
    }

    public AccountingUnifiedSupplierOrderJdCheckUpReportSnapshotStruct readSnapshotJson(String batchId, String jdOrderSn) {

        log.info("\nreadSnapshotJson start \n{}\n{}\nopCheckUpDebug   end", batchId, jdOrderSn);


        List<UnifiedOrderDebugVo>      unifiedOrderDebugVoList      = new ArrayList<>();
        List<UnifiedOrderGoodsDebugVo> unifiedOrderGoodsDebugVoList = new ArrayList<>();

        String unifiedOrderJson      = readJson(batchId + "_debug", jdOrderSn + "_orderAssholeListFromDb");
        String unifiedOrderGoodsJson = readJson(batchId + "_debug", jdOrderSn + "_orderGoodsAssholeListFromDB");

        log.info("\nreadSnapshotJson start\n{}\n{}\nreadSnapshotJson   end", unifiedOrderJson, unifiedOrderGoodsJson);

        if (StrUtil.isNotBlank(unifiedOrderJson)) {
            unifiedOrderDebugVoList = AnJsonUtils.toList(unifiedOrderJson, UnifiedOrderDebugVo.class);
        }

        if (StrUtil.isNotBlank(unifiedOrderGoodsJson)) {
            unifiedOrderGoodsDebugVoList = AnJsonUtils.toList(unifiedOrderGoodsJson, UnifiedOrderGoodsDebugVo.class);
        }

        return AccountingUnifiedSupplierOrderJdCheckUpReportSnapshotStruct
                .builder()

                .unifiedOrderDebugVoList(unifiedOrderDebugVoList)
                .unifiedOrderGoodsDebugVoList(unifiedOrderGoodsDebugVoList)

                .build();
    }

    public String readJson(String batchId,
                           String jdOrderSn) {

        String excelExportPathRoot             = resourceConstant.getPathRoot();
        String excelExportRelativePathTemplate = resourceConstant.getPathTemplate();
        String excelExportRelativePathStorage  = resourceConstant.getPathStorage();

        String relativePath = File.separator + "thirdpart" +
                File.separator + "jd" +
                File.separator + "opCompareOrderAndCheckUpProcessDimOrderOne" +
                File.separator + batchId +
                File.separator;

        String targetFullPath = excelExportPathRoot + excelExportRelativePathStorage;

        // 请求记录
        String targetResponseFileName          = StrUtil.format("{}.json", jdOrderSn);
        String targetResponseWriteFileFullPath = targetFullPath + relativePath + targetResponseFileName;

        log.info("readJson: {}", targetResponseWriteFileFullPath);

        try {

            if (FileUtil.isFile(targetResponseWriteFileFullPath)) {
                return FileUtil.readUtf8String(targetResponseWriteFileFullPath);
            } else {
                return null;
            }

        } catch (IORuntimeException iore) {
            iore.printStackTrace();
            // 文件不存在
            return null;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }

    }

//    final ExecutorService executor = ExecutorBuilder
//            .create()
////            .setCorePoolSize(thirdpartJdAccountingVariable.getCorePoolSize())
////            .setMaxPoolSize(thirdpartJdAccountingVariable.getMaxPoolSize())
//
//            .setCorePoolSize(5)
//            .setMaxPoolSize(10)
//            .useSynchronousQueue()
//            .build();

    /**
     * 慢摇版本 // CompletableFuture.runAsync(() -> { });
     *
     * @param listItemVo
     * @param resultList
     */
    private void opCompareOrderAndCheckUpProcess(
            SysQuartzScheduleTaskStatementOfAccountJdListItemVo listItemVo,
            List<AccountingUnifiedSupplierOrderJdListItemVo> resultList
    ) {

        if (CollUtil.isEmpty(resultList)) {
            return;
        }

//        ExecutorService executor = null;

//        if (thirdpartJdAccountingVariable.getIsOpenThreadPool()) {

//        }

        // 分组统计
        Map<String, Long> groupingAndStatistics = resultList
                .stream()
                .collect(Collectors.groupingBy(AccountingUnifiedSupplierOrderJdListItemVo::getJdOrderSn, Collectors.counting()));

        resultList.forEach(itemVo -> {
            try {

                if (thirdpartJdAccountingVariable.getIsOpenThreadPool()
                        && groupingAndStatistics.get(itemVo.getJdOrderSn()).compareTo(1L) <= 0) {
                    // pool
//                    executor.execute(() -> opCompareOrderAndCheckUpProcessDimOrderOne(listItemVo, itemVo));
                    opCompareOrderAndCheckUpProcessDimOrderOne(listItemVo, itemVo);
                } else {
                    opCompareOrderAndCheckUpProcessDimOrderOne(listItemVo, itemVo);
                }


            } catch (Exception e) {
                e.printStackTrace();
            }
        });
    }

    /**
     * 步骤3:通过京东的订单数据-比对结算中心数据-生成报告
     *
     * @param form
     * @param listItemVo
     * @param loginSysUser
     * @return
     */
    @Override
    public SysNotify opCompareOrderAndCheckUp(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            SysQuartzScheduleTaskStatementOfAccountJdListItemVo listItemVo,
            LoginSysUser loginSysUser) {

        log.info("opCheckUp params {}", AnJsonUtils.toJson(form));


        List<AccountingUnifiedSupplierOrderJdListItemVo> resultList = accountingUnifiedSupplierOrderJdService.queryGenericParam(
                AccountingUnifiedSupplierOrderJdQueryCriteria
                        .builder()

                        .batchId(form.getBatchId())

                        .build(),
                loginSysUser
        );

        log.info("\n################ opCheckUp todo list size {} start ################################", resultList.size());

        opCompareOrderAndCheckUpProcess(listItemVo, resultList);

        log.info("\n################ opCheckUp todo list size {}   end ################################", resultList.size());

        return NotifyUtils.createSysNotify(
                "京东对账-对账任务-对账完成",
                StrUtil.format("#对账单号 {}#", form.getBatchId()),
                SysQuartzScheduleTaskStatementOfAccountRunStateEnum.成功
        );
    }

    /**
     * 步骤3:通过报告的异常数据-重新比对结算中心数据-生成报告
     *
     * @param form
     * @param listItemVo
     * @param loginSysUser
     * @return
     */
    @Override
    public SysNotify opCompareOrderAndCheckUpOnlyException(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            SysQuartzScheduleTaskStatementOfAccountJdListItemVo listItemVo,
            LoginSysUser loginSysUser) {

        log.info("opCheckUp params {}", AnJsonUtils.toJson(form));

        List<AccountingUnifiedSupplierOrderJdListItemVo> resultList = accountingUnifiedSupplierOrderJdService.queryGenericParam(
                AccountingUnifiedSupplierOrderJdQueryCriteria
                        .builder()

                        .batchId(form.getBatchId())
                        .onlyCheckUpException(1)

                        .build(),
                loginSysUser
        );

        log.info("\n################ opCheckUp todo list size {} start ################################", resultList.size());

        opCompareOrderAndCheckUpProcess(listItemVo, resultList);

        log.info("\n################ opCheckUp todo list size {}   end ################################", resultList.size());

        return NotifyUtils.createSysNotify(
                "京东对账-对账任务-对账完成",
                StrUtil.format("#对账单号 {}#", form.getBatchId()),
                SysQuartzScheduleTaskStatementOfAccountRunStateEnum.成功
        );

    }

    /**************************************** 检查任务   end ****************************************/

    /****************************************** 检查   end ******************************************/

}
