package cn.superdesk.uniorder.service.thirdpart.jd.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import cn.superdesk.uniorder.common.enums.accounting.AccountingOrderDimCreateByEnum;
import cn.superdesk.uniorder.common.enums.common.CommonAccountingStateEnum;
import cn.superdesk.uniorder.common.enums.scheduler.jd.ScheduleTaskCheckStateEnum;
import cn.superdesk.uniorder.common.lamda.AnLamdaUtils;
import cn.superdesk.uniorder.common.numerical.AnBeanUtils;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrder;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrderGoods;
import cn.superdesk.uniorder.dao.entity.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportXGoods;
import cn.superdesk.uniorder.dao.entity.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsExample;
import cn.superdesk.uniorder.dao.mapper.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsMapper;
import cn.superdesk.uniorder.dao.mapper.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsMapperEx;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.AccountingUnifiedSupplierJdOpCreateParamDimGoodsSimulateSelectedDimGoods;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsParam;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsQueryCriteria;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsHeadVo;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsListItemVo;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsListItemVoWoof;
import cn.superdesk.uniorder.service.order.base.UnifiedOrderGoodsService;
import cn.superdesk.uniorder.service.order.base.UnifiedOrderService;
import cn.superdesk.uniorder.service.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @Description:
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2022-06-22 16:27:47
 * @UpdateUser: linjinyu
 * @UpdateDate: 2022-06-22 16:27:47
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Service
public class AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsServiceImpl implements AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsService {

    @Autowired
    private AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsMapper   accountingUnifiedSupplierOrderJdCheckUpReportXGoodsMapper;
    @Autowired
    private AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsMapperEx accountingUnifiedSupplierOrderJdCheckUpReportXGoodsMapperEx;

    @Autowired
    private UnifiedOrderService      unifiedOrderService;
    @Autowired
    private UnifiedOrderGoodsService unifiedOrderGoodsService;

    /****************************************** extends BaseService 部分 start ******************************************/

    @Override
    public int insertSelective(AccountingUnifiedSupplierOrderJdCheckUpReportXGoods entity) {
        return accountingUnifiedSupplierOrderJdCheckUpReportXGoodsMapper.insertSelective(entity);
    }

    @Override
    public int insertBatch(List<AccountingUnifiedSupplierOrderJdCheckUpReportXGoods> processList) {
        return accountingUnifiedSupplierOrderJdCheckUpReportXGoodsMapperEx.insertBatch(processList);
    }

    @Override
    public int updateByPrimaryKeySelective(AccountingUnifiedSupplierOrderJdCheckUpReportXGoods entity) {
        return accountingUnifiedSupplierOrderJdCheckUpReportXGoodsMapper.updateByPrimaryKeySelective(entity);
    }

    @Override
    public void deleteObj(Long id) {
    }

    @Override
    public AccountingUnifiedSupplierOrderJdCheckUpReportXGoods findById(Long id) {
        return accountingUnifiedSupplierOrderJdCheckUpReportXGoodsMapper.selectByPrimaryKey(id);
    }

    @Override
    public PageInfo<AccountingUnifiedSupplierOrderJdCheckUpReportXGoods> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize) {
        return null;
    }

    @Override
    public List<AccountingUnifiedSupplierOrderJdCheckUpReportXGoods> findAll(Map<String, Object> queryMap) {
        return null;
    }

    /****************************************** extends BaseService 部分   end ******************************************/


    @Override
    public int addAccountingUnifiedSupplierOrderJdCheckUpReportXGoods(AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsParam param, LoginSysUser loginSysUser) {

        DateTime now = DateUtil.date();

        AccountingUnifiedSupplierOrderJdCheckUpReportXGoods forInsertEntity = new AccountingUnifiedSupplierOrderJdCheckUpReportXGoods();
        AnBeanUtils.copy(param, forInsertEntity);

        forInsertEntity.setCreateTime(now);
        forInsertEntity.setCreateUserId(loginSysUser.getSysUserId());

//        forInsertEntity.setUpdateTime(now);
//        forInsertEntity.setUpdateUserId(loginSysUser.getSysUserId());

        return accountingUnifiedSupplierOrderJdCheckUpReportXGoodsMapper.insertSelective(forInsertEntity);
    }

    @Override
    public int updateAccountingUnifiedSupplierOrderJdCheckUpReportXGoods(AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsParam param, LoginSysUser loginSysUser) {

        AccountingUnifiedSupplierOrderJdCheckUpReportXGoods originEntity = accountingUnifiedSupplierOrderJdCheckUpReportXGoodsMapper.selectByPrimaryKey(param.getId());
        // AssertUtil.notNull(originEntity);
        if (ObjectUtil.isNull(originEntity)) {
            return 0;
        }

        DateTime now = DateUtil.date();

        AccountingUnifiedSupplierOrderJdCheckUpReportXGoods forUpdateEntity = new AccountingUnifiedSupplierOrderJdCheckUpReportXGoods();
        AnBeanUtils.copy(param, forUpdateEntity);

        forUpdateEntity.setId(originEntity.getId());
//        forUpdateEntity.setUpdateTime(now);
//        forUpdateEntity.setUpdateUserId(loginSysUser.getSysUserId());

        return accountingUnifiedSupplierOrderJdCheckUpReportXGoodsMapper.updateByPrimaryKeySelective(forUpdateEntity);
    }

    @Override
    public int deleteAccountingUnifiedSupplierOrderJdCheckUpReportXGoods(Long id, LoginSysUser loginSysUser) {
        DateTime now = DateUtil.date();
        return accountingUnifiedSupplierOrderJdCheckUpReportXGoodsMapper.deleteByPrimaryKey(id);
    }


    @Override
    public AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsListItemVo findListItemVoById(Long id, LoginSysUser loginSysUser) {

        List<AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsListItemVo> resultList = queryGenericParam(
                AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsQueryCriteria
                        .builder()
                        .accountingUnifiedSupplierOrderJdCheckUpReportXGoodsId(id)
                        .build(),
                loginSysUser);

        if (CollUtil.isNotEmpty(resultList)) {
            return resultList.get(0);
        } else {
            return null;
        }
    }

    @Override
    public R<List<AccountingUnifiedSupplierOrderJdCheckUpReportXGoods>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize) {

        AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsExample          example  = new AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsExample();
        AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsExample.Criteria criteria = example.createCriteria();

        // TODO 喜欢用Map 还是 Bean 自己喜欢... 后期添加 转 AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsExample.Criteria
        // AccountingUnifiedSupplierOrderJdCheckUpReportXGoods accountingUnifiedSupplierOrderJdCheckUpReportXGoodsConditions = BeanUtils.mapToBean(conditions,AccountingUnifiedSupplierOrderJdCheckUpReportXGoods.class);

        PageHelper.startPage(pageNun, pageSize);
        List<AccountingUnifiedSupplierOrderJdCheckUpReportXGoods>     resultList = accountingUnifiedSupplierOrderJdCheckUpReportXGoodsMapper.selectByExample(example);
        PageInfo<AccountingUnifiedSupplierOrderJdCheckUpReportXGoods> page       = new PageInfo<AccountingUnifiedSupplierOrderJdCheckUpReportXGoods>(resultList);
        PageHelper.clearPage();

        return new R<List<AccountingUnifiedSupplierOrderJdCheckUpReportXGoods>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), resultList);

    }

    @Override
    public R<List<AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsListItemVo>> pageQueryGenericParam(
            AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {

        AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsExample          example  = new AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsExample();
        AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsExample.Criteria criteria = example.createCriteria();

        // TODO 添加条件... 后期添加 queryCriteria 转 AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsExample.Criteria

        PageHelper.startPage(queryCriteria.getPageNumber(), queryCriteria.getPageSize());
        List<AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsListItemVo>     resultList = queryGenericParam(queryCriteria, loginSysUser);
        PageInfo<AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsListItemVo> page       = new PageInfo<AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsListItemVo>(resultList);
        PageHelper.clearPage();

        return new R<List<AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsListItemVo>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), resultList);

    }

    @Override
    public AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsHeadVo queryHeadGenericParam(
            AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {

        return accountingUnifiedSupplierOrderJdCheckUpReportXGoodsMapperEx.queryHeadGenericParam(queryCriteria);
    }

    @Override
    public List<AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsListItemVo> queryGenericParam(
            AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {

        List<AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsListItemVo> resultList = accountingUnifiedSupplierOrderJdCheckUpReportXGoodsMapperEx.queryGenericParam(queryCriteria);

        additionalInfoQueryGenericParam(resultList);

        return resultList;
    }

    @Override
    public List<AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsListItemVoWoof> queryGenericWoof(
            AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsQueryCriteria queryCriteria) {

        List<AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsListItemVoWoof> resultList =
                accountingUnifiedSupplierOrderJdCheckUpReportXGoodsMapperEx.pageQueryGenericWoof(queryCriteria);

        additionalInfoQueryGenericWoof(resultList);

        return resultList;
    }

    private Long fetchGroupKeyByAccountingUnifiedSupplierOrderJdId(AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsListItemVoWoof voWoof) {
        return voWoof.getAccountingUnifiedSupplierOrderJdId();
    }

    public Map<Long, List<AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsListItemVoWoof>> mapQueryGenericWoof(
            AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsQueryCriteria queryCriteria) {

        List<AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsListItemVoWoof> resultList = queryGenericWoof(queryCriteria);

        Map<Long, List<AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsListItemVoWoof>> transferMapGroupByAccountingUnifiedSupplierOrderJdId = new HashMap<>();

        if (CollUtil.isNotEmpty(resultList)) {
            transferMapGroupByAccountingUnifiedSupplierOrderJdId = resultList
                    .parallelStream()
                    .collect(Collectors.groupingBy(e -> fetchGroupKeyByAccountingUnifiedSupplierOrderJdId(e), Collectors.toList()));

        }

        return transferMapGroupByAccountingUnifiedSupplierOrderJdId;


    }

    private void additionalInfoQueryGenericParam(List<AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsListItemVo> resultList) {

        if (CollUtil.isEmpty(resultList)) {
            return;
        }

        /**************************************** 操作人 start ****************************************/

//		List<Long> sysUserIds = new ArrayList<>();
//
//		List<Long> createUserIds = resultList.stream().filter(o -> o.getCreateUserId() != null).filter(AnLamdaUtils.distinctByKey(o -> o.getCreateUserId())).map(o -> o.getCreateUserId()).collect(Collectors.toList());
//		List<Long> updateUserIds = resultList.stream().filter(o -> o.getUpdateUserId() != null).filter(AnLamdaUtils.distinctByKey(o -> o.getUpdateUserId())).map(o -> o.getUpdateUserId()).collect(Collectors.toList());
//
//		sysUserIds.addAll(createUserIds);
//		sysUserIds.addAll(updateUserIds);
//		sysUserIds = sysUserIds
//				.stream()
//				.distinct()
//				.collect(Collectors.toList());
//
//		log.info("\n{}", JSONUtil.toJsonStr(sysUserIds));
//		Map<Long, SysUser> sysUserMap = sysUserService.convertSysUserIds2MapSysUserId2Entity(sysUserIds);

        /**************************************** 供应商 start ****************************************/

//		List<Long> outSaleIds = new ArrayList<>();
//
//		List<Long> outMerchantIds = resultList.stream().filter(o -> o.getOutMerchantId() != null).filter(AnLamdaUtils.distinctByKey(o -> o.getOutMerchantId())).map(o -> o.getOutMerchantId()).collect(Collectors.toList());
//
//		outSaleIds.addAll(outMerchantIds);
//		outSaleIds = outSaleIds
//				.stream()
//				.distinct()
//				.collect(Collectors.toList());
//
//		Map<Long, UnifiedSupplier> sysSupplierMap = sysSupplierService.convertOutSaleIds2MapOutSaleId2Entity(outSaleIds);

        for (AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsListItemVo vo : resultList) {


            /**************************************** 补-时间 start ****************************************/

//            CHINESE_DATE_PATTERN = "yyyy年MM月dd日";
//            CHINESE_DATE_TIME_PATTERN = "yyyy年MM月dd日HH时mm分ss秒";
//            NORM_DATE_PATTERN = "yyyy-MM-dd";
//            NORM_DATETIME_PATTERN = "yyyy-MM-dd HH:mm:ss";

//			if (ObjectUtil.isNotNull(vo.getCreateTime())) {
//				vo.setCreateTimeFormat(DateUtil.date(vo.getCreateTime()).toString(DatePattern.NORM_DATETIME_PATTERN));
//			}
//			if (ObjectUtil.isNotNull(vo.getUpdateTime())) {
//				vo.setUpdateTimeFormat(DateUtil.date(vo.getUpdateTime()).toString(DatePattern.NORM_DATETIME_PATTERN));
//			}

            /**************************************** 补-来源 start ****************************************/

//			if (ObjectUtil.isNotNull(vo.getServiceNo())) {
//				vo.setServiceNoName(CommonServiceNoEnum.getByServiceNo(vo.getServiceNo()).getServiceName());
//			} else {
//				vo.setServiceNoName(CommonServiceNoEnum.UNKNOW.getServiceName());
//			}
//			if (ObjectUtil.isNotNull(vo.getSourceFrom())) {
//				vo.setSourceFromName(CommonSourceFromEnum.getBySourceFromCode(vo.getSourceFrom()).getSourceFromName());
//			} else {
//				vo.setSourceFromName(CommonSourceFromEnum.UNKNOW.getSourceFromName());
//			}

            /**************************************** 补-操作人 start ****************************************/

//			if (ObjectUtil.isNotNull(sysUserMap.get(vo.getCreateUserId()))) {
//				vo.setCreateUserName(sysUserMap.get(vo.getCreateUserId()).getFullname());
//			}
//			if (ObjectUtil.isNotNull(sysUserMap.get(vo.getUpdateUserId()))) {
//				vo.setUpdateUserName(sysUserMap.get(vo.getUpdateUserId()).getFullname());
//			}

        }

    }

    private void additionalInfoQueryGenericWoof(List<AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsListItemVoWoof> resultList) {

        if (CollUtil.isEmpty(resultList)) {
            return;
        }
    }


    public List<AccountingUnifiedSupplierJdOpCreateParamDimGoodsSimulateSelectedDimGoods> simulateGoodsSelected(String batchId, Integer processResult) {

//        .processResult = ScheduleTaskCheckStateEnum.正常 = 1
        return accountingUnifiedSupplierOrderJdCheckUpReportXGoodsMapperEx.simulateGoodsSelectedDimGoods(
                AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsQueryCriteria
                        .builder()

                        .batchId(batchId)
                        .processResult(processResult)

                        .build()
        );
    }

    @Override
    public int insertXBySingleOrder(
            String batchId,
            Long accountingUnifiedSupplierOrderJdId,
            /* 必定为正单 */ UnifiedOrder orderFromDB,
            List<UnifiedOrder> orderAsWholeListFromDB,
            List<UnifiedOrder> predicatesUnifiedOrderByFieldCompletStateEq1Filter,
            List<UnifiedOrderGoods> predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2GoodsLockingSupplierEq0Filter,
            AccountingOrderDimCreateByEnum dimCreateByEnum,
            ScheduleTaskCheckStateEnum checkStateEnum,
            DateTime now) {

        if (StrUtil.isBlank(batchId)) {
            return 0;
        }
        if (ObjectUtil.isNull(accountingUnifiedSupplierOrderJdId)) {
            return 0;
        }
        if (ObjectUtil.isNull(orderFromDB)) {
            return 0;
        }
        if (CollUtil.isEmpty(orderAsWholeListFromDB)) {
            return 0;
        }
        if (CollUtil.isEmpty(predicatesUnifiedOrderByFieldCompletStateEq1Filter)) {
            return 0;
        }
        if (CollUtil.isEmpty(predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2GoodsLockingSupplierEq0Filter)) {
            return 0;
        }

        Map<String, UnifiedOrder> orderAsWholeListFromDBMap = orderAsWholeListFromDB
                .stream()
                .collect(Collectors.toMap(UnifiedOrder::getOrderSn, v -> v, (k, v) -> v));

        List<AccountingUnifiedSupplierOrderJdCheckUpReportXGoods> processList = new ArrayList<>();

        predicatesUnifiedOrderGoodsByAccountingStateSupplierEq2GoodsLockingSupplierEq0Filter.forEach(item -> {

            processList.add(AccountingUnifiedSupplierOrderJdCheckUpReportXGoods
                    .builder()

                    // .id()
                    .dimCreateBy(dimCreateByEnum.getKey())

                    .batchId(batchId)
                    .accountingUnifiedSupplierOrderJdId(accountingUnifiedSupplierOrderJdId)

                    .accountingOrderId(0L)
                    .accountingOrderSn("")

                    /**************************************** 牵引的订单 start ****************************************/

                    .doggodOrderSnAsWhole(orderFromDB.getOrderSn())
                    .processResult(checkStateEnum.getKey())

                    /**************************************** 牵引的订单   end ****************************************/

                    /**************************************** 具体的订单 start ****************************************/

                    .doggodOrderAccountingStateSupplier(orderAsWholeListFromDBMap.get(item.getOrderSn()).getAccountingStateSupplier())
                    .unifiedOrderId(orderAsWholeListFromDBMap.get(item.getOrderSn()).getId())
                    .orderSn(item.getOrderSn())

                    /**************************************** 具体的订单   end ****************************************/


                    /**************************************** 具体的订单商品 start ****************************************/

                    .doggodGoodsAccountingStateSupplier(item.getAccountingStateSupplier())
                    .unifiedOrderGoodsId(item.getId())
                    .goodsId(item.getGoodsId())
                    .goodsCostPrice(item.getCostPrice())
                    .goodsQuantity(item.getQuantity())
                    .goodsCostAmount(item.getCostPrice().multiply(new BigDecimal(item.getQuantity())))
                    .outSnapshotOrderGoodsId(item.getOutSnapshotOrderGoodsId())

                    /**************************************** 具体的订单商品   end ****************************************/

                    .unifiedOrderCreditId(0L)

                    .createTime(now)
                    .createUserId(996L)

                    .build()
            );
        });

        int ret = insertBatch(processList);

        return ret;
    }

    /**
     * 目前此方法为两个阶段数据补刀产物，不清楚就不要用
     *
     * @param batchId
     * @param orderFromDB
     * @return
     */
//    @Deprecated
//    @Override
//    public int nullOrInsertXBySingleOrder(String batchId,
//                                          UnifiedOrder orderFromDB) {
//
//        DateTime now = DateUtil.date();
//
//        /* 正单 ---- 从京东单作为引子 这里必定是正单 */
//        // UnifiedOrder orderFromDB =
//        /* 退单 ---- 三种情况 0 1 N */
//        List<UnifiedOrder> refundOrderListFromDB  = new ArrayList<>();
//        /* 整单 ---- */
//        List<UnifiedOrder> orderAsWholeListFromDB = new ArrayList<>();
//
//        // TODO mark by linjinyu at 2022-06-22 20:45:24 - 此处要 拉成 正负单下的所有商品
//        List<UnifiedOrderGoods> orderGoodsListFromDB = unifiedOrderGoodsService.findByOrderSn(orderFromDB.getOrderSn());
//
//        /**************************************** 对账的 - 排除单向结算(只留下供应商结算的) start ****************************************/
//
//        List<Predicate<UnifiedOrderGoods>> predicatesByFieldAccountingStateSupplierNotEqMinus1 = new ArrayList<>();
//        predicatesByFieldAccountingStateSupplierNotEqMinus1.add(r -> r.getAccountingStateSupplier() != null && r.getAccountingStateSupplier().compareTo(CommonAccountingStateEnum.不对账.getKey()) != 0);
//        List<UnifiedOrderGoods> predicatesByAccountingStateSupplierNotEqMinus1Filter = AnLamdaUtils.filters(orderGoodsListFromDB, predicatesByFieldAccountingStateSupplierNotEqMinus1);
//
//        /**************************************** 不对账 start ****************************************/
//
//        List<Predicate<UnifiedOrderGoods>> predicatesByFieldAccountingStateSupplierEqMinus1 = new ArrayList<>();
//        predicatesByFieldAccountingStateSupplierEqMinus1.add(r -> r.getAccountingStateSupplier() != null && r.getAccountingStateSupplier().compareTo(CommonAccountingStateEnum.不对账.getKey()) == 0);
//        List<UnifiedOrderGoods> predicatesByAccountingStateSupplierEqMinus1Filter = AnLamdaUtils.filters(orderGoodsListFromDB, predicatesByFieldAccountingStateSupplierEqMinus1);
//
//        // 按 供应商对账状态 分切
//        // |---- 不对账(-1, "不对账"),
//        // |---- 已对账(1, "已对账"), // ----
//        // |---- 未对账(2, "未对账"), // ----
//        // |---- 已作废(3, "已作废"), // ---- mark by linjinyu 20200713 为了作废订单
//        // |---- 已锁定(4, "已锁定"), // ---- mark by linjinyu 20220615 为了京东对账
//
//
//        /**************************************** 未对账 start ****************************************/
//
//        List<Predicate<UnifiedOrderGoods>> predicatesByFieldAccountingStateSupplierEq2 = new ArrayList<>();
//        predicatesByFieldAccountingStateSupplierEq2.add(r -> r.getAccountingStateSupplier() != null && r.getAccountingStateSupplier().compareTo(CommonAccountingStateEnum.未对账.getKey()) == 0);
//        List<UnifiedOrderGoods> predicatesByAccountingStateSupplierEq2Filter = AnLamdaUtils.filters(predicatesByAccountingStateSupplierNotEqMinus1Filter, predicatesByFieldAccountingStateSupplierEq2);
//
//        /**************************************** 已对账 start ****************************************/
//
//        List<Predicate<UnifiedOrderGoods>> predicatesByFieldAccountingStateSupplierEq1 = new ArrayList<>();
//        predicatesByFieldAccountingStateSupplierEq1.add(r -> r.getAccountingStateSupplier() != null && r.getAccountingStateSupplier().compareTo(CommonAccountingStateEnum.已对账.getKey()) == 0);
//        List<UnifiedOrderGoods> predicatesByAccountingStateSupplierEq1Filter = AnLamdaUtils.filters(predicatesByAccountingStateSupplierNotEqMinus1Filter, predicatesByFieldAccountingStateSupplierEq1);
//
//        /**************************************** 已锁定 start ****************************************/
//
//        List<Predicate<UnifiedOrderGoods>> predicatesByFieldAccountingStateSupplierEq4 = new ArrayList<>();
//        predicatesByFieldAccountingStateSupplierEq4.add(r -> r.getAccountingStateSupplier() != null && r.getAccountingStateSupplier().compareTo(CommonAccountingStateEnum.已锁定.getKey()) == 0);
//        List<UnifiedOrderGoods> predicatesByAccountingStateSupplierEq4Filter = AnLamdaUtils.filters(predicatesByAccountingStateSupplierNotEqMinus1Filter, predicatesByFieldAccountingStateSupplierEq4);
//
//
//        return insertXBySingleOrder(
//                batchId,
//                orderFromDB, ,
//                predicatesByAccountingStateSupplierNotEqMinus1Filter, AccountingOrderDimCreateByEnum.订单,
//                , now);
//    }
    @Override
    public int lockXBySingleOrder(String batchId,
                                  UnifiedOrder orderFromDB,
                                  List<UnifiedOrder> orderAsWholeListFromDB,
                                  List<UnifiedOrder> predicatesByFieldCompletStateEq1Filter,
                                  List<UnifiedOrderGoods> predicatesByAccountingStateSupplierEq2Filter) {

        if (StrUtil.isBlank(batchId)) {
            return 0;
        }
        if (ObjectUtil.isNull(orderFromDB)) {
            return 0;
        }
        if (CollUtil.isEmpty(orderAsWholeListFromDB)) {
            return 0;
        }
        if (CollUtil.isEmpty(predicatesByFieldCompletStateEq1Filter)) {
            return 0;
        }
        if (CollUtil.isEmpty(predicatesByAccountingStateSupplierEq2Filter)) {
            return 0;
        }

        /**************************************** 加锁 start ****************************************/

//        List<String> processOrderSn = Arrays.asList(orderFromDB.getOrderSn());
        List<String> processOrderSn = predicatesByFieldCompletStateEq1Filter
                .stream()
                .map(UnifiedOrder::getOrderSn)
                .collect(Collectors.toList());

        List<Long> processSysUnifiedOrderGoodsIds = predicatesByAccountingStateSupplierEq2Filter
                .stream()
                // 有没有这样的可能呢? 不管，为了安全 start
                .filter(o -> null != o.getId())
                .filter(AnLamdaUtils.distinctByKey(o -> o.getId()))
                // 有没有这样的可能呢? 不管，为了安全   end
                .map(UnifiedOrderGoods::getId)
                .collect(Collectors.toList());

        // 更新 订单 供应商对账状态 -> commonAccountingStateEnum(未对账|已锁定)
        unifiedOrderService.updateAccountingStateSupplierByOrderSns(processOrderSn, CommonAccountingStateEnum.已锁定);

        // 更新 商品 供应商对账状态 -> commonAccountingStateEnum(未对账|已锁定)
        unifiedOrderGoodsService.updateAccountingStateSupplierByOrderSnAndSysUnifiedOrderGoodsIds(processOrderSn, processSysUnifiedOrderGoodsIds, CommonAccountingStateEnum.已锁定);

        // 更新 流水 供应商对账状态  -> commonAccountingStateEnum((未对账|已锁定) 此处就不做多余的事了
        // unifiedOrderCreditService.updateFieldAccountingStateSupplierByOrderSnAndOutGoodsIds(processOrderSn, processOutGoodsIds, CommonAccountingStateEnum.已锁定);

        /**************************************** 加锁   end ****************************************/

        return 1;
    }


    @Override
    public int lockXByBatchId(/* 对账号(批次号)*/String batchId) {
        return 0;
    }

    // /* 未对账|已锁定 */CommonAccountingStateEnum commonAccountingStateEnum
    @Override
    public int unLockXByBatchId(/* 对账号(批次号)*/String batchId) {

        /**
         * TODO mark by linjinyu at 2022-06-22 18:52:01 - 目前要求订单商品维度-此方案是错的
         * {@link AccountingUnifiedSupplierOrderJdCheckUpReportServiceImpl#simulateGoodsSelectedDimOrder}
         * 用此表记录的 -accounting_unified_supplier_order_jd_check_up_report_x_goods

         // 构造
         List<AccountingUnifiedSupplierJdOpCreateParamDimGoodsSimulateSelectedDimOrder> simulateGoodsSelected = new ArrayList<>();
         simulateGoodsSelected = accountingUnifiedSupplierOrderJdCheckUpReportService.simulateGoodsSelectedDimOrder(
         AccountingUnifiedSupplierOrderJdCheckUpReportTaskQueryCriteria
         .builder()
         .batchId(batchId)
         .processResult(CommonProcessResultEnum.正常.getKey()) // ---- 异常的是不会锁定 所以不用动
         .build()
         );
         */

        List<AccountingUnifiedSupplierJdOpCreateParamDimGoodsSimulateSelectedDimGoods> simulateGoodsSelected = simulateGoodsSelected(batchId, null);

        if (CollUtil.isEmpty(simulateGoodsSelected)) {
            return 0;
        }

        List<Long>   processSysUnifiedOrderIds      = simulateGoodsSelected.stream().filter(o -> null != o.getUnifiedOrderId()).filter(AnLamdaUtils.distinctByKey(o -> o.getUnifiedOrderId())).map(AccountingUnifiedSupplierJdOpCreateParamDimGoodsSimulateSelectedDimGoods::getUnifiedOrderId).collect(Collectors.toList());
        List<Long>   processSysUnifiedOrderGoodsIds = simulateGoodsSelected.stream().filter(o -> null != o.getUnifiedOrderGoodsId()).filter(AnLamdaUtils.distinctByKey(o -> o.getUnifiedOrderGoodsId())).map(AccountingUnifiedSupplierJdOpCreateParamDimGoodsSimulateSelectedDimGoods::getUnifiedOrderGoodsId).collect(Collectors.toList());
        List<Long>   processOutGoodsIds             = simulateGoodsSelected.stream().filter(o -> null != o.getGoodsId()).filter(AnLamdaUtils.distinctByKey(o -> o.getGoodsId())).map(AccountingUnifiedSupplierJdOpCreateParamDimGoodsSimulateSelectedDimGoods::getGoodsId).collect(Collectors.toList());
        List<String> processOrderSn                 = simulateGoodsSelected.stream().filter(o -> null != o.getOrderSn()).filter(AnLamdaUtils.distinctByKey(o -> o.getOrderSn())).map(AccountingUnifiedSupplierJdOpCreateParamDimGoodsSimulateSelectedDimGoods::getOrderSn).collect(Collectors.toList());


        // 更新 订单 供应商对账状态 -> commonAccountingStateEnum(未对账|已锁定)
        int ret001 = unifiedOrderService.updateAccountingStateSupplierByOrderSns(processOrderSn, CommonAccountingStateEnum.未对账);

        // 更新 商品 供应商对账状态 -> commonAccountingStateEnum(未对账|已锁定)
        int ret002 = unifiedOrderGoodsService.updateAccountingStateSupplierByOrderSnAndSysUnifiedOrderGoodsIds(
                processOrderSn,
                processSysUnifiedOrderGoodsIds,
                CommonAccountingStateEnum.未对账);

        // 更新 流水 供应商对账状态  -> commonAccountingStateEnum((未对账|已锁定) 此处就不做多余的事了
//        unifiedOrderCreditService.updateFieldAccountingStateSupplierByOrderSnAndOutGoodsIds(processOrderSn, processOutGoodsIds, commonAccountingStateEnum);

        return ret002;
    }

    @Override
    public int deleeteXByBatchId(String batchId) {

        if (StrUtil.isBlank(batchId)) {
            return 0;
        }

        AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsExample          example  = new AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsExample();
        AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsExample.Criteria criteria = example.createCriteria();

        criteria
                .andBatchIdEqualTo(batchId);

        return accountingUnifiedSupplierOrderJdCheckUpReportXGoodsMapper.deleteByExample(example);
    }

}