package cn.superdesk.uniorder.service.thirdpart.jd.impl;

import cn.hutool.core.io.FileUtil;
import cn.superdesk.uniorder.common.enums.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountRunStateEnum;
import cn.superdesk.uniorder.common.excel.ExcelResponse;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.sys.notify.SysNotify;
import cn.superdesk.uniorder.dto._constant.ResourceConstant;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.AccountingUnifiedSupplierOrderJdListItemVo;
import cn.superdesk.uniorder.notify.NotifyUtils;
import cn.superdesk.uniorder.service.thirdpart.jd.AccountingUnifiedSupplierOrderJdExportExcelService;
import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.ExcelWriter;
import com.alibaba.excel.write.builder.ExcelWriterBuilder;
import com.alibaba.excel.write.metadata.WriteSheet;
import com.alibaba.excel.write.metadata.fill.FillConfig;
import com.alibaba.excel.write.metadata.fill.FillWrapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.File;
import java.util.List;

/**
 * @Description: Java类作用描述
 * @Author: linjinyu
 * @CreateDate: 2022/6/15 9:47 上午
 * @UpdateUser: linjinyu
 * @UpdateDate: 2022/6/15 9:47 上午
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Service
public class AccountingUnifiedSupplierOrderJdExportExcelServiceImpl
        implements AccountingUnifiedSupplierOrderJdExportExcelService {

    @Autowired
    private ResourceConstant resourceConstant;

    private static final String TEMPLATE_EXCEL_EXPORT_ACCOUNTING_UNIFIED_SUPPLIER_ORDER_JD = "exportExcelJd_v20220615.xlsx";

    @Override
    public SysNotify exportExcelJdImportRecord(
            List<AccountingUnifiedSupplierOrderJdListItemVo> resultList,
            String batchId,
            LoginSysUser loginSysUser) {

        String excelExportPathRoot             = resourceConstant.getPathRoot();
        String excelExportRelativePathTemplate = resourceConstant.getPathTemplate();
        String excelExportRelativePathStorage  = resourceConstant.getPathStorage();

        String relativePath = File.separator + "excel" +
                File.separator + "accounting" +
                File.separator + "score" +
                File.separator + "jd" +
                File.separator;

        String templateRelativePath = excelExportPathRoot + excelExportRelativePathTemplate + relativePath;
        String templateFullPath;

        String targetFullPath = excelExportPathRoot + excelExportRelativePathStorage;

        String targetFileName          = "京东对账" + "_" + "对账单号_" + batchId + ExcelResponse.addTail() + ".xlsx";
        String targetWriteFileFullPath = targetFullPath + relativePath + targetFileName;

//		if (!FileUtil.exist(targetWriteFileFullPath)) {
//			FileUtil.mkdir(targetWriteFileFullPath);
//		}
        FileUtil.touch(targetWriteFileFullPath);


        templateFullPath = templateRelativePath + TEMPLATE_EXCEL_EXPORT_ACCOUNTING_UNIFIED_SUPPLIER_ORDER_JD;


        /**************************************** fill start ****************************************/

        ExcelWriterBuilder excelWriterBuilder = EasyExcel
                .write(targetWriteFileFullPath);
        ExcelWriter excelWriter = null;

        WriteSheet writeSheet0 = EasyExcel
                .writerSheet(0, "列表")
                .build();
        FillConfig fillConfig = FillConfig
                .builder()
                .forceNewRow(Boolean.FALSE)
                .build();
        excelWriter = excelWriterBuilder
                .withTemplate(templateFullPath)
                .build();
        excelWriter
                .fill(new FillWrapper("detail", resultList), fillConfig, writeSheet0);
        // 别忘记关闭流
        excelWriter
                .finish();

        /**************************************** fill start ****************************************/




        return NotifyUtils.createSysNotify(
                targetFileName,
                relativePath + targetFileName,
                SysQuartzScheduleTaskStatementOfAccountRunStateEnum.成功
        );
    }
}
