package cn.superdesk.uniorder.service.thirdpart.jd.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.io.file.FileReader;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.ReUtil;
import cn.hutool.core.util.StrUtil;
import cn.superdesk.uniorder.common.chinese.AnChineseCharacterUtils;
import cn.superdesk.uniorder.common.enums.scheduler.jd.ScheduleTaskProcessStateEnum;
import cn.superdesk.uniorder.common.enums.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountRunStateEnum;
import cn.superdesk.uniorder.common.excel.converters.szhtxx.CustomStringBigDecimalConverter;
import cn.superdesk.uniorder.common.json.AnJsonUtils;
import cn.superdesk.uniorder.common.numerical.AnBeanUtils;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.sys.notify.SysNotify;
import cn.superdesk.uniorder.dao.entity.thirdpart.jd.AccountingUnifiedSupplierOrderJd;
import cn.superdesk.uniorder.dao.entity.thirdpart.jd.AccountingUnifiedSupplierOrderJdExample;
import cn.superdesk.uniorder.dao.mapper.thirdpart.jd.AccountingUnifiedSupplierOrderJdMapper;
import cn.superdesk.uniorder.dao.mapper.thirdpart.jd.AccountingUnifiedSupplierOrderJdMapperEx;
import cn.superdesk.uniorder.dto._constant.ResourceConstant;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.*;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.AccountingUnifiedSupplierOrderJdDetailStatisticsVo;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.AccountingUnifiedSupplierOrderJdListItemVo;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.AccountingUnifiedSupplierOrderJdUpperLevelsStatisticsVo;
import cn.superdesk.uniorder.notify.NotifyUtils;
import cn.superdesk.uniorder.service.thirdpart.jd.AccountingUnifiedSupplierOrderJdService;
import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.ExcelReader;
import com.alibaba.excel.read.metadata.ReadSheet;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.regex.Pattern;

/**
 * @Description: 京东对账单中的订单 算是临时 sheet eg 深圳市侨城汇网络科技有限公司-2021年8月1日集采账单.xlsx
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-10-12 11:29:24
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-10-12 11:29:24
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@RequiredArgsConstructor
@Slf4j
@Service
public class AccountingUnifiedSupplierOrderJdServiceImpl implements AccountingUnifiedSupplierOrderJdService {

    private final AccountingUnifiedSupplierOrderJdMapper   accountingUnifiedSupplierOrderJdMapper;
    private final AccountingUnifiedSupplierOrderJdMapperEx accountingUnifiedSupplierOrderJdMapperEx;

    @Autowired
    private ResourceConstant resourceConstant;

    /****************************************** extends BaseService 部分 start ******************************************/

    @Override
    public int insertSelective(AccountingUnifiedSupplierOrderJd entity) {
        return accountingUnifiedSupplierOrderJdMapper.insertSelective(entity);
    }

    @Override
    public int updateByPrimaryKeySelective(AccountingUnifiedSupplierOrderJd entity) {
        return accountingUnifiedSupplierOrderJdMapper.updateByPrimaryKeySelective(entity);
    }

    @Override
    public void deleteObj(Long id) {
    }

    @Override
    public AccountingUnifiedSupplierOrderJd findById(Long id) {
        return accountingUnifiedSupplierOrderJdMapper.selectByPrimaryKey(id);
    }

    @Override
    public AccountingUnifiedSupplierOrderJd findByBatchIdAndJdOrderSn(String batchId, String jdOrderSn) {

        if (StrUtil.isBlank(batchId) || StrUtil.isBlank(jdOrderSn)) {
            return null;
        }

        AccountingUnifiedSupplierOrderJdExample          example  = new AccountingUnifiedSupplierOrderJdExample();
        AccountingUnifiedSupplierOrderJdExample.Criteria criteria = example.createCriteria();

        criteria
                .andBatchIdEqualTo(batchId)
                .andJdOrderSnEqualTo(jdOrderSn);

        List<AccountingUnifiedSupplierOrderJd> resultList = accountingUnifiedSupplierOrderJdMapper.selectByExample(example);

        if (CollUtil.isNotEmpty(resultList)) {
            return resultList.get(0);
        } else {
            return null;
        }

    }

    @Override
    public PageInfo<AccountingUnifiedSupplierOrderJd> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize) {
        return null;
    }

    @Override
    public List<AccountingUnifiedSupplierOrderJd> findAll(Map<String, Object> queryMap) {
        return null;
    }

    /****************************************** extends BaseService 部分   end ******************************************/


    @Override
    public void addAccountingUnifiedSupplierOrderJd(AccountingUnifiedSupplierOrderJd entity) {
        accountingUnifiedSupplierOrderJdMapper.insertSelective(entity);
    }

    @Override
    public void updateAccountingUnifiedSupplierOrderJd(AccountingUnifiedSupplierOrderJd entity) {
        AccountingUnifiedSupplierOrderJd originEntity = accountingUnifiedSupplierOrderJdMapper.selectByPrimaryKey(entity.getId());
//		AssertUtil.notNull(originEntity);
        AnBeanUtils.copy(entity, originEntity);
        accountingUnifiedSupplierOrderJdMapper.updateByPrimaryKeySelective(originEntity);
    }

    @Override
    public void updateAccountingUnifiedSupplierOrderJdByPrimaryKeySelective(AccountingUnifiedSupplierOrderJd entity) {

        accountingUnifiedSupplierOrderJdMapper.updateByPrimaryKeySelective(entity);
    }

    @Override
    public void deleteAccountingUnifiedSupplierOrderJd(Long id) {
        accountingUnifiedSupplierOrderJdMapper.deleteByPrimaryKey(id);
    }

    @Override
    public int deleteByBatchId(String batchId) {

        if (StrUtil.isBlank(batchId)) {
            return 0;
        }

        AccountingUnifiedSupplierOrderJdExample          example  = new AccountingUnifiedSupplierOrderJdExample();
        AccountingUnifiedSupplierOrderJdExample.Criteria criteria = example.createCriteria();

        criteria
                .andBatchIdEqualTo(batchId);

        return accountingUnifiedSupplierOrderJdMapper.deleteByExample(example);
    }

    @Override
    public AccountingUnifiedSupplierOrderJd findAccountingUnifiedSupplierOrderJdById(Long id) {
        AccountingUnifiedSupplierOrderJd entity = accountingUnifiedSupplierOrderJdMapper.selectByPrimaryKey(id);
//		AssertUtil.notNull(entity);
        return entity;
    }

    @Override
    public R<List<AccountingUnifiedSupplierOrderJd>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize) {

        AccountingUnifiedSupplierOrderJdExample          example  = new AccountingUnifiedSupplierOrderJdExample();
        AccountingUnifiedSupplierOrderJdExample.Criteria criteria = example.createCriteria();

        // TODO 喜欢用Map 还是 Bean 自己喜欢... 后期添加 转 AccountingUnifiedSupplierOrderJdExample.Criteria
        // AccountingUnifiedSupplierOrderJd accountingUnifiedSupplierOrderJdConditions = AnBeanUtils.mapToBean(conditions,AccountingUnifiedSupplierOrderJd.class);

        PageHelper.startPage(pageNun, pageSize);
        List<AccountingUnifiedSupplierOrderJd>     resultList = accountingUnifiedSupplierOrderJdMapper.selectByExample(example);
        PageInfo<AccountingUnifiedSupplierOrderJd> page       = new PageInfo<AccountingUnifiedSupplierOrderJd>(resultList);
        PageHelper.clearPage();

        return new R<List<AccountingUnifiedSupplierOrderJd>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), resultList);

    }

    @Override
    public R<List<AccountingUnifiedSupplierOrderJdListItemVo>> pageQueryGenericParam(
            AccountingUnifiedSupplierOrderJdQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {

        PageHelper.startPage(queryCriteria.getPageNumber(), queryCriteria.getPageSize());
        List<AccountingUnifiedSupplierOrderJdListItemVo>     resultList = queryGenericParam(queryCriteria, loginSysUser);
        PageInfo<AccountingUnifiedSupplierOrderJdListItemVo> page       = new PageInfo<AccountingUnifiedSupplierOrderJdListItemVo>(resultList);
        PageHelper.clearPage();

        return new R<List<AccountingUnifiedSupplierOrderJdListItemVo>>(
                page.getPageNum(),
                page.getPageSize(),
                (int) page.getTotal(),
                resultList
        );

    }

    @Override
    public List<AccountingUnifiedSupplierOrderJdListItemVo> queryGenericParam(
            AccountingUnifiedSupplierOrderJdQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {

        log.info("{}", AnJsonUtils.toJson(queryCriteria));

        List<AccountingUnifiedSupplierOrderJdListItemVo> resultList = accountingUnifiedSupplierOrderJdMapperEx.pageQueryGenericParam(queryCriteria);

        additionalInfoQueryGenericParam(resultList);

        return resultList;
    }

    private void additionalInfoQueryGenericParam(List<AccountingUnifiedSupplierOrderJdListItemVo> resultList) {

        if (CollUtil.isEmpty(resultList)) {
            return;
        }

        for (AccountingUnifiedSupplierOrderJdListItemVo vo : resultList) {

            /**************************************** 补 start ****************************************/

            vo.setProcessResultName(ScheduleTaskProcessStateEnum.getDesc(vo.getProcessResult()));

        }

    }

    @Override
    public AccountingUnifiedSupplierOrderJdDetailStatisticsVo pageQueryHeadGenericParam(
            AccountingUnifiedSupplierOrderJdQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {

        return accountingUnifiedSupplierOrderJdMapperEx.pageQueryHeadGenericParam(queryCriteria);
    }

    @Override
    public AccountingUnifiedSupplierOrderJdUpperLevelsStatisticsVo statisticsQuantityDimOrderNormalOrException(
            AccountingUnifiedSupplierOrderJdQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {
        return accountingUnifiedSupplierOrderJdMapperEx.statisticsQuantityDimOrderNormalOrException(queryCriteria);
    }


    /****************************************** excel import start start ******************************************/

    @Override
    public SysNotify opImportExcelFullVersion(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            LoginSysUser loginSysUser) {

        String excelExportPathRoot             = resourceConstant.getPathRoot();
        String excelExportRelativePathTemplate = resourceConstant.getPathTemplate();
        String excelExportRelativePathStorage  = resourceConstant.getPathStorage();

        String targetFullPath = excelExportPathRoot + form.getTargetRelativePathAndFileName();

        ExcelReader excelReader = null;

        FileReader fileReader = new FileReader(targetFullPath);

        try {
            excelReader = EasyExcel.read(
                    fileReader.getInputStream(),
                    AccountingUnifiedSupplierOrderJdImportFullVersionExcelRow.class,
                    new ThirdPartJdReconciliationScheduleFullVersionExcelRowImportDataListener(
                            this,
                            form.getBatchId(),
                            loginSysUser
                    ))
                    .registerConverter(new CustomStringBigDecimalConverter())
                    .build();
            ReadSheet readSheet = EasyExcel
                    .readSheet(0)
                    .build();
            excelReader
                    .read(readSheet);

        } finally {

            if (excelReader != null) {
                // 这里千万别忘记关闭,读的时候会创建临时文件,到时磁盘会崩的
                excelReader.finish();
            }
        }

        return NotifyUtils.createSysNotify(
                "京东对账-对账任务-已执行导入程序",
                StrUtil.format("#对账单号 {}#", form.getBatchId()),
                SysQuartzScheduleTaskStatementOfAccountRunStateEnum.成功
        );

    }

    @Override
    public SysNotify opImportExcelLiteVersion(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            LoginSysUser loginSysUser) {

        String excelExportPathRoot             = resourceConstant.getPathRoot();
        String excelExportRelativePathTemplate = resourceConstant.getPathTemplate();
        String excelExportRelativePathStorage  = resourceConstant.getPathStorage();

        String targetFullPath = excelExportPathRoot + form.getTargetRelativePathAndFileName();

        ExcelReader excelReader = null;

        FileReader fileReader = new FileReader(targetFullPath);

        try {
            excelReader = EasyExcel.read(
                    fileReader.getInputStream(),
                    AccountingUnifiedSupplierOrderJdImportLiteVersionFacadeExcelRow.class,
                    new ThirdPartJdReconciliationScheduleLiteVersionExcelRowImportDataListener(
                            this,
                            form.getBatchId(),
                            loginSysUser
                    ))
//                    .registerConverter(new CustomStringBigDecimalConverter())
                    .headRowNumber(0)
                    .build();
            ReadSheet readSheet = EasyExcel
                    .readSheet(0)
                    .build();
            excelReader
                    .read(readSheet);

        } finally {

            if (excelReader != null) {
                // 这里千万别忘记关闭,读的时候会创建临时文件,到时磁盘会崩的
                excelReader.finish();
            }
        }

        return NotifyUtils.createSysNotify(
                "京东对账-对账任务-已执行导入程序",
                StrUtil.format("#对账单号 {}#", form.getBatchId()),
                SysQuartzScheduleTaskStatementOfAccountRunStateEnum.成功
        );

    }

    @Override
    public void saveOrUpdate4ThirdPartJdReconciliationScheduleFullVersionExcelRow(
            AccountingUnifiedSupplierOrderJdImportFullVersionExcelRow excelRow, LoginSysUser loginSysUser) {

        if (null == excelRow) {
            return;
        }

        AccountingUnifiedSupplierOrderJd entity = AnBeanUtils.copy(excelRow, AccountingUnifiedSupplierOrderJd.class);

        log.info("saveOrUpdate4ThirdPartJdReconciliationScheduleExcelRow\n{}\n{}", AnJsonUtils.toJson(excelRow), AnJsonUtils.toJson(entity));

        AccountingUnifiedSupplierOrderJd existDB = findByBatchIdAndJdOrderSn(entity.getBatchId(), entity.getJdOrderSn());

        if (ObjectUtil.isNull(existDB)) {
            insertSelective(entity);
        } else {
            entity.setId(existDB.getId());
            updateByPrimaryKeySelective(entity);
        }

    }

    @Override
    public void saveOrUpdate4ThirdPartJdReconciliationScheduleFullVersionExcelRowList(
            List<AccountingUnifiedSupplierOrderJdImportFullVersionExcelRow> excelRowList,
            LoginSysUser loginSysUser) {

        if (CollUtil.isEmpty(excelRowList)) {
            return;
        }

        excelRowList.forEach(excelRow -> {
            saveOrUpdate4ThirdPartJdReconciliationScheduleFullVersionExcelRow(excelRow, loginSysUser);
        });
    }

    @Override
    public int insertBatch4ThirdPartJdReconciliationScheduleFullVersionExcelRowList(
            List<AccountingUnifiedSupplierOrderJdImportFullVersionExcelRow> excelRowList,
            LoginSysUser loginSysUser) {

        if (CollUtil.isEmpty(excelRowList)) {
            return 0;
        }

        List<AccountingUnifiedSupplierOrderJd> processList = new ArrayList<>();

        excelRowList.forEach(excelRow -> {

            AccountingUnifiedSupplierOrderJd entity = AnBeanUtils.copy(excelRow, AccountingUnifiedSupplierOrderJd.class);
            processList.add(entity);

        });

        return insertBatch(processList);
    }

    @Override
    public int insertBatch(List<AccountingUnifiedSupplierOrderJd> processList) {

        if (CollUtil.isEmpty(processList)) {
            return 0;
        }

        return accountingUnifiedSupplierOrderJdMapperEx.insertBatch(processList);
    }

    @Override
    public int replaceBatch(List<AccountingUnifiedSupplierOrderJd> processList) {

        if (CollUtil.isEmpty(processList)) {
            return 0;
        }

        return accountingUnifiedSupplierOrderJdMapperEx.replaceBatch(processList);
    }


    /**
     * 货币 Validator.MONEY
     */
    public final static Pattern MONEY = Pattern.compile("^((?:\\-)?\\d+(?:\\.\\d+)?)$");

    @Override
    public void basisCheckUpForV2_5(AccountingUnifiedSupplierOrderJd entity) {

        /**************************************** 验证 start ****************************************/

        int result = 0;

//        Integer processResult = ScheduleTaskProcessStateEnum.导入中.getKey();

        if (StrUtil.isBlank(entity.getJdOrderAmountStr())) {
            result++;
            entity.setProcessReport("对账金额内容不能为空");
        } else if (!ReUtil.isMatch(MONEY, entity.getJdOrderAmountStr())) {
            result++;
            entity.setProcessReport("对账金额内容,系统无法识别");
        }

//        if (entity.getJdOrderAmount().compareTo(BigDecimal.ZERO) == 0) {
//            result++;
//            entity.setProcessReport("对账金额内容,系统无法识别");
//        }

        if (StrUtil.isBlank(entity.getJdOrderSn())) {
            result++;
            entity.setProcessReport("订单编号内容不能为空");
        } else if (AnChineseCharacterUtils.isChinese(entity.getJdOrderSn())) {
            result++;
            entity.setProcessReport("订单编号内容,系统无法识别");
        }

        if (result > 0) {
            entity.setProcessResult(ScheduleTaskProcessStateEnum.导入失败.getKey());
        } else {
            entity.setProcessResult(ScheduleTaskProcessStateEnum.导入成功.getKey());
        }

        /**************************************** 验证   end ****************************************/
    }

    /**
     * 精简版
     *
     * @param excelRow
     * @param loginSysUser
     */
    @Override
    public void saveOrUpdate4ThirdPartJdReconciliationScheduleLiteVersionExcelRow(
            AccountingUnifiedSupplierOrderJdImportLiteVersionExcelRow excelRow,
            LoginSysUser loginSysUser) {

        if (null == excelRow) {
            return;
        }

        AccountingUnifiedSupplierOrderJd entity = AnBeanUtils.copy(excelRow, AccountingUnifiedSupplierOrderJd.class);

        basisCheckUpForV2_5(entity);

        log.info("saveOrUpdate4ThirdPartJdReconciliationScheduleExcelRow\n{}\n{}",
                AnJsonUtils.toJson(excelRow),
                AnJsonUtils.toJson(entity)
        );

        AccountingUnifiedSupplierOrderJd existDB = findByBatchIdAndJdOrderSn(entity.getBatchId(), entity.getJdOrderSn());

        if (ObjectUtil.isNull(existDB)) {
            insertSelective(entity);
        } else {
            entity.setId(existDB.getId());
            updateByPrimaryKeySelective(entity);
        }

    }

    /**
     * 精简版
     *
     * @param excelRowList
     * @param loginSysUser
     */
    @Override
    public void saveOrUpdate4ThirdPartJdReconciliationScheduleLiteVersionExcelRowList(
            List<AccountingUnifiedSupplierOrderJdImportLiteVersionExcelRow> excelRowList,
            LoginSysUser loginSysUser) {

        if (CollUtil.isEmpty(excelRowList)) {
            return;
        }

        excelRowList.forEach(excelRow -> {
            saveOrUpdate4ThirdPartJdReconciliationScheduleLiteVersionExcelRow(excelRow, loginSysUser);
        });
    }

    @Override
    public int insertBatch4ThirdPartJdReconciliationScheduleLiteVersionExcelRowList(
            List<AccountingUnifiedSupplierOrderJdImportLiteVersionExcelRow> excelRowList,
            LoginSysUser loginSysUser) {

        if (CollUtil.isEmpty(excelRowList)) {
            return 0;
        }

        List<AccountingUnifiedSupplierOrderJd> processList = new ArrayList<>();

        excelRowList.forEach(excelRow -> {

            AccountingUnifiedSupplierOrderJd entity = AnBeanUtils.copy(excelRow, AccountingUnifiedSupplierOrderJd.class);

            basisCheckUpForV2_5(entity);

            processList.add(entity);

        });

        return insertBatch(processList);
    }

    /****************************************** excel import start   end ******************************************/

}