package cn.superdesk.uniorder.service.thirdpart.jd.impl;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.json.JSONUtil;
import cn.superdesk.uniorder.common.enums.common.CommonSourceFromEnum;
import cn.superdesk.uniorder.common.enums.scheduler.jd.ScheduleTaskAccountingStatusEnum;
import cn.superdesk.uniorder.common.enums.scheduler.jd.ScheduleTaskCheckStateEnum;
import cn.superdesk.uniorder.common.json.AnJsonUtils;
import cn.superdesk.uniorder.common.numerical.AnBeanUtils;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.accounting.unified.supplier.AccountingUnifiedSupplier;
import cn.superdesk.uniorder.dao.entity.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJd;
import cn.superdesk.uniorder.dto.param.accounting.unified.supplier.AccountingUnifiedSupplierCreateParamDimGoodsSelected;
import cn.superdesk.uniorder.dto.param.accounting.unified.supplier.AccountingUnifiedSupplierOpCreateParamDimGoods;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.AccountingUnifiedSupplierJdOpCreateParamDimGoodsSimulateSelectedDimGoods;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdOpCancelForm;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdOpConfirmForm;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdOpDeleteForm;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdListItemVo;
import cn.superdesk.uniorder.service.accounting.unified.supplier.AccountingUnifiedSupplierServiceOpCreateDimGoods;
import cn.superdesk.uniorder.service.accounting.unified.supplier.AccountingUnifiedSupplierServiceOpCreateDimOrder;
import cn.superdesk.uniorder.service.order.base.UnifiedOrderCreditService;
import cn.superdesk.uniorder.service.order.base.UnifiedOrderGoodsService;
import cn.superdesk.uniorder.service.order.base.UnifiedOrderService;
import cn.superdesk.uniorder.service.thirdpart.jd.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Description: 简易状态机 星型结构
 * @Author: linjinyu
 * @CreateDate: 10/12/20 4:28 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 10/12/20 4:28 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Service
public class SysQuartzScheduleTaskStatementOfAccountJdExOpPartServiceImpl implements SysQuartzScheduleTaskStatementOfAccountJdExOpPartService {

    @Autowired
    private SysQuartzScheduleTaskStatementOfAccountJdService           sysQuartzScheduleTaskStatementOfAccountJdService;
    @Autowired
    private AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsService accountingUnifiedSupplierOrderJdCheckUpReportXGoodsService;

    @Autowired
    private AccountingUnifiedSupplierOrderJdService              accountingUnifiedSupplierOrderJdService;
    @Autowired
    private AccountingUnifiedSupplierOrderJdCheckUpReportService accountingUnifiedSupplierOrderJdCheckUpReportService;

    @Autowired
    private AccountingUnifiedSupplierServiceOpCreateDimOrder accountingUnifiedSupplierServiceOpCreateDimOrder;
    @Autowired
    private AccountingUnifiedSupplierServiceOpCreateDimGoods accountingUnifiedSupplierServiceOpCreateDimGoods;


    @Autowired
    private UnifiedOrderService       unifiedOrderService;
    @Autowired
    private UnifiedOrderGoodsService  unifiedOrderGoodsService;
    @Autowired
    private UnifiedOrderCreditService unifiedOrderCreditService;


    @Override
    public int opDelete(
            SysQuartzScheduleTaskStatementOfAccountJdOpDeleteForm form,
            LoginSysUser loginSysUser) {


        StringBuffer report = new StringBuffer();

        int ret = 0;

        SysQuartzScheduleTaskStatementOfAccountJdListItemVo itemVo = sysQuartzScheduleTaskStatementOfAccountJdService
                .getListItemVoByBatchId(
                        form.getBatchId(),
                        loginSysUser
                );
        report.append("\n******************************************************");
        report.append(StrUtil.format("\n{}", JSONUtil.toJsonStr(itemVo)));

        if (ObjectUtil.isNull(itemVo)) {
            report.append("\n******************************************************");
            log.info("{}", report.toString());
            return 0;
        }


        // 先解锁(订单 商品 作用->供应商对账状态(@link CommonAccountingStateEnum 4-已锁定 -> 2-未对账)) // , CommonAccountingStateEnum.未对账
        int ret000 = accountingUnifiedSupplierOrderJdCheckUpReportXGoodsService.unLockXByBatchId(form.getBatchId());
        int ret001 = 0;
        int ret002 = 0;
        int ret003 = 0;

//        if (ret000 > 0) {}
        // 删除
        ret001 = sysQuartzScheduleTaskStatementOfAccountJdService.deleteSysQuartzScheduleTaskStatementOfAccountJd(form.getSysQuartzScheduleTaskStatementOfAccountJdId(), loginSysUser);
        ret002 = accountingUnifiedSupplierOrderJdService.deleteByBatchId(form.getBatchId());
        ret003 = accountingUnifiedSupplierOrderJdCheckUpReportService.deleteByBatchId(form.getBatchId());


        report.append(StrUtil.format("\n解锁-关系{}", ret000));
        report.append(StrUtil.format("\n删除-任务{}", ret001));
        report.append(StrUtil.format("\n删除-导入{}", ret002));
        report.append(StrUtil.format("\n删除-报告{}", ret003));

        if (ret001 > 0) {
            ret++;
        }
        if (ret002 > 0) {
            ret++;
        }
        if (ret003 > 0) {
            ret++;
        }

        report.append("\n******************************************************");
        log.info("{}", report.toString());

        return ret;
    }

    @Override
    public int opCancel(
            SysQuartzScheduleTaskStatementOfAccountJdOpCancelForm form,
            LoginSysUser loginSysUser) {

        StringBuffer report = new StringBuffer();

        int      ret = 0;
        DateTime now = DateUtil.date();

        SysQuartzScheduleTaskStatementOfAccountJdListItemVo itemVo = sysQuartzScheduleTaskStatementOfAccountJdService
                .getListItemVoByBatchId(
                        form.getBatchId(),
                        loginSysUser
                );

        report.append("\n******************************************************");
        report.append(StrUtil.format("\n{}", JSONUtil.toJsonStr(itemVo)));

        if (ObjectUtil.isNull(itemVo)) {
            report.append("\n******************************************************");
            log.info("{}", report.toString());
            return 0;
        }

        // 先解锁(订单 商品 作用->供应商对账状态(@link CommonAccountingStateEnum 4-已锁定 -> 2-未对账)) // , CommonAccountingStateEnum.未对账
        int ret000 = accountingUnifiedSupplierOrderJdCheckUpReportXGoodsService.unLockXByBatchId(form.getBatchId());
        int ret001 = 0;
        int ret002 = 0;
        int ret003 = 0;

//        if (ret000 > 0) {
//
//        }

        // mark by linjinyu at 2022-06-23 11:43:35 - 最终还是得加 对账状态 已取消
        ret001 = sysQuartzScheduleTaskStatementOfAccountJdService.updateByPrimaryKeySelective(
                SysQuartzScheduleTaskStatementOfAccountJd
                        .builder()
                        .id(form.getSysQuartzScheduleTaskStatementOfAccountJdId())

                        .accountingStatus(ScheduleTaskAccountingStatusEnum.已取消.getKey())

                        .updateTime(now)
                        .updateUserId(loginSysUser.getSysUserId())

                        .build()

        );
        // 删除
        ret002 = accountingUnifiedSupplierOrderJdService.deleteByBatchId(form.getBatchId());
        ret003 = accountingUnifiedSupplierOrderJdCheckUpReportService.deleteByBatchId(form.getBatchId());

        report.append(StrUtil.format("\n解锁-关系{}", ret000));
        report.append(StrUtil.format("\n更新-任务{}", ret001));
        report.append(StrUtil.format("\n删除-导入{}", ret002));
        report.append(StrUtil.format("\n删除-报告{}", ret003));


        if (ret001 > 0) {
            ret++;
        }
        if (ret002 > 0) {
            ret++;
        }
        if (ret003 > 0) {
            ret++;
        }

        report.append("\n******************************************************");
        log.info("{}", report.toString());

        return ret;
    }

    @Override
    public int opConfirm(
            SysQuartzScheduleTaskStatementOfAccountJdOpConfirmForm form,
            LoginSysUser loginSysUser) {

        int      ret = 0;
        DateTime now = DateUtil.date();

        log.info("{}", AnJsonUtils.toJson(form));

        SysQuartzScheduleTaskStatementOfAccountJdListItemVo itemVo = sysQuartzScheduleTaskStatementOfAccountJdService
                .getListItemVoByBatchId(
                        form.getBatchId(),
                        loginSysUser
                );

        if (ObjectUtil.isNull(itemVo)) {
            return 0;
        }

        /****************************************** 模拟创建 供应商结算-对账单 start ******************************************/

        // 模拟选商品 ******************************************

        /**
         * TODO mark by linjinyu at 2022-06-22 18:52:01 - 目前要求订单商品维度-此方案是错的
         * 用此表记录的 -accounting_unified_supplier_order_jd_check_up_report_x_goods

         List<AccountingUnifiedSupplierJdOpCreateParamDimGoodsSimulateSelectedDimOrder> simulateGoodsSelected = new ArrayList<>();
         simulateGoodsSelected = accountingUnifiedSupplierOrderJdCheckUpReportService.findUnifiedSupplierCreateDimGoodsParam(
         AccountingUnifiedSupplierOrderJdCheckUpReportTaskQueryCriteria
         .builder()
         .batchId(form.getBatchId())
         .processResult(CommonProcessResultEnum.正常.getKey())
         .build()
         );

         List<AccountingUnifiedSupplierCreateParamDimGoodsSelected> simulateGoodsSelected =
         AnBeanUtils.copy(simulateGoodsSelected, AccountingUnifiedSupplierCreateParamDimGoodsSelected.class);
         */

        List<AccountingUnifiedSupplierJdOpCreateParamDimGoodsSimulateSelectedDimGoods> simulateGoodsSelected = accountingUnifiedSupplierOrderJdCheckUpReportXGoodsService
                .simulateGoodsSelected(
                        form.getBatchId(),
                        ScheduleTaskCheckStateEnum.正常.getKey()
                );

        List<AccountingUnifiedSupplierCreateParamDimGoodsSelected> simulateGoodsSelectedTransformation =
                AnBeanUtils.copy(simulateGoodsSelected, AccountingUnifiedSupplierCreateParamDimGoodsSelected.class);

        // 模拟填表单 ******************************************
        AccountingUnifiedSupplierOpCreateParamDimGoods opCreateParamDimGoods = new AccountingUnifiedSupplierOpCreateParamDimGoods();
        opCreateParamDimGoods.setSpecialHandle(886);// 京东的特殊处理
        opCreateParamDimGoods.setSourceFrom(CommonSourceFromEnum.结算中心.getSourceFromCode());
        opCreateParamDimGoods.setStartTime(DateUtil.formatDateTime(itemVo.getCycleBeginTime()));// yyyy-MM-dd HH:mm:ss
        opCreateParamDimGoods.setEndTime(DateUtil.formatDateTime(itemVo.getCycleEndTime()));// yyyy-MM-dd HH:mm:ss
        opCreateParamDimGoods.setGoodsSelected(simulateGoodsSelectedTransformation);

        // 模拟提交 ******************************************
        R<AccountingUnifiedSupplier> response = accountingUnifiedSupplierServiceOpCreateDimGoods
                .opCreateAccountingDimGoodsPreProcess(opCreateParamDimGoods, loginSysUser);

        /****************************************** 模拟创建 供应商结算-对账单   end ******************************************/


        /****************************************  start ****************************************/

        SysQuartzScheduleTaskStatementOfAccountJd forUpdate = new SysQuartzScheduleTaskStatementOfAccountJd();
        forUpdate.setId(form.getSysQuartzScheduleTaskStatementOfAccountJdId());

        if (ObjectUtil.isNotNull(response.getData())) {

            ret = 1;

            // TODO 更新状态逻辑...
            forUpdate.setAccountingOrderSn(response.getData().getAccountingOrderSn());
//            forUpdate.setAccountingStatus(CommonAuditStatusEnum.已确认.getKey());

        }
        // 创建对账单 异常
        else {

            forUpdate.setAccountingOrderSn(null);
            forUpdate.setRemark("op确认账单-生成对账单异常");
//            forUpdate.setAccountingStatus(CommonAuditStatusEnum.已取消.getKey());

            // TODO mark by linjinyu at 2022-06-167 05:09:49 - 记录 异常
        }

        forUpdate.setUpdateTime(now);
        forUpdate.setUpdateUserId(loginSysUser.getSysUserId());

        sysQuartzScheduleTaskStatementOfAccountJdService.updateByPrimaryKeySelective(forUpdate);

        /****************************************    end ****************************************/

        return ret;
    }
}
