package cn.superdesk.uniorder.service.thirdpart.jd.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.date.DatePattern;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.json.JSONUtil;
import cn.superdesk.uniorder.common.enums.accounting.supplier.AccountingOrderSupplierAccountingStatusEnum;
import cn.superdesk.uniorder.common.enums.common.CommonServiceNoEnum;
import cn.superdesk.uniorder.common.enums.common.CommonSourceFromEnum;
import cn.superdesk.uniorder.common.enums.invoice.supplier.InvoiceApplySupplierInvoiceProgressingStatusEnum;
import cn.superdesk.uniorder.common.enums.invoice.supplier.InvoiceApplySupplierPayOffAccountStatusEnum;
import cn.superdesk.uniorder.common.enums.scheduler.jd.ScheduleTaskAccountingStatusEnum;
import cn.superdesk.uniorder.common.enums.scheduler.jd.ScheduleTaskCheckStateEnum;
import cn.superdesk.uniorder.common.enums.scheduler.jd.ScheduleTaskProcessStateEnum;
import cn.superdesk.uniorder.common.enums.scheduler.jd.ScheduleTaskRunStatusEnum;
import cn.superdesk.uniorder.common.lamda.AnLamdaUtils;
import cn.superdesk.uniorder.common.numerical.AnBeanUtils;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.organisation.UnifiedSupplier;
import cn.superdesk.uniorder.dao.entity.sys.SysUser;
import cn.superdesk.uniorder.dao.entity.sys.notify.SysNotify;
import cn.superdesk.uniorder.dao.entity.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJd;
import cn.superdesk.uniorder.dao.entity.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdExample;
import cn.superdesk.uniorder.dao.mapper.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdMapper;
import cn.superdesk.uniorder.dao.mapper.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdMapperEx;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.*;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.*;
import cn.superdesk.uniorder.service.organisation.SysSupplierService;
import cn.superdesk.uniorder.service.sys.SysUserService;
import cn.superdesk.uniorder.service.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportService;
import cn.superdesk.uniorder.service.thirdpart.jd.AccountingUnifiedSupplierOrderJdService;
import cn.superdesk.uniorder.service.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StopWatch;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @Description: 定时任务-时刻任务-对账单
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-10-12 11:29:24
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-10-12 11:29:24
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Service
public class SysQuartzScheduleTaskStatementOfAccountJdServiceImpl implements SysQuartzScheduleTaskStatementOfAccountJdService {

    @Autowired
    private SysQuartzScheduleTaskStatementOfAccountJdMapper   sysQuartzScheduleTaskStatementOfAccountJdMapper;
    @Autowired
    private SysQuartzScheduleTaskStatementOfAccountJdMapperEx sysQuartzScheduleTaskStatementOfAccountJdMapperEx;

    @Autowired
    private AccountingUnifiedSupplierOrderJdService              accountingUnifiedSupplierOrderJdService;
    @Autowired
    private AccountingUnifiedSupplierOrderJdCheckUpReportService accountingUnifiedSupplierOrderJdCheckUpReportService;

    @Autowired
    private SysUserService     sysUserService;
    @Autowired
    private SysSupplierService sysSupplierService;


    /****************************************** extends BaseService 部分 start ******************************************/

    @Override
    public int insertSelective(SysQuartzScheduleTaskStatementOfAccountJd entity) {
        return sysQuartzScheduleTaskStatementOfAccountJdMapper.insertSelective(entity);
    }

    @Override
    public int updateByPrimaryKeySelective(SysQuartzScheduleTaskStatementOfAccountJd entity) {
        return sysQuartzScheduleTaskStatementOfAccountJdMapper.updateByPrimaryKeySelective(entity);
    }

    @Override
    public int updateByBatchIdSelective(SysQuartzScheduleTaskStatementOfAccountJd entity) {

        SysQuartzScheduleTaskStatementOfAccountJdExample          example  = new SysQuartzScheduleTaskStatementOfAccountJdExample();
        SysQuartzScheduleTaskStatementOfAccountJdExample.Criteria criteria = example.createCriteria();

        criteria
                .andBatchIdEqualTo(entity.getBatchId());

        return sysQuartzScheduleTaskStatementOfAccountJdMapper.updateByExampleSelective(entity, example);

    }

    @Override
    public void deleteObj(Long id) {
    }

    @Override
    public SysQuartzScheduleTaskStatementOfAccountJd findById(Long id) {
        return sysQuartzScheduleTaskStatementOfAccountJdMapper.selectByPrimaryKey(id);
    }


    @Override
    public SysQuartzScheduleTaskStatementOfAccountJd findByBatchId(String batchId) {

        SysQuartzScheduleTaskStatementOfAccountJdExample          example  = new SysQuartzScheduleTaskStatementOfAccountJdExample();
        SysQuartzScheduleTaskStatementOfAccountJdExample.Criteria criteria = example.createCriteria();

        criteria.andBatchIdEqualTo(batchId);

        List<SysQuartzScheduleTaskStatementOfAccountJd> resultList = sysQuartzScheduleTaskStatementOfAccountJdMapper.selectByExample(example);

        if (CollUtil.isNotEmpty(resultList)) {
            return resultList.get(0);
        } else {
            return null;
        }

    }

    @Override
    public PageInfo<SysQuartzScheduleTaskStatementOfAccountJd> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize) {
        return null;
    }

    @Override
    public List<SysQuartzScheduleTaskStatementOfAccountJd> findAll(Map<String, Object> queryMap) {
        return null;
    }

    /****************************************** extends BaseService 部分   end ******************************************/


    @Override
    public int addSysQuartzScheduleTaskStatementOfAccountJd(SysQuartzScheduleTaskStatementOfAccountJdParam param, LoginSysUser loginSysUser) {

        /**************************************** 初始化 start ****************************************/

        DateTime now = DateUtil.date();

        SysQuartzScheduleTaskStatementOfAccountJd forInsertEntity = new SysQuartzScheduleTaskStatementOfAccountJd();
        AnBeanUtils.copy(param, forInsertEntity);

        forInsertEntity.setCreateTime(now);
        forInsertEntity.setCreateUserId(loginSysUser.getSysUserId());

        forInsertEntity.setUpdateTime(now);
        forInsertEntity.setUpdateUserId(loginSysUser.getSysUserId());

        /**************************************** 初始化   end ****************************************/

        /**************************************** 供应商信息 start ****************************************/

        Map<Long, UnifiedSupplier> sysSupplierMap = sysSupplierService.convertOutSaleIds2MapOutSaleId2Entity(Arrays.asList(param.getOutMerchantId()));

        if (sysSupplierMap.get(param.getOutMerchantId()) != null) {
            forInsertEntity.setServiceNo(sysSupplierMap.get(param.getOutMerchantId()).getServiceNo());
        } else {
            forInsertEntity.setServiceNo("");
        }

        /**************************************** 供应商信息   end ****************************************/

        return sysQuartzScheduleTaskStatementOfAccountJdMapper.insertSelective(forInsertEntity);
    }

    @Override
    public int updateSysQuartzScheduleTaskStatementOfAccountJd(SysQuartzScheduleTaskStatementOfAccountJdParam param, LoginSysUser loginSysUser) {

        SysQuartzScheduleTaskStatementOfAccountJd originEntity = sysQuartzScheduleTaskStatementOfAccountJdMapper.selectByPrimaryKey(param.getId());
        // AssertUtil.notNull(originEntity);
        if (ObjectUtil.isNull(originEntity)) {
            return 0;
        }

        DateTime now = DateUtil.date();

        SysQuartzScheduleTaskStatementOfAccountJd forUpdateEntity = new SysQuartzScheduleTaskStatementOfAccountJd();
        AnBeanUtils.copy(param, forUpdateEntity);

        forUpdateEntity.setId(originEntity.getId());
        forUpdateEntity.setUpdateTime(now);
        forUpdateEntity.setUpdateUserId(loginSysUser.getSysUserId());

        return sysQuartzScheduleTaskStatementOfAccountJdMapper.updateByPrimaryKeySelective(forUpdateEntity);
    }

    @Override
    public int deleteSysQuartzScheduleTaskStatementOfAccountJd(Long id, LoginSysUser loginSysUser) {
        DateTime now = DateUtil.date();
        return sysQuartzScheduleTaskStatementOfAccountJdMapper.deleteByPrimaryKey(id);
    }


    @Override
    public SysQuartzScheduleTaskStatementOfAccountJdListItemVo findListItemVoById(Long id, LoginSysUser loginSysUser) {

        List<SysQuartzScheduleTaskStatementOfAccountJdListItemVo> resultList = queryGenericParam(
                SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria
                        .builder()
                        .sysQuartzScheduleTaskStatementOfAccountJdId(id)
                        .build(),
                loginSysUser);

        if (CollUtil.isNotEmpty(resultList)) {
            return resultList.get(0);
        } else {
            return null;
        }
    }

    @Override
    public SysQuartzScheduleTaskStatementOfAccountJdListItemVo findListItemVoByBatchId(String batchId, LoginSysUser loginSysUser) {
        List<SysQuartzScheduleTaskStatementOfAccountJdListItemVo> resultList = queryGenericParam(
                SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria
                        .builder()
                        .batchId(batchId)
                        .build(),
                loginSysUser);

        if (CollUtil.isNotEmpty(resultList)) {
            return resultList.get(0);
        } else {
            return null;
        }
    }

    @Override
    public R<List<SysQuartzScheduleTaskStatementOfAccountJd>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize) {

        SysQuartzScheduleTaskStatementOfAccountJdExample          example  = new SysQuartzScheduleTaskStatementOfAccountJdExample();
        SysQuartzScheduleTaskStatementOfAccountJdExample.Criteria criteria = example.createCriteria();

        // TODO 喜欢用Map 还是 Bean 自己喜欢... 后期添加 转 SysQuartzScheduleTaskStatementOfAccountJdExample.Criteria
        // SysQuartzScheduleTaskStatementOfAccountJd sysQuartzScheduleTaskStatementOfAccountJdConditions = AnBeanUtils.mapToBean(conditions,SysQuartzScheduleTaskStatementOfAccountJd.class);

        PageHelper.startPage(pageNun, pageSize);
        List<SysQuartzScheduleTaskStatementOfAccountJd>     resultList = sysQuartzScheduleTaskStatementOfAccountJdMapper.selectByExample(example);
        PageInfo<SysQuartzScheduleTaskStatementOfAccountJd> page       = new PageInfo<SysQuartzScheduleTaskStatementOfAccountJd>(resultList);
        PageHelper.clearPage();

        return new R<List<SysQuartzScheduleTaskStatementOfAccountJd>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), resultList);

    }

    @Override
    public R<List<SysQuartzScheduleTaskStatementOfAccountJdListItemVo>> pageQueryGenericParam(
            SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {


        PageHelper.startPage(queryCriteria.getPageNumber(), queryCriteria.getPageSize());
        List<SysQuartzScheduleTaskStatementOfAccountJdListItemVo>     resultList = queryGenericParam(queryCriteria, loginSysUser);
        PageInfo<SysQuartzScheduleTaskStatementOfAccountJdListItemVo> page       = new PageInfo<SysQuartzScheduleTaskStatementOfAccountJdListItemVo>(resultList);
        PageHelper.clearPage();

        return new R<List<SysQuartzScheduleTaskStatementOfAccountJdListItemVo>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), resultList);

    }

    @Override
    public SysQuartzScheduleTaskStatementOfAccountJdHeadVo queryHeadGenericParam(
            SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {

        return sysQuartzScheduleTaskStatementOfAccountJdMapperEx.queryHeadGenericParam(queryCriteria);
    }

    @Override
    public List<SysQuartzScheduleTaskStatementOfAccountJdListItemVo> queryGenericParam(
            SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria queryCriteria,
            LoginSysUser loginSysUser) {

        List<SysQuartzScheduleTaskStatementOfAccountJdListItemVo> resultList = sysQuartzScheduleTaskStatementOfAccountJdMapperEx.queryGenericParam(queryCriteria);

        additionalInfoQueryGenericParam(resultList);

        return resultList;
    }

    private void additionalInfoQueryGenericParam(List<SysQuartzScheduleTaskStatementOfAccountJdListItemVo> resultList) {

        if (CollUtil.isEmpty(resultList)) {
            return;
        }

        /**************************************** 操作人 start ****************************************/

        List<Long> sysUserIds = new ArrayList<>();

        List<Long> createUserIds = resultList.stream().filter(o -> o.getCreateUserId() != null).filter(AnLamdaUtils.distinctByKey(o -> o.getCreateUserId())).map(o -> o.getCreateUserId()).collect(Collectors.toList());
        List<Long> updateUserIds = resultList.stream().filter(o -> o.getUpdateUserId() != null).filter(AnLamdaUtils.distinctByKey(o -> o.getUpdateUserId())).map(o -> o.getUpdateUserId()).collect(Collectors.toList());

        sysUserIds.addAll(createUserIds);
        sysUserIds.addAll(updateUserIds);
        sysUserIds = sysUserIds
                .stream()
                .distinct()
                .collect(Collectors.toList());

        log.info("\n{}", JSONUtil.toJsonStr(sysUserIds));
        Map<Long, SysUser> sysUserMap = sysUserService.convertSysUserIds2MapSysUserId2Entity(sysUserIds);

        /**************************************** 操作人 start ****************************************/

        List<Long> outSaleIds = new ArrayList<>();

        List<Long> outMerchantIds = resultList.stream().filter(o -> o.getOutMerchantId() != null).filter(AnLamdaUtils.distinctByKey(o -> o.getOutMerchantId())).map(o -> o.getOutMerchantId()).collect(Collectors.toList());

        outSaleIds.addAll(outMerchantIds);
        outSaleIds = outSaleIds
                .stream()
                .distinct()
                .collect(Collectors.toList());

        Map<Long, UnifiedSupplier> sysSupplierMap = sysSupplierService.convertOutSaleIds2MapOutSaleId2Entity(outSaleIds);

        for (SysQuartzScheduleTaskStatementOfAccountJdListItemVo vo : resultList) {

            /**************************************** 补 start ****************************************/

            vo.setProcessStateName(ScheduleTaskProcessStateEnum.getDesc(vo.getProcessState()));
            vo.setAccountingStatusName(ScheduleTaskAccountingStatusEnum.getDesc(vo.getAccountingStatus()));
            vo.setCheckStateName(ScheduleTaskCheckStateEnum.getDesc(vo.getCheckState()));

            if (ObjectUtil.isNotNull(vo.getAusuAccountingStatus())) {
                vo.setAusuAccountingStatusName(AccountingOrderSupplierAccountingStatusEnum.getDesc(vo.getAusuAccountingStatus()));
            } else {
                vo.setAusuAccountingStatus(AccountingOrderSupplierAccountingStatusEnum.未确认.getKey());
                vo.setAusuAccountingStatusName(AccountingOrderSupplierAccountingStatusEnum.未确认.getDesc());
            }
            if (ObjectUtil.isNotNull(vo.getAusuInvoiceStatus())) {
                vo.setAusuInvoiceStatusName(InvoiceApplySupplierInvoiceProgressingStatusEnum.getDesc(vo.getAusuInvoiceStatus()));
            } else {
                vo.setAusuInvoiceStatus(InvoiceApplySupplierInvoiceProgressingStatusEnum.未申请.getKey());
                vo.setAusuInvoiceStatusName(InvoiceApplySupplierInvoiceProgressingStatusEnum.未申请.getDesc());
            }
            if (ObjectUtil.isNotNull(vo.getAusuBackAccountStatus())) {
                vo.setAusuBackAccountStatusName(InvoiceApplySupplierPayOffAccountStatusEnum.getDesc(vo.getAusuBackAccountStatus()));
            } else {

                vo.setAusuBackAccountStatus(InvoiceApplySupplierPayOffAccountStatusEnum.待付款.getKey());
                vo.setAusuBackAccountStatusName(InvoiceApplySupplierPayOffAccountStatusEnum.待付款.getDesc());
//                vo.setAusuBackAccountStatusName("未付款");
            }


            /**************************************** 补-供应商 start ****************************************/

            if (ObjectUtil.isNotNull(sysSupplierMap.get(vo.getOutMerchantId()))) {
                vo.setSaleName(sysSupplierMap.get(vo.getOutMerchantId()).getSaleName());
                vo.setSourceFrom(sysSupplierMap.get(vo.getOutMerchantId()).getSourceFrom());
                vo.setSourceFromName(CommonSourceFromEnum.getBySourceFromCode(sysSupplierMap.get(vo.getOutMerchantId()).getSourceFrom()).getSourceFromName());
            }

            /**************************************** 补-时间 start ****************************************/

//            CHINESE_DATE_PATTERN = "yyyy年MM月dd日";
//            CHINESE_DATE_TIME_PATTERN = "yyyy年MM月dd日HH时mm分ss秒";
//            NORM_DATE_PATTERN = "yyyy-MM-dd";
//            NORM_DATETIME_PATTERN = "yyyy-MM-dd HH:mm:ss";

            if (ObjectUtil.isNotNull(vo.getRunTime())) {
                vo.setRunTimeFormat(DateUtil.date(vo.getRunTime()).toString(DatePattern.NORM_DATETIME_PATTERN));
            }
            if (ObjectUtil.isNotNull(vo.getProcessTime())) {
                vo.setProcessTimeFormat(DateUtil.date(vo.getProcessTime()).toString(DatePattern.NORM_DATETIME_PATTERN));
            }
            if (ObjectUtil.isNotNull(vo.getAccountingTime())) {
                vo.setAccountingTimeFormat(DateUtil.date(vo.getAccountingTime()).toString(DatePattern.NORM_DATETIME_PATTERN));
            }
            if (ObjectUtil.isNotNull(vo.getCheckTime())) {
                vo.setCheckTimeFormat(DateUtil.date(vo.getCheckTime()).toString(DatePattern.NORM_DATETIME_PATTERN));
            }
            if (ObjectUtil.isNotNull(vo.getFinishTime())) {
                vo.setFinishTimeFormat(DateUtil.date(vo.getFinishTime()).toString(DatePattern.NORM_DATETIME_PATTERN));
            }

            if (ObjectUtil.isNotNull(vo.getCycleBeginTime())) {
                vo.setCycleBeginTimeFormat(DateUtil.date(vo.getCycleBeginTime()).toString(DatePattern.NORM_DATE_PATTERN));
            }
            if (ObjectUtil.isNotNull(vo.getCycleEndTime())) {
                vo.setCycleEndTimeFormat(DateUtil.date(vo.getCycleEndTime()).toString(DatePattern.NORM_DATE_PATTERN));
            }

            if (ObjectUtil.isNotNull(vo.getCreateTime())) {
                vo.setCreateTimeFormat(DateUtil.date(vo.getCreateTime()).toString(DatePattern.NORM_DATETIME_PATTERN));
            }
            if (ObjectUtil.isNotNull(vo.getUpdateTime())) {
                vo.setUpdateTimeFormat(DateUtil.date(vo.getUpdateTime()).toString(DatePattern.NORM_DATETIME_PATTERN));
            }

            /**************************************** 补-来源 start ****************************************/

            if (ObjectUtil.isNotNull(vo.getServiceNo())) {
                vo.setServiceNoName(CommonServiceNoEnum.getByServiceNo(vo.getServiceNo()).getServiceName());
            } else {
                vo.setServiceNoName(CommonServiceNoEnum.UNKNOW.getServiceName());
            }

            if (ObjectUtil.isNotNull(vo.getSourceFrom())) {
                vo.setSourceFromName(CommonSourceFromEnum.getBySourceFromCode(vo.getSourceFrom()).getSourceFromName());
            } else {
                vo.setSourceFromName(CommonSourceFromEnum.UNKNOW.getSourceFromName());
            }

            /**************************************** 补-操作人 start ****************************************/

            if (ObjectUtil.isNotNull(sysUserMap.get(vo.getCreateUserId()))) {
                vo.setCreateUserName(sysUserMap.get(vo.getCreateUserId()).getFullname());
            }
            if (ObjectUtil.isNotNull(sysUserMap.get(vo.getUpdateUserId()))) {
                vo.setUpdateUserName(sysUserMap.get(vo.getUpdateUserId()).getFullname());
            }

        }

    }

    @Override
    public SysQuartzScheduleTaskStatementOfAccountJdListItemVo getListItemVoByBatchId(String batchId, LoginSysUser loginSysUser) {

        List<SysQuartzScheduleTaskStatementOfAccountJdListItemVo> resultList = queryGenericParam(
                SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria
                        .builder()
                        .batchId(batchId)
                        .build(),
                loginSysUser
        );

        if (CollUtil.isNotEmpty(resultList)) {
            return resultList.get(0);
        } else {
            return null;
        }
    }


    /**************************************** 任务牵引方法 懒得做状态机 start ****************************************/

    @Override
    public int towImportExcel(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            ScheduleTaskRunStatusEnum runStatusEnum,
            ScheduleTaskProcessStateEnum processStateEnum,
            LoginSysUser loginSysUser) {

        DateTime now = DateUtil.date();

        SysQuartzScheduleTaskStatementOfAccountJd existDb = findByBatchId(form.getBatchId());

        return sysQuartzScheduleTaskStatementOfAccountJdMapper.updateByPrimaryKeySelective(
                SysQuartzScheduleTaskStatementOfAccountJd
                        .builder()

                        .id(existDb.getId())

                        .runState(runStatusEnum.getKey())

                        .processState(processStateEnum.getKey())
                        .processTime(now)

                        .updateTime(now)

                        .build()
        );

    }

    @Override
    public int towCompareOrderAndCheckUpThenReport(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            ScheduleTaskRunStatusEnum runStatusEnum,
            ScheduleTaskAccountingStatusEnum accountingStatusEnum,
            LoginSysUser loginSysUser) {

        DateTime now = DateUtil.date();

        SysQuartzScheduleTaskStatementOfAccountJd existDb = findByBatchId(form.getBatchId());

        return sysQuartzScheduleTaskStatementOfAccountJdMapper.updateByPrimaryKeySelective(
                SysQuartzScheduleTaskStatementOfAccountJd
                        .builder()

                        .id(existDb.getId())

                        .runState(runStatusEnum.getKey())

                        .accountingStatus(accountingStatusEnum.getKey())
                        .accountingTime(now)

                        .updateTime(now)

                        .build()
        );

    }

    @Override
    public int towCompareOrderAndCheckUpThenReportThrowException(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            ScheduleTaskRunStatusEnum runStatusEnum,
            ScheduleTaskAccountingStatusEnum accountingStatusEnum,
            ScheduleTaskCheckStateEnum checkStateEnum,
            LoginSysUser loginSysUser) {

        DateTime now = DateUtil.date();

        SysQuartzScheduleTaskStatementOfAccountJd existDb = findByBatchId(form.getBatchId());

        return sysQuartzScheduleTaskStatementOfAccountJdMapper.updateByPrimaryKeySelective(
                SysQuartzScheduleTaskStatementOfAccountJd
                        .builder()

                        .id(existDb.getId())

                        .runState(runStatusEnum.getKey())

                        .accountingStatus(accountingStatusEnum.getKey())
                        .accountingTime(now)

                        .updateTime(now)

                        .checkState(checkStateEnum.getKey())

                        .build()
        );

    }

    @Override
    public SysQuartzScheduleTaskStatementOfAccountJdListItemVo deQueueOneImportExcel(LoginSysUser loginSysUser) {

        // 默认长这样
        SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria queryCriteria = SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria
                .builder()

                .runState(ScheduleTaskRunStatusEnum.待导入.getKey())
                .processState(ScheduleTaskProcessStateEnum.导入中.getKey())

                .orderByClause("sqstsofaj.create_time ASC")

                .build();


        List<SysQuartzScheduleTaskStatementOfAccountJdListItemVo> resultList = queryGenericParam(queryCriteria, loginSysUser);

        if (CollUtil.isNotEmpty(resultList)) {
            return resultList.get(0);
        } else {
            return null;
        }
    }

    @Override
    public SysQuartzScheduleTaskStatementOfAccountJdListItemVo deQueueOneCompareOrderAndCheckUpThenReport(LoginSysUser loginSysUser) {

        List<SysQuartzScheduleTaskStatementOfAccountJdListItemVo> resultList = queryGenericParam(
                SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria
                        .builder()

                        .runState(ScheduleTaskRunStatusEnum.已导入.getKey())
                        .processState(ScheduleTaskProcessStateEnum.导入成功.getKey())
                        .accountingStatus(ScheduleTaskAccountingStatusEnum.待对账.getKey())

                        .orderByClause("sqstsofaj.create_time ASC")

                        .build(),
                loginSysUser
        );

        if (CollUtil.isNotEmpty(resultList)) {
            return resultList.get(0);
        } else {
            return null;
        }
    }

    /**************************************** 任务牵引方法 懒得做状态机   end ****************************************/

    /**************************************** 任务调度方法 start ****************************************/


    @Override
    public SysNotify dispatcherExcelImportFullVersion(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            LoginSysUser loginSysUser) {

        DateTime now = DateUtil.date();

        StopWatch stopWatch = new StopWatch();
        stopWatch.start(form.getBatchId());

        towImportExcel(
                form,
                ScheduleTaskRunStatusEnum.导入中,
                ScheduleTaskProcessStateEnum.导入中,
                loginSysUser);

        SysNotify sysNotify = accountingUnifiedSupplierOrderJdService.opImportExcelFullVersion(form, loginSysUser);

        // 统计
        AccountingUnifiedSupplierOrderJdUpperLevelsStatisticsVo detailStatisticsVo =
                accountingUnifiedSupplierOrderJdService.statisticsQuantityDimOrderNormalOrException(
                        AccountingUnifiedSupplierOrderJdQueryCriteria
                                .builder()

                                .batchId(form.getBatchId())

                                .build(),
                        loginSysUser
                );

        stopWatch.stop();
        sysNotify.setTitle(StrUtil.format("{}:{}", sysNotify.getTitle(), stopWatch.getTotalTimeSeconds()));

        // 统计 更新
        updateByBatchIdSelective(
                SysQuartzScheduleTaskStatementOfAccountJd
                        .builder()

                        .batchId(form.getBatchId())

                        .statisticsAmountDimOrderOutsider(detailStatisticsVo.getStatisticsAmountDimOrderOutsider())

                        .statisticsQuantityDimOrderTotal(detailStatisticsVo.getStatisticsQuantityDimOrderTotal())
                        .statisticsQuantityDimOrderNormal(detailStatisticsVo.getStatisticsQuantityDimOrderNormal())
                        .statisticsQuantityDimOrderException(detailStatisticsVo.getStatisticsQuantityDimOrderException())

                        .timeConsumingForImport(stopWatch.getTotalTimeMillis())
                        .updateTime(now)

                        .build()
        );

        towImportExcel(
                form,
                ScheduleTaskRunStatusEnum.已导入,
                ScheduleTaskProcessStateEnum.导入成功,
                loginSysUser);

        return sysNotify;
    }

    @Override
    public SysNotify dispatcherExcelImportLiteVersion(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            LoginSysUser loginSysUser) {

        DateTime now = DateUtil.date();

        StopWatch stopWatch = new StopWatch();
        stopWatch.start(form.getBatchId());

        /****************************************  start ****************************************/

        towImportExcel(
                form,
                ScheduleTaskRunStatusEnum.导入中,
                ScheduleTaskProcessStateEnum.导入中,
                loginSysUser
        );

        SysNotify sysNotify = accountingUnifiedSupplierOrderJdService.opImportExcelLiteVersion(form, loginSysUser);


        // 统计
        AccountingUnifiedSupplierOrderJdUpperLevelsStatisticsVo detailStatisticsVo =
                accountingUnifiedSupplierOrderJdService.statisticsQuantityDimOrderNormalOrException(
                        AccountingUnifiedSupplierOrderJdQueryCriteria
                                .builder()

                                .batchId(form.getBatchId())

                                .build(),
                        loginSysUser
                );

        stopWatch.stop();
        sysNotify.setTitle(StrUtil.format("{}:{}", sysNotify.getTitle(), stopWatch.getTotalTimeSeconds()));

        /**************************************** 统计更新 start ****************************************/

        updateByBatchIdSelective(
                SysQuartzScheduleTaskStatementOfAccountJd
                        .builder()

                        .batchId(form.getBatchId())

                        .statisticsAmountDimOrderOutsider(detailStatisticsVo.getStatisticsAmountDimOrderOutsider())

                        .statisticsQuantityDimOrderTotal(detailStatisticsVo.getStatisticsQuantityDimOrderTotal())
                        .statisticsQuantityDimOrderNormal(detailStatisticsVo.getStatisticsQuantityDimOrderNormal())
                        .statisticsQuantityDimOrderException(detailStatisticsVo.getStatisticsQuantityDimOrderException())

                        .timeConsumingForImport(stopWatch.getTotalTimeMillis())
                        .updateTime(now)

                        .build()
        );

        /**************************************** 统计更新   end ****************************************/

        /**************************************** 流程流转 start ****************************************/


        // 视为导入失败的两种情况 ---- 添加逻辑 ---- mark by linjinyu at 2022-06-21 16:43:16 -
        // 1. 经统计后-对账金额为0 ---- 删除逻辑 ---- mark by linjinyu at 2022-07-01 14:50:10 -
        // 2. 经统计后-订单数量为0
        // 3. 经统计后-订单(异常)数量为>0 ---- 添加逻辑 - mark by linjinyu at 2022-07-01 14:50:10 -

        ScheduleTaskProcessStateEnum scheduleTaskProcessStateEnum = ScheduleTaskProcessStateEnum.导入成功;
//        BigDecimal.ZERO.compareTo(detailStatisticsVo.getStatisticsAmountDimOrderOutsider()) == 0 ||
        if (detailStatisticsVo.getStatisticsQuantityDimOrderTotal().compareTo(0L) == 0
                || detailStatisticsVo.getStatisticsQuantityDimOrderException().compareTo(0L) > 0) {
            scheduleTaskProcessStateEnum = ScheduleTaskProcessStateEnum.导入失败;
        }

        towImportExcel(
                form,
                ScheduleTaskRunStatusEnum.已导入,
                scheduleTaskProcessStateEnum,
                loginSysUser);

        /**************************************** 流程流转   end ****************************************/


        return sysNotify;
    }

    @Override
    public SysNotify dispatcherCompareOrderAndCheckUpThenReport(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            LoginSysUser loginSysUser) {

        DateTime now = DateUtil.date();

        StopWatch stopWatch = new StopWatch();
        stopWatch.start(form.getBatchId());


        /**************************************** 任务状态变更 start ****************************************/

        towCompareOrderAndCheckUpThenReport(
                form,
                ScheduleTaskRunStatusEnum.对账中,
                ScheduleTaskAccountingStatusEnum.对账中,
                loginSysUser
        );

        /**************************************** 任务状态变更   end ****************************************/


        /**************************************** 检查比对 start ****************************************/

        SysQuartzScheduleTaskStatementOfAccountJdListItemVo listItemVo = findListItemVoByBatchId(
                form.getBatchId(),
                loginSysUser
        );

        SysNotify sysNotify = accountingUnifiedSupplierOrderJdCheckUpReportService
                .opCompareOrderAndCheckUp(
                        form,
                        listItemVo,
                        loginSysUser);

        /**************************************** 检查比对   end ****************************************/


        /**************************************** 任务相关信息 统计 更新 start ****************************************/

        // 统计 供应商结算 > 京东对账 > 对账详情
        // 第三方导入明细条数：| 1| 结算中心对账明细条数：| 0| 第三方对账金额：| ¥1196.48| 结算中心对账金额：| ¥0.00| 对账差异金额：| ¥1196.48
        AccountingUnifiedSupplierOrderJdCheckUpReportDetailStatisticsVo detailStatisticsVo =
                accountingUnifiedSupplierOrderJdCheckUpReportService.pageQueryHeadGenericParam(
                        AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria
                                .builder()

                                .batchId(form.getBatchId())

                                .build(),
                        loginSysUser
                );

        log.info("统计\n{}", JSONUtil.toJsonPrettyStr(detailStatisticsVo));


        Integer checkState = 0;
        // Dim Order TODO mark by linjinyu at 2022-06-24 17:36:43 - 改商品维度后不能这样判定
//        if (ObjectUtil.isNull(detailStatisticsVo.getStatisticsQuantityDimOrderOutsider())
//                || ObjectUtil.isNull(detailStatisticsVo.getStatisticsQuantityDimOrderOwnsider())) {
//            checkState = ScheduleTaskCheckStateEnum.异常.getKey();
//        } else if (detailStatisticsVo.getStatisticsQuantityDimOrderOutsider()
//                .compareTo(detailStatisticsVo.getStatisticsQuantityDimOrderOwnsider()) == 0) {
//            checkState = ScheduleTaskCheckStateEnum.正常.getKey();
//        } else {
//            checkState = ScheduleTaskCheckStateEnum.异常.getKey();
//        }

        AccountingUnifiedSupplierOrderJdCheckUpReportUpperLevelsStatisticsVo upperLevelsStatisticsVo =
                accountingUnifiedSupplierOrderJdCheckUpReportService.statisticsQuantityDimOrderNormalOrException(
                        AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria
                                .builder()

                                .batchId(form.getBatchId())

                                .build(),
                        loginSysUser
                );

        // Dim Goods
        if (ObjectUtil.isNull(upperLevelsStatisticsVo.getStatisticsQuantityDimOrderNormal())
                || ObjectUtil.isNull(upperLevelsStatisticsVo.getStatisticsQuantityDimOrderException())) {
            checkState = ScheduleTaskCheckStateEnum.异常.getKey();
        } else if (upperLevelsStatisticsVo.getStatisticsQuantityDimOrderException()
                .compareTo(0L) == 0) {
            checkState = ScheduleTaskCheckStateEnum.正常.getKey();
        } else {
            checkState = ScheduleTaskCheckStateEnum.异常.getKey();
        }


        stopWatch.stop();
        sysNotify.setTitle(StrUtil.format("{}:{}", sysNotify.getTitle(), stopWatch.getTotalTimeSeconds()));

        updateByBatchIdSelective(
                SysQuartzScheduleTaskStatementOfAccountJd
                        .builder()

                        .batchId(form.getBatchId())

                        .statisticsAmountDimOrderOutsider(detailStatisticsVo.getStatisticsAmountDimOrderOutsider())
                        .statisticsAmountDimOrderOwnsider(detailStatisticsVo.getStatisticsAmountDimOrderOwnsider())

                        // 导入时定
                        // .statisticsQuantityDimOrderTotal(detailStatisticsVo.getStatisticsQuantityDimOrderOutsider())
                        .statisticsQuantityDimOrderNormal(upperLevelsStatisticsVo.getStatisticsQuantityDimOrderNormal())
                        .statisticsQuantityDimOrderException(upperLevelsStatisticsVo.getStatisticsQuantityDimOrderException())

                        .checkState(checkState)
                        .updateTime(now)

                        .timeConsumingForCompare(stopWatch.getTotalTimeMillis())

                        .build()
        );

        /**************************************** 任务相关信息 统计 更新   end ****************************************/


        /**************************************** 任务状态变更 start ****************************************/

        towCompareOrderAndCheckUpThenReport(
                form,
                ScheduleTaskRunStatusEnum.已对账,
                ScheduleTaskAccountingStatusEnum.对账完成,
                loginSysUser
        );

        /**************************************** 任务状态变更   end ****************************************/

        return sysNotify;
    }

    @Override
    public SysNotify dispatcherCompareOrderAndCheckUpThenReportOnlyException(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            LoginSysUser loginSysUser) {

        DateTime now = DateUtil.date();

        StopWatch stopWatch = new StopWatch();
        stopWatch.start(form.getBatchId());

        towCompareOrderAndCheckUpThenReport(
                form,
                ScheduleTaskRunStatusEnum.对账中,
                ScheduleTaskAccountingStatusEnum.对账中,
                loginSysUser);

        /**************************************** 检查比对 start ****************************************/

        SysQuartzScheduleTaskStatementOfAccountJdListItemVo listItemVo = findListItemVoByBatchId(
                form.getBatchId(),
                loginSysUser
        );

        SysNotify sysNotify = accountingUnifiedSupplierOrderJdCheckUpReportService
                .opCompareOrderAndCheckUpOnlyException(
                        form,
                        listItemVo,
                        loginSysUser
                );

        /**************************************** 检查比对   end ****************************************/


        // 统计
        AccountingUnifiedSupplierOrderJdCheckUpReportDetailStatisticsVo detailStatisticsVo =
                accountingUnifiedSupplierOrderJdCheckUpReportService.pageQueryHeadGenericParam(
                        AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria
                                .builder()

                                .batchId(form.getBatchId())

                                .build(),
                        loginSysUser
                );

        /**************************************** 任务相关信息 统计 更新 start ****************************************/

        Integer checkState = 0;

//        if (ObjectUtil.isNull(detailStatisticsVo.getStatisticsQuantityDimOrderOutsider())
//                || ObjectUtil.isNull(detailStatisticsVo.getStatisticsQuantityDimOrderOwnsider())) {
//            checkState = ScheduleTaskCheckStateEnum.异常.getKey();
//        } else if (detailStatisticsVo.getStatisticsQuantityDimOrderOutsider().compareTo(detailStatisticsVo.getStatisticsQuantityDimOrderOwnsider()) == 0) {
//            checkState = ScheduleTaskCheckStateEnum.正常.getKey();
//        } else {
//            checkState = ScheduleTaskCheckStateEnum.异常.getKey();
//        }

        AccountingUnifiedSupplierOrderJdCheckUpReportUpperLevelsStatisticsVo upperLevelsStatisticsVo =
                accountingUnifiedSupplierOrderJdCheckUpReportService.statisticsQuantityDimOrderNormalOrException(
                        AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria
                                .builder()

                                .batchId(form.getBatchId())

                                .build(),
                        loginSysUser
                );

        // Dim Goods
        if (ObjectUtil.isNull(upperLevelsStatisticsVo.getStatisticsQuantityDimOrderNormal())
                || ObjectUtil.isNull(upperLevelsStatisticsVo.getStatisticsQuantityDimOrderException())) {
            checkState = ScheduleTaskCheckStateEnum.异常.getKey();
        } else if (upperLevelsStatisticsVo.getStatisticsQuantityDimOrderException()
                .compareTo(0L) == 0) {
            checkState = ScheduleTaskCheckStateEnum.正常.getKey();
        } else {
            checkState = ScheduleTaskCheckStateEnum.异常.getKey();
        }

        stopWatch.stop();
        sysNotify.setTitle(StrUtil.format("{}:{}", sysNotify.getTitle(), stopWatch.getTotalTimeSeconds()));

        updateByBatchIdSelective(
                SysQuartzScheduleTaskStatementOfAccountJd
                        .builder()

                        .batchId(form.getBatchId())

                        .statisticsAmountDimOrderOutsider(detailStatisticsVo.getStatisticsAmountDimOrderOutsider())
                        .statisticsAmountDimOrderOwnsider(detailStatisticsVo.getStatisticsAmountDimOrderOwnsider())

                        // 导入时定
                        // .statisticsQuantityDimOrderTotal(detailStatisticsVo.getStatisticsQuantityDimOrderOutsider())
                        .statisticsQuantityDimOrderNormal(upperLevelsStatisticsVo.getStatisticsQuantityDimOrderNormal())
                        .statisticsQuantityDimOrderException(upperLevelsStatisticsVo.getStatisticsQuantityDimOrderException())

                        .checkState(checkState)
                        .updateTime(now)

                        .timeConsumingForCompare(stopWatch.getTotalTimeMillis())

                        .build()
        );

        /**************************************** 任务相关信息 统计 更新   end ****************************************/


        towCompareOrderAndCheckUpThenReport(
                form,
                ScheduleTaskRunStatusEnum.已对账,
                ScheduleTaskAccountingStatusEnum.对账完成,
                loginSysUser);

        return sysNotify;
    }

    /**************************************** 任务调度方法 start ****************************************/

}
