package cn.superdesk.uniorder.controller._thirdpart.jd;

import cn.hutool.core.util.ObjectUtil;
import cn.superdesk.libs.common.json.JsonUtils;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.rest.response.ResponseResultOuterUtils;
import cn.superdesk.uniorder.controller.base.BaseController;
import cn.superdesk.uniorder.dao.entity.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReport;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportParam;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportListItemVo;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.AccountingUnifiedSupplierOrderJdListItemVo;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdListItemVo;
import cn.superdesk.uniorder.dubbo.consumer.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportDubboConsumerService;
import cn.superdesk.uniorder.dubbo.consumer.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdDubboConsumerService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;


/**
 * @Description: 京东对账单中的订单 算是临时 sheet eg 深圳市侨城汇网络科技有限公司-2021年8月1日集采账单.xlsx
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-10-14 17:04:08
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-10-14 17:04:08
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Api(value = "供应商结算-京东对账-op对账详情", tags = {"供应商结算-京东对账-op对账详情"})
@Slf4j
@RestController
@RequestMapping("/accountingUnifiedSupplierOrderJdCheckUpReport")
public class AccountingUnifiedSupplierOrderJdCheckUpReportController extends BaseController {

    @Autowired
    private AccountingUnifiedSupplierOrderJdCheckUpReportDubboConsumerService accountingUnifiedSupplierOrderJdCheckUpReportDubboConsumerService;

    @Autowired
    private SysQuartzScheduleTaskStatementOfAccountJdDubboConsumerService sysQuartzScheduleTaskStatementOfAccountJdDubboConsumerService;

//	@ApiOperation(value = "分页查询 - 默认不用")
//	@RequestMapping(value = "listByObscure", method = RequestMethod.POST)
//	@ResponseBody
//	public R<List<AccountingUnifiedSupplierOrderJdCheckUpReport>> pageQueryAccountingUnifiedSupplierOrderJdCheckUpReport(@RequestBody PageQueryParam param) {
//
//		log.info("pageQueryAccountingUnifiedSupplierOrderJdCheckUpReport:\n{}", JsonUtils.toJson(param));
//
//		R<List<AccountingUnifiedSupplierOrderJdCheckUpReport>> result = new R<>();
//
//		// TODO 参数合法性判定
//
//		result = accountingUnifiedSupplierOrderJdCheckUpReportDubboConsumerService.pageQuery(param.getConditions(), param.getPageNo(), param.getPageSize());
//
//		return result;
//	}

    @ApiOperation(value = "供应商结算-京东对账-op列表-op查看对账(对账详情)")
    @RequestMapping(value = "list", method = RequestMethod.POST)
    @ResponseBody
    public R<List<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVo>> pageQueryGenericParamAccountingUnifiedSupplierOrderJdCheckUpReport(
            @RequestBody AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria queryCriteria) {

        log.info("供应商结算-京东对账-op列表-op查看对账 params:\n{}", JsonUtils.toJson(queryCriteria));

        R<List<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVo>> result = new R<>();

        // TODO 参数合法性判定

        if (ObjectUtil.isNull(queryCriteria.getBatchId())) {
            return ResponseResultOuterUtils.createErrorResult("500", "[参数异常]对账单号");
        }

        result = accountingUnifiedSupplierOrderJdCheckUpReportDubboConsumerService.pageQueryGenericParam(queryCriteria, getToken());

        return result;
    }

    @ApiOperation(value = "按id查询")
    @RequestMapping(value = "{id}", method = RequestMethod.GET)
    @ResponseBody
    public R<List<AccountingUnifiedSupplierOrderJdCheckUpReport>> getById(@PathVariable("id") long id) {

        R<List<AccountingUnifiedSupplierOrderJdCheckUpReport>> result = new R<>();

        // TODO 参数合法性判定

        AccountingUnifiedSupplierOrderJdCheckUpReport entity = accountingUnifiedSupplierOrderJdCheckUpReportDubboConsumerService.findAccountingUnifiedSupplierOrderJdCheckUpReportById(id);

        List<AccountingUnifiedSupplierOrderJdCheckUpReport> data = new ArrayList<>();
        data.add(entity);

        result.setData(data);

        return result;
    }

    @ApiOperation(value = "新增")
    @RequestMapping(value = "add", method = RequestMethod.POST)
    @ResponseBody
    public R<String> addAccountingUnifiedSupplierOrderJdCheckUpReport(@RequestBody AccountingUnifiedSupplierOrderJdCheckUpReportParam param) {

        log.info("addAccountingUnifiedSupplierOrderJdCheckUpReport:\n{}", JsonUtils.toJson(param));

        // TODO 参数合法性判定

        accountingUnifiedSupplierOrderJdCheckUpReportDubboConsumerService.addAccountingUnifiedSupplierOrderJdCheckUpReport(param);

        return new R<>("200", "操作成功", true);
    }


    @ApiOperation(value = "检查")
    @RequestMapping(value = "checkUpAndReportDimOrder", method = RequestMethod.POST)
    @ResponseBody
    public R<String> checkUpAndReportDimOrder(@RequestBody AccountingUnifiedSupplierOrderJdListItemVo itemVo) {

        log.info("checkUpReport:\n{}", JsonUtils.toJson(itemVo));

        // TODO 参数合法性判定

        SysQuartzScheduleTaskStatementOfAccountJdListItemVo listItemVo = sysQuartzScheduleTaskStatementOfAccountJdDubboConsumerService.findListItemVoByBatchId(
                itemVo.getBatchId(),
                getToken()
        );

        if (ObjectUtil.isNull(listItemVo)) {
            return ResponseResultOuterUtils.createErrorResult("500", "未查找到任务");
        }

        accountingUnifiedSupplierOrderJdCheckUpReportDubboConsumerService.checkUpAndReportDimOrder(listItemVo, itemVo);

        return new R<>("200", "操作成功", true);
    }

    @ApiOperation(value = "更新")
    @RequestMapping(value = "update", method = RequestMethod.POST)
    @ResponseBody
    public R<String> updateAccountingUnifiedSupplierOrderJdCheckUpReport(@RequestBody AccountingUnifiedSupplierOrderJdCheckUpReportParam param) {

        log.info("updateAccountingUnifiedSupplierOrderJdCheckUpReport:\n{}", JsonUtils.toJson(param));

        accountingUnifiedSupplierOrderJdCheckUpReportDubboConsumerService.updateAccountingUnifiedSupplierOrderJdCheckUpReport(param);

        return new R<>("200", "操作成功", true);
    }

    @ApiOperation(value = "删除")
    @RequestMapping(value = "delete/{id}", method = RequestMethod.POST)
    @ResponseBody
    public R<String> deleteAccountingUnifiedSupplierOrderJdCheckUpReport(@PathVariable("id") long id) {

        // TODO 参数合法性判定

        accountingUnifiedSupplierOrderJdCheckUpReportDubboConsumerService.deleteAccountingUnifiedSupplierOrderJdCheckUpReport(id);

        return new R<>("200", "操作成功", true);
    }

    @ApiOperation(value = "批量删除")
    @RequestMapping(value = "delete_ids", method = RequestMethod.POST)
    @ResponseBody
    public R<String> deleteIdsAccountingUnifiedSupplierOrderJdCheckUpReport(@RequestParam(value = "ids") long[] ids) {

        log.info(JsonUtils.toJson(ids));

        for (long id : ids) {
            accountingUnifiedSupplierOrderJdCheckUpReportDubboConsumerService.deleteAccountingUnifiedSupplierOrderJdCheckUpReport(id);
        }

        return new R<>("200", "操作成功", true);

    }


}
