package cn.superdesk.uniorder.controller._thirdpart.jd;

import cn.hutool.json.JSONUtil;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.controller.base.BaseController;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria;
import cn.superdesk.uniorder.dubbo.consumer.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportDubboConsumerService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;


/**
 * @Description: 京东对账单中的订单 算是临时 sheet eg 深圳市侨城汇网络科技有限公司-2021年8月1日集采账单.xlsx
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-10-14 17:04:08
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-10-14 17:04:08
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Api(value = "供应商结算-京东对账-op对账详情-op导出", tags = {"供应商结算-京东对账-op对账详情-op导出"})
@Slf4j
@RestController
@RequestMapping("/accountingUnifiedSupplierOrderJdCheckUpReport/export")
public class AccountingUnifiedSupplierOrderJdCheckUpReportExportExcelController extends BaseController {

    @Autowired
    private AccountingUnifiedSupplierOrderJdCheckUpReportDubboConsumerService accountingUnifiedSupplierOrderJdCheckUpReportDubboConsumerService;

    @ApiOperation(value = "供应商结算-京东对账-op列表-op查看对账(对账详情)-op导出列表(完整版 Full Version)-京东账单任务-某次导入数据-报告导出")
    @RequestMapping(value = "/excel/jdCheckUpReport/fullVersion", method = RequestMethod.POST)
    public R<String> exportExcelJdCheckUpReportFullVersion(
            @RequestBody AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria criteria) {

        log.info("供应商结算-京东对账-op列表-op查看对账(对账详情)-op导出列表(完整版 Full Version)-京东账单任务-某次导入数据-报告导出 params: \n{}", JSONUtil.toJsonStr(criteria));

        return new R<String>(accountingUnifiedSupplierOrderJdCheckUpReportDubboConsumerService
                .exportExcelJdCheckUpReportFullVersion(
                        criteria,
                        getToken()
                )
        );
    }

	@ApiOperation(value = "供应商结算-京东对账-op列表-op查看对账(对账详情)-op导出列表(精简版 Lite Version)-京东账单任务-某次导入数据-报告导出")
	@RequestMapping(value = "/excel/jdCheckUpReport/liteVersion", method = RequestMethod.POST)
	public R<String> exportExcelJdCheckUpReportLiteVersion(
	        @RequestBody AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria criteria) {

		log.info("供应商结算-京东对账-op列表-op查看对账(对账详情)-op导出列表(精简版 Lite Version)-京东账单任务-某次导入数据-报告导出 params: \n{}", JSONUtil.toJsonStr(criteria));

		return new R<String>(accountingUnifiedSupplierOrderJdCheckUpReportDubboConsumerService
                .exportExcelJdCheckUpReportLiteVersion(
                        criteria,
                        getToken()
                )
        );
	}

}
