package cn.superdesk.uniorder.controller._thirdpart.jd;

import cn.superdesk.libs.common.json.JsonUtils;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.rest.response.ResponseResultOuterUtils;
import cn.superdesk.uniorder.controller.base.BaseController;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsParam;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsQueryCriteria;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsHeadVo;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsListItemVo;
import cn.superdesk.uniorder.dubbo.consumer.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsDubboConsumerService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;


/**
 * @Description:
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2022-06-22 16:27:47
 * @UpdateUser: linjinyu
 * @UpdateDate: 2022-06-22 16:27:47
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Api(value = "xxx-xxx", tags = {"xxx-xxx"})
@Slf4j
@RestController
@RequestMapping("/accountingUnifiedSupplierOrderJdCheckUpReportXGoods")
public class AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsController extends BaseController {

    @Autowired
    private AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsDubboConsumerService accountingUnifiedSupplierOrderJdCheckUpReportXGoodsDubboConsumerService;


    @ApiOperation(value = "xxx-xxx-op列表")
    @RequestMapping(value = "list", method = RequestMethod.POST)
    @ResponseBody
    public R<List<AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsListItemVo>> pageQueryGenericParam(
            @RequestBody AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsQueryCriteria queryCriteria) {

        log.info("pageQueryAccountingUnifiedSupplierOrderJdCheckUpReportXGoods:\n{}", JsonUtils.toJson(queryCriteria));

        // TODO 参数合法性判定

        R<List<AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsListItemVo>> result = new R<>();
        result = accountingUnifiedSupplierOrderJdCheckUpReportXGoodsDubboConsumerService.pageQueryGenericParam(queryCriteria, getToken());

        return result;
    }

    @ApiOperation(value = "xxx-xxx-op页头")
    @RequestMapping(value = "head", method = RequestMethod.POST)
    public R<AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsHeadVo> pageQueryHeadGenericParam(
            @RequestBody AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsQueryCriteria queryCriteria) {

        return ResponseResultOuterUtils.createSuccesResult("",
                accountingUnifiedSupplierOrderJdCheckUpReportXGoodsDubboConsumerService
                        .queryHeadGenericParam(
                                queryCriteria,
                                getToken()
                        )
        );
    }

    @ApiOperation(value = "xxx-xxx-op列表-op按id查询")
    @RequestMapping(value = "{id}", method = RequestMethod.GET)
    @ResponseBody
    public R<AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsListItemVo> getById(@PathVariable("id") long id) {

        return ResponseResultOuterUtils.createSuccesResult("",
                accountingUnifiedSupplierOrderJdCheckUpReportXGoodsDubboConsumerService
                        .findListItemVoById(
                                id,
                                getToken()
                        )
        );
    }

    @ApiOperation(value = "xxx-xxx-op列表-op新增-op提交")
    @RequestMapping(value = "add", method = RequestMethod.POST)
    @ResponseBody
    public R<String> addAccountingUnifiedSupplierOrderJdCheckUpReportXGoods(@RequestBody AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsParam param) {

        log.info("addAccountingUnifiedSupplierOrderJdCheckUpReportXGoods:\n{}", JsonUtils.toJson(param));

        // TODO 参数合法性判定

        int ret = accountingUnifiedSupplierOrderJdCheckUpReportXGoodsDubboConsumerService.addAccountingUnifiedSupplierOrderJdCheckUpReportXGoods(param, getToken());

        if (ret == 0) {
            return ResponseResultOuterUtils.createErrorResult("500", "操作失败");
        } else {
            return ResponseResultOuterUtils.createSuccesResult("操作成功");
        }
    }

    @ApiOperation(value = "xxx-xxx-op列表-op编辑-op提交")
    @RequestMapping(value = "update", method = RequestMethod.POST)
    @ResponseBody
    public R<String> updateAccountingUnifiedSupplierOrderJdCheckUpReportXGoods(@RequestBody AccountingUnifiedSupplierOrderJdCheckUpReportXGoodsParam param) {

        log.info("updateAccountingUnifiedSupplierOrderJdCheckUpReportXGoods:\n{}", JsonUtils.toJson(param));

        int ret = accountingUnifiedSupplierOrderJdCheckUpReportXGoodsDubboConsumerService.updateAccountingUnifiedSupplierOrderJdCheckUpReportXGoods(param, getToken());

        if (ret == 0) {
            return ResponseResultOuterUtils.createErrorResult("500", "操作失败");
        } else {
            return ResponseResultOuterUtils.createSuccesResult("操作成功");
        }
    }

    @ApiOperation(value = "xxx-xxx-op列表-op删除")
    @RequestMapping(value = "delete/{id}", method = RequestMethod.POST)
    @ResponseBody
    public R<String> deleteAccountingUnifiedSupplierOrderJdCheckUpReportXGoods(@PathVariable("id") long id) {

        // TODO 参数合法性判定

        int ret = accountingUnifiedSupplierOrderJdCheckUpReportXGoodsDubboConsumerService.deleteAccountingUnifiedSupplierOrderJdCheckUpReportXGoods(id, getToken());

        if (ret == 0) {
            return ResponseResultOuterUtils.createErrorResult("500", "操作失败");
        } else {
            return ResponseResultOuterUtils.createSuccesResult("操作成功");
        }
    }

    @ApiOperation(value = "xxx-xxx-op列表-op批量删除")
    @RequestMapping(value = "delete_ids", method = RequestMethod.POST)
    @ResponseBody
    public R<String> deleteIdsAccountingUnifiedSupplierOrderJdCheckUpReportXGoods(@RequestParam(value = "ids") long[] ids) {

        log.info(JsonUtils.toJson(ids));

        int ret = 0;

        for (long id : ids) {
            ret = accountingUnifiedSupplierOrderJdCheckUpReportXGoodsDubboConsumerService.deleteAccountingUnifiedSupplierOrderJdCheckUpReportXGoods(id, getToken());
        }

        if (ret == 0) {
            return ResponseResultOuterUtils.createErrorResult("500", "操作失败");
        } else {
            return ResponseResultOuterUtils.createSuccesResult("操作成功");
        }

    }


}
