package cn.superdesk.uniorder.controller._thirdpart.jd;

import cn.superdesk.libs.common.json.JsonUtils;
import cn.superdesk.uniorder.common.pagination.PageQueryParam;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.controller.base.BaseController;
import cn.superdesk.uniorder.dao.entity.thirdpart.jd.AccountingUnifiedSupplierOrderJd;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.AccountingUnifiedSupplierOrderJdParam;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.AccountingUnifiedSupplierOrderJdQueryCriteria;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.AccountingUnifiedSupplierOrderJdListItemVo;
import cn.superdesk.uniorder.dubbo.consumer.thirdpart.jd.AccountingUnifiedSupplierOrderJdDubboConsumerService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;


/**
 * @Description: 京东对账单中的订单 算是临时 sheet eg 深圳市侨城汇网络科技有限公司-2021年8月1日集采账单.xlsx
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-10-12 11:29:24
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-10-12 11:29:24
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Api(value = "供应商结算-京东对账-op导入详情", tags = {"供应商结算-京东对账-op导入详情"})
@Slf4j
@RestController
@RequestMapping("/accountingUnifiedSupplierOrderJd")
public class AccountingUnifiedSupplierOrderJdController extends BaseController {

    @Autowired
    private AccountingUnifiedSupplierOrderJdDubboConsumerService accountingUnifiedSupplierOrderJdDubboConsumerService;

    @ApiOperation(value = "分页查询-默认不用")
    @RequestMapping(value = "listByObscure", method = RequestMethod.POST)
    @ResponseBody
    public R<List<AccountingUnifiedSupplierOrderJd>> pageQueryAccountingUnifiedSupplierOrderJd(@RequestBody PageQueryParam param) {

        log.info("pageQueryAccountingUnifiedSupplierOrderJd:\n{}", JsonUtils.toJson(param));

        R<List<AccountingUnifiedSupplierOrderJd>> result = new R<>();

        // TODO 参数合法性判定

        result = accountingUnifiedSupplierOrderJdDubboConsumerService.pageQuery(param.getConditions(), param.getPageNo(), param.getPageSize());

        return result;
    }

    /**
     * http://192.168.6.223:8089/web/accountingUnifiedSupplierOrderJd/list
     *
     * @param queryCriteria
     * @return
     */
    @ApiOperation(value = "分页查询")
    @RequestMapping(value = "list", method = RequestMethod.POST)
    @ResponseBody
    public R<List<AccountingUnifiedSupplierOrderJdListItemVo>> pageQueryGenericParamAccountingUnifiedSupplierOrderJd(
            @RequestBody AccountingUnifiedSupplierOrderJdQueryCriteria queryCriteria) {

        log.info("pageQueryAccountingUnifiedSupplierOrderJd:\n{}", JsonUtils.toJson(queryCriteria));

        R<List<AccountingUnifiedSupplierOrderJdListItemVo>> result = new R<>();

        // TODO 参数合法性判定

        result = accountingUnifiedSupplierOrderJdDubboConsumerService.pageQueryGenericParam(queryCriteria, getToken());

        return result;
    }

    @ApiOperation(value = "按id查询")
    @RequestMapping(value = "{id}", method = RequestMethod.GET)
    @ResponseBody
    public R<List<AccountingUnifiedSupplierOrderJd>> getById(@PathVariable("id") long id) {

        R<List<AccountingUnifiedSupplierOrderJd>> result = new R<>();

        // TODO 参数合法性判定

        AccountingUnifiedSupplierOrderJd entity = accountingUnifiedSupplierOrderJdDubboConsumerService.findAccountingUnifiedSupplierOrderJdById(id);

        List<AccountingUnifiedSupplierOrderJd> data = new ArrayList<>();
        data.add(entity);

        result.setData(data);

        return result;
    }

    @ApiOperation(value = "新增")
    @RequestMapping(value = "add", method = RequestMethod.POST)
    @ResponseBody
    public R<String> addAccountingUnifiedSupplierOrderJd(@RequestBody AccountingUnifiedSupplierOrderJdParam param) {

        log.info("addAccountingUnifiedSupplierOrderJd:\n{}", JsonUtils.toJson(param));


        // TODO 参数合法性判定

        accountingUnifiedSupplierOrderJdDubboConsumerService.addAccountingUnifiedSupplierOrderJd(param);

        return new R<>("200", "操作成功", true);
    }

    @ApiOperation(value = "更新")
    @RequestMapping(value = "update", method = RequestMethod.POST)
    @ResponseBody
    public R<String> updateAccountingUnifiedSupplierOrderJd(@RequestBody AccountingUnifiedSupplierOrderJdParam param) {

        log.info("updateAccountingUnifiedSupplierOrderJd:\n{}", JsonUtils.toJson(param));

        accountingUnifiedSupplierOrderJdDubboConsumerService.updateAccountingUnifiedSupplierOrderJd(param);

        return new R<>("200", "操作成功", true);
    }

    @ApiOperation(value = "删除")
    @RequestMapping(value = "delete/{id}", method = RequestMethod.POST)
    @ResponseBody
    public R<String> deleteAccountingUnifiedSupplierOrderJd(@PathVariable("id") long id) {

        // TODO 参数合法性判定

        accountingUnifiedSupplierOrderJdDubboConsumerService.deleteAccountingUnifiedSupplierOrderJd(id);

        return new R<>("200", "操作成功", true);
    }

    @ApiOperation(value = "批量删除")
    @RequestMapping(value = "delete_ids", method = RequestMethod.POST)
    @ResponseBody
    public R<String> deleteIdsAccountingUnifiedSupplierOrderJd(@RequestParam(value = "ids") long[] ids) {

        log.info(JsonUtils.toJson(ids));

        for (long id : ids) {
            accountingUnifiedSupplierOrderJdDubboConsumerService.deleteAccountingUnifiedSupplierOrderJd(id);
        }

        return new R<>("200", "操作成功", true);

    }


}
