package cn.superdesk.uniorder.controller._thirdpart.jd;

import cn.hutool.json.JSONUtil;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.controller.base.BaseController;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.AccountingUnifiedSupplierOrderJdQueryCriteria;
import cn.superdesk.uniorder.dubbo.consumer.thirdpart.jd.AccountingUnifiedSupplierOrderJdDubboConsumerService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

/**
 * @Description: Java类作用描述
 * @Author: linjinyu
 * @CreateDate: 2022/6/14 10:45 上午
 * @UpdateUser: linjinyu
 * @UpdateDate: 2022/6/14 10:45 上午
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Api(value = "供应商结算-京东对账-op导入详情", tags = {"供应商结算-京东对账-op导入详情"})
@Slf4j
@RestController
@RequestMapping("/accountingUnifiedSupplierOrderJd/export")
public class AccountingUnifiedSupplierOrderJdExportExcelController extends BaseController {

    @Autowired
    private AccountingUnifiedSupplierOrderJdDubboConsumerService accountingUnifiedSupplierOrderJdDubboConsumerService;

    @ApiOperation(value = "供应商结算-京东对账-op列表-op下载导入文件")
    @RequestMapping(value = "/excel/jdCheckUpReport/liteVersion", method = RequestMethod.POST)
    public R<String> exportExcelJdImportRecord(
            @RequestBody AccountingUnifiedSupplierOrderJdQueryCriteria queryCriteria) {

        log.info("供应商结算-京东对账-op列表-op查看对账(对账详情)-op导出列表(精简版 Lite Version)-京东账单任务-某次导入数据-报告导出 params: \n{}", JSONUtil.toJsonStr(queryCriteria));

        return new R<String>(accountingUnifiedSupplierOrderJdDubboConsumerService
                .exportExcelJdImportRecord(
                        queryCriteria,
                        getToken()
                )
        );
    }
}
