package cn.superdesk.uniorder.dubbo.consumer.invoice.supplier;

import cn.superdesk.uniorder.common.exception.UnifiedOrderRuntimeException;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.JwtUtil;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dto.param.invoice.customer.reportaccounting.ActualPayableReportAccountingCreateParam;
import cn.superdesk.uniorder.dto.param.invoice.customer.reportaccounting.ActualReportAccountingConfirmParam;
import cn.superdesk.uniorder.dto.param.invoice.customer.reportaccounting.InvoiceStatusRepair;
import cn.superdesk.uniorder.dto.vo.invoice.reportaccounting.ActualPayableReportAccountingDetailVO;
import cn.superdesk.uniorder.dto.vo.invoice.supplier.paymentReport.AddPaymentReportEchoVo;
import cn.superdesk.uniorder.dto.vo.invoice.supplier.paymentReport.PaymentReportEchoVo;
import cn.superdesk.uniorder.dubbo.facade.invoice.supplier.DubboAccountingReportPaymenService;
import com.alibaba.dubbo.config.annotation.Reference;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.RequestBody;

@Slf4j
@Component
public class AccountingReportPaymentDubboConsumerService {
    @Reference(version = "1.0.0", timeout = 30000, retries = -1)
    private DubboAccountingReportPaymenService dubboAccountingReportPaymenService;

    public void billPaymentStatusRepair(InvoiceStatusRepair repair, String token) {
        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
        dubboAccountingReportPaymenService.billPaymentStatusRepair(repair, loginSysUser);
    }

    public PaymentReportEchoVo getPaymentReportEcho (String accountingOrderId) {
        return dubboAccountingReportPaymenService.getPaymentReportEcho(accountingOrderId);
    }

    public R<AddPaymentReportEchoVo> getAddPaymentReportEcho(Long accountingOrderId, LoginSysUser loginSysUser) throws UnifiedOrderRuntimeException {
        return dubboAccountingReportPaymenService.getAddPaymentReportEcho(accountingOrderId, loginSysUser);
    }

    public ActualPayableReportAccountingDetailVO getPaymentReportDetail(Long id) {
        return dubboAccountingReportPaymenService.getPaymentReportDetail(id);
    }

    public R<?> confirmPaymentReportList(@RequestBody ActualReportAccountingConfirmParam param, String token) {
        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
        return dubboAccountingReportPaymenService.confirmPaymentReportList(param, loginSysUser);
    }

    public R<?> addPaymentReport(@RequestBody ActualPayableReportAccountingCreateParam param, String token) {
        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
        return dubboAccountingReportPaymenService.addPaymentReport(param, loginSysUser);
    }
}
