package cn.superdesk.uniorder.dubbo.consumer.organisation;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.JwtUtil;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dto.param.organisation.SysBusinessUserParam;
import cn.superdesk.uniorder.dto.param.organisation.SysBusinessUserQueryCriteria;
import cn.superdesk.uniorder.dto.param.organisation.SysOperationUserQueryCriteria;
import cn.superdesk.uniorder.dto.vo.sys.SysBusinessUserVo;
import cn.superdesk.uniorder.dto.vo.sys.SysOperationUserVo;
import cn.superdesk.uniorder.dubbo.consumer._permission.PermissionDubboCustomerService;
import cn.superdesk.uniorder.dubbo.facade.organisation.DubboSysBusinessUserService;
import com.alibaba.dubbo.config.annotation.Reference;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;


@Slf4j
@Component
public class SysBusinessUserDubboConsumerService {

	@Reference(version = "1.0.0", timeout = 30000, retries = -1)
	private DubboSysBusinessUserService dubboSysBusinessUserService;

	@Resource
	private PermissionDubboCustomerService permissionDubboCustomerService;

	public SysBusinessUserVo findById(Long id) {

		return dubboSysBusinessUserService.findById(id);
	}

	public R<List<SysBusinessUserVo>> pageQuery(SysBusinessUserQueryCriteria queryCriteria, String token) {

		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
		return dubboSysBusinessUserService.findByPaging(queryCriteria);
	}

	public R<List<SysOperationUserVo>> pageQueryOperationUser(SysOperationUserQueryCriteria queryCriteria) {
		return dubboSysBusinessUserService.queryOperationUserList(queryCriteria);
	}

	public void insert(SysBusinessUserParam param) {

		dubboSysBusinessUserService.insert(param);
	}

	public void updateByPrimaryKeySelective(SysBusinessUserParam param) {

		dubboSysBusinessUserService.updateByPrimaryKeySelective(param);
	}

	public void deleteByIds(List<Long> ids) {
		dubboSysBusinessUserService.deleteByIds(ids);
	}

}
