package cn.superdesk.uniorder.dubbo.consumer.sys;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.JwtUtil;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dto.param.system.SysAccountConfigParam;
import cn.superdesk.uniorder.dto.param.system.SysAccountConfigQueryCriteria;
import cn.superdesk.uniorder.dto.vo.sys.SysAccountConfigVo;
import cn.superdesk.uniorder.dubbo.consumer._permission.PermissionDubboCustomerService;
import cn.superdesk.uniorder.dubbo.facade.sys.DubboSysAccountConfigService;
import com.alibaba.dubbo.config.annotation.Reference;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;

/**
 * 共享参数配置
 *
 * @author zhu 270897222@qq.com
 * @since 1.0.0 2022-10-28
 */
@Slf4j
@Component
public class SysAccountConfigDubboConsumerService {

    @Reference(version = "1.0.0", timeout = 30000, retries = -1)
    private DubboSysAccountConfigService dubboSysAccountConfigService;

    @Resource
    private PermissionDubboCustomerService permissionDubboCustomerService;

    public SysAccountConfigVo findById(Long id) {
        return dubboSysAccountConfigService.findById(id);
    }

    public R<List<SysAccountConfigVo>> pageQuery(SysAccountConfigQueryCriteria queryCriteria, String token) {

        return dubboSysAccountConfigService.findByPaging(queryCriteria);
    }

    public void insert(SysAccountConfigParam param) {

        dubboSysAccountConfigService.insert(param);
    }

    public void updateByPrimaryKeySelective(SysAccountConfigParam param) {

        dubboSysAccountConfigService.updateByPrimaryKeySelective(param);
    }

    public void deleteByIds(List<Long> ids) {
        dubboSysAccountConfigService.deleteByIds(ids);
    }

}
