package cn.superdesk.uniorder.dubbo.consumer.sys;


import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.JwtUtil;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dto.param.system.SysAccountConfigParam;
import cn.superdesk.uniorder.dto.param.system.SysAccountRealityReceivableParam;
import cn.superdesk.uniorder.dto.param.system.SysAccountRealityReceivableQueryCriteria;
import cn.superdesk.uniorder.dto.vo.sys.SysAccountRealityReceivableVo;
import cn.superdesk.uniorder.dubbo.consumer._permission.PermissionDubboCustomerService;
import cn.superdesk.uniorder.dubbo.facade.sys.DubboSysAccountRealityReceivableService;
import com.alibaba.dubbo.config.annotation.Reference;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;

/**
 * 实收报账单
 *
 * @author zhu 270897222@qq.com
 * @since 1.0.0 2022-10-28
 */
@Slf4j
@Component
public class SysAccountRealityReceivableDubboConsumerService {

    @Reference(version = "1.0.0", timeout = 30000, retries = -1)
    private DubboSysAccountRealityReceivableService dubboSysAccountRealityReceivableService;
    @Resource
    private SysAccountConfigDubboConsumerService sysAccountConfigDubboConsumerService;

    @Resource
    private PermissionDubboCustomerService permissionDubboCustomerService;

    public SysAccountRealityReceivableVo findById(Long id) {

        return dubboSysAccountRealityReceivableService.findById(id);
    }

    public R<List<SysAccountRealityReceivableVo>> pageQuery(SysAccountRealityReceivableQueryCriteria queryCriteria, String token) {

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
        return dubboSysAccountRealityReceivableService.findByPaging(queryCriteria);
    }

    public void insert(SysAccountRealityReceivableParam param) {

        dubboSysAccountRealityReceivableService.insert(param);
    }
    @Transactional(rollbackFor = Exception.class)
    public void updateByPrimaryKeySelective(SysAccountRealityReceivableParam param, String token) {

        dubboSysAccountRealityReceivableService.updateByPrimaryKeySelective(param);
        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
        SysAccountConfigParam configParam = new SysAccountConfigParam();
        configParam.setId(param.getAccountConfigId());
        if(loginSysUser!=null){
            configParam.setUserId(String.valueOf(loginSysUser.getSysUserId()));
            configParam.setUserName(loginSysUser.getSysUserName());
        }
        configParam.setUpdateTime(new Date());
        sysAccountConfigDubboConsumerService.updateByPrimaryKeySelective(configParam);
    }

    public void deleteByIds(List<Long> ids) {
        dubboSysAccountRealityReceivableService.deleteByIds(ids);
    }

}
