package cn.superdesk.uniorder.dubbo.consumer.thirdpart.jd;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.JwtUtil;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReport;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportParam;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.*;
import cn.superdesk.uniorder.dubbo.facade.thirdpart.jd.DubboAccountingUnifiedSupplierOrderJdCheckUpReportService;
import com.alibaba.dubbo.config.annotation.Reference;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

/**
 * @Description: 京东对账单中的订单 算是临时 sheet eg 深圳市侨城汇网络科技有限公司-2021年8月1日集采账单.xlsx
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-10-14 17:04:08
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-10-14 17:04:08
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Component
public class AccountingUnifiedSupplierOrderJdCheckUpReportDubboConsumerService {

    @Reference(version = "1.0.0", timeout = 10000, retries = -1)
    private DubboAccountingUnifiedSupplierOrderJdCheckUpReportService dubboAccountingUnifiedSupplierOrderJdCheckUpReportService;


    /****************************************** extends BaseService 部分 start ******************************************/

    public void addObj(AccountingUnifiedSupplierOrderJdCheckUpReportParam param) {

        dubboAccountingUnifiedSupplierOrderJdCheckUpReportService.addObj(param);

    }

    public void updateObj(AccountingUnifiedSupplierOrderJdCheckUpReportParam param) {

        dubboAccountingUnifiedSupplierOrderJdCheckUpReportService.updateObj(param);
    }

    public void deleteObj(Long id) {

        dubboAccountingUnifiedSupplierOrderJdCheckUpReportService.deleteObj(id);
    }

    public AccountingUnifiedSupplierOrderJdCheckUpReport findById(Long id) {

        return dubboAccountingUnifiedSupplierOrderJdCheckUpReportService.findById(id);
    }

    public PageInfo<AccountingUnifiedSupplierOrderJdCheckUpReport> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize) {

        return dubboAccountingUnifiedSupplierOrderJdCheckUpReportService.findByPaging(conditions, pageNun, pageSize);
    }

    public List<AccountingUnifiedSupplierOrderJdCheckUpReport> findAll(Map<String, Object> queryMap) {

        return dubboAccountingUnifiedSupplierOrderJdCheckUpReportService.findAll(queryMap);
    }

    /****************************************** extends BaseService 部分   end ******************************************/


    public void addAccountingUnifiedSupplierOrderJdCheckUpReport(AccountingUnifiedSupplierOrderJdCheckUpReportParam param) {

        dubboAccountingUnifiedSupplierOrderJdCheckUpReportService.addAccountingUnifiedSupplierOrderJdCheckUpReport(param);
    }


    public void updateAccountingUnifiedSupplierOrderJdCheckUpReport(AccountingUnifiedSupplierOrderJdCheckUpReportParam param) {

        dubboAccountingUnifiedSupplierOrderJdCheckUpReportService.updateAccountingUnifiedSupplierOrderJdCheckUpReport(param);
    }


    public void deleteAccountingUnifiedSupplierOrderJdCheckUpReport(Long id) {
        dubboAccountingUnifiedSupplierOrderJdCheckUpReportService.deleteAccountingUnifiedSupplierOrderJdCheckUpReport(id);
    }


    public AccountingUnifiedSupplierOrderJdCheckUpReport findAccountingUnifiedSupplierOrderJdCheckUpReportById(Long id) {

        return dubboAccountingUnifiedSupplierOrderJdCheckUpReportService.findAccountingUnifiedSupplierOrderJdCheckUpReportById(id);
    }


    public R<List<AccountingUnifiedSupplierOrderJdCheckUpReport>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize) {

        return dubboAccountingUnifiedSupplierOrderJdCheckUpReportService.pageQuery(conditions, pageNun, pageSize);
    }


    public R<List<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVo>> pageQueryGenericParam(
            AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria queryCriteria,
            String token) {

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

        return dubboAccountingUnifiedSupplierOrderJdCheckUpReportService.pageQueryGenericParam(queryCriteria, loginSysUser);
    }

    public R<List<AccountingUnifiedSupplierOrderJdCheckUpReportListItemVoWoof>> pageQueryGenericWoof(
            AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria queryCriteria,
            String token) {

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

        return dubboAccountingUnifiedSupplierOrderJdCheckUpReportService.pageQueryGenericWoof(queryCriteria, loginSysUser);
    }

    public AccountingUnifiedSupplierOrderJdCheckUpReportDetailStatisticsVo pageQueryHeadGenericParam(AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria queryCriteria, String token) {

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

        return dubboAccountingUnifiedSupplierOrderJdCheckUpReportService.pageQueryHeadGenericParam(queryCriteria, loginSysUser);
    }

    /****************************************** 检查 start  ******************************************/

    public R<String> checkUpAndReportDimOrder(
            SysQuartzScheduleTaskStatementOfAccountJdListItemVo listItemVo,
            AccountingUnifiedSupplierOrderJdListItemVo itemVo) {

        return dubboAccountingUnifiedSupplierOrderJdCheckUpReportService.checkUpAndReportDimOrder(listItemVo, itemVo);
    }

    public AccountingUnifiedSupplierOrderJdCheckUpReportSnapshotStruct readSnapshotJson(String batchId, String jdOrderSn) {

        log.info("\nopCheckUpDebug start \n{}\n{}\nopCheckUpDebug   end", batchId, jdOrderSn);

        return dubboAccountingUnifiedSupplierOrderJdCheckUpReportService.readSnapshotJson(batchId, jdOrderSn);
    }

    /****************************************** 检查   end ******************************************/

    /****************************************** export excel start ******************************************/

    public String exportExcelJdCheckUpReportFullVersion(
            AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria queryCriteria,
            String token) {

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

        return dubboAccountingUnifiedSupplierOrderJdCheckUpReportService
                .exportExcelJdCheckUpReportFullVersion(queryCriteria, loginSysUser);
    }

    public String exportExcelJdCheckUpReportLiteVersion(
            AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria queryCriteria,
            String token) {

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

        return dubboAccountingUnifiedSupplierOrderJdCheckUpReportService
                .exportExcelJdCheckUpReportLiteVersion(queryCriteria, loginSysUser);
    }

    /****************************************** export excel   end ******************************************/
}
