package cn.superdesk.uniorder.dubbo.consumer.thirdpart.jd;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.JwtUtil;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.thirdpart.jd.AccountingUnifiedSupplierOrderJd;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.AccountingUnifiedSupplierOrderJdImportFullVersionExcelRow;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.AccountingUnifiedSupplierOrderJdImportLiteVersionExcelRow;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.AccountingUnifiedSupplierOrderJdParam;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.AccountingUnifiedSupplierOrderJdQueryCriteria;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.AccountingUnifiedSupplierOrderJdDetailStatisticsVo;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.AccountingUnifiedSupplierOrderJdListItemVo;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.AccountingUnifiedSupplierOrderJdUpperLevelsStatisticsVo;
import cn.superdesk.uniorder.dubbo.facade.thirdpart.jd.DubboAccountingUnifiedSupplierOrderJdService;
import com.alibaba.dubbo.config.annotation.Reference;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

/**
 * @Description: 京东对账单中的订单 算是临时 sheet eg 深圳市侨城汇网络科技有限公司-2021年8月1日集采账单.xlsx
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-10-12 11:29:24
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-10-12 11:29:24
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Component
public class AccountingUnifiedSupplierOrderJdDubboConsumerService {

    @Reference(version = "1.0.0", timeout = 10000, retries = -1)
    private DubboAccountingUnifiedSupplierOrderJdService dubboAccountingUnifiedSupplierOrderJdService;


    /****************************************** extends BaseService 部分 start ******************************************/

    public void addObj(AccountingUnifiedSupplierOrderJdParam param) {

        dubboAccountingUnifiedSupplierOrderJdService.addObj(param);

    }

    public void updateObj(AccountingUnifiedSupplierOrderJdParam param) {

        dubboAccountingUnifiedSupplierOrderJdService.updateObj(param);
    }

    public void deleteObj(Long id) {

        dubboAccountingUnifiedSupplierOrderJdService.deleteObj(id);
    }

    public AccountingUnifiedSupplierOrderJd findById(Long id) {

        return dubboAccountingUnifiedSupplierOrderJdService.findById(id);
    }

    public PageInfo<AccountingUnifiedSupplierOrderJd> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize) {

        return dubboAccountingUnifiedSupplierOrderJdService.findByPaging(conditions, pageNun, pageSize);
    }

    public List<AccountingUnifiedSupplierOrderJd> findAll(Map<String, Object> queryMap) {

        return dubboAccountingUnifiedSupplierOrderJdService.findAll(queryMap);
    }

    /****************************************** extends BaseService 部分   end ******************************************/


    public void addAccountingUnifiedSupplierOrderJd(AccountingUnifiedSupplierOrderJdParam param) {

        dubboAccountingUnifiedSupplierOrderJdService.addAccountingUnifiedSupplierOrderJd(param);
    }


    public void updateAccountingUnifiedSupplierOrderJd(AccountingUnifiedSupplierOrderJdParam param) {

        dubboAccountingUnifiedSupplierOrderJdService.updateAccountingUnifiedSupplierOrderJd(param);
    }


    public void deleteAccountingUnifiedSupplierOrderJd(Long id) {
        dubboAccountingUnifiedSupplierOrderJdService.deleteAccountingUnifiedSupplierOrderJd(id);
    }


    public AccountingUnifiedSupplierOrderJd findAccountingUnifiedSupplierOrderJdById(Long id) {

        return dubboAccountingUnifiedSupplierOrderJdService.findAccountingUnifiedSupplierOrderJdById(id);
    }


    public R<List<AccountingUnifiedSupplierOrderJd>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize) {

        return dubboAccountingUnifiedSupplierOrderJdService.pageQuery(conditions, pageNun, pageSize);
    }


    public R<List<AccountingUnifiedSupplierOrderJdListItemVo>> pageQueryGenericParam(
            AccountingUnifiedSupplierOrderJdQueryCriteria queryCriteria,
            String token) {
        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

        return dubboAccountingUnifiedSupplierOrderJdService.pageQueryGenericParam(queryCriteria, loginSysUser);
    }

    public List<AccountingUnifiedSupplierOrderJdListItemVo> queryGenericParam(
            AccountingUnifiedSupplierOrderJdQueryCriteria queryCriteria,
            String token) {

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
        return dubboAccountingUnifiedSupplierOrderJdService.queryGenericParam(queryCriteria, loginSysUser);
    }

    public AccountingUnifiedSupplierOrderJdDetailStatisticsVo pageQueryHeadGenericParam(
            AccountingUnifiedSupplierOrderJdQueryCriteria queryCriteria,
            String token) {
        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
        return dubboAccountingUnifiedSupplierOrderJdService.pageQueryHeadGenericParam(queryCriteria, loginSysUser);
    }

    public AccountingUnifiedSupplierOrderJdUpperLevelsStatisticsVo statisticsQuantityDimOrderNormalOrException(
            AccountingUnifiedSupplierOrderJdQueryCriteria queryCriteria,
            String token){

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
        return dubboAccountingUnifiedSupplierOrderJdService.statisticsQuantityDimOrderNormalOrException(queryCriteria, loginSysUser);
    }


    /****************************************** excel import start start ******************************************/

    public String exportExcelJdImportRecord(AccountingUnifiedSupplierOrderJdQueryCriteria queryCriteria, String token) {

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

        return dubboAccountingUnifiedSupplierOrderJdService.exportExcelJdImportRecord(queryCriteria, loginSysUser);
    }


    /**
     * 完整版
     *
     * @param excelRow
     * @param token
     */
    public void saveOrUpdate4ThirdPartJdReconciliationScheduleFullVersionExcelRow(AccountingUnifiedSupplierOrderJdImportFullVersionExcelRow excelRow, String token) {

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
        dubboAccountingUnifiedSupplierOrderJdService.saveOrUpdate4ThirdPartJdReconciliationScheduleFullVersionExcelRow(excelRow, loginSysUser);
    }

    /**
     * 完整版
     *
     * @param excelRowList
     * @param token
     */
    public void saveOrUpdate4ThirdPartJdReconciliationScheduleFullVersionExcelRowList(List<AccountingUnifiedSupplierOrderJdImportFullVersionExcelRow> excelRowList, String token) {

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
        dubboAccountingUnifiedSupplierOrderJdService.saveOrUpdate4ThirdPartJdReconciliationScheduleFullVersionExcelRowList(excelRowList, loginSysUser);
    }

    /**
     * 精简版
     *
     * @param excelRow
     * @param token
     */
    public void saveOrUpdate4ThirdPartJdReconciliationScheduleLiteVersionExcelRow(AccountingUnifiedSupplierOrderJdImportLiteVersionExcelRow excelRow, String token) {

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
        dubboAccountingUnifiedSupplierOrderJdService.saveOrUpdate4ThirdPartJdReconciliationScheduleLiteVersionExcelRow(excelRow, loginSysUser);
    }

    /**
     * 精简版
     *
     * @param excelRowList
     * @param token
     */
    public void saveOrUpdate4ThirdPartJdReconciliationScheduleLiteVersionExcelRowList(List<AccountingUnifiedSupplierOrderJdImportLiteVersionExcelRow> excelRowList, String token) {

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
        dubboAccountingUnifiedSupplierOrderJdService.saveOrUpdate4ThirdPartJdReconciliationScheduleLiteVersionExcelRowList(excelRowList, loginSysUser);
    }

    /****************************************** excel import start   end ******************************************/
}
