package cn.superdesk.uniorder.dubbo.consumer.thirdpart.jd;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.JwtUtil;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJd;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.*;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdHeadVo;
import cn.superdesk.uniorder.dto.vo.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdListItemVo;
import cn.superdesk.uniorder.dubbo.consumer._permission.PermissionDubboCustomerService;
import cn.superdesk.uniorder.dubbo.facade.thirdpart.jd.DubboSysQuartzScheduleTaskStatementOfAccountJdService;
import com.alibaba.dubbo.config.annotation.Reference;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * @Description: 定时任务-时刻任务-对账单
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-10-12 11:29:24
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-10-12 11:29:24
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Component
public class SysQuartzScheduleTaskStatementOfAccountJdDubboConsumerService {

    @Reference(version = "1.0.0", timeout = 60000, retries = -1)
    private DubboSysQuartzScheduleTaskStatementOfAccountJdService dubboSysQuartzScheduleTaskStatementOfAccountJdService;

    @Resource
    private PermissionDubboCustomerService permissionDubboCustomerService;


    /****************************************** extends BaseService 部分 start ******************************************/

    public int insertSelective(SysQuartzScheduleTaskStatementOfAccountJd entity) {

        return dubboSysQuartzScheduleTaskStatementOfAccountJdService.insertSelective(entity);

    }

    public int updateByPrimaryKeySelective(SysQuartzScheduleTaskStatementOfAccountJd entity) {

        return dubboSysQuartzScheduleTaskStatementOfAccountJdService.updateByPrimaryKeySelective(entity);
    }

    public void deleteObj(Long id) {

        dubboSysQuartzScheduleTaskStatementOfAccountJdService.deleteObj(id);
    }

    public SysQuartzScheduleTaskStatementOfAccountJd findById(Long id) {

        return dubboSysQuartzScheduleTaskStatementOfAccountJdService.findById(id);
    }

    @Deprecated
    public PageInfo<SysQuartzScheduleTaskStatementOfAccountJd> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize) {

        return dubboSysQuartzScheduleTaskStatementOfAccountJdService.findByPaging(conditions, pageNun, pageSize);
    }

    @Deprecated
    public List<SysQuartzScheduleTaskStatementOfAccountJd> findAll(Map<String, Object> queryMap) {

        return dubboSysQuartzScheduleTaskStatementOfAccountJdService.findAll(queryMap);
    }

    /****************************************** extends BaseService 部分   end ******************************************/


    public int addSysQuartzScheduleTaskStatementOfAccountJd(SysQuartzScheduleTaskStatementOfAccountJdParam param, String token) {

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
        return dubboSysQuartzScheduleTaskStatementOfAccountJdService.addSysQuartzScheduleTaskStatementOfAccountJd(param, loginSysUser);
    }


    public int updateSysQuartzScheduleTaskStatementOfAccountJd(SysQuartzScheduleTaskStatementOfAccountJdParam param, String token) {

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
        return dubboSysQuartzScheduleTaskStatementOfAccountJdService.updateSysQuartzScheduleTaskStatementOfAccountJd(param, loginSysUser);
    }


    public int deleteSysQuartzScheduleTaskStatementOfAccountJd(Long id, String token) {

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
        return dubboSysQuartzScheduleTaskStatementOfAccountJdService.deleteSysQuartzScheduleTaskStatementOfAccountJd(id, loginSysUser);
    }


    public SysQuartzScheduleTaskStatementOfAccountJdListItemVo findListItemVoById(Long id, String token) {

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

        return dubboSysQuartzScheduleTaskStatementOfAccountJdService.findListItemVoById(id, loginSysUser);
    }

    public SysQuartzScheduleTaskStatementOfAccountJdListItemVo findListItemVoByBatchId(String batchId, String token) {

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

        return dubboSysQuartzScheduleTaskStatementOfAccountJdService.findListItemVoByBatchId(batchId, loginSysUser);
    }


    public R<List<SysQuartzScheduleTaskStatementOfAccountJd>> pageQuery(
            Map<String, Object> conditions,
            int pageNun,
            int pageSize) {

        return dubboSysQuartzScheduleTaskStatementOfAccountJdService.pageQuery(conditions, pageNun, pageSize);
    }


    public R<List<SysQuartzScheduleTaskStatementOfAccountJdListItemVo>> pageQueryGenericParam(
            SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria queryCriteria,
            String token) {

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

        return dubboSysQuartzScheduleTaskStatementOfAccountJdService.pageQueryGenericParam(queryCriteria, loginSysUser);
    }

    public SysQuartzScheduleTaskStatementOfAccountJdHeadVo queryHeadGenericParam(
            SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria queryCriteria,
            String token) {

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

        return dubboSysQuartzScheduleTaskStatementOfAccountJdService.queryHeadGenericParam(queryCriteria, loginSysUser);
    }


    public List<SysQuartzScheduleTaskStatementOfAccountJdListItemVo> queryGenericParam(
            SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria queryCriteria,
            String token) {

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

        return dubboSysQuartzScheduleTaskStatementOfAccountJdService.queryGenericParam(queryCriteria, loginSysUser);
    }

    public SysQuartzScheduleTaskStatementOfAccountJdListItemVo deQueueOneImportExcel(String token) {
        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
        return dubboSysQuartzScheduleTaskStatementOfAccountJdService.deQueueOneImportExcel(loginSysUser);
    }

    public SysQuartzScheduleTaskStatementOfAccountJdListItemVo deQueueOneCompareOrderAndCheckUpThenReport(String token) {
        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
        return dubboSysQuartzScheduleTaskStatementOfAccountJdService.deQueueOneCompareOrderAndCheckUpThenReport(loginSysUser);
    }


    public int opSetRemark(
            SysQuartzScheduleTaskStatementOfAccountJdOpSetRemarkForm form,
            String token) {

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

        return dubboSysQuartzScheduleTaskStatementOfAccountJdService.opSetRemark(form, loginSysUser);
    }

    public int opSetIsPause(
            SysQuartzScheduleTaskStatementOfAccountJdOpSetIsPauseForm form,
            String token) {

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

        return dubboSysQuartzScheduleTaskStatementOfAccountJdService.opSetIsPause(form, loginSysUser);
    }

    public String asyncExcelImportFullVersion(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            String token) {

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

        return dubboSysQuartzScheduleTaskStatementOfAccountJdService.asyncExcelImportFullVersion(form, loginSysUser);

    }

    public String asyncExcelImportLiteVersion(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            String token) {

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

        return dubboSysQuartzScheduleTaskStatementOfAccountJdService.asyncExcelImportLiteVersion(form, loginSysUser);
    }

    /****************************************** 检查 start ******************************************/

    /**
     * 步骤3:通过京东的订单数据-比对统一订单数据-生成报告
     * 检查 比对
     *
     * @param form
     * @param token
     * @return
     */
    public String asyncCompareOrderAndCheckUpThenReport(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            String token) {

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

        return dubboSysQuartzScheduleTaskStatementOfAccountJdService.asyncCompareOrderAndCheckUpThenReport(form, loginSysUser);
    }

    /**
     * 步骤3:通过报告的异常数据-重新比对统一订单数据-生成报告
     *
     * @param form
     * @param token
     * @return
     */
    public String asyncCompareOrderAndCheckUpThenReportOnlyException(
            SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form,
            String token) {

        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

        return dubboSysQuartzScheduleTaskStatementOfAccountJdService.asyncCompareOrderAndCheckUpThenReportOnlyException(form, loginSysUser);
    }
}
