package cn.superdesk.uniorder.dubbo.consumer.thirdpart.jd;

import cn.superdesk.uniorder.common.security.JwtUtil;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdOpCancelForm;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdOpConfirmForm;
import cn.superdesk.uniorder.dto.param.thirdpart.jd.SysQuartzScheduleTaskStatementOfAccountJdOpDeleteForm;
import cn.superdesk.uniorder.dubbo.consumer._permission.PermissionDubboCustomerService;
import cn.superdesk.uniorder.dubbo.facade.thirdpart.jd.DubboSysQuartzScheduleTaskStatementOfAccountJdExOpPartService;
import com.alibaba.dubbo.config.annotation.Reference;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;


/**
 * @Description:
 * @Author: linjinyu
 * @CreateDate: 10/12/20 4:28 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 10/12/20 4:28 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Component
public class SysQuartzScheduleTaskStatementOfAccountJdExOpPartDubboConsumerService {

    @Reference(version = "1.0.0", timeout = 300000, retries = -1)
    private DubboSysQuartzScheduleTaskStatementOfAccountJdExOpPartService dubboSysQuartzScheduleTaskStatementOfAccountJdExOpPartService;

    @Resource
    private PermissionDubboCustomerService permissionDubboCustomerService;

    /**
     * 供应商结算-京东对账-op列表-op删除任务
     *
     * @param form
     * @param token
     * @return
     */
    public int opDelete(SysQuartzScheduleTaskStatementOfAccountJdOpDeleteForm form, String token) {
        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
        return dubboSysQuartzScheduleTaskStatementOfAccountJdExOpPartService.opDelete(form, loginSysUser);
    }

    /**
     * 供应商结算-京东对账-op列表-op取消账单
     *
     * @param form
     * @param token
     */
    public int opCancel(SysQuartzScheduleTaskStatementOfAccountJdOpCancelForm form, String token) {
        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
        return dubboSysQuartzScheduleTaskStatementOfAccountJdExOpPartService.opCancel(form, loginSysUser);
    }

    /**
     * 供应商结算-京东对账-op列表-op确认账单
     *
     * @param form
     * @param token
     */
    public int opConfirm(SysQuartzScheduleTaskStatementOfAccountJdOpConfirmForm form, String token) {
        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
        return dubboSysQuartzScheduleTaskStatementOfAccountJdExOpPartService.opConfirm(form, loginSysUser);
    }

}
