package cn.superdesk.uniorder.executor.scheduler.task;

import cn.superdesk.uniorder.dao.entity.sys.SysUser;
import cn.superdesk.uniorder.dubbo.consumer.sys.SysUserDubboConsumerService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;


/**
 * @Description: 次日清理昨日登录失败次数
 * @Author: @270897222@qq.com
 * @CreateDate: 2022/11/12
 */
@Slf4j
@Component
@Configuration
@EnableScheduling
public class LoginFailCountTask {
    @Autowired
    private SysUserDubboConsumerService sysUserDubboConsumerService;

    @Scheduled(cron=("0 10 0 * * ?"))
//    @Scheduled(cron = ("0 0/1 * * * ?"))
    public void run() {
        //最后登录时间是昨日的所有数据
        List<SysUser> list = new ArrayList<>();
        sysUserDubboConsumerService.updateBatch(list);
        log.info("update sys_user loginFailCount is 0.");
    }
}
